@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
if "%~0"=="$CSPINSTALL.cmd" goto START

if not "%$cmd_plain%"=="1" cls
echo 
echo  CSP Key Container Installation Utility (based on "SN"-utility) 
echo 
goto START

:SYNTAX
if "%~0"=="$CSPINSTALL.cmd" goto INCORRECT_NESTED_CALL
echo.
echo  Parameters: 
echo.
echo 1) Required: ^<Container Name^>
echo 2) Optional: ^<KeyPair Container File Name^> (defaults to: ^<Container Name^>.pfx)
echo.
echo  Examples: 
echo.
echo $CspInstall "XSoft"
echo $CspInstall "XEntity" "XEntity.KeyPair.snk"
echo.
echo This will install keypair from file "XSoft.pfx" / "XEntity.KeyPair.snk"
echo into CSP-container named "XSoft" / "XEntity".
echo.
echo *** Use "?", "/?", "-?" or no parameters to see this help. ***
goto FINISH

:START
setlocal
set errorlevel=0
set errorlevel=

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%2]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAMS_FORBIDDEN

if not [%2]==[] goto NOT_SYNTAX_PARAMS
if "%~1"==""    goto SYNTAX
if "%~1"=="?"   goto SYNTAX
if "%~1"=="/?"  goto SYNTAX
if "%~1"=="-?"  goto SYNTAX
:NOT_SYNTAX_PARAMS

if not [%3]==[] goto INCORRECT_PARAMS

set ContainerName=%~1
set KeyPairContainerFile=%~2

if "%KeyPairContainerFile%"=="" set KeyPairContainerFile=%ContainerName%.pfx

set Command=SN -q -i "%KeyPairContainerFile%" "%ContainerName%"
echo.
echo  %Command%
echo.
echo * Installing CSP key container ...
%Command%
if %errorlevel% neq 0 goto FAILURE

:SUCCESS
if "%~0"=="$CSPINSTALL.cmd" goto FINISH
echo.
echo  CSP-INSTALL  SUCCESS 
echo 
goto FINISH

:FAILURE
if "%~0"=="$CSPINSTALL.cmd" goto ERROR
echo.
echo  ## CSP-INSTALL  FAILURE 
echo 
goto ERROR

:INCORRECT_PARAMS
echo.
echo ## Incorrect parameters.
echo ## One parameter expected: key name (base name).
goto ERROR

rem ================================================================================

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:EMPTY_PARAMS_FORBIDDEN
echo.
echo ## Empty parameters ("") are forbidden.
goto ERROR

:ERROR
if "%~0"=="$CSPINSTALL.cmd" goto SET_ERROR
echo 
if not "%$cmd_plain%"=="1" pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$CSPINSTALL.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ================================================================================
