@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
if "%~0"=="$CSPUNINSTALL.cmd" goto START

if not "%$cmd_plain%"=="1" cls
echo 
echo  CSP Key Container De-Installation Utility (based on "SN"-utility) 
echo 
goto START

:SYNTAX
if "%~0"=="$CSPUNINSTALL.cmd" goto INCORRECT_NESTED_CALL
echo.
echo One parameter is required: ^<CSP Container Name^>.
echo.
echo  Examples: 
echo.
echo $CspUninstall "XSoft"
echo.
echo This will uninstall "XSoft" CSP-container.
echo.
echo *** Use "?", "/?", "-?" or no parameters to see this help. ***
goto FINISH

:START
setlocal
set errorlevel=0
set errorlevel=

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%2]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAMS_FORBIDDEN

if not [%2]==[] goto NOT_SYNTAX_PARAMS
if "%~1"==""    goto SYNTAX
if "%~1"=="?"   goto SYNTAX
if "%~1"=="/?"  goto SYNTAX
if "%~1"=="-?"  goto SYNTAX
:NOT_SYNTAX_PARAMS

if not [%2]==[] goto INCORRECT_PARAMS

set ContainerName=%~1

set Command=SN -q -d "%ContainerName%"
echo.
echo  %Command%
echo.
echo * Uninstalling CSP key container ...
%Command%
if %errorlevel% neq 0 goto FAILURE

:SUCCESS
if "%~0"=="$CSPUNINSTALL.cmd" goto FINISH
echo.
echo  CSP-UNINSTALL  SUCCESS 
echo 
goto FINISH

:FAILURE
if "%~0"=="$CSPUNINSTALL.cmd" goto ERROR
echo.
echo  ## CSP-UNINSTALL  FAILURE 
echo 
goto ERROR

:INCORRECT_PARAMS
echo.
echo ## Incorrect parameters.
echo ## One parameter expected: key name (base name).
goto ERROR

rem ================================================================================

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:EMPTY_PARAMS_FORBIDDEN
echo.
echo ## Empty parameters ("") are forbidden.
goto ERROR

:ERROR
if "%~0"=="$CSPUNINSTALL.cmd" goto SET_ERROR
echo 
if not "%$cmd_plain%"=="1" pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$CSPUNINSTALL.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ================================================================================
