@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
if "%~0"=="$MAPPDISTR.cmd" goto START

:NORMAL_CALL
if not "%$cmd_plain%"=="1" cls
echo 
echo  Multiple XCopy App.Distribution Utility (based on "$XAppDistr"-utility) 
echo 
goto START

:SYNTAX
if "%~0"=="$MAPPDISTR.cmd" goto INCORRECT_NESTED_CALL
echo.
echo  Parameters: 
echo.
echo 1) Required: ^<Distribution Script File Base Upper Name^> 
echo              to start in "*.Distr" subfolders.
echo 2) Optional: ^<Distribution Folder Extension^> 
echo              instead of ".Distr" (default value);
echo              specify "" to process all subfolders.
echo.
echo  Environment Variables (optional): 
echo.
echo $mappdistr.IgnoreAbsentScripts  0/1
echo    Default value is "0" (don't ignore).
echo.
echo  Examples: 
echo.
echo $MappDistr "DISTRIBUTE_APPLICATION"
echo $MappDistr "UPDATE_APPLICATION"
echo $MappDistr "REMOVE_APPLICATION"
echo.
echo $MappDistr "DISTRIBUTE_APPLICATION_2"
echo $MappDistr "UPDATE_APPLICATION_2"
echo $MappDistr "REMOVE_APPLICATION_2"
echo.
echo $MappDistr "DISTRIBUTE_APPLICATION_X"
echo $MappDistr "UPDATE_APPLICATION_X"
echo $MappDistr "REMOVE_APPLICATION_X"
echo.
echo $MappDistr "DISTRIBUTE_APPLICATION" ".Special.Distr"
echo $MappDistr "UPDATE_APPLICATION" ".Special.Distr"
echo $MappDistr "REMOVE_APPLICATION" ".Special.Distr"
echo.
echo $MappDistr "DISTRIBUTE_APPLICATION" ""
echo $MappDistr "UPDATE_APPLICATION" ""
echo $MappDistr "REMOVE_APPLICATION" ""
echo.
echo *** Use "?", "/?", "-?" or no parameters to see this help. ***
goto FINISH

:START
setlocal enableextensions enabledelayedexpansion

set SaveCD=%CD%

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAM_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAM_FORBIDDEN

if not [%2]==[] goto NOT_SYNTAX_PARAMS
if "%~1"==""    goto SYNTAX
if "%~1"=="?"   goto SYNTAX
if "%~1"=="/?"  goto SYNTAX
if "%~1"=="-?"  goto SYNTAX
:NOT_SYNTAX_PARAMS

if     [%1]==[] goto INCORRECT_PARAMS
if not [%3]==[] goto INCORRECT_PARAMS

rem ================================================================================

set DistributionScriptFileBaseUpperName=%~1

set DistributionFolderExtension=.Distr
if "%2"=="""" set DistributionFolderExtension=
if not "%~2"=="" set DistributionFolderExtension=%~2

rem --------------------------------------------------------------------------------

set DistributionScriptFileUpperName=%DistributionScriptFileBaseUpperName%.CMD
set DistributionScriptFileXName=%DistributionScriptFileBaseUpperName%.cmd

set DistributionFolderPattern=*%DistributionFolderExtension%

rem --------------------------------------------------------------------------------

set ReportFileName=~MultiDistributionReport.txt

call :SET_REPORT_FILE_PATH "%CD%\"

rem ================================================================================

if "%~0"=="$MAPPDISTR.cmd" goto SKIP_CONFIRMATION
echo.
echo  Distribution CMD-Script  %DistributionScriptFileBaseUpperName%
echo  Distribution Folder Extension  %DistributionFolderExtension%
echo.
echo 
echo  CONFIRM MULTIPLE APPLICATION DISTRIBUTION:  ("Ctrl+C"  break off) 
echo.
pause
:SKIP_CONFIRMATION

rem ================================================================================

set ReportFileCreated=0

rem --------------------------------------------------------------------------------

call :DELETE_FILE_VERBOSE "%ReportFile%"
if %errorlevel% neq 0 goto FAILURE

rem --------------------------------------------------------------------------------

set MultiDistributionError=0
set DistributionItemNo=0

call :PRINT_REPORT_HEADER > "%ReportFile%"

set ReportFileCreated=1

for /D %%D in ("%DistributionFolderPattern%") do (
rem --------------------------------------------------------------------------------

echo.
echo *******************************************************************************

set DistributionFolderName=%%D
set DistributionScriptFile=%%D\!DistributionScriptFileUpperName!

if exist "!DistributionScriptFile!" (
rem -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

call :PRINT_NEXT_DISTRIBUTIOIN_ITEM

call :CHANGE_PATH_SILENT "!DistributionFolderName!"
if !errorlevel! neq 0 goto FAILURE

call :RESET_ERROR
call %DistributionScriptFileXName%
if !errorlevel! neq 0 (
set MultiDistributionError=1
echo.>> "%ReportFile%"
echo # ERROR (see report/error files, if available and up to date^)>> "!ReportFile!"
) else (
rem
)

rem -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
) else (
rem -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

if not "!$mappdistr.IgnoreAbsentScripts!"=="1" (
call :PRINT_NEXT_DISTRIBUTIOIN_ITEM
call :PRINT_SCRIPT_FILE_NOT_FOUND
call :PRINT_SCRIPT_FILE_NOT_FOUND >> "!ReportFile!"
set MultiDistributionError=1
) else (
rem
)

rem -- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
)

call :RESTORE_PATH_SILENT

rem --------------------------------------------------------------------------------
)
if %errorlevel% neq 0 set MultiDistributionError=1

if "%MultiDistributionError%"=="1" goto FAILURE

rem ================================================================================

:SUCCESS
call :PRINT_REPORT_SUCCESS_FOOTER >> "%ReportFile%"
if "%~0"=="$MAPPDISTR.cmd" goto FINISH
echo.
echo  MULTIPLE APPLICATION DISTRIBUTION  SUCCESS 
echo 
goto FINISH

:FAILURE
if "%ReportFileCreated%"=="1" call :PRINT_REPORT_FAILURE_FOOTER >> "%ReportFile%"
if "%~0"=="$MAPPDISTR.cmd" goto ERROR
echo.
echo  ## MULTIPLE APPLICATION DISTRIBUTION  FAILURE 
echo 
goto ERROR

rem ================================================================================

:INCORRECT_PARAMS
echo.
echo ## Incorrect parameters.
echo ## Run with "?", "/?", "-?" or without parameters for syntax.
goto ERROR

rem ********************************************************************************


rem ********************************************************************************
:PRINT_REPORT_HEADER
rem --------------------------------------------------------------------------------
echo *******************************************************************************
echo *** MULTIPLE APPLICATION DISTRIBUTION: ****************************************
echo *** ---------------------------------- ****************************************
time /t
echo # Distribution CMD-Script: "%DistributionScriptFileBaseUpperName%"
echo.
echo ===============================================================================
rem --------------------------------------------------------------------------------
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:PRINT_REPORT_SPLITTER
echo.
echo -------------------------------------------------------------------------------
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:PRINT_REPORT_SUCCESS_FOOTER
rem --------------------------------------------------------------------------------
echo.
echo ===============================================================================
time /t
echo *** -------------------------------------------- ******************************
echo *** MULTIPLE APPLICATION DISTRIBUTION -- SUCCESS ******************************
echo *******************************************************************************
rem --------------------------------------------------------------------------------
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:PRINT_REPORT_FAILURE_FOOTER
rem --------------------------------------------------------------------------------
echo.
echo ===============================================================================
time /t
echo *** ----------------------------------------------- ***************************
echo *** ## MULTIPLE APPLICATION DISTRIBUTION -- FAILURE ***************************
echo *******************************************************************************
rem --------------------------------------------------------------------------------
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:SET_REPORT_FILE_PATH
set ReportFile=%~dpn1%ReportFileName%
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:PRINT_NEXT_DISTRIBUTIOIN_ITEM
rem --------------------------------------------------------------------------------

set /a DistributionItemNo+=1

echo.
echo ^<%DistributionItemNo%^>: Running "%DistributionScriptFileBaseUpperName%" in "%DistributionFolderName%" ...

if not "%DistributionItemNo%"=="1" call :PRINT_REPORT_SPLITTER >> "%ReportFile%"
time /t >> "!ReportFile!"
echo * ^<%DistributionItemNo%^> Processing of "%DistributionFolderName%" application:>> "%ReportFile%"

rem --------------------------------------------------------------------------------
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:PRINT_SCRIPT_FILE_NOT_FOUND
echo.
echo ## CMD-Script not found: "%DistributionScriptFileBaseUpperName%".
goto RETURN_SUCCESS
rem ********************************************************************************


rem ********************************************************************************
:DELETE_FILE_VERBOSE
rem --------------------------------------------------------------------------------
if "%~1"=="" goto DELETE_FILE_VERBOSE_INCORRECT_CALL
if not exist "%~1" goto RETURN_SUCCESS
echo.
echo * Deleting file: "%~1" ...
call :RESET_ERROR
del/q "%~1"
if exist "%~1" goto RETURN_ERROR
rem --------------------------------------------------------------------------------
goto RETURN_SUCCESS
rem ================================================================================
:DELETE_FILE_VERBOSE_INCORRECT_CALL
echo.
echo ## Incorrect subroutine call: "DELETE_FILE_VERBOSE".
goto RETURN_ERROR
rem ********************************************************************************


rem ********************************************************************************
:RESET_ERROR
set errorlevel=0
set errorlevel=
goto :EOF
rem ********************************************************************************


rem ********************************************************************************

:RETURN_SUCCESS
call :RESET_ERROR
goto :EOF

:RETURN_ERROR
set errorlevel=1
goto :EOF

rem ================================================================================

:END_LOCAL_RETURN_SUCCESS
endlocal
call :RESET_ERROR
goto :EOF

:END_LOCAL_RETURN_ERROR
endlocal
set errorlevel=1
goto :EOF

rem ********************************************************************************


rem ********************************************************************************

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:INCORRECT_SPECIAL_CALL
echo.
echo ## Incorrect special call.
goto ERROR

rem ================================================================================

:EMPTY_PARAM_FORBIDDEN
echo.
echo ## Empty parameter ("") is forbidden for this position.
goto ERROR

rem ********************************************************************************


rem ********************************************************************************

:CHANGE_PATH
echo.
echo * Changing path to: "%~1" ...
call :RESET_ERROR
cd /d "%~1"
if %errorlevel% neq 0 goto RETURN_ERROR
goto RETURN_SUCCESS

:CHANGE_PATH_SILENT
call :RESET_ERROR
cd /d "%~1"
if %errorlevel% neq 0 goto RETURN_ERROR
goto RETURN_SUCCESS

:RESTORE_PATH
if "%CD%"=="%SaveCD%" goto RETURN_SUCCESS
echo.
echo * Restoring path to: "%SaveCD%" ...
cd /d "%SaveCD%"
if "%CD%"=="%SaveCD%" goto RETURN_SUCCESS
goto CANT_RESTORE_PATH

:RESTORE_PATH_SILENT
if "%CD%"=="%SaveCD%" goto RETURN_SUCCESS
cd /d "%SaveCD%"
if "%CD%"=="%SaveCD%" goto RETURN_SUCCESS

:CANT_RESTORE_PATH
echo.
echo ## FATAL ERROR:
echo Can not restore path to: "%SaveCD%".
echo.
echo Batch processing terminated!
echo 
pause
exit

rem ********************************************************************************

:ERROR
if "%~0"=="$MAPPDISTR.cmd" goto SKIP_ERROR_PAUSE
echo 
if not "%$cmd_plain%"=="1" pause

:SKIP_ERROR_PAUSE
call :RESTORE_PATH

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$MAPPDISTR.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ********************************************************************************
