@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
if "%~0"=="$NDRVMAP.cmd" goto START

if not "%$cmd_plain%"=="1" cls
echo 
echo  Network Drive Mapping Utility (based on "NET USE" command) 
echo 
goto START

:SYNTAX
if "%~0"=="$NDRVMAP.cmd" goto INCORRECT_NESTED_CALL
echo.
echo  Supported parameters: 
echo.
echo 1) Required: ^<Drive Letter^> with colon
echo 2) Required: ^<Net Share Path^>
echo 3) Optional: ^<Persistence Keyword^>  "Persistent" (case insensitive)
echo.
echo  Examples: 
echo.
echo $ndrvmap X: \\Server\Share
echo $ndrvmap M: \\Mercury\Movies /Persistent
echo.
echo *** Use "?", "/?", "-?" or no parameters to see this help. ***
goto FINISH

:START
setlocal
set errorlevel=0
set errorlevel=

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%2]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAMS_FORBIDDEN

if not [%2]==[] goto NOT_SYNTAX_PARAMS
if "%~1"==""    goto SYNTAX
if "%~1"=="?"   goto SYNTAX
if "%~1"=="/?"  goto SYNTAX
if "%~1"=="-?"  goto SYNTAX
:NOT_SYNTAX_PARAMS

if     [%2]==[] goto INCORRECT_PARAMS
if not [%4]==[] goto INCORRECT_PARAMS

set DriveName=%~1
set NetSharePath=%~2
set PersistenceKeyword=%~3

if "%PersistenceKeyword%"=="" goto TEMPORARY
if /i not "%PersistenceKeyword%"=="/Persistent" goto INCORRECT_PERSISTENCE_KEYWORD
set Persistent=Yes
goto PERSISTENT_PARSED
:TEMPORARY
set Persistent=No
:PERSISTENT_PARSED

set Command=net use "%DriveName%" "%NetSharePath%" /persistent:%Persistent%

if "%~0"=="$NDRVMAP.cmd" goto SKIP_CONFIRM
echo.
echo  Drive Name: %DriveName%
echo  Share Path: %NetSharePath%
echo  Persistent: %Persistent%
echo.
echo 
echo  CONFIRM DISK CREATION:  ("Ctrl+C"  break off) 
echo.
pause
:SKIP_CONFIRM

echo.
echo  %Command%
echo.
echo * Mapping the disk ...
echo.
%Command%
if %errorlevel% neq 0 goto FAILURE

:SUCCESS
if "%~0"=="$NDRVMAP.cmd" goto FINISH
echo.
echo  DISK MAP  SUCCESS 
echo 
goto FINISH

:FAILURE
if "%~0"=="$NDRVMAP.cmd" goto ERROR
echo.
echo  ## DISK MAP  FAILURE 
echo 
goto ERROR

:INCORRECT_PARAMS
echo.
echo ## Incorrect number of parameters. Two or three expected:
echo ## Drive Name (with colon), Net Share Path and Persistence Keyword (opt.).
goto ERROR

:INCORRECT_PERSISTENCE_KEYWORD
echo.
echo ## Incorrect Persistence Keyword.
echo ## "Persistent" expected (the case doesn't have a matter).
goto ERROR

rem ================================================================================

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:EMPTY_PARAMS_FORBIDDEN
echo.
echo ## Empty parameters ("") are forbidden.
goto ERROR

:ERROR
if "%~0"=="$NDRVMAP.cmd" goto SET_ERROR
echo 
if not "%$cmd_plain%"=="1" pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$NDRVMAP.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ================================================================================
