@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
if "%~0"=="$NDRVUNMAP.cmd" goto START

if not "%$cmd_plain%"=="1" cls
echo 
echo  Network Drive Unmapping Utility (based on "NET USE" command) 
echo 
goto START

:SYNTAX
if "%~0"=="$NDRVUNMAP.cmd" goto INCORRECT_NESTED_CALL
echo.
echo One parameter is required: ^<Drive Name^> with colon.
echo.
echo  Examples: 
echo.
echo $ndrvunmap Z:
echo.
echo *** Use "?", "/?", "-?" or no parameters to see this help. ***
goto FINISH

:START
setlocal
set errorlevel=0
set errorlevel=

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%2]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAMS_FORBIDDEN

if not [%2]==[] goto NOT_SYNTAX_PARAMS
if "%~1"==""    goto SYNTAX
if "%~1"=="?"   goto SYNTAX
if "%~1"=="/?"  goto SYNTAX
if "%~1"=="-?"  goto SYNTAX
:NOT_SYNTAX_PARAMS

if not [%2]==[] goto TOO_MANY_PARAMS

set DriveName=%~1
set Command=net use "%DriveName%" /delete

if "%~0"=="$NDRVUNMAP.cmd" goto SKIP_CONFIRM
echo.
echo  Drive Name: %DriveName%
echo.
echo 
echo  CONFIRM DISK DELETION:  ("Ctrl+C"  break off) 
echo.
pause
:SKIP_CONFIRM

echo.
echo  %Command%
echo.
echo * Unmapping the disk ...
echo.
%Command%
if %errorlevel% neq 0 goto FAILURE

:SUCCESS
if "%~0"=="$NDRVUNMAP.cmd" goto FINISH
echo.
echo  DISK UNMAP  SUCCESS 
echo 
goto FINISH

:FAILURE
if "%~0"=="$NDRVUNMAP.cmd" goto ERROR
echo.
echo  ## DISK UNMAP  FAILURE 
echo 
goto ERROR

:TOO_MANY_PARAMS
echo.
echo ## Too many parameters. Only one expected: Drive Name (with colon).
goto ERROR

rem ================================================================================

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:EMPTY_PARAMS_FORBIDDEN
echo.
echo ## Empty parameters ("") are forbidden.
goto ERROR

:ERROR
if "%~0"=="$NDRVUNMAP.cmd" goto SET_ERROR
echo 
if not "%$cmd_plain%"=="1" pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$NDRVUNMAP.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ================================================================================
