@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
goto START

:TITLE
if "%~0"=="$NEWCON.cmd" goto INCORRECT_NESTED_CALL
if not "%$cmd_plain%"=="1" cls
echo 
echo  CMD-Console Launching Utility (based on "START"-command) 
echo 
echo.
echo Parameters are not supported (except "?", "/?" and "-?" to see this title).
goto FINISH

:START
setlocal
set errorlevel=0
set errorlevel=

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%2]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAMS_FORBIDDEN

if not [%2]==[] goto PARAMS_NOT_SUPPORTED
if "%~1"=="?"   goto TITLE
if "%~1"=="/?"  goto TITLE
if "%~1"=="-?"  goto TITLE
if not [%1]==[] goto PARAMS_NOT_SUPPORTED

if "%SystemDrive%"=="" goto SYSTEM_DRIVE_NOT_DEF

set $cmd_plain=1

echo * Starting CMD-Console ...
start /max "CMD-Console" /D "%SystemDrive%\" "cmd.exe"
if %errorlevel% neq 0 goto ERROR
goto :EOF

rem ================================================================================

:PARAMS_NOT_SUPPORTED
echo.
echo ## Parameters are not supported (except "?", "/?" and "-?").
goto ERROR

:SYSTEM_DRIVE_NOT_DEF
echo.
echo ## Environment variable "PROCESSOR_ARCHITECTURE" is not defined.
goto ERROR

rem ================================================================================

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:EMPTY_PARAMS_FORBIDDEN
echo.
echo ## Empty parameters ("") are forbidden.
goto ERROR

rem ================================================================================

:ERROR
if "%~0"=="$NEWCON.cmd" goto SET_ERROR
echo 
if not "%$cmd_plain%"=="1" pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$NEWCON.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ================================================================================
