@echo off
rem ********************************************************************************
rem *** Command Line Utilities; Author: Sergei Kitaev ******************************
rem ********************************************************************************
goto START

:SYNTAX
if "%~0"=="$SYSLOGOFF.cmd" goto INCORRECT_NESTED_CALL
if not "%$cmd_plain%"=="1" cls
echo 
echo  System Log-off Utility (based on "SHUTDOWN"-command) 
echo 
echo.
echo One parameter-keyword is supported: "forced" (case insensitive).
echo.
echo  Examples: 
echo.
echo $SysLogoff
echo $SysLogoff Forced
echo.
echo *** Use "?", "/?", "-?" or no parameters to see this help. ***
goto FINISH

:START
setlocal
set errorlevel=0
set errorlevel=

if "%cmdextversion%"=="" goto INCORRECT_CMDEXT_VERSION
if not cmdextversion 2   goto INCORRECT_CMDEXT_VERSION

if [%1]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%2]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%3]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%4]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%5]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%6]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%7]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%8]==[""] goto EMPTY_PARAMS_FORBIDDEN
if [%9]==[""] goto EMPTY_PARAMS_FORBIDDEN

if not [%2]==[] goto NOT_SYNTAX_PARAMS
if "%~1"=="?"   goto SYNTAX
if "%~1"=="/?"  goto SYNTAX
if "%~1"=="-?"  goto SYNTAX
:NOT_SYNTAX_PARAMS

if not [%2]==[] goto INCORRECT_PARAMS

set Keyword=%~1

if "%Keyword%"=="" goto NORMAL_MODE
if /i not "%Keyword%"=="forced" goto INCORRECT_PARAMS
set Command=shutdown -l -f
goto CONFIRM_ACTION

:NORMAL_MODE
set Command=shutdown -l

:CONFIRM_ACTION
if "%~0"=="$SYSLOGOFF.cmd" goto PERFORM_ACTION
if not "%$cmd_plain%"=="1" cls

if /i "%Keyword%"=="forced" goto CONFIRM_FORCED
echo 
echo  LOG OFF CURRENT USER:  ("Ctrl+C"  break off) 
echo.
pause
goto PERFORM_ACTION

:CONFIRM_FORCED
echo 
echo  LOG OFF CURRENT USER  FORCED:  ("Ctrl+C"  break off) 
echo.
pause

:PERFORM_ACTION
call :EXEC_CMD %Command%
if %errorlevel% neq 0 goto ERROR

exit

rem ================================================================================

:INCORRECT_PARAMS
echo.
echo ## Incorrect parameters.
echo ## One parameter-keyword is admissible: forced
goto ERROR

rem ================================================================================

:EXEC_CMD
echo.
echo  %* ...
echo.
%*
goto :EOF

rem ================================================================================

:INCORRECT_CMDEXT_VERSION
echo.
echo ## Incorrect Version of CMD-Extensions. Version 2 or later is required.
goto ERROR

:INCORRECT_NESTED_CALL
echo.
echo ## Incorrect nested call.
goto ERROR

:EMPTY_PARAMS_FORBIDDEN
echo.
echo ## Empty parameters ("") are forbidden.
goto ERROR

:ERROR
if "%~0"=="$SYSLOGOFF.cmd" goto SET_ERROR
echo 
if not "%$cmd_plain%"=="1" pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="$SYSLOGOFF.cmd" goto :EOF
echo.
if not "%$cmd_plain%"=="1" pause
goto :EOF

rem ================================================================================
