﻿//**************************************************************************************************
//
// "KernelUtils" -- STATIC LIBRARY OF UTILITIES FOR DRIVERS (UNITING HEADER FILE).
//
// * REQUIRED FUNCTION CALLING DEFAULT FORMAT FOR USER PROJECT -- "STDCALL".
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once

#ifndef $KERNEL_UTILS_H
#define $KERNEL_UTILS_H

//==================================================================================================

// === Standatd system headers (DDK and WDF): ===
#include <NTDDK.h>
#include <WDF.h>

// === Standart general headers (CTR): ===
#include <StdArg.h>

// === Key Definitions (preprocessor): ===
#define $KERNEL_MODE 1
#include <KeyDefs.h>


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// THEMATIC HEADERS (SECTIONS):
//
//==================================================================================================

#if __cplusplus
   extern "C" {
#endif

//--------------------------------------------------------------------------------------------------

#include "Sections\KernelUtils.Settings.h"
#include "Sections\KernelUtils.String.h"
#include "Sections\KernelUtils.Trace.h"
#include "Sections\KernelUtils.FatalError.h"
#include "Sections\KernelUtils.IoChecks.h"
#include "Sections\KernelUtils.IoBuffer.h"
#include "Sections\KernelUtils.Helpers.h"
#include "Sections\KernelUtils.WdfHelpers.h"

//--------------------------------------------------------------------------------------------------

#if __cplusplus
   } // extern "C"
#endif

//==================================================================================================

#endif // $KERNEL_UTILS_H
