﻿#pragma once

#ifndef $KERNEL_UTILS_H
   #error "This header file is designed to be included only from 'KernelUtils.h'."
#endif

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// MACROCONSTANTS:
//
//==================================================================================================

#define $DBG_PRINT_BUFFER_CCH    (512)


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// CATEGORY MESSAGES:
//
//==================================================================================================

#if DBG
   #define $DBG_PRINT(message) \
      $Trace(message)
   #define $DBG_PRINTF(_messageFmtAndArguments_) \
      $TracefMessage _messageFmtAndArguments_

   #define $DBG_PRINT_INFORMATION(message) \
      $TraceInformation(message)
   #define $DBG_PRINTF_INFORMATION(_messageFmtAndArguments_) \
      $TracefInformation _messageFmtAndArguments_

   #define $DBG_PRINT_WARNING(message) \
      $TraceWarning(message)
   #define $DBG_PRINTF_WARNING(_messageFmtAndArguments_) \
      $TracefWarning _messageFmtAndArguments_

   #define $DBG_PRINT_ERROR(message) \
      $TraceError(message)
   #define $DBG_PRINTF_ERROR(_messageFmtAndArguments_) \
      $TracefError _messageFmtAndArguments_

   #define $DBG_PRINT_OPERATION(operation) \
      $TraceOperation(operation)
   #define $DBG_PRINTF_OPERATION(_operationFmtAndArguments_) \
      $TracefOperation _operationFmtAndArguments_
#else
   #define $DBG_PRINT(message)                                          $VOID_VALUE
   #define $DBG_PRINTF(_messageFmtAndArguments_)                        $VOID_VALUE

   #define $DBG_PRINT_INFORMATION(message)                              $VOID_VALUE
   #define $DBG_PRINTF_INFORMATION(_messageFmtAndArguments_)            $VOID_VALUE

   #define $DBG_PRINT_WARNING(message)                                  $VOID_VALUE
   #define $DBG_PRINTF_WARNING(_messageFmtAndArguments_)                $VOID_VALUE

   #define $DBG_PRINT_ERROR(message)                                    $VOID_VALUE
   #define $DBG_PRINTF_ERROR(_messageFmtAndArguments_)                  $VOID_VALUE

   #define $DBG_PRINT_OPERATION(operation)                              $VOID_VALUE
   #define $DBG_PRINTF_OPERATION(_operationFmtAndArguments_)            $VOID_VALUE
#endif


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// SPECIAL MESSAGES:
//
//==================================================================================================

#if DBG
   #define $DBG_PRINT_CURRENT_IRQL() \
      $TraceCurrentIrql()
   #define $DBG_PRINT_FUNCTION_FAILURE(functionName) \
      $TraceFunctionFailure(functionName)
   #define $DBG_PRINT_FUNCTION_FAILURE_WITH_STATUS(functionName,status) \
      $TraceFunctionFailureWithStatus((functionName),(status))

   #define $DBG_PRINT_IDENTIFIER(identifier) \
      $TraceIdentifier(identifier)

   #define $DBG_PRINT_UNSUPPORTED_CTL_CODE(controlCode) \
      $TraceUnsupportedIoControlCode(controlCode)
   #define $DBG_PRINT_UNSUPPORTED_CM_RESOURCE_TYPE(resourceType) \
      $TraceUnsupportedCmResourceType(resourceType)

   #define $DBG_PRINT_INPUT_TRANSFER(bytes) \
      $TraceInputTransfer(bytes)
   #define $DBG_PRINT_OUTPUT_TRANSFER(bytes) \
      $TraceOutputTransfer(bytes)

   #define $DBG_PRINT_IN_FUNCTION() \
      $TraceInFunction(__FUNCTION__)
   #define $DBG_PRINT_OUT_OF_FUNCTION() \
      $TraceOutOfFunction(__FUNCTION__)
   #define $DBG_PRINT_OUT_OF_FUNCTION_WITH_STATUS(status) \
      $TraceOutOfFunctionWithStatus(__FUNCTION__,(status))
#else
   #define $DBG_PRINT_CURRENT_IRQL()                                    $VOID_VALUE
   #define $DBG_PRINT_FUNCTION_FAILURE(functionName)                    $VOID_VALUE
   #define $DBG_PRINT_FUNCTION_FAILURE_WITH_STATUS(functionName,status) $VOID_VALUE

   #define $DBG_PRINT_IDENTIFIER(identifier)                            $VOID_VALUE

   #define $DBG_PRINT_UNSUPPORTED_CTL_CODE(controlCode)                 $VOID_VALUE
   #define $DBG_PRINT_UNSUPPORTED_CM_RESOURCE_TYPE(type)                $VOID_VALUE

   #define $DBG_PRINT_OUTPUT_TRANSFER(bytes)                            $VOID_VALUE
   #define $DBG_PRINT_INPUT_TRANSFER(bytes)                             $VOID_VALUE

   #define $DBG_PRINT_IN_FUNCTION()                                     $VOID_VALUE
   #define $DBG_PRINT_OUT_OF_FUNCTION()                                 $VOID_VALUE
   #define $DBG_PRINT_OUT_OF_FUNCTION_WITH_STATUS(status)               $VOID_VALUE
#endif

#if DBG
   #define $DBG_PRINT_ZERO_INPUT_LENGTH_W() \
      $TraceZeroInputLength($TraceMessageCategory_Warning)
   #define $DBG_PRINT_ZERO_OUTPUT_LENGTH_W() \
      $TraceZeroOutputLength($TraceMessageCategory_Warning)

   #define $DBG_PRINT_NONZERO_INPUT_LENGTH_W() \
      $TraceNonZeroInputLength($TraceMessageCategory_Warning)
   #define $DBG_PRINT_NONZERO_OUTPUT_LENGTH_W() \
      $TraceNonZeroOutputLength($TraceMessageCategory_Warning)

   #define $DBG_PRINT_INCORRECT_INPUT_LENGTH_W() \
      $TraceIncorrectInputLength($TraceMessageCategory_Warning)
   #define $DBG_PRINT_INCORRECT_OUTPUT_LENGTH_W() \
      $TraceIncorrectOutputLength($TraceMessageCategory_Warning)

   #define $DBG_PRINT_INSUFFICIENT_INPUT_LENGTH_W() \
      $TraceInsufficientInputLength($TraceMessageCategory_Warning)
   #define $DBG_PRINT_INSUFFICIENT_OUTPUT_LENGTH_W() \
      $TraceInsufficientOutputLength($TraceMessageCategory_Warning)
#else
   #define $DBG_PRINT_ZERO_INPUT_LENGTH_W()                             $VOID_VALUE
   #define $DBG_PRINT_ZERO_OUTPUT_LENGTH_W()                            $VOID_VALUE

   #define $DBG_PRINT_NONZERO_INPUT_LENGTH_W()                          $VOID_VALUE
   #define $DBG_PRINT_NONZERO_OUTPUT_LENGTH_W()                         $VOID_VALUE

   #define $DBG_PRINT_INCORRECT_INPUT_LENGTH_W()                        $VOID_VALUE
   #define $DBG_PRINT_INCORRECT_OUTPUT_LENGTH_W()                       $VOID_VALUE

   #define $DBG_PRINT_INSUFFICIENT_INPUT_LENGTH_W()                     $VOID_VALUE
   #define $DBG_PRINT_INSUFFICIENT_OUTPUT_LENGTH_W()                    $VOID_VALUE
#endif

#if DBG
   #define $DBG_PRINT_ZERO_INPUT_LENGTH_E() \
      $TraceZeroInputLength($TraceMessageCategory_Error)
   #define $DBG_PRINT_ZERO_OUTPUT_LENGTH_E() \
      $TraceZeroOutputLength($TraceMessageCategory_Error)

   #define $DBG_PRINT_NONZERO_INPUT_LENGTH_E() \
      $TraceNonZeroInputLength($TraceMessageCategory_Error)
   #define $DBG_PRINT_NONZERO_OUTPUT_LENGTH_E() \
      $TraceNonZeroOutputLength($TraceMessageCategory_Error)

   #define $DBG_PRINT_INCORRECT_INPUT_LENGTH_E() \
      $TraceIncorrectInputLength($TraceMessageCategory_Error)
   #define $DBG_PRINT_INCORRECT_OUTPUT_LENGTH_E() \
      $TraceIncorrectOutputLength($TraceMessageCategory_Error)

   #define $DBG_PRINT_INSUFFICIENT_INPUT_LENGTH_E() \
      $TraceInsufficientInputLength($TraceMessageCategory_Error)
   #define $DBG_PRINT_INSUFFICIENT_OUTPUT_LENGTH_E() \
      $TraceInsufficientOutputLength($TraceMessageCategory_Error)
#else
   #define $DBG_PRINT_ZERO_INPUT_LENGTH_E()                             $VOID_VALUE
   #define $DBG_PRINT_ZERO_OUTPUT_LENGTH_E()                            $VOID_VALUE

   #define $DBG_PRINT_NONZERO_INPUT_LENGTH_E()                          $VOID_VALUE
   #define $DBG_PRINT_NONZERO_OUTPUT_LENGTH_E()                         $VOID_VALUE

   #define $DBG_PRINT_INCORRECT_INPUT_LENGTH_E()                        $VOID_VALUE
   #define $DBG_PRINT_INCORRECT_OUTPUT_LENGTH_E()                       $VOID_VALUE

   #define $DBG_PRINT_INSUFFICIENT_INPUT_LENGTH_E()                     $VOID_VALUE
   #define $DBG_PRINT_INSUFFICIENT_OUTPUT_LENGTH_E()                    $VOID_VALUE
#endif

//==================================================================================================
