﻿#pragma once

#ifndef $KERNEL_UTILS_H
   #error "This header file is designed to be included only from 'KernelUtils.h'."
#endif

#include "KernelUtils.FatalErrorDefs.h"
#include "KernelUtils.AssertionDefs.h"

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// FATAL ERROR SUPPORT:
//
//==================================================================================================

void $RaiseFatalError($PCASZ pcaszMessage);
void $RaiseFatalErrorWithStatus(NTSTATUS status,$PCASZ pcaszMessage);

void $RaisefFatalError($PCASZ pcaszMessageFmt, ... );
void $RaisefFatalErrorWithStatus(NTSTATUS status,$PCASZ pcaszMessageFmt, ... );

void $VRaisefFatalError($PCASZ pcaszMessageFmt,va_list argList);
void $VRaisefFatalErrorWithStatus(NTSTATUS status,$PCASZ pcaszMessageFmt,va_list argList);

//--------------------------------------------------------------------------------------------------

void $RaiseFatalErrorDbg( $PCASZ pcaszSourceFile OPTIONAL,
                          int nLineNo OPTIONAL,
                          $PCASZ pcaszMessage );
void $RaiseFatalErrorWithStatusDbg( $PCASZ pcaszSourceFile OPTIONAL, int nLineNo OPTIONAL,
                                   NTSTATUS status, $PCASZ pcaszMessage );

void $RaisefFatalErrorDbg( $PCASZ pcaszSourceFile OPTIONAL, int nLineNo OPTIONAL,
                           $PCASZ pcaszMessageFmt, ... );
void $RaisefFatalErrorWithStatusDbg( $PCASZ pcaszSourceFile OPTIONAL, int nLineNo OPTIONAL,
                                     NTSTATUS status, $PCASZ pcaszMessageFmt, ... );

void $VRaisefFatalErrorDbg( $PCASZ pcaszSourceFile OPTIONAL, int nLineNo OPTIONAL,
                            $PCASZ pcaszMessageFmt, va_list argList );
void $VRaisefFatalErrorWithStatusDbg( $PCASZ pcaszSourceFile OPTIONAL, int nLineNo OPTIONAL,
                                      NTSTATUS status, $PCASZ pcaszMessageFmt, va_list argList );

//==================================================================================================

void $RaiseFatalError_FunctionFailure($PCASZ pcaszFunctionName);
void $RaiseFatalError_FunctionFailureWithStatus($PCASZ pcaszFunctionName,NTSTATUS status);

//--------------------------------------------------------------------------------------------------

void $RaiseFatalErrorDbg_FunctionFailure( $PCASZ pcaszSourceFile OPTIONAL,
                                          int nLineNo OPTIONAL,
                                          $PCASZ pcaszFunctionName );
void $RaiseFatalErrorDbg_FunctionFailureWithStatus
(
   $PCASZ pcaszSourceFile OPTIONAL, int nLineNo OPTIONAL,
   $PCASZ pcaszFunctionName, NTSTATUS status
);

//==================================================================================================

void $RaiseFatalError_AssertionFailure($PCASZ pcaszCallingFunctionName);

void $RaiseFatalErrorDbg_AssertionFailure( $PCASZ pcaszSourceFile OPTIONAL,
                                           int nLineNo OPTIONAL,
                                           $PCASZ pcaszFailedExpression );

//==================================================================================================
