﻿#pragma once

#ifndef $KERNEL_UTILS_H
   #error "This header file is designed to be included only from 'KernelUtils.h'."
#endif

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// FATAL ERROR DEFS (WITHOUT STATUS):
//
//==================================================================================================

#if DBG
   #define $RAISE_FATAL_ERROR(message) \
      $RaiseFatalErrorDbg(__FILE__,__LINE__,(message))

   #define $RAISE_FATAL_ERROR_1(messageFmt,a1) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1) )
   #define $RAISE_FATAL_ERROR_2(messageFmt,a1,a2) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2) )
   #define $RAISE_FATAL_ERROR_3(messageFmt,a1,a2,a3) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3) )
   #define $RAISE_FATAL_ERROR_4(messageFmt,a1,a2,a3,a4) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4) )
   #define $RAISE_FATAL_ERROR_5(messageFmt,a1,a2,a3,a4,a5) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4),(a5) )
   #define $RAISE_FATAL_ERROR_6(messageFmt,a1,a2,a3,a4,a5,a6) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6) )
   #define $RAISE_FATAL_ERROR_7(messageFmt,a1,a2,a3,a4,a5,a6,a7) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7) )
   #define $RAISE_FATAL_ERROR_8(messageFmt,a1,a2,a3,a4,a5,a6,a7,a8) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8) )
   #define $RAISE_FATAL_ERROR_9(messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9) )
   #define $RAISE_FATAL_ERROR_10(messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) \
      $RaisefFatalErrorDbg( __FILE__, __LINE__, \
         (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9),(a10) )

   #define $RAISE_FATAL_ERROR_FUNCTION_FAILURE(functionName) \
      $RaiseFatalErrorDbg_FunctionFailure(__FILE__,__LINE__,(functionName))
#else
   #define $RAISE_FATAL_ERROR(message) \
      $RaiseFatalError((message))

   #define $RAISE_FATAL_ERROR_1(messageFmt,a1) \
      $RaisefFatalError( (messageFmt), (a1) )
   #define $RAISE_FATAL_ERROR_2(messageFmt,a1,a2) \
      $RaisefFatalError((messageFmt),(a1),(a2))
   #define $RAISE_FATAL_ERROR_3(messageFmt,a1,a2,a3) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3))
   #define $RAISE_FATAL_ERROR_4(messageFmt,a1,a2,a3,a4) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4))
   #define $RAISE_FATAL_ERROR_5(messageFmt,a1,a2,a3,a4,a5) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4),(a5))
   #define $RAISE_FATAL_ERROR_6(messageFmt,a1,a2,a3,a4,a5,a6) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4),(a5),(a6))
   #define $RAISE_FATAL_ERROR_7(messageFmt,a1,a2,a3,a4,a5,a6,a7) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4),(a5),(a6),(a7))
   #define $RAISE_FATAL_ERROR_8(messageFmt,a1,a2,a3,a4,a5,a6,a7,a8) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8))
   #define $RAISE_FATAL_ERROR_9(messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9))
   #define $RAISE_FATAL_ERROR_10(messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) \
      $RaisefFatalError((messageFmt),(a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9),(a10))

   #define $RAISE_FATAL_ERROR_FUNCTION_FAILURE(functionName) \
      $RaiseFatalError_FunctionFailure(functionName)
#endif


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// FATAL ERROR DEFS -- WITH STATUS:
//
//==================================================================================================

#if DBG
   #define $RAISE_FATAL_ERROR_WITH_STATUS(status,message) \
      $RaiseFatalErrorWithStatusDbg(__FILE__,__LINE__,(status),(message))

   #define $RAISE_FATAL_ERROR_WITH_STATUS_1(status,messageFmt,a1) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_2(status,messageFmt,a1,a2) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_3(status,messageFmt,a1,a2,a3) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_4(status,messageFmt,a1,a2,a3,a4) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_5(status,messageFmt,a1,a2,a3,a4,a5) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4),(a5) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_6(status,messageFmt,a1,a2,a3,a4,a5,a6) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_7(status,messageFmt,a1,a2,a3,a4,a5,a6,a7) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_8(status,messageFmt,a1,a2,a3,a4,a5,a6,a7,a8) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_9(status,messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_10(status,messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) \
      $RaisefFatalErrorWithStatusDbg( __FILE__, __LINE__, \
         (status), (messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9),(a10) )

   #define $RAISE_FATAL_ERROR_FUNCTION_FAILURE_WITH_STATUS(functionName,status) \
      $RaiseFatalErrorDbg_FunctionFailureWithStatus(__FILE__,__LINE__,(functionName),(status))
#else
   #define $RAISE_FATAL_ERROR_WITH_STATUS(status,message) \
      $RaiseFatalErrorWithStatus(__FILE__,__LINE__,(status),(message))

   #define $RAISE_FATAL_ERROR_WITH_STATUS_1(status,messageFmt,a1) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_2(status,messageFmt,a1,a2) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1),(a2))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_3(status,messageFmt,a1,a2,a3) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1),(a2),(a3))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_4(status,messageFmt,a1,a2,a3,a4) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1),(a2),(a3),(a4))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_5(status,messageFmt,a1,a2,a3,a4,a5) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1),(a2),(a3),(a4),(a5))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_6(status,messageFmt,a1,a2,a3,a4,a5,a6) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1),(a2),(a3),(a4),(a5),(a6))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_7(status,messageFmt,a1,a2,a3,a4,a5,a6,a7) \
      $RaisefFatalErrorWithStatus((status),(messageFmt),(a1),(a2),(a3),(a4),(a5),(a6),(a7))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_8(status,messageFmt,a1,a2,a3,a4,a5,a6,a7,a8) \
      $RaisefFatalErrorWithStatus((status),(messageFmt), (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8))
   #define $RAISE_FATAL_ERROR_WITH_STATUS_9(status,messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9) \
      $RaisefFatalErrorWithStatus( (status), (messageFmt), \
         (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9) )
   #define $RAISE_FATAL_ERROR_WITH_STATUS_10(status,messageFmt,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) \
      $RaisefFatalErrorWithStatus( (status), (messageFmt), \
         (a1),(a2),(a3),(a4),(a5),(a6),(a7),(a8),(a9),(a10) )

   #define $RAISE_FATAL_ERROR_FUNCTION_FAILURE_WITH_STATUS(functionName,status) \
      $RaiseFatalError_FunctionFailureWithStatus((functionName),(status))
#endif

//==================================================================================================
