﻿#pragma once

#ifndef $KERNEL_UTILS_H
   #error "This header file is designed to be included only from 'KernelUtils.h'."
#endif

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// INPUT/OUTPUT BUFFER MANIPULATIONS:
//
//==================================================================================================

BOOLEAN $RetrieveInputBuffer
(
   OUT NTSTATUS* pStatus, WDFREQUEST hRequest, size_t minimumRequiredSize,
   OUT $PPCVOID ppcvBuffer, OUT size_t* pLength OPTIONAL
);

BOOLEAN $RetrieveOutputBuffer
(
   OUT NTSTATUS* pStatus, WDFREQUEST hRequest, size_t minimumRequiredSize,
   OUT $PPVOID ppvBuffer, OUT size_t* pLength OPTIONAL
);

//--------------------------------------------------------------------------------------------------

BOOLEAN $RetrieveUserInputBuffer
(
   OUT NTSTATUS* pStatus, WDFREQUEST hRequest, size_t minimumRequiredSize,
   OUT $PPCVOID ppcvSafeBuffer, OUT size_t* pLength OPTIONAL
);

BOOLEAN $RetrieveUserOutputBuffer
(
   OUT NTSTATUS* pStatus, WDFREQUEST hRequest, size_t minimumRequiredSize,
   OPTIONAL OUT $PPVOID ppvSafeBuffer, OUT size_t* pLength OPTIONAL,
   OUT WDFMEMORY* phMemory, OUT $PPVOID ppvUnsafeBuffer
);

//--------------------------------------------------------------------------------------------------

BOOLEAN $CopyOutputMemoryToUnsafeUserBuffer( OUT NTSTATUS* pStatus,
                                             WDFMEMORY hMemory,
                                             PVOID pvUnsafeBuffer );

//==================================================================================================
