﻿#pragma once

#ifndef $KERNEL_UTILS_H
   #error "This header file is designed to be included only from 'KernelUtils.h'."
#endif

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// DIFFERENT CHECKS:
//
//==================================================================================================

BOOLEAN $CheckInputLength(OUT NTSTATUS* pStatus,BOOLEAN bCondition);
BOOLEAN $CheckOutputLength(OUT NTSTATUS* pStatus,BOOLEAN bCondition);

BOOLEAN $CheckInputLengthIsZero(OUT NTSTATUS* pStatus,size_t length);
BOOLEAN $CheckOutputLengthIsZero(OUT NTSTATUS* pStatus,size_t length);

BOOLEAN $CheckInputLengthNotZero(OUT NTSTATUS* pStatus,size_t length);
BOOLEAN $CheckOutputLengthNotZero(OUT NTSTATUS* pStatus,size_t length);

BOOLEAN $CheckInputOutputLengthsAreZero( OUT NTSTATUS* pStatus,
                                         size_t inputLength,
                                         size_t ouputLength );
BOOLEAN $CheckInputOutputLengthsNotZero( OUT NTSTATUS* pStatus,
                                         size_t inputLength,
                                         size_t ouputLength );

BOOLEAN $CheckInputLengthIs(OUT NTSTATUS* pStatus,size_t length,size_t expectedLength);
BOOLEAN $CheckOutputLengthIs(OUT NTSTATUS* pStatus,size_t length,size_t expectedLength);

BOOLEAN $CheckSufficientInputLength(OUT NTSTATUS* pStatus,size_t length,size_t minimumLength);
BOOLEAN $CheckSufficientOutputLength(OUT NTSTATUS* pStatus,size_t length,size_t minimumLength);

//==================================================================================================
