﻿#pragma once

#ifndef $KERNEL_UTILS_H
   #error "This header file is designed to be included only from 'KernelUtils.h'."
#endif

#include "KernelUtils.DbgPrintDefs.h"

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// TRACE MESSAGE CATEGORY (ENUMERATION):
//
//==================================================================================================

typedef enum
{
   $TraceMessageCategory_Neutral,
   $TraceMessageCategory_Information,
   $TraceMessageCategory_Warning,
   $TraceMessageCategory_Error
}
$TraceMessageCategory, *$PTraceMessageCategory;
typedef const $TraceMessageCategory* $PCTraceMessageCategory;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// TRACE SUPPORT:
//
//==================================================================================================

NTSTATUS $Trace  ($PCASZ pcaszMessage);
NTSTATUS $Tracef ($PCASZ pcaszMessageFmt, ... );
NTSTATUS $VTracef($PCASZ pcaszMessageFmt,va_list argList);

NTSTATUS $TraceInformation  ($PCASZ pcaszMessage);
NTSTATUS $TracefInformation ($PCASZ pcaszMessageFmt, ... );
NTSTATUS $VTracefInformation($PCASZ pcaszMessageFmt,va_list argList);

NTSTATUS $TraceWarning  ($PCASZ pcaszMessage);
NTSTATUS $TracefWarning ($PCASZ pcaszMessageFmt, ... );
NTSTATUS $VTracefWarning($PCASZ pcaszMessageFmt,va_list argList);

NTSTATUS $TraceError  ($PCASZ pcaszMessage);
NTSTATUS $TracefError ($PCASZ pcaszMessageFmt, ... );
NTSTATUS $VTracefError($PCASZ pcaszMessageFmt,va_list argList);

NTSTATUS $TraceOperation  ($PCASZ pcaszOperation);
NTSTATUS $TracefOperation ($PCASZ pcaszOperationFmt, ... );
NTSTATUS $VTracefOperation($PCASZ pcaszOperationFmt,va_list argList);

NTSTATUS $TraceMessage  ( $TraceMessageCategory category, $PCASZ pcaszMessage );
NTSTATUS $TracefMessage ( $TraceMessageCategory category, $PCASZ pcaszMessageFmt, ... );
NTSTATUS $VTracefMessage( $TraceMessageCategory category,
                          $PCASZ pcaszMessageFmt,
                          va_list argList );

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceFunctionFailure($PCASZ pcaszFunctionName);
NTSTATUS $TraceFunctionFailureWithStatus($PCASZ pcaszFunctionName,NTSTATUS status);
NTSTATUS $TraceCurrentIrql();

NTSTATUS $TraceIdentifier($PCASZ pcaszIdentifier);

NTSTATUS $TraceUnsupportedIoControlCode($UINT uControlCode);
NTSTATUS $TraceUnsupportedCmResourceType(UCHAR byResourceType);

NTSTATUS $TraceZeroInputLength($TraceMessageCategory category);
NTSTATUS $TraceZeroOutputLength($TraceMessageCategory category);

NTSTATUS $TraceNonZeroInputLength($TraceMessageCategory category);
NTSTATUS $TraceNonZeroOutputLength($TraceMessageCategory category);

NTSTATUS $TraceIncorrectInputLength($TraceMessageCategory category);
NTSTATUS $TraceIncorrectOutputLength($TraceMessageCategory category);

NTSTATUS $TraceInsufficientInputLength($TraceMessageCategory category);
NTSTATUS $TraceInsufficientOutputLength($TraceMessageCategory category);

NTSTATUS $TraceInputTransfer(size_t bytes);
NTSTATUS $TraceOutputTransfer(size_t bytes);

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceInFunction($PCASZ pcaszFunctionName);
NTSTATUS $TraceOutOfFunction($PCASZ pcaszFunctionName);
NTSTATUS $TraceOutOfFunctionWithStatus($PCASZ pcaszFunctionName,NTSTATUS status);

//==================================================================================================
