﻿//**************************************************************************************************
//
// KEY DEFINITIONS -- TYPES.
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once

#ifndef $KEY_DEFS_TYPES_H
#define $KEY_DEFS_TYPES_H

//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Void type/pointers:
//
//==================================================================================================

typedef void                     $VOID;
typedef const void               $CVOID;

typedef $VOID           *        $PVOID;
typedef $CVOID          *        $PCVOID;
typedef $VOID           *  const $CPVOID;
typedef $CVOID          *  const $CPCVOID;

typedef $PVOID          *        $PPVOID;
typedef $PCVOID         *        $PPCVOID;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Explicit 8-bit integer (signed/unsigned):
//
//==================================================================================================

typedef __int8                   $INT8;
typedef const $INT8              $CINT8;

typedef $INT8           *        $PINT8;
typedef $CINT8          *        $PCINT8;
typedef $INT8           *  const $CPINT8;
typedef $CINT8          *  const $CPCINT8;

typedef $PINT8          *        $PPINT8;
typedef $PCINT8         *        $PPCINT8;

//--------------------------------------------------------------------------------------------------

typedef unsigned __int8          $UINT8;
typedef const $UINT8             $CUINT8;

typedef $UINT8          *        $PUINT8;
typedef $CUINT8         *        $PCUINT8;
typedef $UINT8          *  const $CPUINT8;
typedef $CUINT8         *  const $CPCUINT8;

typedef $PUINT8         *        $PPUINT8;
typedef $PCUINT8        *        $PPCUINT8;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Explicit 16-bit integer (signed/unsigned):
//
//==================================================================================================

typedef __int16                  $INT16;
typedef const $INT16             $CINT16;

typedef $INT16          *        $PINT16;
typedef $CINT16         *        $PCINT16;
typedef $INT16          *  const $CPINT16;
typedef $CINT16         *  const $CPCINT16;

typedef $PINT16         *        $PPINT16;
typedef $PCINT16        *        $PPCINT16;

//--------------------------------------------------------------------------------------------------

typedef unsigned __int16         $UINT16;
typedef const $UINT16            $CUINT16;

typedef $UINT16         *        $PUINT16;
typedef $CUINT16        *        $PCUINT16;
typedef $UINT16         *  const $CPUINT16;
typedef $CUINT16        *  const $CPCUINT16;

typedef $PUINT16        *        $PPUINT16;
typedef $PCUINT16       *        $PPCUINT16;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Explicit 32-bit integer (signed/unsigned):
//
//==================================================================================================

typedef __int32                  $INT32;
typedef const $INT32             $CINT32;

typedef $INT32          *        $PINT32;
typedef $CINT32         *        $PCINT32;
typedef $INT32          *  const $CPINT32;
typedef $CINT32         *  const $CPCINT32;

typedef $PINT32         *        $PPINT32;
typedef $PCINT32        *        $PPCINT32;

//--------------------------------------------------------------------------------------------------

typedef unsigned __int32         $UINT32;
typedef const $UINT32            $CUINT32;

typedef $UINT32         *        $PUINT32;
typedef $CUINT32        *        $PCUINT32;
typedef $UINT32         *  const $CPUINT32;
typedef $CUINT32        *  const $CPCUINT32;

typedef $PUINT32        *        $PPUINT32;
typedef $PCUINT32       *        $PPCUINT32;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Explicit 64-bit integer (signed/unsigned):
//
//==================================================================================================

typedef __int64                  $INT64;
typedef const $INT64             $CINT64;

typedef $INT64          *        $PINT64;
typedef $CINT64         *        $PCINT64;
typedef $INT64          *  const $CPINT64;
typedef $CINT64         *  const $CPCINT64;

typedef $PINT64         *        $PPINT64;
typedef $PCINT64        *        $PPCINT64;

//--------------------------------------------------------------------------------------------------

typedef unsigned __int64         $UINT64;
typedef const $UINT64            $CUINT64;

typedef $UINT64         *        $PUINT64;
typedef $CUINT64        *        $PCUINT64;
typedef $UINT64         *  const $CPUINT64;
typedef $CUINT64        *  const $CPCUINT64;

typedef $PUINT64        *        $PPUINT64;
typedef $PCUINT64       *        $PPCUINT64;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Normal integer -- 32 bits (signed/unsigned):
//
//==================================================================================================

typedef $INT32                   $INT;
typedef $CINT32                  $CINT;

typedef $PINT32                  $PINT;
typedef $PCINT32                 $PCINT;
typedef $CPINT32                 $CPINT;
typedef $CPCINT32                $CPCINT;

typedef $PPINT32                 $PPINT;
typedef $PPCINT32                $PPCINT;

//--------------------------------------------------------------------------------------------------

typedef $UINT32                  $UINT;
typedef $CUINT32                 $CUINT;

typedef $PUINT32                 $PUINT;
typedef $PCUINT32                $PCUINT;
typedef $CPUINT32                $CPUINT;
typedef $CPCUINT32               $CPCUINT;

typedef $PPUINT32                $PPUINT;
typedef $PPCUINT32               $PPCUINT;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Short integer -- 16 bits (signed/unsigned):
//
//==================================================================================================

typedef $INT16                   $SHORT;
typedef $CINT16                  $CSHORT;

typedef $PINT16                  $PSHORT;
typedef $PCINT16                 $PCSHORT;
typedef $CPINT16                 $CPSHORT;
typedef $CPCINT16                $CPCSHORT;

typedef $PPINT16                 $PPSHORT;
typedef $PPCINT16                $PPCSHORT;

//--------------------------------------------------------------------------------------------------

typedef $UINT16                  $USHORT;
typedef $CUINT16                 $CUSHORT;

typedef $PUINT16                 $PUSHORT;
typedef $PCUINT16                $PCUSHORT;
typedef $CPUINT16                $CPUSHORT;
typedef $CPCUINT16               $CPCUSHORT;

typedef $PPUINT16                $PPUSHORT;
typedef $PPCUINT16               $PPCUSHORT;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Long integer -- 64 bits (signed/unsigned):
//
//==================================================================================================

typedef $INT64                   $LONG;
typedef $CINT64                  $CLONG;

typedef $PINT64                  $PLONG;
typedef $PCINT64                 $PCLONG;
typedef $CPINT64                 $CPLONG;
typedef $CPCINT64                $CPCLONG;

typedef $PPINT64                 $PPLONG;
typedef $PPCINT64                $PPCLONG;

//--------------------------------------------------------------------------------------------------

typedef $UINT64                  $ULONG;
typedef $CUINT64                 $CULONG;

typedef $PUINT64                 $PULONG;
typedef $PCUINT64                $PCULONG;
typedef $CPUINT64                $CPULONG;
typedef $CPCUINT64               $CPCULONG;

typedef $PPUINT64                $PPULONG;
typedef $PPCUINT64               $PPCULONG;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Byte -- 8 bits (unsigned):
//
//==================================================================================================

typedef $UINT8                   $BYTE;
typedef $CUINT8                  $CBYTE;

typedef $PUINT8                  $PBYTE;
typedef $PCUINT8                 $PCBYTE;
typedef $CPUINT8                 $CPBYTE;
typedef $CPCUINT8                $CPCBYTE;

typedef $PPUINT8                 $PPBYTE;
typedef $PPCUINT8                $PPCBYTE;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Single word -- 16 bits (unsigned):
//
//==================================================================================================

typedef $UINT16                  $WORD;
typedef $CUINT16                 $CWORD;

typedef $PUINT16                 $PWORD;
typedef $PCUINT16                $PCWORD;
typedef $CPUINT16                $CPWORD;
typedef $CPCUINT16               $CPCWORD;

typedef $PPUINT16                $PPWORD;
typedef $PPCUINT16               $PPCWORD;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Double word -- 32 bits (unsigned):
//
//==================================================================================================

typedef $UINT32                  $DWORD;
typedef $CUINT32                 $CDWORD;

typedef $PUINT32                 $PDWORD;
typedef $PCUINT32                $PCDWORD;
typedef $CPUINT32                $CPDWORD;
typedef $CPCUINT32               $CPCDWORD;

typedef $PPUINT32                $PPDWORD;
typedef $PPCUINT32               $PPCDWORD;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// "Quattro"-word -- 64 bits (unsigned):
//
//==================================================================================================

typedef $UINT64                  $QWORD;
typedef $CUINT64                 $CQWORD;

typedef $PUINT64                 $PQWORD;
typedef $PCUINT64                $PCQWORD;
typedef $CPUINT64                $CPQWORD;
typedef $CPCUINT64               $CPCQWORD;

typedef $PPUINT64                $PPQWORD;
typedef $PPCUINT64               $PPCQWORD;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Platform specific size type -- 32/64 bits (unsigned/signed):
//
//==================================================================================================

#if _WIN64
typedef unsigned __int64         $SIZE_T;
#else
typedef __w64 unsigned __int32   $SIZE_T;
#endif
typedef const $SIZE_T            $CSIZE_T;

typedef $SIZE_T         *        $PSIZE_T;
typedef $CSIZE_T        *        $PCSIZE_T;
typedef $SIZE_T         *  const $CPSIZE_T;
typedef $CSIZE_T        *  const $CPCSIZE_T;

typedef $PSIZE_T        *        $PPSIZE_T;
typedef $PCSIZE_T       *        $PPCSIZE_T;

//--------------------------------------------------------------------------------------------------

#if _WIN64
typedef __int64                  $SSIZE_T;
#else
typedef __w64 __int32            $SSIZE_T;
#endif
typedef const $SSIZE_T           $CSSIZE_T;

typedef $SSIZE_T        *        $PSSIZE_T;
typedef $CSSIZE_T       *        $PCSSIZE_T;
typedef $SSIZE_T        *  const $CPSSIZE_T;
typedef $CSSIZE_T       *  const $CPCSSIZE_T;

typedef $PSSIZE_T       *        $PPSSIZE_T;
typedef $PCSSIZE_T      *        $PPCSSIZE_T;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Platform specific integer -- 32/64 bits (unsigned/signed):
//
//==================================================================================================

typedef $SIZE_T                  $UINT_PTR;
typedef $CSIZE_T                 $CUINT_PTR;

typedef $PSIZE_T                 $PUINT_PTR;
typedef $PCSIZE_T                $PCUINT_PTR;
typedef $CPSIZE_T                $CPUINT_PTR;
typedef $CPCSIZE_T               $CPCUINT_PTR;

typedef $PPSIZE_T                $PPUINT_PTR;
typedef $PPCSIZE_T               $PPCUINT_PTR;

//--------------------------------------------------------------------------------------------------

typedef $SSIZE_T                 $INT_PTR;
typedef $CSSIZE_T                $CINT_PTR;

typedef $PSSIZE_T                $PINT_PTR;
typedef $PCSSIZE_T               $PCINT_PTR;
typedef $CPSSIZE_T               $CPINT_PTR;
typedef $CPCSSIZE_T              $CPCINT_PTR;

typedef $PPSSIZE_T               $PPINT_PTR;
typedef $PPCSSIZE_T              $PPCINT_PTR;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Normal boolean -- 8 bits (unsigned):
//
//==================================================================================================

typedef $BYTE                    $BOOL;
typedef $CBYTE                   $CBOOL;

typedef $PBYTE                   $PBOOL;
typedef $PCBYTE                  $PCBOOL;
typedef $CPBYTE                  $CPBOOL;
typedef $CPCBYTE                 $CPCBOOL;

typedef $PPBYTE                  $PPBOOL;
typedef $PPCBYTE                 $PPCBOOL;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// 32-bit boolean (unsigned):
//
//==================================================================================================

typedef $UINT32                  $BOOL32;
typedef $CUINT32                 $CBOOL32;

typedef $PUINT32                 $PBOOL32;
typedef $PCUINT32                $PCBOOL32;
typedef $CPUINT32                $CPBOOL32;
typedef $CPCUINT32               $CPCBOOL32;

typedef $PPUINT32                $PPBOOL32;
typedef $PPCUINT32               $PPCBOOL32;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Character -- UNICODE/ANSI/OEM:
//
//==================================================================================================

typedef wchar_t                  $CHAR;
typedef char                     $ACH;
typedef char                     $OCH;

typedef const $CHAR              $CCHAR;
typedef const $ACH               $CACH;
typedef const $OCH               $COCH;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Character pointers -- UNICODE/ANSI/OEM:
//
//==================================================================================================

typedef $CHAR           *        $PCHAR;
typedef $CCHAR          *        $PCCHAR;
typedef $CHAR           *  const $CPCHAR;
typedef $CCHAR          *  const $CPCCHAR;

typedef $PCHAR          *        $PPCHAR;
typedef $PCCHAR         *        $PPCCHAR;

//--------------------------------------------------------------------------------------------------

typedef $ACH            *        $PACH;
typedef $CACH           *        $PCACH;
typedef $ACH            *  const $CPACH;
typedef $CACH           *  const $CPCACH;

typedef $PACH           *        $PPACH;
typedef $PCACH          *        $PPCACH;

//--------------------------------------------------------------------------------------------------

typedef $OCH            *        $POCH;
typedef $COCH           *        $PCOCH;
typedef $OCH            *  const $CPOCH;
typedef $COCH           *  const $CPCOCH;

typedef $POCH           *        $PPOCH;
typedef $PCOCH          *        $PPCOCH;


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// Zero terminated strings -- UNICODE/ANSI/OEM:
//
//==================================================================================================

typedef $PCHAR                   $PSZ;
typedef $PCCHAR                  $PCSZ;
typedef $CPCHAR                  $CPSZ;
typedef $CPCCHAR                 $CPCSZ;

typedef $PSZ            *        $PPSZ;
typedef $PCSZ           *        $PPCSZ;

//--------------------------------------------------------------------------------------------------

typedef $PACH                    $PASZ;
typedef $PCACH                   $PCASZ;
typedef $CPACH                   $CPASZ;
typedef $CPCACH                  $CPCASZ;

typedef $PASZ           *        $PPASZ;
typedef $PCASZ          *        $PPCASZ;

//--------------------------------------------------------------------------------------------------

typedef $POCH                    $POSZ;
typedef $PCOCH                   $PCOSZ;
typedef $CPOCH                   $CPOSZ;
typedef $CPCOCH                  $CPCOSZ;

typedef $POSZ           *        $PPOSZ;
typedef $PCOSZ          *        $PPCOSZ;

//==================================================================================================

#endif // $KEY_DEFS_TYPES_H
