@echo off

if not "%~0"=="#SETTINGS.cmd" goto INCORRECT_CALL

rem ================================================================================

if not defined $wdk_root goto WDK_ROOT_NOT_DEF
if not defined TEMP      goto TEMP_NOT_DEF
if not defined WINDIR    goto WINDIR_NOT_DEF

rem ================================================================================

set #ProjectName=KernelUtils
set #LibRoot=..\Lib\

set #TargetModuleName=%#ProjectName%.lib

set #BuildParameters=-eZ
set #RebuildParameters=

set #OS_for_x86=W2K
set #OS_for_x64=WLH

set #CleanupKeyword_x86_C=chk_%#OS_for_x86%_x86
set #CleanupKeyword_x86_F=fre_%#OS_for_x86%_x86
set #CleanupKeyword_x64_C=chk_%#OS_for_x64%_amd64
set #CleanupKeyword_x64_F=fre_%#OS_for_x64%_amd64

set #OutputDir_x86_C=objchk_%#OS_for_x86%_x86\i386\
set #OutputDir_x86_F=objfre_%#OS_for_x86%_x86\i386\
set #OutputDir_x64_C=objchk_%#OS_for_x64%_amd64\amd64\
set #OutputDir_x64_F=objfre_%#OS_for_x64%_amd64\amd64\

set #OutputModulePath_x86_C=objchk_%#OS_for_x86%_x86\i386\%#TargetModuleName%
set #OutputModulePath_x86_F=objfre_%#OS_for_x86%_x86\i386\%#TargetModuleName%
set #OutputModulePath_x64_C=objchk_%#OS_for_x64%_amd64\amd64\%#TargetModuleName%
set #OutputModulePath_x64_F=objfre_%#OS_for_x64%_amd64\amd64\%#TargetModuleName%

set #LibDir_x86_C=%#LibRoot%x86\Checked\
set #LibDir_x86_F=%#LibRoot%x86\Free\
set #LibDir_x64_C=%#LibRoot%x64\Checked\
set #LibDir_x64_F=%#LibRoot%x64\Free\

set #LibPath_x86_C=%#LibRoot%x86\Checked\%#TargetModuleName%
set #LibPath_x86_F=%#LibRoot%x86\Free\%#TargetModuleName%
set #LibPath_x64_C=%#LibRoot%x64\Checked\%#TargetModuleName%
set #LibPath_x64_F=%#LibRoot%x64\Free\%#TargetModuleName%

goto :EOF

rem ================================================================================

:WDK_ROOT_NOT_DEF
echo.
echo ## Environment variable "$wdk_root" is not defined.
goto ERROR

:TEMP_NOT_DEF
echo.
echo ## Environment variable "TEMP" is not defined.
goto ERROR

:WINDIR_NOT_DEF
echo.
echo ## Environment variable "WINDIR" is not defined.
goto ERROR

rem ================================================================================

:INCORRECT_CALL
echo.
echo ## Incorrect call of "#settings.cmd" (auxiliary batch).
echo 
pause
goto ERROR

rem ================================================================================

:ERROR
set errorlevel=1
goto :EOF

rem ================================================================================
