﻿#include "Precompiled.h"
#include "SharedIncludes.h"

//==================================================================================================

static void VerifyStringRoutineParameterA($PCASZ pcaszString);
static void VerifyStringRoutineParametersA($PCASZ pcaszDest,size_t cchDest,$PCASZ pcaszSource);

//==================================================================================================

size_t $StrLengthA($PCASZ pcasz)
{
   $PCACH pcach;

   VerifyStringRoutineParameterA(pcasz);

   for (pcach=pcasz;;pcach++)
      if (!*pcach)
         return pcach-pcasz;
}

//--------------------------------------------------------------------------------------------------

BOOLEAN $StrCopyA(OUT $PASZ paszDest,size_t cchDest,$PCASZ pcaszSource)
{
   size_t idx;

   VerifyStringRoutineParametersA(paszDest,cchDest,pcaszSource);

   for (idx=0; idx<cchDest; idx++)
      if (!(paszDest[idx]=pcaszSource[idx]))
         return TRUE;

   paszDest[cchDest-1]='\0';

   return FALSE;
}

//--------------------------------------------------------------------------------------------------

BOOLEAN $StrPrintfA(OUT $PASZ paszDest,size_t cchDest,$PCASZ pcaszFormat, ... )
{
   va_list argList;

   VerifyStringRoutineParametersA(paszDest,cchDest,pcaszFormat);

   return $StrVPrintfA( paszDest, cchDest,
      $VA_COMPLEMENT(pcaszFormat,argList) );
}

BOOLEAN $StrVPrintfA(OUT $PASZ paszDest,size_t cchDest,$PCASZ pcaszFormat,va_list argList)
{
   int nCount;

   VerifyStringRoutineParametersA(paszDest,cchDest,pcaszFormat);

   paszDest[cchDest-1]='\0';

   nCount=_vsnprintf(paszDest,cchDest-1,pcaszFormat,argList);

   if (paszDest[cchDest-1])
      $RaiseFatalError("Failure of \"_vsnprintf\" function.");

   return nCount>=0;
}

//==================================================================================================

static void VerifyStringRoutineParameterA($PCASZ pcaszString)
{
   VerifyStringRoutineParameterX((PVOID)pcaszString);
}

static void VerifyStringRoutineParametersA($PCASZ pcaszDest,size_t cchDest,$PCASZ pcaszSource)
{
   VerifyStringRoutineParametersX((PVOID)pcaszDest,cchDest,(PVOID)pcaszSource);
}

//==================================================================================================
