﻿#include "Precompiled.h"
#include "SharedIncludes.h"

//==================================================================================================

static $CPCASZ
   c_pcaszCategorySymbols="-IWE";
static volatile LONG
   sv_nOutputFlag;

//==================================================================================================

NTSTATUS $Trace($PCASZ pcaszMessage)
{
   return $TracefMessage($TraceMessageCategory_Neutral,pcaszMessage);
}

NTSTATUS $Tracef($PCASZ pcaszMessageFmt, ... )
{
   va_list argList;
   return $VTracef($VA_COMPLEMENT(pcaszMessageFmt,argList));
}

NTSTATUS $VTracef($PCASZ pcaszMessageFmt,va_list argList)
{
   return $VTracefMessage($TraceMessageCategory_Neutral,pcaszMessageFmt,argList);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceInformation($PCASZ pcaszMessage)
{
   return $TracefMessage($TraceMessageCategory_Information,pcaszMessage);
}

NTSTATUS $TracefInformation($PCASZ pcaszMessageFmt, ... )
{
   va_list argList;
   return $VTracefInformation($VA_COMPLEMENT(pcaszMessageFmt,argList));
}

NTSTATUS $VTracefInformation($PCASZ pcaszMessageFmt,va_list argList)
{
   return $VTracefMessage($TraceMessageCategory_Information,pcaszMessageFmt,argList);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceWarning($PCASZ pcaszMessage)
{
   return $TracefMessage($TraceMessageCategory_Warning,pcaszMessage);
}

NTSTATUS $TracefWarning($PCASZ pcaszMessageFmt, ... )
{
   va_list argList;
   return $VTracefWarning($VA_COMPLEMENT(pcaszMessageFmt,argList));
}

NTSTATUS $VTracefWarning($PCASZ pcaszMessageFmt,va_list argList)
{
   return $VTracefMessage($TraceMessageCategory_Warning,pcaszMessageFmt,argList);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceError($PCASZ pcaszMessage)
{
   return $TracefMessage($TraceMessageCategory_Error,pcaszMessage);
}

NTSTATUS $TracefError($PCASZ pcaszMessageFmt, ... )
{
   va_list argList;
   return $VTracefError($VA_COMPLEMENT(pcaszMessageFmt,argList));
}

NTSTATUS $VTracefError($PCASZ pcaszMessageFmt,va_list argList)
{
   return $VTracefMessage($TraceMessageCategory_Error,pcaszMessageFmt,argList);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceOperation($PCASZ pcaszOperation)
{
   return $Tracef("* %s ...",pcaszOperation);
}

NTSTATUS $TracefOperation($PCASZ pcaszOperationFmt, ... )
{
   va_list argList;
   return $VTracefOperation($VA_COMPLEMENT(pcaszOperationFmt,argList));
}

NTSTATUS $VTracefOperation($PCASZ pcaszOperationFmt,va_list argList)
{
   $ACH aszOperation[$DBG_PRINT_BUFFER_CCH];
   $StrVPrintfA(aszOperation,$DBG_PRINT_BUFFER_CCH,pcaszOperationFmt,argList);
   return $TraceOperation(aszOperation);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceMessage($TraceMessageCategory category,$PCASZ pcaszMessage)
{
   $ACH     aszTraceOutput[$DBG_PRINT_BUFFER_CCH];
   NTSTATUS status = STATUS_SUCCESS;

   if (($UINT)category>3)
      $RaiseFatalError("Incorrect argument for trace message category.");

   $StrPrintfA(
      aszTraceOutput, $DBG_PRINT_BUFFER_CCH,
      "%s | %c >> %s\r\n",
      $DriverBinaryName(),
      c_pcaszCategorySymbols[(int)category],
      pcaszMessage );

   if (!InterlockedExchange(&sv_nOutputFlag,1))
      status=DbgPrint("\r\n");
   if (NT_SUCCESS(status))
      status=DbgPrint("%s",aszTraceOutput);

#if DBG
   if (!NT_SUCCESS(status))
      DbgBreakPointWithStatus(status);
#endif

   return status;
}

NTSTATUS $TracefMessage($TraceMessageCategory category,$PCASZ pcaszMessageFmt, ... )
{
   va_list argList;
   return $VTracefMessage(category,$VA_COMPLEMENT(pcaszMessageFmt,argList));
}

NTSTATUS $VTracefMessage($TraceMessageCategory category,$PCASZ pcaszMessageFmt,va_list argList)
{
   $ACH aszMessage[$DBG_PRINT_BUFFER_CCH];
   $StrVPrintfA(aszMessage,$DBG_PRINT_BUFFER_CCH,pcaszMessageFmt,argList);
   return $TraceMessage(category,aszMessage);
}

//==================================================================================================

NTSTATUS $TraceCurrentIrql()
{
   KIRQL irql=KeGetCurrentIrql();

   return $TracefInformation(
      "Current IRQL: %s (%d).",
      $IrqlIdentifier(irql),
      ($UINT)irql );
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceFunctionFailure($PCASZ pcaszFunctionName)
{
   return $TracefError("\"%s\" failed.",pcaszFunctionName);
}

NTSTATUS $TraceFunctionFailureWithStatus($PCASZ pcaszFunctionName,NTSTATUS status)
{
   return $TracefError(
      "\"%s\" failed with status: 0x%08X (%s).",
      pcaszFunctionName, status, $StatusSeverityName(status) );
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceIdentifier($PCASZ pcaszIdentifier)
{
   return $TracefInformation("<< %s >>",pcaszIdentifier);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceUnsupportedIoControlCode($UINT uControlCode)
{
   return $TracefError("Unsupported IOCTL-code: 0x%08X.",uControlCode);
}

NTSTATUS $TraceUnsupportedCmResourceType(UCHAR byResourceType)
{
   return $TracefWarning("Unsupported CM-resource type: 0x%02X.",($UINT)byResourceType);
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceZeroInputLength($TraceMessageCategory category)
{
   return $TraceMessage(category,"Zero input length (application ==> device).");
}

NTSTATUS $TraceZeroOutputLength($TraceMessageCategory category)
{
   return $TraceMessage(category,"Zero output length (device ==> application).");
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceNonZeroInputLength($TraceMessageCategory category)
{
   return $TraceMessage(category,"Non-zero input length (application ==> device).");
}

NTSTATUS $TraceNonZeroOutputLength($TraceMessageCategory category)
{
   return $TraceMessage(category,"Non-zero output length (device ==> application).");
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceIncorrectInputLength($TraceMessageCategory category)
{
   return $TraceMessage(category,"Incorrect input length (application ==> device).");
}

NTSTATUS $TraceIncorrectOutputLength($TraceMessageCategory category)
{
   return $TraceMessage(category,"Incorrect output length (device ==> application).");
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceInsufficientInputLength($TraceMessageCategory category)
{
   return
      $TraceMessage(category,"Insufficient input length (application ==> device).");
}

NTSTATUS $TraceInsufficientOutputLength($TraceMessageCategory category)
{
   return
      $TraceMessage(category,"Insufficient output length (device ==> application).");
}

//--------------------------------------------------------------------------------------------------

NTSTATUS $TraceInputTransfer(size_t bytes)
{
   return $TracefInformation(
      "Bytes transferred (input): %d (application ==> device).",
      bytes<=(size_t)MAXLONG ? (int)bytes : -1 );
}

NTSTATUS $TraceOutputTransfer(size_t bytes)
{
   return $TracefInformation(
      "Bytes transferred (output): %d (device ==> application).",
      bytes<=(size_t)MAXLONG ? (int)bytes : -1 );
}

//==================================================================================================

NTSTATUS $TraceInFunction($PCASZ pcaszFunctionName)
{
   NTSTATUS
      status=$Trace("");
   if (!NT_SUCCESS(status))
      return status;
   return
      $Tracef(
         "=== In \"%s\" (at %s): ===",
         pcaszFunctionName,
         $IrqlIdentifier(KeGetCurrentIrql()) );
}

NTSTATUS $TraceOutOfFunction($PCASZ pcaszFunctionName)
{
   NTSTATUS
      status=$Tracef(
         "=== Out of \"%s\" (at %s). ===",
         pcaszFunctionName,
         $IrqlIdentifier(KeGetCurrentIrql()) );
   if (!NT_SUCCESS(status))
      return status;
   return $Trace("");
}

NTSTATUS $TraceOutOfFunctionWithStatus($PCASZ pcaszFunctionName,NTSTATUS status)
{
   NTSTATUS
      traceStatus=$TracefMessage(
         ($TraceMessageCategory)(($UINT)status>>30),
         "=== Out of \"%s\" (at %s); Status: 0x%08X (%s). ===",
         pcaszFunctionName, $IrqlIdentifier(KeGetCurrentIrql()),
         status, $StatusSeverityName(status) );
   if (!NT_SUCCESS(traceStatus))
      return traceStatus;
   return $Trace("");
}

//==================================================================================================
