﻿#include "Precompiled.h"
#include "SharedIncludes.h"

#include <KernelUtils.PagedSegmentsOn.h>

//==================================================================================================
// Очистка дополнительных связанных с устройством ресурсов:
//--------------------------------------------------------------------------------------------------
void Driver_EvtDeviceContextCleanup
(
   WDFOBJECT hDeviceObject
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   WDFDEVICE         hDevice = (WDFDEVICE)hDeviceObject;
   PDRIVER_FDO_DATA  pFdoData;
   $INT              nDevices;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_IN_FUNCTION();
   PAGED_CODE();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   pFdoData = Driver_FdoGetData(hDevice);

   if (pFdoData->CreatedSuccessfully)
   {
      nDevices = InterlockedDecrement( &Driver_DeviceCount );

      $DBG_PRINT_INFORMATION  ( "Отключено одно устройство." );
      $DBG_PRINTF_INFORMATION(( "Общее число устройств теперь = %d.", nDevices ));
   }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_OUT_OF_FUNCTION();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
