﻿#include "Precompiled.h"
#include "SharedIncludes.h"

#include <KernelUtils.PagedSegmentsOn.h>

//==================================================================================================
// Введение устройства в рабочее состояние:
//--------------------------------------------------------------------------------------------------
NTSTATUS Driver_EvtDeviceD0Entry
(
   WDFDEVICE               hDevice,
   WDF_POWER_DEVICE_STATE  powerState
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   NTSTATUS          status = STATUS_SUCCESS;
   PDRIVER_FDO_DATA  pFdoData;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_IN_FUNCTION();
   PAGED_CODE();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   pFdoData = Driver_FdoGetData(hDevice);

   if (pFdoData->WasInD0)
   {
      if (pFdoData->RGMValueD0 != SHAPER_RGM_INACTIVE)
      {
         Driver_DeviceWriteRegister(pFdoData,SHAPER_RGM,pFdoData->RGMValueD0);

         $DBG_PRINTF_INFORMATION((
            "Прежний режим восстановлен (RGM): 0x%08X.",
            pFdoData->RGMValueD0 ));
      }
   }
   else
   {
      Driver_DeviceDeactivate(pFdoData);
      pFdoData->WasInD0 = TRUE;
   }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EXIT:
   $DBG_PRINT_OUT_OF_FUNCTION_WITH_STATUS(status);
   return status;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
