﻿#include "Precompiled.h"
#include "SharedIncludes.h"

#include <KernelUtils.PagedSegmentsOn.h>

//==================================================================================================
// Выведение устройства из рабочего состояния (спящий режим и т.п.):
//--------------------------------------------------------------------------------------------------
NTSTATUS Driver_EvtDeviceD0Exit
(
   WDFDEVICE               hDevice,
   WDF_POWER_DEVICE_STATE  powerState
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   NTSTATUS          status = STATUS_SUCCESS;
   PDRIVER_FDO_DATA  pFdoData;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_IN_FUNCTION();
   PAGED_CODE();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   pFdoData = Driver_FdoGetData(hDevice);

   pFdoData->RGMValueD0 = Driver_DeviceReadRegister(pFdoData,SHAPER_RGM);

   $DBG_PRINTF_INFORMATION((
      "Текущий режим сохранён (RGM): 0x%08X.",
      pFdoData->RGMValueD0 ));

   Driver_DeviceDeactivate(pFdoData);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EXIT:
   $DBG_PRINT_OUT_OF_FUNCTION_WITH_STATUS(status);
   return status;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
