﻿#include "Precompiled.h"
#include "SharedIncludes.h"

#include <KernelUtils.PagedSegmentsOn.h>

//==================================================================================================
// Создание файла устройства (при открытии из приложения):
//--------------------------------------------------------------------------------------------------
void Driver_EvtDeviceFileCreate
(
   WDFDEVICE      hDevice,
   WDFREQUEST     hRequest,
   WDFFILEOBJECT  hFileObject
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   PDRIVER_FDO_DATA  pFdoData;

   UNREFERENCED_PARAMETER(hRequest);
   UNREFERENCED_PARAMETER(hFileObject);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_IN_FUNCTION();
   PAGED_CODE();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   pFdoData = Driver_FdoGetData(hDevice);

   if (pFdoData->FileCreated)
   {
      $DBG_PRINT_ERROR("Попытка открытия более чем одного файла (одновременно) на устройстве.");
      WdfRequestComplete(hRequest,STATUS_INVALID_DEVICE_STATE);
      goto EXIT;
   }

   WdfRequestComplete(hRequest,STATUS_SUCCESS);

   pFdoData->FileCreated = TRUE;

   $DBG_PRINT_INFORMATION("Открыт файл на устройстве.");

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EXIT:
   $DBG_PRINT_OUT_OF_FUNCTION();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
