<?xml version="1.0" encoding="UTF-8"?>
<!-- XSL-ТРАНСФОРМАТОР В HTML (ВИЗУАЛИЗАЦИЯ РЕГИСТРОВОЙ РАСКЛАДКИ): -->
<xsl:transform
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
   xmlns:doc="http://www.pulseshaper.voronezh.ru/Schemas/ShaperDevice.Registers.xsd">
<!--=============================================================================================-->
<!-- ШАБЛОН ЭЛЕМЕНТА ДОКУМЕНТА XML: -->
<xsl:template match="/">

<!-- Документ HTML: -->
<HTML>
   <!-- Заголовок HTML: -->
   <HEAD>
      <META http-equiv="Content-Type" content="text/html; charset=utf-8" />
      <!-- Извлечение атрибута "DisplayName" в название документа: -->
      <TITLE><xsl:value-of select="doc:ShaperDevice.Registers/@DisplayName" /></TITLE>
      <!-- Стили HTML: -->
      <STYLE>
         <!-- Заголовок таблицы: -->
         TH {
            FONT-FAMILY: "Arial CYR";
            COLOR: "White";
            BACKGROUND: "Gray";
            TEXT-ALIGN: center;
         }
      </STYLE>
   </HEAD>
   <!-- Тело HTML: -->
   <BODY bgColor="BlanchedAlmond">
      <!-- Титульная надпись: -->
      <H2 align="Center">
         <FONT face="Tahoma">
            <!-- Извлечение атрибута "DisplayName" в заголовок: -->
            <xsl:value-of select="doc:ShaperDevice.Registers/@DisplayName" />
         </FONT>
      </H2>
      <!-- Разделители: -->
      <BR />
      <!-- Таблица: -->
      <TABLE width="100%" border="1" bordercolor="Gray" cellpadding="3">
         <!-- Заголовок таблицы: -->
         <THEAD>
            <TH>Регистр (имя)</TH>
            <TH>Загружаемое значение</TH>
         </THEAD>
         <!-- Тело таблицы: -->
         <TBODY>
            <!-- Обработка всех элемента документа и всех вложенных в него: -->
            <xsl:apply-templates select="doc:ShaperDevice.Registers" />
         </TBODY>
      </TABLE>
      <!-- Разделители: -->
      <BR /><BR /><HR />
      <!-- Комментарии: -->
      <FONT color="Gray">
         <I>
            <P align="Center">&#x00AB; Регистровая раскладка для программы <B>ShaperTerminal</B> &#x00BB;</P>
            <P align="Center">&#x00A9; Китаев С.Ю.</P>
         </I>
      </FONT>
   </BODY>
</HTML>

</xsl:template>
<!--=============================================================================================-->

<!-- Шаблон для всех вложенных в "ShaperDevice.Registers" элементов с атрибутом "SetValue": -->
<xsl:template match="doc:ShaperDevice.Registers/*[@SetValue]">
   <!-- Строка таблицы: -->
   <TR>
      <!-- Имя элемента - в 1-ю колонку:  -->
      <TD width="20%"><xsl:value-of select="name()" /></TD>
      <!-- Значение атрибута "SetValue" - во 2-ю колонку:  -->
      <TD><FONT face="Lucida Console">0x<xsl:value-of select="@SetValue" /></FONT></TD>
   </TR>
</xsl:template>

<!--=============================================================================================-->
</xsl:transform>
