﻿using System;
using System.Xml;

using ElementaryExtensions;
using ShaperAccess;

namespace ShaperTerminal {

using Properties;

//**************************************************************************************************
class ProfileConfiguration: XmlConfiguration {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public ProfileConfiguration(): base(sr_strSchemaText)
{}

//--------------------------------------------------------------------------------------------------

public string
   DisplayName;
public UInt32
   LoadTo_BankNo;

//==================================================================================================

public void Load(string strFileName)
{
   Load(strFileName,true);
}

public void Load(string strFileName,bool bLoadAllContent)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   LoadDocument(strFileName);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   DisplayName = CurrentNode.Attributes["DisplayName"].InnerText;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (!bLoadAllContent)
      return;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   NavigateToNode("x:LoadTo",true);

   LoadTo_BankNo =
      ЄValueParser.ParseUInt32Invariant(
         CurrentNode.Attributes["BankNo"].InnerText );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}

//==================================================================================================

static readonly string
   sr_strSchemaText = Resources.ShaperDevice_Profile_XSD;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // ProfileConfiguration
//**************************************************************************************************

} // ShaperTerminal
