﻿using System;
using System.Reflection;

using ElementaryExtensions;

namespace ShaperTerminal {

//**************************************************************************************************
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

static void AboutProcedure()
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   PrintProcedureTitle(c_strAboutProcedureCaption);

   ЄConsole.PrintFeature( ЄConsole.ExclamationColor,
      "УСТРОЙСТВО ИМПУЛЬСНОГО ШЕЙПЕРА (PCI) {0} ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ",
      ЄConsole.LongDashString );

   ЄConsole.Print();

   ЄConsole.Type("Версия: ");
   ЄConsole.PrintIntensive
   (
   #if DEBUG
      "{0} (Debug)",
   #else
      "{0}",
   #endif
      Assembly.GetExecutingAssembly().GetName().Version
   );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintDoubleSplitter(true);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintInfoCaption(true,"Программые модули:");
   ЄConsole.PrintDashAlignedList
   (
      new string[]
      {
         "Shaper.sys",
         "ShaperAccess.dll",
         "ShaperTerminal.exe",
         "ElementaryExtensions.*.dll"
      },
      new string[]
      {
         "функциональный WDF-драйвер (KMDF)",
         "API устройства шейпера (класс \"ShaperDevice\")",
         ".NET-приложение управления устройством",
         "библиотека ElementaryExtensions"
      }
   );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintInfoCaption(true,"Конфигурационные файлы:");
   ЄConsole.PrintDashAlignedList
   (
      new string[]
      {
         s_strConfigurationFileName,
         ЄApplication.Name+".exe.config",
         "Registers\\*"+c_strRegLayoutXmlFileExt,
         "Profiles\\*"+c_strProfileBinFileExt,
         "Profiles\\*"+c_strProfileXmlFileExt
      },
      new string[]
      {
         "конфигурация устройства шейпера",
         "конфигурационный файл приложения .NET",
         "регистровые раскладки режимов",
         "бинарные профили частоты/амплитуды",
         "файлы-описатели профилей сигнала"
      }
   );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintSplitter(true,true);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintFaint(
      "  Данная программа написана с использованием библиотеки \"ElementaryExtensions\"\n"+
      "предоставляющей дополнительный набор функций программирования в среде .NET.\n"+
      "  Приложение \"ShaperTerminal\" базируется на специально разработанном\n"+
      "\"простейшем терминальном пользовательском интерфейсе\" (реализован в классе\n"+
      "\"ЄConsole\" пространства имен \"ElementaryExtensions\")." );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintDoubleSplitter(true,true);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintInfoCaption("Разработчики:");
   ЄConsole.PrintDashAlignedList
   (
      new string[]
      {
         "Китаев Ю.И. (Y.I.Kitaev@mail.ru)",
         "Китаев С.Ю. (serg_kit@mail.ru)"
      },
      new string[]
      {
         "проектирование платы шейпера",
         "написание П.О. поддержки"
      }
   );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   CompletionDialog_Return();

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ShaperTerminal
