using System;

using ElementaryExtensions;
using ShaperAccess;

namespace ShaperTerminal {

//**************************************************************************************************
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const string
   c_strKeysUsageProcedureCaption        = "   ",
   c_strReadWriteRegisterProcedureCaption= "/ 32-  "+
                                           "(  )",
   c_strLoadRegistersProcedureCaption    = "   "+
                                           "( XML-)",
   c_strLoadProfileProcedureCaption      = "   (/)",
   c_strDeactivateDeviceProcedureCaption = "  "+
                                           "(   )",
   c_strSawTestProcedureCaption          = "  ",
   c_strTestMemoryProcedureCaption       = "   ",
   c_strAboutProcedureCaption            = " ";

const int
   c_nKeysUsageProcedureIdx        = 0,
   c_nReadWriteRegisterProcedureIdx= 1,
   c_nLoadRegistersProcedureIdx    = 2,
   c_nLoadProfileProcedureIdx      = 3,
   c_nDeactivateDeviceProcedureIdx = 4,
   c_nSawTestProcedureIdx          = 5,
   c_nTestMemoryProcedureIdx       = 6,
   c_nAboutProcedureIdx            = 7;

const int
   c_nTotalProcedures = 8;

//--------------------------------------------------------------------------------------------------

const string
   c_strRegLayoutXmlFileExt= ".xml",
   c_strProfileXmlFileExt  = ".xml",
   c_strProfileBinFileExt  = ".bin";

const string
   c_strDialogItem_SpecifyFileName = "<<    () >>",
   c_strDialogItem_RefusalAndReturn= " (   )";

const int
   c_nPauseUIInterval = 1000;

//==================================================================================================

static readonly string[]
   sr_astrProcedureCaptions =
   {
      c_strKeysUsageProcedureCaption,
      c_strReadWriteRegisterProcedureCaption,
      c_strLoadRegistersProcedureCaption,
      c_strLoadProfileProcedureCaption,
      c_strDeactivateDeviceProcedureCaption,
      c_strSawTestProcedureCaption,
      c_strTestMemoryProcedureCaption,
      c_strAboutProcedureCaption
   };

static readonly ConsoleKey[]
   sr_MainMenuKeys =
   {
      ConsoleKey.F1,
      ConsoleKey.F2,
      ConsoleKey.F3,
      ConsoleKey.F4,
      ConsoleKey.F5,
      ConsoleKey.F6,
      ConsoleKey.F9,
      ConsoleKey.F1
   };

static readonly ConsoleModifiers[]
   sr_MainMenuKeyModifiers =
   {
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      ConsoleModifiers.Control
   };

//==================================================================================================

static string
   s_strConfigurationFileName = "ShaperDevice.xml",
   s_strActiveRegLayoutDisplayName,
   s_strActiveProfileDisplayName;
static string[]
   s_astrRegLayoutDisplayNames,
   s_astrProfileDisplayNames;
static bool[]
   s_abRegLayoutAvailabilities,
   s_abProfileAvailabilities;
static DeviceConfiguration
   s_DeviceConfiguration=new DeviceConfiguration();
static bool
   s_bLogoInformationPrinted,
   s_bStartupHasPlayed,
   s_bCleanupRequest;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ShaperTerminal
