﻿using System;

using ElementaryExtensions;

namespace ShaperTerminal {

//**************************************************************************************************
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ReportError()
{
   Sound.Play(SoundSignal.Error);
}

public static void ReportError(Exception e)
{
   ReportError(false,e);
}

public static void ReportError(string strMessage)
{
   ReportError(false,strMessage);
}

public static void ReportError(string strMessageFmt,params object[] aobParams)
{
   ReportError(false,strMessageFmt,aobParams);
}

//--------------------------------------------------------------------------------------------------

public static void ReportError(bool bInsertBlankLine,Exception e)
{
   ReportError(bInsertBlankLine,e.Message);
}

public static void ReportError(bool bInsertBlankLine,string strMessage)
{
   ЄConsole.PrintError(bInsertBlankLine,strMessage);
   ReportError();
}

public static void ReportError( bool bInsertBlankLine,
                                string strMessageFmt,
                                params object[] aobParams )
{
   ReportError(bInsertBlankLine,string.Format(strMessageFmt,aobParams));
}

//==================================================================================================

public static void ReportSuccess()
{
   Sound.Play(SoundSignal.Success);
}

public static void ReportSuccess(string strMessage)
{
   ReportSuccess(false,strMessage);
}

public static void ReportSuccess(string strMessageFmt,params object[] aobParams)
{
   ReportSuccess(false,strMessageFmt,aobParams);
}

//--------------------------------------------------------------------------------------------------

public static void ReportSuccess(bool bInsertBlankLine,string strMessage)
{
   ЄConsole.PrintSuccess(bInsertBlankLine,strMessage);
   ReportSuccess();
}

public static void ReportSuccess( bool bInsertBlankLine,
                                  string strMessageFmt,
                                  params object[] aobParams )
{
   ReportSuccess(bInsertBlankLine,string.Format(strMessageFmt,aobParams));
}

//==================================================================================================

public static void ReportNotSuccess()
{
   Sound.Play(SoundSignal.NotSuccess);
}

public static void ReportNotSuccess(string strMessage)
{
   ReportNotSuccess(false,strMessage);
}

public static void ReportNotSuccess(string strMessageFmt,params object[] aobParams)
{
   ReportNotSuccess(false,strMessageFmt,aobParams);
}

//--------------------------------------------------------------------------------------------------

public static void ReportNotSuccess(bool bInsertBlankLine,string strMessage)
{
   ЄConsole.PrintFaint(bInsertBlankLine,strMessage);
   ReportNotSuccess();
}

public static void ReportNotSuccess( bool bInsertBlankLine,
                                     string strMessageFmt,
                                     params object[] aobParams )
{
   ReportNotSuccess(bInsertBlankLine,string.Format(strMessageFmt,aobParams));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ShaperTerminal
