﻿using System;
using System.ComponentModel;

using ElementaryExtensions;
using ShaperAccess;

namespace ShaperTerminal {

//**************************************************************************************************
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

class SawTestThreadExchange
{
   public SawTestThreadExchange( FrequencyOrMagnitude fixedParameterKind,
                                 UInt32 uFixedParameterValue )
   {
      FixedParameterKind = fixedParameterKind;
      FixedParameterValue= uFixedParameterValue;
      SampleDelay        = s_DeviceConfiguration.SawTest_SampleDelay;
   }

   public FrequencyOrMagnitude
      FixedParameterKind;
   public UInt32
      FixedParameterValue,
      SampleDelay;
   public volatile Win32Exception
      Exception;
   public volatile bool
      StopRequest = false;
}

//==================================================================================================

static void SawTestThreadRoutine(object obSawTestThreadExchange)
{
   SawTestThreadExchange
      exchange = (SawTestThreadExchange)obSawTestThreadExchange;
   while (!exchange.StopRequest)
      try
      {
         ShaperDevice.GenerateSawTooth(
            exchange.FixedParameterKind==FrequencyOrMagnitude.Magnitude,
            exchange.FixedParameterValue,
            exchange.SampleDelay );
      }
      catch (Win32Exception e)
      {
         exchange.Exception=e;
         return;
      }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ShaperTerminal
