﻿using System;
using System.ComponentModel;

using ElementaryExtensions;
using ShaperAccess;

namespace ShaperTerminal {

//**************************************************************************************************
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

static void TestMemoryProcedure()
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   s_strActiveProfileDisplayName=null;

   ЄConsole.PrintDoubleSplitter(true);

   ЄConsole.PrintOperation(true,"Запущена операция тестирования памяти устройства");

   bool
      bSucceeded;
   UInt32
      uProblemBankNo,
      uErrorCellAddress,
      uWrittenValue,
      uReadValue;

   try
   {
      bSucceeded = ShaperDevice.TestMemory( out uProblemBankNo, out uErrorCellAddress,
                                            out uWrittenValue, out uReadValue );
   }
   catch (Win32Exception e)
   {
      ReportError(e);
      CompletionDialog_Continue();
      return;
   }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄConsole.PrintDoubleSplitter(true,true);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (bSucceeded)
   {
      ReportSuccess("Тест прошёл успешно.");
      PauseUI();
      return;
   }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ReportError("Тест завершился неудачей.");

   ЄConsole.PrintShallowSplitter(true,true);

   ЄConsole.PrintAlignedList
   (
      new string[]
      {
         "Проблемный банк (0/1)",
         "Адрес ячейки сбоя",
         "Записанное тестом значение",
         "Считанное тестом значение"
      },
      new string[]
      {
         uProblemBankNo.ToString(),
         string.Format("0x{0:X3}",uErrorCellAddress),
         string.Format("0x{0:X8}",uWrittenValue),
         string.Format("0x{0:X8}",uReadValue)
      }
   );

   CompletionDialog_Continue();

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ShaperTerminal
