﻿using System;

using ElementaryExtensions;

namespace ShaperTerminal {

//**************************************************************************************************
enum SoundSignal
{
   Statrup, Exit, Success, Error, NotSuccess
}
//**************************************************************************************************


//**************************************************************************************************
static class Sound {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void Play(SoundSignal signal)
{
   PlayEx(false,false,signal);
}

public static void PlaySync(SoundSignal signal)
{
   PlayEx(true,false,signal);
}

public static void PlayEx(bool bSynchronous,bool bIgnoreMuteFlag,SoundSignal signal)
{
   double[][] soundLayouts=
   {
      new double[]{ 0.5,1, 1,1, 2,1, 4,1 }, // Statrup
      new double[]{ 4,1, 2,1, 1,1, 0.5,1 }, // Exit
      new double[]{ 1,1, 2,1 },             // Success
      new double[]{ 2,2 },                  // Error
      new double[]{ 0.5,3 }                 // NotSuccess
   };
   ЄBeeper.RelativeBeepEx(
      bSynchronous, bIgnoreMuteFlag,
      soundLayouts[(int)signal] );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Sound
//**************************************************************************************************

} // ShaperTerminal
