﻿using System;
using System.Diagnostics;
using System.Reflection;
using System.Configuration;

using ElementaryExtensions;

namespace ShaperTerminal {

using Properties;

//**************************************************************************************************
static class Startup {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

static int Main()
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   Console.Title=Assembly.GetEntryAssembly().GetName().Name;

   Console.TreatControlCAsInput=true;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ЄLibrary.Initialization.PrepareForFullTrustedApplication(
      ЄApplicationType.Console );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   Console.Title=string.Format( "{0} {1} {2}",
      ЄApplication.Name, ЄUnicode.EmDash,
      ЄAssemblyAttributeReader<AssemblyTitleAttribute>.Retreive().Title );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   using (new ЄRuntimeParametersAltering())
   {
      ЄFatalError.BreakdownFinalCallback=Program.BreakdownFinalCallback;

      ЄConsole.DialogCaptionFmt_PressKeyToContinue_2 =
         "Для продолжения нажмите {0} или {1}";
      ЄConsole.DialogCaptionFmt_PressKeyToReturn_2 =
         "Для возврата нажмите {0} или {1}";
      ЄConsole.DialogCaptionFmt_PressKeyToExit_2 =
         "Для выхода из программы нажмите {0} или {1}";
      ЄConsole.DialogCaption_ConfirmRefusal =
         "Подтвердите отказ:";
      ЄConsole.CancelTerminationMessage =
         "Прерывание по <Ctrl+Break>";

      ЄBeeper.Mute =
         ConfigurationManager.AppSettings["Mute"]=="1";
      //ЄBeeper.Mute=true;

      ЄRuntimeParametersAltering.ApplyChanges();
   }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   Console.CancelKeyPress+=Program.CancelHandler;

   bool
      bUnhandledException=false;
   try
   {
      using (new ЄDebug("RUN"))
         Program.Run();
   }
   catch (ЄAppExitException e)
   {
      if (e is ЄAppFailureException)
         Program.ReportError(e);
      else
      {
         ЄConsole.PrintExpressive(e.Message);
         Sound.Play(SoundSignal.NotSuccess);
      }
      ЄApplication.OverwriteExitCode(e.ExitCode);
      CompletionDialog_Exit();
   }
   catch
   {
      bUnhandledException=true;
      throw;
   }
   finally
   {
      if (!bUnhandledException)
         try
         {
            using (new ЄDebug("CLEANUP"))
               Program.PerformCleanup();
         }
         catch (ЄAppFailureException e)
         {
            Program.ReportError(e);
            ЄApplication.OverwriteExitCode(e.ExitCode);
            CompletionDialog_Exit();
         }
   }

   Program.SayGoodbye();

   return ЄApplication.PrepareForExit();

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}

static void CompletionDialog_Exit()
{
   ЄConsole.PrintDoubleSplitter(true);
   ЄConsole.PressEnterOrEscapeToExitDialog(true);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Startup
//**************************************************************************************************

} // ShaperTerminal
