@echo off

if not "%~0"=="#SETTINGS.cmd" goto INCORRECT_CALL

rem ================================================================================

if not defined $wdk_root goto WDK_ROOT_NOT_DEF
if not defined TEMP      goto TEMP_NOT_DEF
if not defined WINDIR    goto WINDIR_NOT_DEF

rem ================================================================================

set #ProjectName=XDevice

set #InfName=%#ProjectName%.inf
set #InxName=%#ProjectName%.inx
set #SysName=%#ProjectName%.sys
set #PdbName=%#ProjectName%.pdb

set #BuildParameters=-eZ
set #RebuildParameters=

set #OS_for_x86=W2K
set #OS_for_x64=WLH

set #CleanupKeyword_x86_C=chk_%#OS_for_x86%_x86
set #CleanupKeyword_x86_F=fre_%#OS_for_x86%_x86
set #CleanupKeyword_x64_C=chk_%#OS_for_x64%_amd64
set #CleanupKeyword_x64_F=fre_%#OS_for_x64%_amd64

set #OutputDir_x86_C=objchk_%#OS_for_x86%_x86\i386\
set #OutputDir_x86_F=objfre_%#OS_for_x86%_x86\i386\
set #OutputDir_x64_C=objchk_%#OS_for_x64%_amd64\amd64\
set #OutputDir_x64_F=objfre_%#OS_for_x64%_amd64\amd64\

set WdfCoInstallerFileName=WdfCoInstaller01005.dll

set #WdfRedistrDir_x86=%$wdk_root%\redist\wdf\x86\
set #WdfRedistrDir_x64=%$wdk_root%\redist\wdf\amd64\

set #WdfCoInstallerRedistrPath_x86=%#WdfRedistrDir_x86%%WdfCoInstallerFileName%
set #WdfCoInstallerRedistrPath_x64=%#WdfRedistrDir_x64%%WdfCoInstallerFileName%

set #WdkToolsDir=%$wdk_root%\tools\
set #CheckInfDir=%#WdkToolsDir%chkinf\
set #CheckInfHtmlDir=%#WdkToolsDir%chkinf\htm\

set #DriversSystemDir=%windir%\System32\Drivers\

set #TestRebuildCmdBatchXName=REBUILD_X86_C.cmd
set #TestDriverBinaryPath_SYS=objchk_w2k_x86\i386\%#SysName%
set #TestDriverBinaryPath_PDB=objchk_w2k_x86\i386\%#PdbName%

goto :EOF

rem ================================================================================

:WDK_ROOT_NOT_DEF
echo.
echo ## Environment variable "$wdk_root" is not defined.
goto ERROR

:TEMP_NOT_DEF
echo.
echo ## Environment variable "TEMP" is not defined.
goto ERROR

:WINDIR_NOT_DEF
echo.
echo ## Environment variable "WINDIR" is not defined.
goto ERROR

rem ================================================================================

:INCORRECT_CALL
echo.
echo ## Incorrect call of "#settings.cmd" (auxiliary batch).
echo 
pause
goto ERROR

rem ================================================================================

:ERROR
set errorlevel=1
goto :EOF

rem ================================================================================
