﻿#include "Precompiled.h"
#include "SharedIncludes.h"

#pragma code_seg("INIT")
#pragma data_seg("PAGEDATA")

//==================================================================================================
// Точка входа драйвера:
//--------------------------------------------------------------------------------------------------
NTSTATUS DriverEntry
(
   PDRIVER_OBJECT    pDriverObject,
   PUNICODE_STRING   pRegistryPath
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   NTSTATUS             status = STATUS_SUCCESS;
   WDF_DRIVER_CONFIG    config;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $SetDriverBinaryName("XDevice.sys");
   $SetDriverPoolTag(($UINT)'veDX');
   $DBG_PRINT_IN_FUNCTION();
   PAGED_CODE();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   $DBG_PRINT_INFORMATION  ( "##" );
   $DBG_PRINTF_INFORMATION(( "## %s", $VER_FILE_DESCRIPTION ));
   $DBG_PRINTF_INFORMATION(( "## Версия: %s", $VER_VERSION_STRING ));
   $DBG_PRINTF_INFORMATION(( "## Скомпилирован: %s %s (%s)",
                             __DATE__, __TIME__, $DriverBinaryName() ));
   $DBG_PRINTF_INFORMATION(( "## %s", $VER_COMMENTS ));
   $DBG_PRINT_INFORMATION  ( "##" );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// Создание объекта WDF-драйвера:

   WDF_DRIVER_CONFIG_INIT(&config,Driver_EvtDriverDeviceAdd);
   config.EvtDriverUnload = Driver_EvtDriverUnload;

   status = WdfDriverCreate(
      pDriverObject, pRegistryPath,
      WDF_NO_OBJECT_ATTRIBUTES,
      &config, WDF_NO_HANDLE );

   if (!NT_SUCCESS(status))
   {
      $DBG_PRINT_FUNCTION_FAILURE_WITH_STATUS("WdfDriverCreate",status);
      goto EXIT;
   }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EXIT:
   $DBG_PRINT_OUT_OF_FUNCTION_WITH_STATUS(status);
   return status;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
