﻿#include "Precompiled.h"
#include "SharedIncludes.h"

//==================================================================================================
// Обработка общего запроса чтения из устройства -- буферизов.ВЫВОД (УСТРОЙСТВО ==> приложение):
//--------------------------------------------------------------------------------------------------
void Driver_EvtIoRead
(
   WDFQUEUE    hQueue,
   WDFREQUEST  hRequest,
   size_t      outputLength
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   NTSTATUS    status = STATUS_SUCCESS;
   $UINT_PTR   infoLength = 0;
   PVOID       pvOutputBuffer;

   static $CCHAR
      cszMagicText[]=
         L"У лукоморья дуб зелёный;\r\n"
         L"Златая цепь на дубе том:\r\n"
         L"И днём и ночью кот учёный\r\n"
         L"Всё ходит по цепи кругом;";

   UNREFERENCED_PARAMETER(hQueue);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_IN_FUNCTION();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Проверка длины вывода:
   if (!$CheckOutputLength(&status,!(outputLength%2u)))
      goto COMPLETE;
   if (outputLength<sizeof(cszMagicText))
      $DBG_PRINT_INSUFFICIENT_OUTPUT_LENGTH_W();

// Получение системного буфера вывода:
   if (!$RetrieveOutputBuffer(&status,hRequest,2,&pvOutputBuffer,NULL))
      goto COMPLETE;

// Заполнение буфера вывода информацией (для приложения):
   infoLength = min(outputLength,sizeof(cszMagicText));
   RtlCopyMemory(pvOutputBuffer,cszMagicText,infoLength);
   (($PSZ)pvOutputBuffer)[infoLength/2-1]=L'\0';

   $DBG_PRINT_OUTPUT_TRANSFER(infoLength);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COMPLETE:
   WdfRequestCompleteWithInformation(hRequest,status,infoLength);
   $DBG_PRINT_OUT_OF_FUNCTION();
   return;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COMPLETE_NO_INFO:
   WdfRequestComplete(hRequest,status);
   $DBG_PRINT_OUT_OF_FUNCTION();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
