﻿#include "Precompiled.h"
#include "SharedIncludes.h"

//==================================================================================================
// Обработка общего запроса записи в устройство -- буферизов.ВВОД (УСТРОЙСТВО <== приложение):
//--------------------------------------------------------------------------------------------------
void Driver_EvtIoWrite
(
   WDFQUEUE    hQueue,
   WDFREQUEST  hRequest,
   size_t      inputLength
)
{
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   NTSTATUS    status = STATUS_SUCCESS;
   $UINT_PTR   infoLength = 0;
   $PCVOID     pcvInputBuffer;

   UNREFERENCED_PARAMETER(hQueue);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
   $DBG_PRINT_IN_FUNCTION();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Получение системного буфера ввода:
   if (!$RetrieveInputBuffer(&status,hRequest,1,&pcvInputBuffer,NULL))
      goto COMPLETE;

// Проверка на пустую строку:
   if (inputLength==1 || $IS_EMPTY_SZ(($PCASZ)pcvInputBuffer))
   {
      $DBG_PRINT_WARNING("Пустое сообщение получено из приложения.");
      goto COMPLETE;
   }

// Трассировка находящегося в буфере ввода сообщения (подготовленного приложением):
   if (inputLength>1)
   {
      (($PASZ)pcvInputBuffer)[inputLength-1]='\0';
      $TraceInformation(($PCASZ)pcvInputBuffer);
      infoLength = $StrLengthA(($PCASZ)pcvInputBuffer)+1;
   }

   $DBG_PRINT_INPUT_TRANSFER(infoLength);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COMPLETE:
   WdfRequestCompleteWithInformation(hRequest,status,infoLength);
   $DBG_PRINT_OUT_OF_FUNCTION();
   return;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
COMPLETE_NO_INFO:
   WdfRequestComplete(hRequest,status);
   $DBG_PRINT_OUT_OF_FUNCTION();
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}
//==================================================================================================
