﻿//**************************************************************************************************
//
// ЗАГОЛОВОЧНЫЙ ФАЙЛ УСТРОЙСТВА "XDevice" (ДЛЯ РЕЖИМОВ ПОЛЬЗОВАТЕЛЯ И ЯДРА).
//
// === H-файлы необходимые для подключения к проекту пользовательского режима: ===
//
// * "InitGuid.h" -- макрос "DEFINE_GUID"
// * "WinIoCtl.h" -- макрос "CTL_CODE"
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#pragma once


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// "GUID"-идентификатор(ы) устройства:
//
//==================================================================================================

// Интерфейс устройства ({5A6395E4-F88C-45ac-AA0D-F8C3E6E674E8}):
DEFINE_GUID( GUID_DEVINTERFACE_XDEVICE, \
   0x5a6395e4, 0xf88c, 0x45ac, 0xaa, 0xd, 0xf8, 0xc3, 0xe6, 0xe6, 0x74, 0xe8 );


//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// "IOCTL"-коды управления устройством:
//
//==================================================================================================

// Трассировка сообщения приветствия:
#define IOCTL_XDEVICE_TRACE_HELLO \
   CTL_CODE(FILE_DEVICE_UNKNOWN,0x800,METHOD_BUFFERED,FILE_WRITE_DATA)

// Получение даты-времени копмиляции драйвера:
#define IOCTL_XDEVICE_RETRIEVE_DRIVER_BUILD \
   CTL_CODE(FILE_DEVICE_UNKNOWN,0x801,METHOD_BUFFERED,FILE_READ_DATA)

// Обмен сообщениями для трассировки:
#define IOCTL_XDEVICE_EXCHANGE_TRACE_MESSAGES \
   CTL_CODE(FILE_DEVICE_UNKNOWN,0x802,METHOD_NEITHER,FILE_ANY_ACCESS)


//**************************************************************************************************
