﻿#include "Precompiled.h"
#include "SharedIncludes.h"

namespace XDeviceTest {

//==================================================================================================

AppFailureException::AppFailureException()
{
   i_nExitCode=1;
}

AppFailureException::AppFailureException(String^ strMessage)
   :Exception(strMessage)
{
   i_nExitCode=1;
}

AppFailureException::AppFailureException(String^ strMessage,Exception^ innerException)
   :Exception(strMessage,innerException)
{
   i_nExitCode=1;
}

//--------------------------------------------------------------------------------------------------

AppFailureException::AppFailureException(int nExitCode)
{
   i_nExitCode=nExitCode;
}

AppFailureException::AppFailureException(String^ strMessage,int nExitCode)
   :Exception(strMessage)
{
   i_nExitCode=nExitCode;
}

AppFailureException::AppFailureException(String^ strMessage,Exception^ innerException,int nExitCode)
   :Exception(strMessage,innerException)
{
   i_nExitCode=nExitCode;
}

//==================================================================================================

int AppFailureException::ExitCode::get()
{
   return i_nExitCode;
}

//==================================================================================================

AppFailureException^ AppFailureException::Create( String^ strMessageFmt,
                                                  ... array<Object^>^ aobParams )
{
   return gcnew AppFailureException(String::Format(strMessageFmt,aobParams));
}

//==================================================================================================

} // XDeviceTest
