﻿#include "Precompiled.h"
#include "SharedIncludes.h"

namespace XDeviceTest {

//==================================================================================================

void XConsole::Print(bool bInsertBlankLine,String^ str)
{
   if (bInsertBlankLine) Print();
   Output(NormalColor,str,true);
}

void XConsole::Print(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams)
{
   if (bInsertBlankLine) Print();
   Output(NormalColor,strFormat,aobParams,true);
}

//--------------------------------------------------------------------------------------------------

void XConsole::Print(bool bInsertBlankLine,ConsoleColor color,String^ str)
{
   if (bInsertBlankLine) Print();
   Output(color,str,true);
}

void XConsole::Print( bool bInsertBlankLine, ConsoleColor color,
                      String^ strFormat, ... array<Object^>^ aobParams )
{
   if (bInsertBlankLine) Print();
   Output(color,strFormat,aobParams,true);
}

//==================================================================================================

void XConsole::PrintFaint(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,FaintColor,str); }

void XConsole::PrintFaint(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams)
   { Print(bInsertBlankLine,FaintColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintIntensive(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,IntensiveColor,str); }

void XConsole::PrintIntensive( bool bInsertBlankLine,
                               String^ strFormat,
                               ... array<Object^>^ aobParams)
   { Print(bInsertBlankLine,IntensiveColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintImportant(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,ImportantColor,str); }

void XConsole::PrintImportant( bool bInsertBlankLine,
                               String^ strFormat,
                               ... array<Object^>^ aobParams )
   { Print(bInsertBlankLine,ImportantColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintExpressive(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,ExpressiveColor,str); }

void XConsole::PrintExpressive( bool bInsertBlankLine,
                                String^ strFormat,
                                ... array<Object^>^ aobParams )
   { Print(bInsertBlankLine,ExpressiveColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintExclamation(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,ExclamationColor,str); }

void XConsole::PrintExclamation( bool bInsertBlankLine,
                                 String^ strFormat,
                                 ... array<Object^>^ aobParams )
   { Print(bInsertBlankLine,ExclamationColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintInformation(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,InformationColor,str); }

void XConsole::PrintInformation( bool bInsertBlankLine,
                                 String^ strFormat,
                                 ... array<Object^>^ aobParams )
   { Print(bInsertBlankLine,InformationColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintWarning(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,WarningColor,str); }

void XConsole::PrintWarning(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams)
   { Print(bInsertBlankLine,WarningColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintError(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,ErrorColor,str); }

void XConsole::PrintError(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams)
   { Print(bInsertBlankLine,ErrorColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintSuccess(bool bInsertBlankLine,String^ str)
   { Print(bInsertBlankLine,SuccessColor,str); }

void XConsole::PrintSuccess(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams)
   { Print(bInsertBlankLine,SuccessColor,strFormat,aobParams); }

//--------------------------------------------------------------------------------------------------

void XConsole::PrintOperation(bool bInsertBlankLine,String^ strOperation)
{
   Print( bInsertBlankLine, OperationColor,
          String::Format("* {0} ...",strOperation) );
}

void XConsole::PrintOperation( bool bInsertBlankLine,
                               String^ strOperationFmt,
                               ... array<Object^>^ aobParams )
{
   Print(bInsertBlankLine,OperationColor,String::Format(strOperationFmt,aobParams));
}

//==================================================================================================

} // XDeviceTest
