﻿#pragma once

namespace XDeviceTest {

//**************************************************************************************************
ref class XConsole
{
   static XConsole() {}

public:
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   static void Type(String^ str);
   static void Type(String^ strFormat, ... array<Object^>^ aobParams);

   static void Type(ConsoleColor color,String^ str);
   static void Type(ConsoleColor color,String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeFaint(String^ str);
   static void TypeFaint(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeIntensive(String^ str);
   static void TypeIntensive(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeImportant(String^ str);
   static void TypeImportant(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeExpressive(String^ str);
   static void TypeExpressive(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeExclamation(String^ str);
   static void TypeExclamation(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeInformation(String^ str);
   static void TypeInformation(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeWarning(String^ str);
   static void TypeWarning(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeError(String^ str);
   static void TypeError(String^ strFormat, ... array<Object^>^ aobParams);

   static void TypeSuccess(String^ str);
   static void TypeSuccess(String^ strFormat, ... array<Object^>^ aobParams);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   static void Print();

   static void Print(String^ str);
   static void Print(String^ strFormat, ... array<Object^>^ aobParams);

   static void Print(ConsoleColor color,String^ str);
   static void Print(ConsoleColor color,String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintFaint(String^ str);
   static void PrintFaint(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintIntensive(String^ str);
   static void PrintIntensive(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintImportant(String^ str);
   static void PrintImportant(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintExpressive(String^ str);
   static void PrintExpressive(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintExclamation(String^ str);
   static void PrintExclamation(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintInformation(String^ str);
   static void PrintInformation(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintWarning(String^ str);
   static void PrintWarning(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintError(String^ str);
   static void PrintError(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintSuccess(String^ str);
   static void PrintSuccess(String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintOperation(String^ str);
   static void PrintOperation(String^ strFormat, ... array<Object^>^ aobParams);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   static void Print(bool bInsertBlankLine,String^ str);
   static void Print(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams);

   static void Print(bool bInsertBlankLine,ConsoleColor color,String^ str);
   static void Print(bool bInsertBlankLine,ConsoleColor color,String^ strFormat,
                     ... array<Object^>^ aobParams);

   static void PrintFaint(bool bInsertBlankLine,String^ str);
   static void PrintFaint(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintIntensive(bool bInsertBlankLine,String^ str);
   static void PrintIntensive(bool bInsertBlankLine,String^ strFormat,
                              ... array<Object^>^ aobParams);

   static void PrintImportant(bool bInsertBlankLine,String^ str);
   static void PrintImportant(bool bInsertBlankLine,String^ strFormat,
                              ... array<Object^>^ aobParams);

   static void PrintExpressive(bool bInsertBlankLine,String^ str);
   static void PrintExpressive(bool bInsertBlankLine,String^ strFormat,
                               ... array<Object^>^ aobParams);

   static void PrintExclamation(bool bInsertBlankLine,String^ str);
   static void PrintExclamation(bool bInsertBlankLine,String^ strFormat,
                                ... array<Object^>^ aobParams);

   static void PrintInformation(bool bInsertBlankLine,String^ str);
   static void PrintInformation(bool bInsertBlankLine,String^ strFormat,
                                ... array<Object^>^ aobParams);

   static void PrintWarning(bool bInsertBlankLine,String^ str);
   static void PrintWarning(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintError(bool bInsertBlankLine,String^ str);
   static void PrintError(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintSuccess(bool bInsertBlankLine,String^ str);
   static void PrintSuccess(bool bInsertBlankLine,String^ strFormat, ... array<Object^>^ aobParams);

   static void PrintOperation(bool bInsertBlankLine,String^ str);
   static void PrintOperation(bool bInsertBlankLine,String^ strFormat,
                              ... array<Object^>^ aobParams);

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   static void Output(ConsoleColor color,String^ str);
   static void Output(ConsoleColor color,String^ strFormat, ... array<Object^>^ aobParams);
   static void Output(ConsoleColor color,String^ str,bool bFeedLine);
   static void Output( ConsoleColor color,
                       String^ strFormat,
                       array<Object^>^ aobParams,
                       bool bFeedLine );

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   static ConsoleKeyInfo ReadKey();
   static void ResetInput();

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   static void PressEnterOrEscapeToExitDialog();

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   literal ConsoleColor
      NormalColor     = ConsoleColor::Gray,
      FaintColor      = ConsoleColor::DarkGray,
      IntensiveColor  = ConsoleColor::White,
      ImportantColor  = ConsoleColor::Yellow,
      ExpressiveColor = ConsoleColor::Yellow,
      ExclamationColor= ConsoleColor::Magenta,
      InformationColor= ConsoleColor::Cyan,
      WarningColor    = ConsoleColor::Yellow,
      ErrorColor      = ConsoleColor::Red,
      SuccessColor    = ConsoleColor::Green,
      OperationColor  = ConsoleColor::White;
};
//**************************************************************************************************

} // XDeviceTest
