﻿#include "Precompiled.h"
#include "SharedIncludes.h"

namespace XDeviceTest {

//==================================================================================================

HANDLE DeviceAccess::OpenHandle(String^ strDeviceLink,DWORD dwDesiredAccess)
{
   $PSZ
      pszDeviceLink=($PSZ)(PVOID)Marshal::StringToHGlobalUni(strDeviceLink);
   try
   {
      HANDLE
         hDeviceFile=::CreateFile( pszDeviceLink, dwDesiredAccess,
                                   0, NULL, OPEN_EXISTING, 0, NULL );
      if (hDeviceFile==INVALID_HANDLE_VALUE)
         throw gcnew Win32Exception();
      return hDeviceFile;
   }
   finally
   {
      Marshal::FreeHGlobal((IntPtr)pszDeviceLink);
   }
}

//--------------------------------------------------------------------------------------------------

String^ DeviceAccess::ObtainLink()
{
   HDEVINFO
      hDeviceInfoSet=::SetupDiGetClassDevs( &GUID_DEVINTERFACE_XDEVICE, NULL, NULL,
                                            DIGCF_DEVICEINTERFACE | DIGCF_PRESENT );
   if (hDeviceInfoSet==INVALID_HANDLE_VALUE)
      throw gcnew Win32Exception();
   try
   {
      SP_DEVICE_INTERFACE_DATA
         deviceInterfaceData,
         deviceInterfaceData_2;

      deviceInterfaceData.cbSize=sizeof(SP_DEVICE_INTERFACE_DATA);
      if (!::SetupDiEnumDeviceInterfaces( hDeviceInfoSet, NULL,
                                          &GUID_DEVINTERFACE_XDEVICE,
                                          0, &deviceInterfaceData ))
         if (::GetLastError()==ERROR_NO_MORE_ITEMS)
            return nullptr;
         else
            throw gcnew Win32Exception();
         
      deviceInterfaceData_2.cbSize=sizeof(SP_DEVICE_INTERFACE_DATA);
      if (::SetupDiEnumDeviceInterfaces( hDeviceInfoSet, NULL,
                                         &GUID_DEVINTERFACE_XDEVICE,
                                         1, &deviceInterfaceData_2 ))
         throw gcnew Win32Exception(
            "Обнаружено несколько экземпляров устройства \"XDevice\". "
            "Наличие более чем одного устройства данного типа не поддерживается." );
      else
         if (::GetLastError()!=ERROR_NO_MORE_ITEMS)
            throw gcnew Win32Exception();

      DWORD dwRequiredSize;

      if (!::SetupDiGetDeviceInterfaceDetail( hDeviceInfoSet, &deviceInterfaceData,
                                              NULL, 0, &dwRequiredSize, NULL ))
         if (::GetLastError()!=ERROR_INSUFFICIENT_BUFFER)
            throw gcnew Win32Exception();

      PSP_DEVICE_INTERFACE_DETAIL_DATA
         pDeviceInterfaceDetailData =
            (PSP_DEVICE_INTERFACE_DETAIL_DATA)
            (PVOID)Marshal::AllocHGlobal(dwRequiredSize);
      try
      {
         pDeviceInterfaceDetailData->cbSize=sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

         if (!::SetupDiGetDeviceInterfaceDetail(
               hDeviceInfoSet, &deviceInterfaceData,
               pDeviceInterfaceDetailData, dwRequiredSize,
               0, NULL ))
            throw gcnew Win32Exception();

         return gcnew String(pDeviceInterfaceDetailData->DevicePath);
      }
      finally
      {
         Marshal::FreeHGlobal((IntPtr)pDeviceInterfaceDetailData);
      }
   }
   finally
   {
      if (!::SetupDiDestroyDeviceInfoList(hDeviceInfoSet))
         throw gcnew Win32Exception();
   }
}

//==================================================================================================

} // XDeviceTest
