@echo off
setlocal

cls
echo EXTRACTING PUBLIC KEY:
echo 

call :RESET_ERROR

set BaseName=XSoft

set CertFileName=%BaseName%.pfx
set PublicKeyFileName_SNK=%BaseName%.PublicKey.snk
set PublicKeyFileName_TXT=%BaseName%.PublicKey.txt
set PublicKeyFileName_CSV=%BaseName%.PublicKey.csv

echo.
echo * Extracting public key to SNK ...
echo.
SN -q -p "%CertFileName%" "%PublicKeyFileName_SNK%"
if %errorlevel% neq 0 goto FAILURE

echo.
echo * Extracting public key to CSV ...
SN -q -o "%PublicKeyFileName_SNK%" "%PublicKeyFileName_CSV%"
if %errorlevel% neq 0 goto FAILURE

echo.
echo * Extracting public key to TXT ...
SN -q -tp "%PublicKeyFileName_SNK%" > %PublicKeyFileName_TXT%
if %errorlevel% neq 0 goto FAILURE

rem ================================================================================

:SUCCESS
echo.
echo  EXTRACT PUBLIC KEY  SUCCESS 
goto FINISH

:FAILURE
echo.
echo  ## EXTRACT PUBLIC KEY  FAILURE 
goto ERROR

rem ================================================================================

:RESET_ERROR
set errorlevel=0
set errorlevel=
goto :EOF

rem ================================================================================

:ERROR
echo 
pause

:ERROR_EXIT
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
call :RESET_ERROR
echo.
pause
goto :EOF

rem ================================================================================
