@echo off
if "%~0"=="GENERATE_N_INSTALL.cmd" goto START
cls

echo GENERATING CERTIFICATE AND INSTALL IT:
echo 

:START
setlocal
set errorlevel=0
set errorlevel=

call #SETTINGS.cmd
if %errorlevel% neq 0 goto ERROR

call :DELETE_FILE %#CertListFile%
if %errorlevel% neq 0 goto FAILURE

if exist "%#CerFile%" goto ALREADY_EXISTS

call :EXEC_CMD MakeCert -r -pe -n "%#x509name%" -$ "%#Authority%" -sky "%#CertKeyType%" -sr "%#StoreLocation%" -ss "%#StoreName%"
if %errorlevel% neq 0 goto FAILURE

call LIST_STORE.cmd
if %errorlevel% neq 0 goto FAILURE

:SUCCESS
if "%~0"=="GENERATE_N_INSTALL.cmd" goto FINISH
echo.
echo  GENERATE AND INSTALL CERTIFICATE  SUCCESS 
goto FINISH

:FAILURE
if "%~0"=="GENERATE_N_INSTALL.cmd" goto ERROR
echo.
echo  ## GENERATE AND INSTALL CERTIFICATE  FAILURE 
goto ERROR

rem ================================================================================

:EXEC_CMD
echo.
echo  %* ...
echo.
%*
goto :EOF

:DELETE_FILE
if not exist "%*" goto :EOF
echo.
echo * Deleting file: "%*" ...
del/q "%*"
if not exist "%*" goto :EOF
set errorlevel=1
goto :EOF

rem ================================================================================

:ALREADY_EXISTS
echo.
echo ## File already exists: "%#CerFile%".
goto FAILURE

rem ================================================================================

:ERROR
if "%~0"=="GENERATE_N_INSTALL.cmd" goto SET_ERROR
echo 
pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="GENERATE_N_INSTALL.cmd" goto :EOF
echo.
pause
goto :EOF

rem ================================================================================
