:SetVar Function "paycoll_CheckBankAccount"
exec sys_DropFunction '$(Function)'
GO
create function [$(Function)]
(
   @Bik              $(dt_Bik),
   @BankAccountID    $(dt_BankAccount)
)
returns bit
AS
BEGIN
/*================================================================================================*/
/*
##      ר ר  ""-:
*/
/*================================================================================================*/

if @Bik is null or
   @BankAccountID is null or
   LEN(@Bik)<>$(num_BikLength) or
   LEN(@BankAccountID)<>$(num_BankAccountLength)
   return 0

----------------------------------------------------------------------------------------------------

declare
   @BikTail       char(3),
   @BikTailCode   int,
   @OrgCodeStr    char(3),
   @Sequence      char(23),
   @Weights       char(23),
   @Sum           int,
   @i             int

----------------------------------------------------------------------------------------------------

select
   @BikTail=SUBSTRING(@Bik,7,3),
   @BikTailCode=convert(int,@BikTail)

if @BikTailCode between 201 and 999
   set @OrgCodeStr=@BikTail
else
   if @BikTail in ('000','001')
      set @OrgCodeStr='0'+SUBSTRING(@Bik,5,2)
   else
      return 0

----------------------------------------------------------------------------------------------------

select
   @Sequence=@OrgCodeStr+@BankAccountID,
   @Weights='71371371371371371371371',
   @Sum=0, @i=1

while @i<=23
   select
      @Sum=@Sum+CONVERT(int,SUBSTRING(@Sequence,@i,1))*
                CONVERT(int,SUBSTRING(@Weights ,@i,1))%10,
      @i=@i+1

return
   case @Sum%10
      when 0 then 1
      else 0
   end

/*================================================================================================*/
END
GO
