:SetVar Procedure "paycoll_SetBankAttributes"
exec sys_DropProcedure '$(Procedure)'
GO
create procedure [$(Procedure)] (@Bik $(dt_Bik),@Name $(dt_Name),@NewBik $(dt_Bik)=null)
AS
/*================================================================================================*/
/*
##    ( Ҩ ):
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
exec [paycoll_VerifyStateAndSecurity]
----------------------------------------------------------------------------------------------------

if @Bik is null or @Name is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

exec [paycoll_VerifyBankAttributes] @Bik,@Name

if @NewBik is not null
   exec [paycoll_VerifyBik] @NewBik

if @Bik=@NewBik
   set @NewBik=null

----------------------------------------------------------------------------------------------------

declare @PaycollDivID uniqueidentifier

exec [paycoll_BikToIdentOfBank] @Bik,@PaycollDivID out

if @NewBik is not null and
   exists( select * from PAYCOLL_DIVISIONS (nolock)
           where ID<>@PaycollDivID and BIK=@NewBik )
   raiserror ('    ""-    .',11,1)

if exists( select * from PAYCOLL_DIVISIONS (nolock)
           where ID<>@PaycollDivID and NAME=@Name )
   raiserror ('        .',11,1)

----------------------------------------------------------------------------------------------------

update
   PAYCOLL_DIVISIONS
set
   BIK = ISNULL(@NewBik,BIK),
   NAME= RTRIM(@Name)
where
   ID=@PaycollDivID

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
