/*================================================================================================*/
/*
##
##     Ҩ :
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
$(BEGIN_TRANSACTION)
----------------------------------------------------------------------------------------------------

/**************************************************************************************************/
/*
##  ( Ҩ ):
*/
----------------------------------------------------------------------------------------------------
create table PAYCOLL_DIVISIONS
(
   ID                      uniqueidentifier        not null
                           constraint DFLT_PAYCOLL_DIVISIONS_ID
                                                   default NEWID()
                                                   rowguidcol,
   BIK                     $(dt_Bik)               not null,
   NAME                    $(dt_Name)              not null,
   constraint PK_PAYCOLL_DIVISIONS                 primary key (ID)
)
----------------------------------------------------------------------------------------------------
create unique index Bik  on PAYCOLL_DIVISIONS (BIK)
create unique index Name on PAYCOLL_DIVISIONS (NAME)
/**************************************************************************************************/


/**************************************************************************************************/
/*
##    ( -):
*/
----------------------------------------------------------------------------------------------------
create table PAYCOLL_PROPERTIES
(
   ID                      uniqueidentifier        not null
                           constraint DFLT_PAYCOLL_PROPERTIES_ID
                                                   default NEWID()
                                                   rowguidcol,
   MANAGEMENT_COMPANY_ID   int                     null,
   TECHSUBDIV_ID           int                     null,
   PAYCOLL_DIV_ID_1        uniqueidentifier        null,
   PAYCOLL_DIV_ID_2        uniqueidentifier        null,
   BANK_ACCOUNT_ID_1       $(dt_BankAccount)       null,
   BANK_ACCOUNT_ID_2       $(dt_BankAccount)       null,
   ADDRESS_1               $(dt_Address)           null,
   ADDRESS_2               $(dt_Address)           null,
   PHONE_1                 $(dt_Phone)             null,
   PHONE_2                 $(dt_Phone)             null,
   PHONE_3                 $(dt_Phone)             null,
   PHONE_4                 $(dt_Phone)             null,
   FINGROUP_CODE           int                     null,
   constraint PK_PAYCOLL_PROPERTIES                primary key (ID),
   constraint UQ_PAYCOLL_PROPERTIES_COMPANY_ID     unique (MANAGEMENT_COMPANY_ID,TECHSUBDIV_ID),
   constraint FK_PAYCOLL_PROPERTIES_DIVISIONS_1    foreign key (PAYCOLL_DIV_ID_1)
                                                   references PAYCOLL_DIVISIONS,
   constraint FK_PAYCOLL_PROPERTIES_DIVISIONS_2    foreign key (PAYCOLL_DIV_ID_2)
                                                   references PAYCOLL_DIVISIONS,
   constraint FK_PAYCOLL_PROPERTIES_COMPANIES      foreign key (MANAGEMENT_COMPANY_ID)
                                                   references [ ],
   constraint FK_PAYCOLL_PROPERTIES_SUBDIVISIONS   foreign key (TECHSUBDIV_ID)
                                                   references TECH_SUBDIVISIONS
)
----------------------------------------------------------------------------------------------------
create index ManagementCompanyID on PAYCOLL_PROPERTIES (MANAGEMENT_COMPANY_ID)
create index TechsubdivID        on PAYCOLL_PROPERTIES (TECHSUBDIV_ID)
/**************************************************************************************************/

----------------------------------------------------------------------------------------------------
$(COMMIT_TRANSACTION)
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
