:SetVar Procedure "QuickInfo:FindByAddress"
exec sys_DropProcedure '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @StreetNamePattern $(dt_String) = null,
   @BuildingNoPattern $(dt_String) = null,
   @FlatNoPattern     $(dt_String) = null 
)
AS
/*================================================================================================*/
/*
##
##   :
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @StreetNamePattern is null and @BuildingNoPattern is null and @FlatNoPattern is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

declare @PrintFintermId int

select @PrintFintermId=MAX(ID) from FIN_TERMS (nolock) where CLOSED=1

----------------------------------------------------------------------------------------------------

select
   RTRIM(s.NAME)+', .'+RTRIM(b.BLDN_NO)+', .'+RTRIM(f.FLAT_NO)
               'ADDRESS',
   o.INITIALS  'INITIALS',
   o.ID        'ACCOUNT_ID',
   dbo.[QuickInfo:ConcatenateSubdivPackCodes](b.TECHSUBDIV_ID,pv.PACK_NO)
               'SUBDIV_PACK_CODES'
from
   OCCUPATIONS o (nolock)
join
   FLATS f (nolock)
   on f.ID=o.FLAT_ID
join
   BUILDINGS b (nolock)
   on b.ID=f.BLDN_ID
join
   STREETS s (nolock)
   on s.ID=b.STREET_ID
left outer join
   PRINT_VERIFICATION pv (nolock)
   on pv.FINTERM_ID=@PrintFintermId and pv.OCC_ID=o.ID
where
   ( @StreetNamePattern is null or s.NAME    like @StreetNamePattern escape '\' ) and
   ( @BuildingNoPattern is null or b.BLDN_NO like @BuildingNoPattern escape '\' ) and
   ( @FlatNoPattern     is null or f.FLAT_NO like @FlatNoPattern     escape '\' )
order by
   s.NAME,
   dbo.GetNo(b.BLDN_NO), b.BLDN_NO,
   dbo.GetNo(f.FLAT_NO), f.FLAT_NO,
   o.INITIALS, o.ID

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [QuickInfo:FindByAddress] '%',null,'11'
*/
