:SetVar Procedure "QuickInfo:FindByInitials"
exec sys_DropProcedure '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @LastNamePattern   $(dt_String) = null,
   @FirstNamePattern  $(dt_String) = null,
   @SecondNamePattern $(dt_String) = null
)
AS
/*================================================================================================*/
/*
##
##   :
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @LastNamePattern is null and @FirstNamePattern is null and @SecondNamePattern is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

declare @PrintFintermId int

select @PrintFintermId=MAX(ID) from FIN_TERMS (nolock) where CLOSED=1

----------------------------------------------------------------------------------------------------

select
   RTRIM(s.NAME)+', .'+RTRIM(b.BLDN_NO)+', .'+RTRIM(f.FLAT_NO)
               'ADDRESS',
   RTRIM(p.LAST_NAME)+' '+RTRIM(p.FIRST_NAME)+' '+RTRIM(p.SECOND_NAME)
               'INITIALS',
   o.ID        'ACCOUNT_ID',
   dbo.[QuickInfo:ConcatenateSubdivPackCodes](b.TECHSUBDIV_ID,pv.PACK_NO)
               'SUBDIV_PACK_CODES'
from
   OCCUPATIONS o (nolock)
join
   PEOPLE p (nolock)
   on p.OCC_ID=o.ID and p.WHO_ID=''
join
   FLATS f (nolock)
   on f.ID=o.FLAT_ID
join
   BUILDINGS b (nolock)
   on b.ID=f.BLDN_ID
join
   STREETS s (nolock)
   on s.ID=b.STREET_ID
left outer join
   PRINT_VERIFICATION pv (nolock)
   on pv.FINTERM_ID=@PrintFintermId and pv.OCC_ID=o.ID
where
   ( @LastNamePattern   is null or p.LAST_NAME   like @LastNamePattern   escape '\' ) and
   ( @FirstNamePattern  is null or p.FIRST_NAME  like @FirstNamePattern  escape '\' ) and
   ( @SecondNamePattern is null or p.SECOND_NAME like @SecondNamePattern escape '\' )
order by
   o.INITIALS,
   s.NAME,
   dbo.GetNo(b.BLDN_NO), b.BLDN_NO,
   dbo.GetNo(f.FLAT_NO), f.FLAT_NO,
   o.ID

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [QuickInfo:FindByInitials] '%%','%','%'
*/
