:SetVar Procedure "QuickInfo:VerifyAppVersion"
exec sys_DropProcedure '$(Procedure)'
GO
create procedure [$(Procedure)] (@Major int,@Minor int,@BuildNumber int,@Revision int)
AS
/*================================================================================================*/
/*
##
##   (  <-->   ):
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @Major is null or @Minor is null or @BuildNumber is null or @Revision is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

declare
   @ReqMajor int, @ReqMinor int,
   @MinBuildNumber int, @MinRevision int,
   @ErrorMessage $(dt_Message)
select
   @ReqMajor=2009, @ReqMinor=4,
   @MinBuildNumber=1, @MinRevision=0

----------------------------------------------------------------------------------------------------

if @Major=@ReqMajor and @Minor=@ReqMinor and
   ( @BuildNumber>@MinBuildNumber or
     @BuildNumber=@MinBuildNumber and @Revision>=@MinRevision )
   return

----------------------------------------------------------------------------------------------------

set @ErrorMessage =
   '      .'+$(NL)+
   '___  "'+ISNULL(APP_NAME(),'QuickInfo')+'": ___'+$(NL)+
   $(BULL)+'    : '+
   LTRIM(STR(@Major))+'.'+LTRIM(STR(@Minor))+'.'+
   LTRIM(STR(@BuildNumber))+'.'+LTRIM(STR(@Revision))+';'+$(NL)+
   $(BULL)+' '+
   case 
      when @Major=@ReqMajor and @Minor=@ReqMinor then
         '   : '
      else
         '   : '
   end+
   LTRIM(STR(@ReqMajor))+'.'+LTRIM(STR(@ReqMinor))+'.'+
   case 
      when @Major=@ReqMajor and @Minor=@ReqMinor
      then LTRIM(STR(@MinBuildNumber)) else '*'
   end+'.'+
   case 
      when @Major=@ReqMajor and @Minor=@ReqMinor
      then LTRIM(STR(@MinRevision)) else '*'
   end+'.'

raiserror (@ErrorMessage,11,1)

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [QuickInfo:VerifyAppVersion] '2000','0','0','0'
exec [QuickInfo:VerifyAppVersion] '2009','4','0','0'
exec [QuickInfo:VerifyAppVersion] '2009','4','1','5'
*/
