:SetVar ProcBaseName "DropFunction"
if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]='$(SysPrefix)$(ProcBaseName)' )
   drop procedure [$(SysPrefix)$(ProcBaseName)]
GO
create procedure [$(SysPrefix)$(ProcBaseName)] (@FuncName $(dt_SysName))
AS
/*================================================================================================*/
/* System Helpers; Author: Sergei Kitaev
----------------------------------------------------------------------------------------------------
##
## === FUNCTION DESTRUCTION (IF EXISTS): ===
##
## Usage: exec <sysprefix>DropFunction '<FunctionName>'
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @FuncName is null
   raiserror ('Incorrect call of "$(SysPrefix)$(ProcBaseName)" procedure.',11,1)

----------------------------------------------------------------------------------------------------

if exists( select * from [sysobjects] (nolock) where [type]='FN' and [name]=@FuncName )
   exec('drop function ['+@FuncName+']')

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
