:SetVar ProcBaseName "DropFunctions"
if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]='$(SysPrefix)$(ProcBaseName)' )
   drop procedure [$(SysPrefix)$(ProcBaseName)]
GO
create procedure [$(SysPrefix)$(ProcBaseName)] (@FuncNamePattern $(dt_SysName))
AS
/*================================================================================================*/
/* System Helpers; Author: Sergei Kitaev
----------------------------------------------------------------------------------------------------
##
## === FUNCTIONS SET DESTRUCTION, BY NAME PATTERN: ===
##
## Usage: exec <sysprefix>DropFunctions '<prefixkwd>\_%'
##
## (Symbol '\' is used as escape character to designate that '_' is not pattern placeholder.)
##
## *** CAUTION: USE THIS PROCEDURE VERY CAREFULLY! ***
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @FuncNamePattern is null
   raiserror ('Incorrect call of "$(SysPrefix)$(ProcBaseName)" procedure.',11,1)

----------------------------------------------------------------------------------------------------

if CHARINDEX(' ',@FuncNamePattern)>0 or @FuncNamePattern='%' or SUBSTRING(@FuncNamePattern,1,2)='%%'
   raiserror ('Incorrect function name pattern.',11,1)

create table #FUNC_LIST ([Name] $(dt_SysName) primary key)
insert #FUNC_LIST
   select [name] from [sysobjects] (nolock)
   where [type]='FN' and [name] like @FuncNamePattern escape '\'

declare @FuncName $(dt_SysName)

while 0=0
begin
   select @FuncName=MIN([Name]) from #FUNC_LIST
   if @FuncName is null
      return

   exec [$(SysPrefix)DropFunction] @FuncName

   delete #FUNC_LIST where [Name]=@FuncName
end

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
