:SetVar ProcBaseName "DropProcedure"
if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]='$(SysPrefix)$(ProcBaseName)' )
   drop procedure [$(SysPrefix)$(ProcBaseName)]
GO
create procedure [$(SysPrefix)$(ProcBaseName)] (@ProcName $(dt_SysName))
AS
/*================================================================================================*/
/* System Helpers; Author: Sergei Kitaev
----------------------------------------------------------------------------------------------------
##
## === PROCEDURE DESTRUCTION (IF EXISTS): ===
##
## Usage: exec <sysprefix>DropProcedure '<ProcedureName>'
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @ProcName is null
   raiserror ('Incorrect call of "$(SysPrefix)$(ProcBaseName)" procedure.',11,1)

----------------------------------------------------------------------------------------------------

if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]=@ProcName )
   exec('drop procedure ['+@ProcName+']')

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
