:SetVar ProcBaseName "DropProcedures"
if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]='$(SysPrefix)$(ProcBaseName)' )
   drop procedure [$(SysPrefix)$(ProcBaseName)]
GO
create procedure [$(SysPrefix)$(ProcBaseName)] (@ProcNamePattern $(dt_SysName))
AS
/*================================================================================================*/
/* System Helpers; Author: Sergei Kitaev
----------------------------------------------------------------------------------------------------
##
## === PROCEDURES SET DESTRUCTION, BY NAME PATTERN: ===
##
## Usage: exec <sysprefix>DropProcedures '<prefixkwd>\_%'
##
## (Symbol '\' is used as escape character to designate that '_' is not pattern placeholder.)
##
## *** CAUTION: USE THIS PROCEDURE VERY CAREFULLY! ***
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @ProcNamePattern is null
   raiserror ('Incorrect call of "$(SysPrefix)$(ProcBaseName)" procedure.',11,1)

----------------------------------------------------------------------------------------------------

if CHARINDEX(' ',@ProcNamePattern)>0 or @ProcNamePattern='%' or SUBSTRING(@ProcNamePattern,1,2)='%%'
   raiserror ('Incorrect procedure name pattern.',11,1)

create table #PROC_LIST ([Name] $(dt_SysName) primary key)
insert #PROC_LIST
   select [name] from [sysobjects] (nolock)
   where [type]='P' and [name] like @ProcNamePattern escape '\'

declare @ProcName $(dt_SysName)

while 0=0
begin
   select @ProcName=MIN([Name]) from #PROC_LIST
   if @ProcName is null
      return

   exec [$(SysPrefix)DropProcedure] @ProcName

   delete #PROC_LIST where [Name]=@ProcName
end

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
