:SetVar ProcBaseName "DropTable"
if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]='$(SysPrefix)$(ProcBaseName)' )
   drop procedure [$(SysPrefix)$(ProcBaseName)]
GO
create procedure [$(SysPrefix)$(ProcBaseName)] (@TableName $(dt_SysName))
AS
/*================================================================================================*/
/* System Helpers; Author: Sergei Kitaev
----------------------------------------------------------------------------------------------------
##
## === TABLE DESTRUCTION (IF EXISTS): ===
##
## Usage: exec <sysprefix>DropTable '<TableName>'
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @TableName is null
   raiserror ('Incorrect call of "$(SysPrefix)$(ProcBaseName)" procedure.',11,1)

----------------------------------------------------------------------------------------------------

if exists( select * from [sysobjects] (nolock) where [type]='U' and [name]=@TableName )
   exec('drop table ['+@TableName+']')

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
