:SetVar ProcBaseName "RevokeExec"
if exists( select * from [sysobjects] (nolock) where [type]='P' and [name]='$(SysPrefix)$(ProcBaseName)' )
   drop procedure [$(SysPrefix)$(ProcBaseName)]
GO
create procedure [$(SysPrefix)$(ProcBaseName)]
(
   @ProcNamePattern  $(dt_SysName),
   @UserOrGroupName  $(dt_SysName)
)
AS
/*================================================================================================*/
/* System Helpers; Author: Sergei Kitaev
----------------------------------------------------------------------------------------------------
##
## === EXECUTION PRIVILEGE REVOCATION: ===
##
## Usage: exec <sysprefix>RevokeExec '<prefixkwd>\_%','<UserOrGroupName>'
##
## (Symbol '\' is used as escape character to designate that '_' is not pattern placeholder.)
##
## *** CAUTION: USE THIS PROCEDURE VERY CAREFULLY! ***
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @ProcNamePattern is null or @UserOrGroupName is null
   raiserror ('Incorrect call of "$(SysPrefix)$(ProcBaseName)" procedure.',11,1)

----------------------------------------------------------------------------------------------------

create table #PROC_LIST ([Name] $(dt_SysName) primary key)
insert #PROC_LIST
   select [name] from [sysobjects] (nolock)
   where [type]='P' and [name] like @ProcNamePattern escape '\'

declare @ProcName $(dt_SysName)

while 0=0
begin
   select @ProcName=MIN([Name]) from #PROC_LIST
   if @ProcName is null
      return

   exec ('revoke execute on ['+@ProcName+'] from ['+@UserOrGroupName+']')

   delete #PROC_LIST where [Name]=@ProcName
end

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
