@echo off
set errorlevel=0
set errorlevel=

call $SQL_SETTINGS.cmd
if %errorlevel% neq 0 goto ERROR

if "%~0"=="MAKE_REPORTS.cmd" goto PLAIN_HEADER
cls

echo MAKING SQL-REPORTS:
echo 
echo.
echo  SQL-Server  : %$sql_server%
echo  SQL-Database: %$sql_database%
echo.
echo 
echo  START REPORTS  (Ctrl+C or Ctrl+Break  break off) 
echo.
pause
goto RUN

:PLAIN_HEADER
echo 
echo  MAKING REPORTS 

:RUN
setlocal

call :DELETE_FILES Sys*.txt
if %errorlevel% neq 0 goto FAILURE

call $SQLTRANS.cmd "sys_databases.sql" "sys_databases.txt"
if %errorlevel% neq 0 goto FAILURE

call $SQLTRANS.cmd "sys_tables.sql" "sys_tables.txt"
if %errorlevel% neq 0 goto FAILURE

call $SQLTRANS.cmd "sys_processes.sql" "sys_processes.txt"
if %errorlevel% neq 0 goto FAILURE

:SUCCESS
if "%~0"=="MAKE_REPORTS.cmd" goto FINISH
echo.
echo  MAKE REPORTS  SUCCESS 
echo 
goto FINISH

:FAILURE
if "%~0"=="MAKE_REPORTS.cmd" goto ERROR
echo.
echo  ## MAKE REPORTS  FAILURE 
echo 
goto ERROR

rem ================================================================================

:DELETE_FILES
if not exist "%*" goto :EOF
echo.
echo * Deleting files: "%*" ...
del/q "%*"
if not exist "%*" goto :EOF
set errorlevel=1
goto :EOF

rem ================================================================================

:ERROR
if "%~0"=="MAKE_REPORTS.cmd" goto SET_ERROR
echo 
pause

:SET_ERROR
endlocal
set errorlevel=1
goto :EOF

:FINISH
endlocal
set errorlevel=0
set errorlevel=
if "%~0"=="MAKE_REPORTS.cmd" goto :EOF
echo.
pause

rem ================================================================================
