﻿using System;

using XHelpers;

namespace ConsoleCalculator {

//**************************************************************************************************
/// <summary>
/// Main class in this program (however, application entry point is in "Startup" class).
/// </summary>
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// CONSTANTS:

const string
   _InputPrimaryOperand_Message_ = "Input primary operand",
   _InputOperand_Message_        = "Input operand",
   _PressOperationKey_Message_   = "Press operation key";

//--------------------------------------------------------------------------------------------------

// STATIC READONLY FIELDS:

static readonly string[]
   _OperationCaptions_=
   {
      "- (invert sign)",
      "+ (plus)",
      "- (minus)",
      "* (multiply by)",
      "/ (divide by)",
      "Power (raise to)",
      "<< Repeat last operation >>",
      "<< One operation back >>"
   };

static readonly ConsoleKey[]
   _MainOperationKeysArray_ =
   {
      ConsoleKey.Subtract, // unary -
      ConsoleKey.Add,      // +
      ConsoleKey.Subtract, // -
      ConsoleKey.Multiply, // *
      ConsoleKey.Divide,   // /
      ConsoleKey.Multiply, // power
      ConsoleKey.Enter,    // repeate last operation
      ConsoleKey.Backspace // one operation back
   },
   _AltOperationKeysArray_ =
   {
      ConsoleKey.OemMinus, // unary -
      ConsoleKey.OemPlus,  // +
      ConsoleKey.OemMinus, // -
      ConsoleKey.D8,       // *
      ConsoleKey.Oem2,     // /
      ConsoleKey.D8,       // power
      ConsoleKey.Enter,    // repeate last operation
      ConsoleKey.Backspace // one operation back
   },
   _OperationKeysArray_ = XArray.Concatenate
   (
      _MainOperationKeysArray_,
      _AltOperationKeysArray_
   );

static readonly ConsoleModifiers[]
   _MainOperationModifiersArray_ =
   {
      ConsoleModifiers.Control, // unary -
      0,                        // +
      0,                        // -
      0,                        // *
      0,                        // /
      ConsoleModifiers.Control, // power
      0,                        // repeate last operation
      0                         // one operation back
   },
   _OperationModifiersArray_ = XArray.Concatenate
   (
      _MainOperationModifiersArray_,
      _MainOperationModifiersArray_
   );

static readonly int
   _MaxInputCaptionLength_ = XString.MaxLength
   (
      _InputPrimaryOperand_Message_,
      _InputOperand_Message_,
      _PressOperationKey_Message_
   );

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ConsoleCalculator
