﻿using System;

using XHelpers;

namespace ConsoleCalculator {

//**************************************************************************************************
static class Sounds {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static readonly XSound
   Startup  = new XSound(),
   Exit     = new XSound(),
   Back     = new XSound();

//==================================================================================================

static Sounds()
{
   XSound.PlaySoundCallback =
      delegate (XSound sound,bool synch)
      {
         if (sound==Startup) Play( synch, 0.5,1, 1,1,  2,1,  4,1   ); else
         if (sound==Exit   ) Play( synch, 4,1,   2,1,  1,1,  0.5,1 ); else
         if (sound==Back   ) Play( synch, 2,1,   1,1               ); else
            return false;
         return true;
      };
}

//--------------------------------------------------------------------------------------------------

static void Play(bool synchronously,params double[] beeps)
{
   XBeeper.Play( synchronously, beeps );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Sounds
//**************************************************************************************************

} // ConsoleCalculator
