:SetVar Procedure "PaycorMaster:AcceptDocumentTypeName"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @DocumentTypeId   uniqueidentifier = null,
   @DocumentTypeName $(dt_Name) out
)
AS
/*================================================================================================*/
/*
##     :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @DocumentTypeName is null
   raiserror ('   "$(Procedure)".',11,1)

if @DocumentTypeName=''
   raiserror ('   .',11,1)
if @DocumentTypeName<>LTRIM(@DocumentTypeName)
   raiserror ('   .',11,1)

----------------------------------------------------------------------------------------------------

set @DocumentTypeName=RTRIM(@DocumentTypeName)

----------------------------------------------------------------------------------------------------

if @DocumentTypeId is not null and
   not exists( select * from [CORRECTION_DOCUMENT_TYPES] (nolock) where [Id]=@DocumentTypeId )
   raiserror ('      .',11,1)

if exists
(
   select *
   from [CORRECTION_DOCUMENT_TYPES] (nolock)
   where [Name]=@DocumentTypeName and (@DocumentTypeId is null or [Id]<>@DocumentTypeId)
)
   raiserror ('       .',11,1)

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
