:SetVar Procedure "PaycorMaster:AcceptConnection"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @UserName               $(dt_Name)  out,
   @IsUserInSysadminRole   bit         out
)
AS
/*================================================================================================*/
/*
##
##   :
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
--exec [Correction:VerifyStateAndSecurity]
----------------------------------------------------------------------------------------------------

declare
   @ApplicationName  $(dt_SysName),
   @UserLogName      $(dt_SysName)

exec [Correction:ObtainPerformerInfo]
   @UserName            = @UserName             out,
   @UserLogName         = @UserLogName          out,
   @ApplicationName     = @ApplicationName      out,
   @IsUserInSysadminRole= @IsUserInSysadminRole out

----------------------------------------------------------------------------------------------------

declare @PreviousUserLogName $(dt_SysName)

select
   @PreviousUserLogName = RTRIM([loginame])
from
   [master]..[sysprocesses] (nolock)
where
   [spid]         <> @@SPID      and
   [dbid]         =  DB_ID()     and
   [hostname]     =  HOST_NAME() and
   [program_name] =  APP_NAME()

if @PreviousUserLogName is not null
begin
   declare @ErrorMessage $(dt_Message)
   set @ErrorMessage =
      ' '+$(LAQUO)+@ApplicationName+$(RAQUO)+'     '+
      '  :'+$(NL)+
      $(RARROW)+' : "'+HOST_NAME()+'";'+$(NL)+
      $(RARROW)+' SQL-: "'+@@SERVERNAME+'";'+$(NL)+
      $(RARROW)+'  : "'+DB_NAME()+'";'+$(NL)+
      $(RARROW)+'  : "'+@UserLogName+'";'+$(NL)+
      $(RARROW)+'   : "'+@PreviousUserLogName+'".'
   raiserror (@ErrorMessage,11,1)
end

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [PaycorMaster:AcceptConnection]
*/
