:SetVar Procedure "PaycorMaster:AddCause"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @CauseId          uniqueidentifier  out,
   @CauseName        $(dt_Name),
   @CountersRelated  bit,

   @ErrorMessage     $(dt_Message)     out
)
AS
/*================================================================================================*/
/*
##   :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @CauseName is null or @CountersRelated is null
   raiserror ('   "$(Procedure)".',11,1)

exec [PaycorMaster:AcceptCauseName] @CauseName=@CauseName out

----------------------------------------------------------------------------------------------------

set @CauseId=NEWID()

insert [CORRECTION_CAUSES]
   ( [Id], [Name], [CountersRelated] )
values
   ( @CauseId, @CauseName, @CountersRelated )

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
