:SetVar Procedure "PaycorMaster:AddDocumentType"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @DocumentTypeId   uniqueidentifier  out,
   @DocumentTypeName $(dt_Name),

   @ErrorMessage     $(dt_Message)     out
)
AS
/*================================================================================================*/
/*
##    :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
----------------------------------------------------------------------------------------------------
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @DocumentTypeName is null
   raiserror ('   "$(Procedure)".',11,1)

exec [PaycorMaster:AcceptDocumentTypeName] @DocumentTypeName=@DocumentTypeName out

----------------------------------------------------------------------------------------------------

set @DocumentTypeId=NEWID()

insert [CORRECTION_DOCUMENT_TYPES]
   ( [Id], [Name] )
values
   ( @DocumentTypeId, @DocumentTypeName )

----------------------------------------------------------------------------------------------------
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
