:SetVar Procedure "PaycorMaster:ExcludeCause"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @CauseId       uniqueidentifier,

   @Percental     bit,
   @AffectsUnits  bit,

   @ErrorMessage  $(dt_Message) out
)
AS
/*================================================================================================*/
/*
##       ( ):
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @CauseId is null or @Percental is null or @AffectsUnits is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

delete
   [CORRECTION_TYPE_FLAGS]
where
   [CauseId]     = @CauseId and
   [Percental]   = @Percental and
   [AffectsUnits]= @AffectsUnits

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
*/
