:SetVar Procedure "PaycorMaster:GetCandidateCauses"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)] (@Percental bit,@AffectsUnits bit)
AS
/*================================================================================================*/
/*
##   -    :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @Percental is null or @AffectsUnits is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

select
   ca.[Id],
   ca.[Name],
   ca.[CountersRelated]
from
   [CORRECTION_CAUSES] ca (nolock)
left outer join
   [CORRECTION_TYPE_FLAGS] f (nolock)
   on f.[CauseId]     = ca.[Id] and
      f.[Percental]   = @Percental and
      f.[AffectsUnits]= @AffectsUnits
where
   ca.[Indeterminate] = 0 and
   f.[CauseId] is null

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [PaycorMaster:GetCandidateCauses] 1,1
exec [PaycorMaster:GetCandidateCauses] 1,0
exec [PaycorMaster:GetCandidateCauses] 0,0
exec [PaycorMaster:GetCandidateCauses] 0,1
*/
