:SetVar Procedure "PaycorMaster:ModifyCause"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @CauseId          uniqueidentifier,
   @CauseName        $(dt_Name),
   @CountersRelated  bit,

   @ErrorMessage     $(dt_Message) out
)
AS
/*================================================================================================*/
/*
##   :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------
--raiserror ('  .',11,1)
----------------------------------------------------------------------------------------------------

if @CauseId is null or @CauseName is null or @CountersRelated is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

exec [PaycorMaster:AcceptCauseName]  @CauseId, @CauseName out

----------------------------------------------------------------------------------------------------

update
   [CORRECTION_CAUSES]
set
   [Name]=@CauseName,
   [CountersRelated]=@CountersRelated
where
   [Id]=@CauseId

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
