:SetVar Procedure "PaycorMaster:ModifyDocumentType"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @DocumentTypeId   uniqueidentifier,
   @DocumentTypeName $(dt_Name),

   @ErrorMessage     $(dt_Message) out
)
AS
/*================================================================================================*/
/*
##    :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @DocumentTypeId is null or @DocumentTypeName is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

exec [PaycorMaster:AcceptDocumentTypeName]  @DocumentTypeId, @DocumentTypeName out

----------------------------------------------------------------------------------------------------

update [CORRECTION_DOCUMENT_TYPES] set [Name]=@DocumentTypeName where [Id]=@DocumentTypeId

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
