:SetVar Procedure "PaycorMaster:RemoveCause"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @CauseId       uniqueidentifier,

   @ErrorMessage  $(dt_Message) out
)
AS
/*================================================================================================*/
/*
##   :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @CauseId is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------
/*
if exists( select * from [PERFORMED_CORRECTION_OPERATIONS] (nolock) where [CauseId]=@CauseId )
   raiserror ('      .',11,1)
*/
----------------------------------------------------------------------------------------------------
$(BEGIN_TRANSACTION)
----------------------------------------------------------------------------------------------------

delete [CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE] where [CauseId]=@CauseId
delete [CORRECTION_TYPE_FLAGS] where [CauseId]=@CauseId
delete [CORRECTION_CAUSES] where [Id]=@CauseId

----------------------------------------------------------------------------------------------------
$(COMMIT_TRANSACTION)
----------------------------------------------------------------------------------------------------

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   $(ROLLBACK_UNCOMMITED)
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
