:SetVar Procedure "PaycorMaster:RemoveDocumentType"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @DocumentTypeId   uniqueidentifier,

   @ErrorMessage     $(dt_Message) out
)
AS
/*================================================================================================*/
/*
##    :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @DocumentTypeId is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------
/*
if exists
(
   select *
   from [PERFORMED_CORRECTION_OPERATIONS] (nolock)
   where [DocumentTypeId]=@DocumentTypeId
)
   raiserror ('      .',11,1)
*/
----------------------------------------------------------------------------------------------------
$(BEGIN_TRANSACTION)
----------------------------------------------------------------------------------------------------

delete [CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE] where [DocumentTypeId]=@DocumentTypeId

delete [CORRECTION_DOCUMENT_TYPES] where [Id]=@DocumentTypeId

----------------------------------------------------------------------------------------------------
$(COMMIT_TRANSACTION)
----------------------------------------------------------------------------------------------------

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   $(ROLLBACK_UNCOMMITED)
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
