:SetVar Procedure "PaycorMaster:UnbindDocumentType"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @CauseId          uniqueidentifier,
   @DocumentTypeId   uniqueidentifier,

   @ErrorMessage     $(dt_Message) out
)
AS
/*================================================================================================*/
/*
##     :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
BEGIN TRY
/*================================================================================================*/
--exec [Correction:VerifyStateAndSecurity] 1
----------------------------------------------------------------------------------------------------

if @CauseId is null or @DocumentTypeId is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

delete
   [CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE]
where
   [CauseId]       = @CauseId and
   [DocumentTypeId]= @DocumentTypeId

/*================================================================================================*/
END TRY
----------------------------------------------------------------------------------------------------
BEGIN CATCH
   set @ErrorMessage=ERROR_MESSAGE()
   return 1
END CATCH
----------------------------------------------------------------------------------------------------
set @ErrorMessage=null
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
