:SetVar Procedure "PaycorMaster:VerifyAppVersion"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)] (@Major int,@Minor int,@BuildNumber int,@Revision int)
AS
/*================================================================================================*/
/*
##
##   :
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @Major is null or @Minor is null or @BuildNumber is null or @Revision is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

declare
   @ReqMajor int, @ReqMinor int, @MinBuildNumber int, @MinRevision int

select
   @ReqMajor      = 2009,
   @ReqMinor      = 11,
   @MinBuildNumber= 0,
   @MinRevision   = 0

if @Major=@ReqMajor and @Minor=@ReqMinor and
   ( @BuildNumber>@MinBuildNumber or
     @BuildNumber=@MinBuildNumber and @Revision>=@MinRevision )
   return

----------------------------------------------------------------------------------------------------

declare
   @ApplicationName  $(dt_SysName),
   @ErrorMessage     $(dt_Message)

exec [Correction:GetApplicationName] @ApplicationName out

set @ErrorMessage =
   '      .'+$(NLNL)+
   '___  '+$(LAQUO)+@ApplicationName+$(RAQUO)+': ___'+$(NL)+
   $(BULL)+'    : '+
   LTRIM(STR(@Major))+'.'+LTRIM(STR(@Minor))+'.'+
   LTRIM(STR(@BuildNumber))+'.'+LTRIM(STR(@Revision))+';'+$(NL)+
   $(BULL)+' '+
   case 
      when @Major=@ReqMajor and @Minor=@ReqMinor then
         '   : '
      else
         '   : '
   end+
   LTRIM(STR(@ReqMajor))+'.'+LTRIM(STR(@ReqMinor))+'.'+
   case 
      when @Major=@ReqMajor and @Minor=@ReqMinor
      then LTRIM(STR(@MinBuildNumber)) else '*'
   end+'.'+
   case 
      when @Major=@ReqMajor and @Minor=@ReqMinor
      then LTRIM(STR(@MinRevision)) else '*'
   end+'.'

raiserror (@ErrorMessage,11,1)

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [PaycorMaster:VerifyAppVersion]  2009, 11, 1, 0
exec [PaycorMaster:VerifyAppVersion]  2009, 5, 0, 0
exec [PaycorMaster:VerifyAppVersion]  2009, 5, 3, 7
*/
