:SetVar Procedure "Correction:ObtainPerformerInfo"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @UserName               $(dt_Name)   = null out,
   @UserLogName            $(dt_SysName)= null out,
   @HostName               $(dt_SysName)= null out,
   @ApplicationName        $(dt_SysName)= null out,
   @IsUserInSysadminRole   bit          = null out
)
AS
/*================================================================================================*/
/*
##      :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

set @UserLogName=SUSER_SNAME()

if @UserLogName is null
   raiserror (
      '       .',
      11, 1 )

----------------------------------------------------------------------------------------------------
/*
select
   @UserName=RTRIM(FAMILY_NAME)+' '+RTRIM(FIRST_NAME)+' '+RTRIM(SECOND_NAME)
from
   [USERS] u (nolock)
where
   [login_name]=@UserLogName

if @UserName is null
   raiserror (
      '       .',
      11, 1 )
*/
set @UserName=' '
----------------------------------------------------------------------------------------------------

set @HostName=HOST_NAME()

if @HostName is null
   raiserror (
      '       .',
      11, 1 )

----------------------------------------------------------------------------------------------------

exec [Correction:GetApplicationName] @ApplicationName out

----------------------------------------------------------------------------------------------------

set @IsUserInSysadminRole=dbo.[Correction:IsUserInSysadminRole]()

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
set nocount on
declare @UserName nvarchar(100), @UserLogName nvarchar(128), @HostName nvarchar(128)
exec [Correction:ObtainPerformerInfo] @UserName out, @UserLogName out, @HostName out
select @UserName    'UserName'
select @UserLogName 'UserLogName'
select @HostName    'HostName'
*/
