:SetVar Procedure "Correction:GetCauseDocumentTypes"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)] (@CauseId uniqueidentifier)
AS
/*================================================================================================*/
/*
##    ,  ˨  :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @CauseId is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------

select
   dt.[Id],
   dt.[Name],
   CONVERT($(dt_GuidStr),dt.[Id]) 'IdStr'
from
   [CORRECTION_DOCUMENT_TYPES] dt (nolock)
join
   [CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE] c_dt (nolock)
   on c_dt.[CauseId]       = @CauseId and
      c_dt.[DocumentTypeId]= dt.[Id]
where
   dt.[Indeterminate]=0
order by
   dt.[Name]

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [Correction:GetCauseDocumentTypes] 'E54FD615-FA0C-44EF-A3CD-643A71D9555C'
exec [Correction:GetCauseDocumentTypes] 'E54FD615-FA0C-44EF-A3CD-643A71D9555C',0
exec [Correction:GetCauseDocumentTypes] '75D6D95B-ED8B-47A1-A6F4-3806F447B905'
*/
