:SetVar Procedure "Correction:GetCauses"
exec [sys_DropProcedure] '$(Procedure)'
GO
create procedure [$(Procedure)]
(
   @ServiceId     $(dt_ServiceId),
   @Percental     bit = 0,
   @AffectsUnits  bit = 0
)
AS
/*================================================================================================*/
/*
##    :
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------

if @ServiceId is null or @Percental is null or @AffectsUnits is null
   raiserror ('   "$(Procedure)".',11,1)

----------------------------------------------------------------------------------------------------
/*
declare @IsServiceCountable bit
set @IsServiceCountable =
   case
      when exists( select * from [COUNTABLE_SERVICES] (nolock) where [SERVICE_ID]=@ServiceId )
      then 1 else 0
   end
*/
select
   ca.[Id],
   ca.[Name],
   CONVERT($(dt_GuidStr),ca.[Id]) 'IdStr'
from
   [CORRECTION_CAUSES] ca (nolock)
join
   [CORRECTION_TYPE_FLAGS] f (nolock)
   on f.[CauseId]=ca.[Id]
where
   ca.[Indeterminate] = 0 and
   f.[Percental]   = @Percental and
   f.[AffectsUnits]= @AffectsUnits --and
/*
   not
   (
      @IsServiceCountable=0 and [CountersRelated]=1
   or
      f.[AffectsUnits]=1 and @ServiceId in (
      '','','','','','','','','','','','' )
   or
      @ServiceId='' and [Id] not in (
      '56C486A2-288B-467A-8504-D455A84814DF' )
   )
*/
order by
   ca.[Name]

----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
GO
--grant exec on [$(Procedure)] to [$(ident_AuthorizedGroup)]
GO
/*
exec [Correction:GetCauses] '',1,1
exec [Correction:GetCauses] '',1,0
exec [Correction:GetCauses] '',0,0
exec [Correction:GetCauses] '',0,1

exec [Correction:GetCauses] '',1,1
exec [Correction:GetCauses] '',1,0
exec [Correction:GetCauses] '',0,0
exec [Correction:GetCauses] '',0,1

exec [Correction:GetCauses] '',0,0
*/
