/*================================================================================================*/
/*
##
##    :
##
*/
/*================================================================================================*/
$(BEGIN)
----------------------------------------------------------------------------------------------------
$(BEGIN_TRANSACTION)
----------------------------------------------------------------------------------------------------

set NOCOUNT on

/**************************************************************************************************/
/*
##  :
*/
----------------------------------------------------------------------------------------------------
:SetVar str_IndeterminateCauseId "'3B0CA3CB-5D3C-4C44-A950-389BB349F768'"
----------------------------------------------------------------------------------------------------
create table [CORRECTION_CAUSES]
(
   [Id]                 uniqueidentifier rowguidcol
                        constraint [DFLT:CORRECTION_CAUSES.Id]
                        default NEWID(),
   [Name]               $(dt_Name) not null,
   [Indeterminate]      bit not null
                        constraint [DFLT:CORRECTION_CAUSES.Indeterminate]
                        default 0,
   [CountersRelated]    bit not null
                        constraint [DFLT:CORRECTION_CAUSES.ConsumptionRelated]
                        default 0
   constraint
      [PK:CORRECTION_CAUSES]
      primary key ( [Id] ),
   constraint
      [UQ:CORRECTION_CAUSES.Name]
      unique ( [Name] )
)
----------------------------------------------------------------------------------------------------
create index [Name] on [CORRECTION_CAUSES] ([Name])
----------------------------------------------------------------------------------------------------
insert [CORRECTION_CAUSES] values ( $(str_IndeterminateCauseId), '< >', 1, 0 )
/**************************************************************************************************/


/**************************************************************************************************/
/*
##   :
*/
----------------------------------------------------------------------------------------------------
create table [CORRECTION_TYPE_FLAGS]
(
   [CauseId]         uniqueidentifier  not null,
   [Percental]       bit               not null,
   [AffectsUnits]    bit               not null

   constraint
      [PK:CORRECTION_TYPE_FLAGS]
      primary key ( [CauseId], [Percental], [AffectsUnits] )
   constraint
      [FK:CORRECTION_TYPE_FLAGS.CauseId-CORRECTION_CAUSES]
      foreign key ( [CauseId] )
      references [CORRECTION_CAUSES]
)
----------------------------------------------------------------------------------------------------
insert [CORRECTION_TYPE_FLAGS] values ( $(str_IndeterminateCauseId), 0, 0 )
insert [CORRECTION_TYPE_FLAGS] values ( $(str_IndeterminateCauseId), 0, 1 )
insert [CORRECTION_TYPE_FLAGS] values ( $(str_IndeterminateCauseId), 1, 0 )
insert [CORRECTION_TYPE_FLAGS] values ( $(str_IndeterminateCauseId), 1, 1 )
/**************************************************************************************************/


/**************************************************************************************************/
/*
##  ,     :
*/
----------------------------------------------------------------------------------------------------
create table [CORRECTION_DOCUMENT_TYPES]
(
   [Id]              uniqueidentifier rowguidcol
                     constraint [DFLT:CORRECTION_DOCUMENT_TYPES.Id]
                     default NEWID(),
   [Name]            $(dt_Name)  not null,
   [Indeterminate]   bit         not null
                     constraint [DFLT:CORRECTION_DOCUMENT_TYPES.Indeterminate]
                     default 0
   constraint
      [PK:CORRECTION_DOCUMENT_TYPES]
      primary key ( [Id] ),
   constraint
      [UQ:CORRECTION_DOCUMENT_TYPES.Name]
      unique ( [Name] )
)
----------------------------------------------------------------------------------------------------
create index [Name] on [CORRECTION_DOCUMENT_TYPES] ([Name])
----------------------------------------------------------------------------------------------------
insert [CORRECTION_DOCUMENT_TYPES] values
(
   '1EA870AF-EF35-4C0C-8434-67124DC7DA8A', '<  >', 1
)
/**************************************************************************************************/


/**************************************************************************************************/
/*
##     :
*/
----------------------------------------------------------------------------------------------------
create table [CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE]
(
   [CauseId]         uniqueidentifier not null,
   [DocumentTypeId]  uniqueidentifier not null

   constraint
      [PK:CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE]
      primary key ( [CauseId], [DocumentTypeId] ),
   constraint
      [FK:CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE.CauseId-CORRECTION_CAUSES]
      foreign key ( [CauseId] )
      references [CORRECTION_CAUSES],
   constraint
      [FK:CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE.DocumentTypeId-CORRECTION_DOCUMENT_TYPES]
      foreign key ( [DocumentTypeId] )
      references [CORRECTION_DOCUMENT_TYPES]
)
----------------------------------------------------------------------------------------------------
create index [DocumentTypeId]
   on [CORRECTION_CAUSE_DOCTYPE_CORRESPONDENCE] ( [DocumentTypeId] )
/**************************************************************************************************/

----------------------------------------------------------------------------------------------------
$(COMMIT_TRANSACTION)
----------------------------------------------------------------------------------------------------
$(END)
/*================================================================================================*/
