﻿using System;
using System.Reflection;
using System.ComponentModel;
using System.Globalization;

using System.Windows;
using System.Windows.Data;
using System.Windows.Media.Imaging;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public class CorrectionCause: INotifyPropertyChanged {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public event PropertyChangedEventHandler PropertyChanged;

//--------------------------------------------------------------------------------------------------

public CorrectionCause(Guid id,string name,bool isCountersRelated)
{
   _Id_               = id;
   _Name_             = name;
   _IsCountersRelated_= isCountersRelated;
}

//--------------------------------------------------------------------------------------------------

public Guid Id
{
   get { return _Id_; }
}

public string Name
{
   get {
      return _Name_; }
   set {
      _Name_ = value;
      OnPropertyChanged(MethodBase.GetCurrentMethod()); }
}

public bool IsCountersRelated
{
   get {
      return _IsCountersRelated_; }
   set {
      _IsCountersRelated_ = value;
      OnPropertyChanged(MethodBase.GetCurrentMethod()); }
}

//--------------------------------------------------------------------------------------------------

public void OnPropertyChanged(string propertyName)
{
   if (PropertyChanged!=null)
      PropertyChanged(this,new PropertyChangedEventArgs(propertyName));
}

//==================================================================================================

void OnPropertyChanged(MethodBase setMethod)
{
   OnPropertyChanged(XPropertyInfo.ExtractNameBySetMethod(setMethod));
}

//==================================================================================================

Guid
   _Id_;
string
   _Name_;
bool
   _IsCountersRelated_;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // CorrectionCause
//**************************************************************************************************


//**************************************************************************************************
public class CorrectionCauseToImageConverter: IMultiValueConverter {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public object Convert(object[] values,Type targerType,object parameter,CultureInfo culture)
{
   var isCauseCountersRelated = (bool)values[0];

   return isCauseCountersRelated ? _CounterImage_ : null;
}

public object[] ConvertBack(object value,Type[] targetTypes,object parameter,CultureInfo culture)
{
   throw new NotSupportedException();
}

//==================================================================================================

static readonly BitmapImage
   _CounterImage_ = new BitmapImage(new Uri("/Images/Counter.ico",UriKind.Relative));

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // CorrectionCauseToImageConverter
//**************************************************************************************************

} // PaycorMaster
