﻿using System;

using System.Windows;
using System.Windows.Input;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public class AppCommands {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static RoutedUICommand Close
   { get { return _Close_; } }
public static RoutedUICommand ClosePage
   { get { return _ClosePage_; } }

public static RoutedUICommand ConnectDatabase
   { get { return _ConnectDatabase_; } }
public static RoutedUICommand DisconnectDatabase
   { get { return _DisconnectDatabase_; } }

public static RoutedUICommand OpenConfigurationPage
   { get { return _OpenConfigurationPage_; } }

public static RoutedUICommand Options
   { get { return _Options_; } }

public static RoutedUICommand About
   { get { return _About_; } }

//==================================================================================================

static readonly RoutedUICommand _Close_;
static readonly RoutedUICommand _ClosePage_;

static readonly RoutedUICommand _ConnectDatabase_;
static readonly RoutedUICommand _DisconnectDatabase_;

static readonly RoutedUICommand _OpenConfigurationPage_;

static readonly RoutedUICommand _Options_;

static readonly RoutedUICommand _About_;

//--------------------------------------------------------------------------------------------------

static AppCommands()
{
   _Close_ = new RoutedUICommand(
      "Закрытие программы",
      "Close",
      typeof(AppCommands),
      XInput.CreateInputs(Key.F4,ModifierKeys.Alt) );
   _ClosePage_ = new RoutedUICommand(
      "Закрытие страницы",
      "ClosePage",
      typeof(AppCommands),
      XInput.CreateInputs(Key.F4,ModifierKeys.Control) );

   _ConnectDatabase_ = new RoutedUICommand(
      "Подключение к базе данных",
      "ConnectDatabase",
      typeof(AppCommands),
      XInput.CreateInputs(Key.O,ModifierKeys.Control) );
   _DisconnectDatabase_ = new RoutedUICommand(
      "Отключение от базы данных",
      "DisconnectDatabase",
      typeof(AppCommands),
      XInput.CreateInputs(Key.D,ModifierKeys.Control) );

   _OpenConfigurationPage_ = new RoutedUICommand(
      "Конфигурирование системы",
      "OpenConfigurationPage",
      typeof(AppCommands) );

   _Options_ = new RoutedUICommand(
      "Установка пользовательских настроек",
      "Options",
      typeof(AppCommands),
      XInput.CreateInputs(Key.O,ModifierKeys.Control|ModifierKeys.Shift) );

   _About_ = new RoutedUICommand(
      "О программе",
      "About",
      typeof(AppCommands) );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // AppCommands
//**************************************************************************************************

} // PaycorMaster
