﻿using System;

using System.Windows;
using System.Windows.Input;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public class ConfigurationCommands {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static RoutedUICommand CreateCause
   { get { return _CreateCause_; } }
public static RoutedUICommand EditCause
   { get { return _EditCause_; } }
public static RoutedUICommand RemoveCause
   { get { return _RemoveCause_; } }

public static RoutedUICommand CreateDocumentType
   { get { return _CreateDocumentType_; } }
public static RoutedUICommand EditDocumentType
   { get { return _EditDocumentType_; } }
public static RoutedUICommand RemoveDocumentType
   { get { return _RemoveDocumentType_; } }

public static RoutedUICommand IncludeCause
   { get { return _IncludeCause_; } }
public static RoutedUICommand ExcludeCause
   { get { return _ExcludeCause_; } }

public static RoutedUICommand BindDocumentType
   { get { return _BindDocumentType_; } }
public static RoutedUICommand UnbindDocumentType
   { get { return _UnbindDocumentType_; } }

//==================================================================================================

static readonly RoutedUICommand _CreateCause_;
static readonly RoutedUICommand _EditCause_;
static readonly RoutedUICommand _RemoveCause_;

static readonly RoutedUICommand _CreateDocumentType_;
static readonly RoutedUICommand _EditDocumentType_;
static readonly RoutedUICommand _RemoveDocumentType_;

static readonly RoutedUICommand _IncludeCause_;
static readonly RoutedUICommand _ExcludeCause_;

static readonly RoutedUICommand _BindDocumentType_;
static readonly RoutedUICommand _UnbindDocumentType_;

//--------------------------------------------------------------------------------------------------

static ConfigurationCommands()
{
   _CreateCause_ = new RoutedUICommand(
      "Создание причины корректировки",
      "CreateCause",
      typeof(ConfigurationCommands) );
   _EditCause_ = new RoutedUICommand(
      "Редактирование причины корректировки",
      "EditCause",
      typeof(ConfigurationCommands) );
   _RemoveCause_ = new RoutedUICommand(
      "Удаление причины корректировки",
      "RemoveCause",
      typeof(ConfigurationCommands) );

   _CreateDocumentType_ = new RoutedUICommand(
      "Создание типа документа корректировки",
      "CreateDocumentType",
      typeof(ConfigurationCommands) );
   _EditDocumentType_ = new RoutedUICommand(
      "Редактирование типа документа корректировки",
      "EditDocumentType",
      typeof(ConfigurationCommands) );
   _RemoveDocumentType_ = new RoutedUICommand(
      "Удаление типа документа корректировки",
      "RemoveDocumentType",
      typeof(ConfigurationCommands) );

   _IncludeCause_ = new RoutedUICommand(
      "Подключение причины корректировки",
      "IncludeCause",
      typeof(ConfigurationCommands) );
   _ExcludeCause_ = new RoutedUICommand(
      "Отключение причины корректировки",
      "ExcludeCause",
      typeof(ConfigurationCommands) );

   _BindDocumentType_ = new RoutedUICommand(
      "Подключение типа документа к причине корректировки",
      "BindDocumentType",
      typeof(ConfigurationCommands) );
   _UnbindDocumentType_ = new RoutedUICommand(
      "Отключение типа документа от причины корректировки",
      "UnbindDocumentType",
      typeof(ConfigurationCommands) );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // ConfigurationCommands
//**************************************************************************************************

} // PaycorMaster
