﻿using System;
using System.ComponentModel;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public class CustomPage: Page {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public bool FocusFirstElementOnLoad { get; set; }

public new DependencyObject VisualParent
{
   get { return base.VisualParent; }
}

//--------------------------------------------------------------------------------------------------

public CustomPage()
{
   FocusFirstElementOnLoad = true;
}

//--------------------------------------------------------------------------------------------------

public virtual void DoCommandExecuted(object sender,ExecutedRoutedEventArgs e)
{}

public virtual void DoCommandCanExecute(object sender,CanExecuteRoutedEventArgs e)
{}

//--------------------------------------------------------------------------------------------------

public virtual void DoKeyDown(object sender,KeyEventArgs e)
{}

//==================================================================================================

protected override void OnInitialized(EventArgs e)
{
   base.OnInitialized(e);

   if (!DesignerProperties.GetIsInDesignMode(this))
   {
      Loaded += Page_Loaded;
   }
}

//==================================================================================================

void Page_Loaded(object sender,RoutedEventArgs e)
{
   XInput.ProvideToolTipsWithGestures(this);

   CommandManager.InvalidateRequerySuggested();

   App.MainWindow.Focus();
   FocusManager.SetFocusedElement(App.MainWindow,null);
   if (FocusFirstElementOnLoad)
      XFocus.MoveToFirstElementOf(this);

   MainWindow.Navigation.RemoveBackEntry();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // CustomPage
//**************************************************************************************************

} // PaycorMaster
