﻿using System;
using System.ComponentModel;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Interop;
using System.Windows.Input;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public class CustomWindow: XWindow {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

protected override void OnInitialized(EventArgs e)
{
   base.OnInitialized(e);

   if (!DesignerProperties.GetIsInDesignMode(this))
   {
      //ApplyWaitCursorWhenBusy = false;
   }
}

//--------------------------------------------------------------------------------------------------

protected override void OnPreviewMouseLeftButtonDown(MouseButtonEventArgs e)
{
   base.OnPreviewMouseLeftButtonDown(e);

   if (e.Handled) return;

   var el = e.Source as UIElement;

   if (el==null) return;

   var tb = el as TextBox;
   var pb = el as PasswordBox;

   if (tb!=null || pb!=null)
      if (!el.IsKeyboardFocused)
      {
         el.Focus(); e.Handled=true;
      }
      else
         if (tb!=null)
            tb.Select(tb.CaretIndex,0);
}

protected override void OnPreviewGotKeyboardFocus(KeyboardFocusChangedEventArgs e)
{
   base.OnPreviewGotKeyboardFocus(e);

   if (e.Handled) return;

   if (e.Source is TextBox)
      ((TextBox)e.Source).SelectAll();
   if (e.Source is PasswordBox)
      ((PasswordBox)e.Source).SelectAll();
}

//--------------------------------------------------------------------------------------------------

protected override void OnPreviewKeyDown(KeyEventArgs e)
{
   base.OnPreviewKeyDown(e);

   if (e.Handled) return;

   var el = e.Source as UIElement;

   if (el==null) return;
/*
   if (el is CheckBox && e.Key==Key.Return)
   {
      var cb = (CheckBox)el;
      if (cb.IsChecked.HasValue)
      {
         if (cb.IsChecked.Value)
            cb.IsChecked = false;
         else
            cb.IsChecked = true;
         cb.RaiseEvent(new RoutedEventArgs(CheckBox.ClickEvent));
         goto HANDLED;
      }
   }
*/
   if ( XOps.IsOneOf(e.Key,Key.Up,Key.Down) &&
        e.KeyboardDevice.Modifiers == ModifierKeys.None &&
        ( el is TextBoxBase || el is PasswordBox ||
          el is ButtonBase  || el is ToggleButton ) )
   {
      el.MoveFocus(
         new TraversalRequest( e.Key==Key.Up ?
            FocusNavigationDirection.Previous :
            FocusNavigationDirection.Next ) );
      goto HANDLED;
   }

   return;

HANDLED:
   e.Handled = true;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // CustomWindow
//**************************************************************************************************

} // PaycorMaster
