﻿using System;

using XHelpers;
using XHelpers.Linq;

namespace PaycorMaster {

//**************************************************************************************************
public class DbConnector: XDatabaseConnector<PaycorMasterDataContext> {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public string UserInformationString
{
   get { return _UserInformationString_; }
}

public bool IsUserInSysadminRole
{
   get { return _IsUserInSysadminRole_; }
}

//==================================================================================================

public new DbConnector Duplicate()
{
   return (DbConnector)base.Duplicate();
}

//==================================================================================================

protected override PaycorMasterDataContext CreateDataContext(string connectionString)
{
   return new PaycorMasterDataContext( connectionString );
}

protected override void ResetCustomProperties()
{
   _UserInformationString_ = null;
   _IsUserInSysadminRole_ = false;
}

//--------------------------------------------------------------------------------------------------

protected override void OnEstablishConnection(PaycorMasterDataContext database)
{
   Version
      version = XProgram.Version;
   string
      userName = null;
   bool?
      isUserInSysadminRole = new Nullable<bool>();

   database.PaycorMaster_VerifyAppVersion(
      version.Major, version.Minor,
      version.Build, version.Revision );
   database.PaycorMaster_AcceptConnection(
      ref userName, ref isUserInSysadminRole );

   _UserInformationString_ = userName;
   if (_IsUserInSysadminRole_ = isUserInSysadminRole.Value)
      _UserInformationString_ += " (администратор)";
}

//==================================================================================================

string
   _UserInformationString_;
bool
   _IsUserInSysadminRole_;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // DbConnector
//**************************************************************************************************

} // PaycorMaster
