﻿using System;
using System.ComponentModel;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

using System.Windows;
using System.Windows.Input;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
partial class ConfigurationPage {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public override void DoCommandExecuted(object sender,ExecutedRoutedEventArgs e)
{
   if (e.Command==ConfigurationCommands.CreateCause)
   {
      CreateCause(); return;
   }
   if (e.Command==ConfigurationCommands.EditCause)
   {
      EditCause(); return;
   }
   if (e.Command==ConfigurationCommands.RemoveCause)
   {
      RemoveCause(); return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (e.Command==ConfigurationCommands.CreateDocumentType)
   {
      CreateDocumentType(); return;
   }
   if (e.Command==ConfigurationCommands.EditDocumentType)
   {
      EditDocumentType(); return;
   }
   if (e.Command==ConfigurationCommands.RemoveDocumentType)
   {
      RemoveDocumentType(); return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (e.Command==ConfigurationCommands.IncludeCause)
   {
      IncludeCause(); return;
   }
   if (e.Command==ConfigurationCommands.ExcludeCause)
   {
      ExcludeCause(); return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (e.Command==ConfigurationCommands.BindDocumentType)
   {
      BindDocumentType(); return;
   }
   if (e.Command==ConfigurationCommands.UnbindDocumentType)
   {
      UnbindDocumentType(); return;
   }
}

//==================================================================================================

public override void DoCommandCanExecute(object sender,CanExecuteRoutedEventArgs e)
{

   if (e.Command==ConfigurationCommands.CreateDocumentType)
   {
      e.CanExecute = _ActiveCause_ != null;
      return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (XOps.IsOneOf( e.Command,
                     ConfigurationCommands.EditCause,
                     ConfigurationCommands.RemoveCause ))
   {
      e.CanExecute = IsCauseListBox( _SelectedListBox_ ) &&
                     IsListBoxSelectedWithItem( _SelectedListBox_ );
      return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (XOps.IsOneOf( e.Command,
                     ConfigurationCommands.EditDocumentType,
                     ConfigurationCommands.RemoveDocumentType ))
   {
      e.CanExecute = IsDocumentTypeListBox( _SelectedListBox_ ) &&
                     IsListBoxSelectedWithItem( _SelectedListBox_ );
      return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (e.Command==ConfigurationCommands.IncludeCause)
   {
      e.CanExecute = IsListBoxSelectedWithItem( listboxExcludedCauses );
      return;
   }
   if (e.Command==ConfigurationCommands.ExcludeCause)
   {
      e.CanExecute = IsListBoxSelectedWithItem( listboxIncludedCauses );
      return;
   }

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   if (e.Command==ConfigurationCommands.BindDocumentType)
   {
      e.CanExecute = IsListBoxSelectedWithItem( listboxUnboundDocumentTypes );
      return;
   }
   if (e.Command==ConfigurationCommands.UnbindDocumentType)
   {
      e.CanExecute = IsListBoxSelectedWithItem( listboxBoundDocumentTypes );
      return;
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // ConfigurationPage
//**************************************************************************************************

} // PaycorMaster
