﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public partial class ConfigurationPage: CustomPage {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

private void Page_Loaded(object sender,RoutedEventArgs e)
{
//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   Loaded -= Page_Loaded;

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   listboxIncludedCauses      .ArrangeBehaviour( App.MainWindow );
   listboxExcludedCauses      .ArrangeBehaviour( App.MainWindow );
   listboxBoundDocumentTypes  .ArrangeBehaviour( App.MainWindow );
   listboxUnboundDocumentTypes.ArrangeBehaviour( App.MainWindow );

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   ForceAttachListBoxMouseEventHandlers( listboxIncludedCauses       );
   ForceAttachListBoxMouseEventHandlers( listboxExcludedCauses       );
   ForceAttachListBoxMouseEventHandlers( listboxBoundDocumentTypes   );
   ForceAttachListBoxMouseEventHandlers( listboxUnboundDocumentTypes );

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   listboxIncludedCauses.SetValue(
      CreateObjectCommandProperty,
      ConfigurationCommands.CreateCause );
   listboxIncludedCauses.SetValue(
      EditObjectCommandProperty,
      ConfigurationCommands.EditCause );
   listboxIncludedCauses.SetValue(
      RemoveObjectCommandProperty,
      ConfigurationCommands.RemoveCause );

   listboxExcludedCauses.SetValue(
      CreateObjectCommandProperty,
      ConfigurationCommands.CreateCause );
   listboxExcludedCauses.SetValue(
      EditObjectCommandProperty,
      ConfigurationCommands.EditCause );
   listboxExcludedCauses.SetValue(
      RemoveObjectCommandProperty,
      ConfigurationCommands.RemoveCause );

   listboxBoundDocumentTypes.SetValue(
      CreateObjectCommandProperty,
      ConfigurationCommands.CreateDocumentType );
   listboxBoundDocumentTypes.SetValue(
      EditObjectCommandProperty,
      ConfigurationCommands.EditDocumentType );
   listboxBoundDocumentTypes.SetValue(
      RemoveObjectCommandProperty,
      ConfigurationCommands.RemoveDocumentType );

   listboxUnboundDocumentTypes.SetValue(
      CreateObjectCommandProperty,
      ConfigurationCommands.CreateDocumentType );
   listboxUnboundDocumentTypes.SetValue(
      EditObjectCommandProperty,
      ConfigurationCommands.EditDocumentType );
   listboxUnboundDocumentTypes.SetValue(
      RemoveObjectCommandProperty,
      ConfigurationCommands.RemoveDocumentType );

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   listboxIncludedCauses.SetValue(
      IncludeItemCommandProperty,
      ConfigurationCommands.IncludeCause  );
   listboxIncludedCauses.SetValue(
      ExcludeItemCommandProperty,
      ConfigurationCommands.ExcludeCause );

   listboxExcludedCauses.SetValue(
      IncludeItemCommandProperty,
      ConfigurationCommands.ExcludeCause );
   listboxExcludedCauses.SetValue(
      ExcludeItemCommandProperty,
      ConfigurationCommands.IncludeCause  );

   listboxBoundDocumentTypes.SetValue(
      IncludeItemCommandProperty,
      ConfigurationCommands.BindDocumentType );
   listboxBoundDocumentTypes.SetValue(
      ExcludeItemCommandProperty,
      ConfigurationCommands.UnbindDocumentType );

   listboxUnboundDocumentTypes.SetValue(
      IncludeItemCommandProperty,
      ConfigurationCommands.UnbindDocumentType );
   listboxUnboundDocumentTypes.SetValue(
      ExcludeItemCommandProperty,
      ConfigurationCommands.BindDocumentType );

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   BuildListBoxMenus( listboxIncludedCauses       );
   BuildListBoxMenus( listboxExcludedCauses       );
   BuildListBoxMenus( listboxBoundDocumentTypes   );
   BuildListBoxMenus( listboxUnboundDocumentTypes );

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   UpdateMainMenuContextItem();

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

   _IsInitialized_ = true;

   XBackgroundOperation.WaitOperationDeactivateAppWaiting();

//-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
}

//==================================================================================================

private void checkboxPercentalAffectsUnits_Click(object sender,RoutedEventArgs e)
{
   XBackgroundOperation.Start
   (
      _LoadingDataCaption_,
      delegate { LoadCauses(); }
   );
}

//--------------------------------------------------------------------------------------------------

private void listboxCauses_SelectionChanged(object sender,SelectionChangedEventArgs e)
{
   if (!XBackgroundOperation.IsActive && !PreloadDocumentTypes())
      XBackgroundOperation.Start
      (
         _LoadingDocumentTypesCaption_,
         delegate { LoadDocumentTypes(); }
      );
}

//--------------------------------------------------------------------------------------------------

private void listboxCausesDocTypes_GotKeyboardFocus(object sender,KeyboardFocusChangedEventArgs e)
{
   _ClickHoldListBoxItem_ = null;

   var listBox = (CustomListBox)sender;

   SelectListBox( listBox );

   var lbi = e.NewFocus as ListBoxItem;
   if (lbi!=null)
   {
      lbi.ContextMenu = GetListBoxItemMenu( listBox );
      ContextMenuService.SetPlacementTarget(lbi,lbi);
      ContextMenuService.SetPlacement(lbi,PlacementMode.Bottom);
   };

   if (IsCauseListBox(listBox) && !XBackgroundOperation.IsActive && !PreloadDocumentTypes())
      XBackgroundOperation.Start
      (
         _LoadingDocumentTypesCaption_,
         delegate { LoadDocumentTypes(); }
      );
}

//--------------------------------------------------------------------------------------------------

private void labelActiveCauses_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
   listboxIncludedCauses.Focus(); listboxIncludedCauses.ScrollSelectedItemIntoView();
}

private void labelCandidateCauses_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
   listboxExcludedCauses.Focus(); listboxExcludedCauses.ScrollSelectedItemIntoView();
}

private void labelBoundDocumentTypes_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
   listboxBoundDocumentTypes.Focus(); listboxBoundDocumentTypes.ScrollSelectedItemIntoView();
}

private void labelUnboundDocumentTypes_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
   listboxUnboundDocumentTypes.Focus(); listboxUnboundDocumentTypes.ScrollSelectedItemIntoView();
}

//--------------------------------------------------------------------------------------------------

public void listboxCausesDocTypes_DragEnterOver(object sender,DragEventArgs e)
{
   var sourceListBox = e.Data.GetData(typeof(CustomListBox)) as ListBox;
   var targetListBox = (ListBox)sender;

   if (!(
      sourceListBox==listboxExcludedCauses &&
      targetListBox==listboxIncludedCauses &&
      ConfigurationCommands.IncludeCause.CanExecute(null,null) ||

      sourceListBox==listboxIncludedCauses &&
      targetListBox==listboxExcludedCauses &&
      ConfigurationCommands.ExcludeCause.CanExecute(null,null) ||

      sourceListBox==listboxUnboundDocumentTypes &&
      targetListBox==listboxBoundDocumentTypes &&
      ConfigurationCommands.BindDocumentType.CanExecute(null,null) ||

      sourceListBox==listboxBoundDocumentTypes &&
      targetListBox==listboxUnboundDocumentTypes &&
      ConfigurationCommands.UnbindDocumentType.CanExecute(null,null)
   ))
   {
      e.Effects = DragDropEffects.None;
      e.Handled = true;
   }
}

//--------------------------------------------------------------------------------------------------

private void listboxCausesDocTypes_Drop(object sender,DragEventArgs e)
{
   CommandManager.InvalidateRequerySuggested();

   var listBox = (ListBox)sender;
   var command = GetListBoxCommand(listBox,IncludeItemCommandProperty);

   if (command.CanExecute(null,null))
   {
      command.Execute(null,null);
      listBox.Focus();
   }
}

//--------------------------------------------------------------------------------------------------

private void listboxCausesDocTypes_KeyDown(object sender,KeyEventArgs e)
{
   var listBox = (ListBox)sender;

   DependencyProperty commandProperty = null;

   if (XInput.IsSoleKey(e,Key.Insert))
      commandProperty = CreateObjectCommandProperty;
   else
   if (XInput.IsSoleKey(e,Key.F2))
      commandProperty = EditObjectCommandProperty;
   else
   if (XInput.IsSoleKey(e,Key.Delete))
      commandProperty = RemoveObjectCommandProperty;
   else
   if (XInput.IsSoleKey(e,Key.Back))
      commandProperty = ExcludeItemCommandProperty;

   if (commandProperty!=null)
      XCommand.TryExecute(true,GetListBoxCommand(listBox,commandProperty));
}

//--------------------------------------------------------------------------------------------------

private void tabcontrol_SelectionChanged(object sender,SelectionChangedEventArgs e)
{
   UpdateMainMenuContextItem();
}

//--------------------------------------------------------------------------------------------------

private void listboxCausesDocTypes_MouseMove(object sender,MouseEventArgs e)
{
   var listBox = (CustomListBox)sender;
   var lbi = listBox.SelectedListBoxItem;

   if ( listBox==_SelectedListBox_ &&
        listBox.SelectedItem!=null &&
        lbi!=null && lbi==_ClickHoldListBoxItem_ &&
        lbi.IsMouseOver && Mouse.LeftButton==MouseButtonState.Pressed )
      DragDrop.DoDragDrop(listBox,listBox,DragDropEffects.Move);
}

private void listboxCausesDocTypes_MouseEnter(object sender,MouseEventArgs e)
{
   _ClickHoldListBoxItem_ = null;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // ConfigurationPage
//**************************************************************************************************

} // PaycorMaster
