﻿using System;
using System.Globalization;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Input;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public class OkInscription: XDrawingSurfice {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public OkInscription()
{
   _FontSize_ = 50;
   _InscriptionOffset_ = 2.5;

   ClipToBounds = true;

   Loaded += OkInscription_Loaded;
}

//==================================================================================================

protected override void OnMouseEnter(MouseEventArgs e)
{
   base.OnMouseEnter(e);
   if (e.Handled) return;
   ProcessMouseHit(e);
}

protected override void OnMouseLeave(MouseEventArgs e)
{
   base.OnMouseLeave(e);
   if (e.Handled) return;
   ProcessMouseHit(e);
}

protected override void OnMouseMove(MouseEventArgs e)
{
   base.OnMouseMove(e);
   if (e.Handled) return;
   ProcessMouseHit(e);
}

//==================================================================================================

void OkInscription_Loaded(object sender,RoutedEventArgs e)
{
   Loaded -= OkInscription_Loaded;

   AddVisual( _BackgroundInscription_ = CreateInscription( Brushes.DimGray, _InscriptionOffset_ ) );
   AddVisual( _ForegroundInscription_ = CreateInscription( Brushes.Blue   ,-_InscriptionOffset_ ) );
}

//--------------------------------------------------------------------------------------------------

DrawingVisual CreateInscription(Brush brush,double offset)
{
   var dv = new DrawingVisual();
   var dc = dv.RenderOpen();
   var ft = new FormattedText( "Ok",
      CultureInfo.GetCultureInfo("en-us"), FlowDirection.LeftToRight,
      new Typeface("Comic Sans MS"), _FontSize_, brush );
   dc.DrawText( ft,
      new Point( (Width-ft.Width)/2+offset,
                 (Height-ft.Height)/2+offset) );
   dc.Close();
   return dv;
}

void ProcessMouseHit(MouseEventArgs e)
{
   if (GetVisual(e)!=null)
   {
      if (_HotInscription_==null)
      {
         AddVisual( _HotInscription_ = CreateInscription(Brushes.Yellow,-_InscriptionOffset_) );
         Cursor = Cursors.Hand;
      }
   }
   else
      if (_HotInscription_!=null)
      {
         RemoveVisual( XOps.NullExchange(ref _HotInscription_) );
         Cursor = null;
      }
}

//==================================================================================================

DrawingVisual
   _ForegroundInscription_,
   _BackgroundInscription_,
   _HotInscription_;
double
   _FontSize_,
   _InscriptionOffset_;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // OkInscription
//**************************************************************************************************

} // PaycorMaster
