﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public partial class AboutWindow: CustomWindow {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Point _LastResizingCoordinates_;

//==================================================================================================

public AboutWindow()
{
   XCursor.SetWait();
   InitializeComponent();
}

public new static void ShowDialog()
{
   new AboutWindow().ShowModal(App.MainWindow);
}

//==================================================================================================

protected override void OnActivated(EventArgs e)
{
   base.OnActivated(e);
   textblockTitle .Foreground = (Brush)Resources["ActiveTitleForeground" ];
   textblockFooter.Foreground = (Brush)Resources["ActiveFooterForeground"];
   borderWindow   .Background = (Brush)Resources["ActiveNonClientBrush"  ];
}

protected override void OnDeactivated(EventArgs e)
{
   base.OnDeactivated(e);
   textblockTitle .Foreground = (Brush)Resources["InactiveTitleForeground" ];
   textblockFooter.Foreground = (Brush)Resources["InactiveFooterForeground"];
   borderWindow   .Background = (Brush)Resources["InactiveNonClientBrush"  ];
}

//==================================================================================================

private void Window_Loaded(object sender,RoutedEventArgs e)
{
   Loaded -= Window_Loaded;

   Title = textblockTitle.Text = string.Format(
      "{0} (о программе)",
      AssemblyInfo.Title );

   textblockFooter.Text = string.Format(
      "Версия: {0}{1}",
      AssemblyInfo.VersionString,
      XAssembly.IsConfiguredForDebug() ? " (Debug)" : "" );

   borderWindow.Cursor = textblockTitle.Cursor = textblockFooter.Cursor =
      XCursor.Create( Properties.Resources.HandNWSE_ANI );
   gridClientArea.Cursor = Cursors.Arrow;

   flowdocumentviewer.Focus();

   XSoundPlayer.PlayFile(@"Sound\Magical.wav");

   XCursor.Reset();
}

//--------------------------------------------------------------------------------------------------

private void Window_KeyDown(object sender,KeyEventArgs e)
{
   if (XInput.IsSoleEnterKey(e))
      DialogResult = true;
}

private void OkInscription_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
//throw new ApplicationException("Искусственная ошибка отладки.");
   DialogResult = true;
}

private void buttonClose_Click(object sender,RoutedEventArgs e)
{
   DialogResult = false;
}

//--------------------------------------------------------------------------------------------------

private void borderWindow_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
   if (XOps.IsOneOf(e.Source,borderWindow,textblockTitle,textblockFooter))
      DragMove();
}

//--------------------------------------------------------------------------------------------------

private void resizegrip_MouseLeftButtonDown(object sender,MouseButtonEventArgs e)
{
   _LastResizingCoordinates_ = PointToScreen(e.GetPosition(this));
   resizegrip.CaptureMouse();
}

private void resizegrip_MouseLeftButtonUp(object sender,MouseButtonEventArgs e)
{
   if (e.LeftButton==MouseButtonState.Released)
      resizegrip.ReleaseMouseCapture();
}

//--------------------------------------------------------------------------------------------------

private void resizegrip_MouseMove(object sender,MouseEventArgs e)
{
   if (Mouse.Captured==resizegrip)
   {
      Point mousePosition = e.GetPosition(this);

      if ( mousePosition.X==0 && mousePosition.Y==0 )
         return;

      mousePosition = PointToScreen( mousePosition );

      if (mousePosition!=_LastResizingCoordinates_)
      {
         double
            tentativeDw = (mousePosition.X - _LastResizingCoordinates_.X)*2,
            tentativeDh = (mousePosition.Y - _LastResizingCoordinates_.Y)*2,
            tentativeWidth = ActualWidth + tentativeDw,
            tentativeHeight= ActualHeight+ tentativeDh,
            newWidth = Math.Min(Math.Max( tentativeWidth , MinWidth  ),MaxWidth ),
            newHeight= Math.Min(Math.Max( tentativeHeight, MinHeight ),MaxHeight),
            actualDw = newWidth - ActualWidth,
            actualDh = newHeight- ActualHeight,
            newLeft  = Left-actualDw/2,
            newTop   = Top -actualDh/2;
         int
            cxNewWidth    = XVideo.UnitsToPixelsX(newWidth    ),
            cyNewHeight   = XVideo.UnitsToPixelsY(newHeight   ),
            cxActualWidth = XVideo.UnitsToPixelsX(ActualWidth ),
            cyActualHeight= XVideo.UnitsToPixelsY(ActualHeight);

         if (cxNewWidth!=cxActualWidth || cyNewHeight!=cyActualHeight)
         {
            SetPositionAndSize(newLeft,newTop,newWidth,newHeight);

            if (cxNewWidth!=cxActualWidth)
               _LastResizingCoordinates_.X = mousePosition.X - (tentativeDw-actualDw)/2;

            if (cyNewHeight!=cyActualHeight)
               _LastResizingCoordinates_.Y = mousePosition.Y - (tentativeDh-actualDh)/2;
         }
      }
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // AboutWindow
//**************************************************************************************************

} // PaycorMaster
