﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Globalization;

using System.Windows;
using System.Windows.Controls;

using XHelpers;

namespace PaycorMaster {

//**************************************************************************************************
public enum CorrectionCauseDocTypeDialogKind { Cause, DocumentType }
//**************************************************************************************************


//**************************************************************************************************
public class CorrectionCauseDocTypeDialogData
{
   public UIElement
      CenterByElement;
   public CorrectionCauseDocTypeDialogKind
      DialogKind;
   public bool
      IsCreationDialog;
   public object
      TheObject;
   public Guid?
      ObjectId;
   public string
      ObjectName;
   public bool?
      IsCauseCountersRelated;
   public object
      PosteriourCallback;
}
//**************************************************************************************************


//**************************************************************************************************
public class CorrectionCauseDocTypeNameValidationRule: ValidationRule
{
   public override ValidationResult Validate(object value,CultureInfo cultureInfo)
   {
      string objectName=(string)value;

      if (objectName=="")
         return new ValidationResult(true,null);

      if (XString.StartsWithSpaces(objectName))
         return new ValidationResult( false,
            "Наименование не должно начинаться с пробела." );

      objectName = objectName.TrimEnd();

      if (!XString.IsSpaceNormalizedName(objectName))
         return new ValidationResult( false,
            "Наименование не должно содержать несколько подряд идущих пробелов." );

      foreach (char ch in objectName)
         if (char.IsLetter(ch) && !XChar.IsNativeLetter(ch))
            return new ValidationResult( false,
               "Допустимы только русские буквы (и прочие небуквенные символы) в наименовании." );

      return new ValidationResult(true,null);
   }
}
//**************************************************************************************************


//**************************************************************************************************
public delegate void CorrectionCauseCallback(CorrectionCause cause);
public delegate void CorrectionDocTypeCallback(CorrectionDocumentType documentType);
//**************************************************************************************************

} // PaycorMaster
