﻿using System;

using XHelpers;

namespace ConsoleApp {

//**************************************************************************************************
static partial class Program {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="Win32Exception" />
static string GetCurrentDirectory()
{
   for (;;)
   {
      uint capacity = Win32.GetCurrentDirectory(0,(char[])null);
      var buffer = new char[ capacity ];
      uint res = Win32.GetCurrentDirectory( capacity, buffer );
      if (res==0)
         throw XWin32Error.CreateExceptionFromLastError();
      if (res<capacity)
         return new string(buffer,0,(int)res);
   }
}

/// <exception cref="Win32Exception" />
static unsafe string GetTempPath()
{
   for (;;)
   {
      uint capacity = Win32.GetTempPath(0,(char*)null);
      var dsz = new XDisposableSZ( (int)capacity-1 );
      uint res = Win32.GetTempPath( capacity, (char*)dsz );
      if (res==0)
         throw XWin32Error.CreateExceptionFromLastError();
      if (res<capacity)
         return dsz.ToString();
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Program
//**************************************************************************************************

} // ConsoleApp
