﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;

using XHelpers;

namespace SilverlightApp {

//**************************************************************************************************
public partial class FrontalLayout: UserControl {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public FrontalLayout()
{
   InitializeComponent();
   navigationFrame.Content = new MainPage();
}

//==================================================================================================

private void FrontalLayout_Loaded(object sender,RoutedEventArgs e)
{
   Loaded -= FrontalLayout_Loaded;

   XApplication.SpecifyDispatcher( Dispatcher );
   XApplication.LayoutRoot = ((FrontalLayout)XApplication.RootControl).gridRoot;

   var initialStatusBackground = stackpanelStatus.Background;

   XAppWaiting.DisplayAppWaitingStatusHandler +=
      delegate (bool isActive,string caption,object data)
      {
         XDispatcher.Synchronize(delegate{
            if (isActive)
            {
               stackpanelStatus.Background = new SolidColorBrush( Colors.Black );
               textblockStatus.Text = string.Format("{0} ...",caption ?? "Executing operation");
            }
            else
            {
               textblockStatus.Text = " ";
               stackpanelStatus.Background = initialStatusBackground;
            }
         });
      };
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // FrontalLayout
//**************************************************************************************************


//**************************************************************************************************
public class MyException: Exception
{
   public MyException(string message): base(message)
   {}
}
//**************************************************************************************************

} // SilverlightApp
