﻿using System;
using System.Globalization;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using XHelpers;

namespace WpfApplication {

//**************************************************************************************************
/// <summary>
/// Interaction logic for MainWindow.xaml
/// </summary>
public partial class MainWindow: XWindow {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public MainWindow()
{
   InitializeComponent();
}

//==================================================================================================

void DisplayAppWaitingStatusHandler(bool isActive,string caption,object data)
{
   textblockStatusCaption.Text = isActive ?
      caption!=null ?
         string.Format("{0} ...",caption) :
         "" :
      "Ready";
   textblockStatusCaption.FontWeight =
      isActive ? FontWeights.Bold : FontWeights.Normal;
}

//==================================================================================================

private void Window_Loaded(object sender,RoutedEventArgs e)
{
   Loaded -= Window_Loaded;
   XDebug.PrintInformation( "Application started." );
   XAppWaiting.DisplayAppWaitingStatusHandler +=
      DisplayAppWaitingStatusHandler;
   XAppWaiting.RefreshStatus();
}

private void buttonOperation_Click(object sender,RoutedEventArgs e)
{
   XBackgroundOperation.Start
   (
      "Operation",
      "Executing operation",
      delegate
      {
         Thread.Sleep(1000);

         XAppWaiting.DisplayStatus("Step one");
         Thread.Sleep(1000);

         XAppWaiting.DisplayStatus("Step two");
         Thread.Sleep(1000);

         //XMessageBox.ShowExclamation("Hello!");
         //XAppWaiting.ReportError("Failure!");
         //return;

         XAppWaiting.DisplayStatus("Step three");
         Thread.Sleep(1000);
      }
   );
}

private void buttonBreakdown_Click(object sender,RoutedEventArgs e)
{
   try
      { throw new ApplicationException("Error-1."); }
   catch (Exception x)
      { throw new ApplicationException("Error-2.",x); }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // MainWindow
//**************************************************************************************************

} // WpfApplication
