@echo off
setlocal
set initial_cd=%CD%

if "%~0"=="REBUILD_D.cmd" goto BEGIN
cls
echo RE-BUILDING PROJECTS  "DEBUG":
echo 

:BEGIN
call :RESET_ERROR

call :REBUILD_PROJECT "ConsoleApp"
if %errorlevel% neq 0 goto FAILURE

call :REBUILD_PROJECT "WpfApplication"
if %errorlevel% neq 0 goto FAILURE

call :REBUILD_PROJECT "SilverlightApp"
if %errorlevel% neq 0 goto FAILURE

call :RESTORE_DIR

rem ================================================================================

:SUCCESS
if "%~0"=="REBUILD_D.cmd" goto FINISH
echo.
echo  REBUILD PROJECTS (DEBUG)  SUCCESS 
goto FINISH

:FAILURE
if "%~0"=="REBUILD_D.cmd" goto ERROR
echo.
echo  ## REBUILD PROJECTS (DEBUG)  FAILURE 
goto ERROR

rem ================================================================================

:REBUILD_PROJECT
call :CHANGE_DIR "%initial_cd%\%~1"
if %errorlevel% neq 0 goto :EOF

call REBUILD_D.cmd
if %errorlevel% neq 0 goto :EOF

:COMPLETE_REBUILD_PROJECT
echo.
echo 
goto :EOF

rem ================================================================================

:RESET_ERROR
set errorlevel=0
set errorlevel=
goto :EOF

:CHANGE_DIR
echo.
echo * Changing directory to: "%~1" ...
cd /d "%~1"
goto :EOF

:RESTORE_DIR
if /i "%CD%"=="%initial_cd%" goto :EOF
echo.
echo * Restoring directory to: "%initial_cd%" ...
cd /d "%initial_cd%"
if /i "%CD%"=="%initial_cd%" goto :EOF
echo.
echo ## === FATAL ERROR: ===
echo ## Can not restore directory to: "%initial_cd%".
echo ## Batch processing terminated!
echo 
pause
exit

rem ================================================================================

:ERROR
if "%~0"=="REBUILD_D.cmd" goto SKIP_ERROR_PAUSE
echo 
pause

:SKIP_ERROR_PAUSE
call :RESTORE_DIR

:ERROR_EXIT
endlocal
set errorlevel=1
goto :EOF

:FINISH
if "%~0"=="REBUILD_D.cmd" goto SKIP_FINISH_PAUSE
echo.
pause

:SKIP_FINISH_PAUSE
call :RESTORE_DIR

:NORMAL_EXIT
endlocal
call :RESET_ERROR
goto :EOF

rem ================================================================================
