﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string CancellationMessage
{
   get
   {
      switch (XCultureInfo.CurrentUINeutralCulture.Name)
      {
         case XNeutralCultureNames.Russian:
            return "Прерывание по <Ctrl+Break>";
         case XNeutralCultureNames.Spanish:
            return "Interrupción por <Ctrl+Break>";
      }
      return "Termination by <Ctrl+Break>";
   }
}

//==================================================================================================

public static string ExitionDialogPromptMessage
{
   get
   {
      string messageFmt;
      switch (XCultureInfo.CurrentUINeutralCulture.Name)
      {
         case XNeutralCultureNames.Russian:
            messageFmt = "Для выхода нажмите {0} либо {1}";
            break;
         case XNeutralCultureNames.Spanish:
            messageFmt = "Opriman {0} o {1} para salir";
            break;
         default:
            messageFmt = "Press {0} or {1} to exit";
            break;
      }
      return string.Format( messageFmt,
         KeyToString(ConsoleKey.Enter),
         KeyToString(ConsoleKey.Escape) );
   }
}

public static string ContinuationDialogPromptMessage
{
   get
   {
      string messageFmt;
      switch (XCultureInfo.CurrentUINeutralCulture.Name)
      {
         case XNeutralCultureNames.Russian:
            messageFmt = "Для продолжения нажмите {0} либо {1}";
            break;
         case XNeutralCultureNames.Spanish:
            messageFmt = "Opriman {0} o {1} para continuar";
            break;
         default:
            messageFmt = "Press {0} or {1} to continue";
            break;
      }
      return string.Format( messageFmt,
         KeyToString(ConsoleKey.Enter),
         KeyToString(ConsoleKey.Escape) );
   }
}

//---------------------------------------------------------------------------------------------------

public static string ConfirmationDialogActionText_Confirm
{
   get
   {
      switch (XCultureInfo.CurrentUINeutralCulture.Name)
      {
         case XNeutralCultureNames.Russian:
            return "Да (подтверждение)";
         case XNeutralCultureNames.Spanish:
            return "Sí (confirmación)";
      }
      return "Yes (confirm)";
   }
}

public static string ConfirmationDialogActionText_Cancel
{
   get
   {
      switch (XCultureInfo.CurrentUINeutralCulture.Name)
      {
         case XNeutralCultureNames.Russian:
            return "Нет (отмена)";
         case XNeutralCultureNames.Spanish:
            return "No (cancelación)";
      }
      return "No (cancel)";
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
