﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Threading;
using System.Globalization;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XChar {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool IsNativeLetter(char ch)
{
   return IsNativeLetter(ch,CultureInfo.CurrentCulture);
}

public static bool IsNativeLetter(char ch,[Optional] CultureInfo culture)
{
   var ci = culture ?? CultureInfo.InvariantCulture;

   switch (XCultureInfo.ToNeutral(ci).Name)
   {
   case XNeutralCultureNames.English:
      return XAscii.IsLetter( ch );
   case XNeutralCultureNames.Spanish:
      return XAscii.IsLetter( ch ) || XOps.IsOneOf( ch,
         'Á','á', 'É','é', 'Í','í', 'Ó','ó', 'Ú','ú', 'Ü','ü' );
   }

   switch (ci.Name)
   {
   case XSpecificCultureNames.ru_RU:
      return XOps.IsBetween(ch,'А','Я') || XOps.IsBetween(ch,'а','я') || XOps.IsOneOf(ch,'Ё','ё');
   }

   throw XCultureInfo.CreateNotSupportedOperationException( culture );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XChar
//**************************************************************************************************

} // XHelpers
