﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
static partial class Win32 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public const uint
   STD_OUTPUT_HANDLE    = unchecked((uint)-11),
   ERROR_INVALID_HANDLE = 6;

public static readonly IntPtr
   INVALID_HANDLE_VALUE = (IntPtr)(-1);

//==================================================================================================

[StructLayout(LayoutKind.Sequential)]
public struct COORD
{
  public short X;
  public short Y;
}

[StructLayout(LayoutKind.Sequential)]
public struct SMALL_RECT
{
  public short Left;
  public short Top;
  public short Right;
  public short Bottom;
}

[StructLayout(LayoutKind.Sequential)]
public struct CONSOLE_SCREEN_BUFFER_INFO 
{
   public COORD      dwSize;
   public COORD      dwCursorPosition;
   public short      wAttributes;
   public SMALL_RECT srWindow;
   public COORD      dwMaximumWindowSize;
}

//==================================================================================================

[DllImport("Kernel32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern IntPtr GetStdHandle(uint uStdHandle);

[DllImport("Kernel32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern bool GetConsoleScreenBufferInfo
(
   IntPtr hConsoleOutput,
   out CONSOLE_SCREEN_BUFFER_INFO consoleScreenBufferInfo
);

[DllImport("Kernel32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern IntPtr GetConsoleWindow();

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern bool CharToOemBuff(char[] achSrc,[Out] byte[] abyDst,uint uDstLength);

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern bool OemToCharBuff(byte[] abySrc,[Out] char[] achDst,uint uDstLength);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Win32
//**************************************************************************************************

} // XHelpers
