﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int PerformDialog( string caption,
                                 string[] actions,
                                 ConsoleKey[] keysArray,
                                 [Optional] bool[] enablings )
{
   return PerformDialog(false,caption,actions,enablings,keysArray);
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] bool[] enablings,
                                 [Optional] string cancelAction )
{
   return PerformDialog( false, caption,
      actions, enablings, keysArray,
      cancelAction );
}

public static int PerformDialog( string caption,
                                 string[] actions,
                                 ConsoleKey[] keysArray,
                                 [Optional] bool[] enablings,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey )
{
   return PerformDialog( false, caption,
      actions, enablings, keysArray,
      cancelAction, cancelKey );
}

public static int PerformDialog( string caption,
                                 string[] actions,
                                 ConsoleKey[] keysArray,
                                 [Optional] bool[] enablings,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey,
                                 [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformDialog( false,
      caption, actions, enablings, keysArray,
      cancelAction, cancelKey, cancelModifiers );
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption, string[] actions, bool isLastActionCancel,
                                 [Optional] bool[] enablings, ConsoleKey[] keysArray )
{
   return PerformDialog(false,caption,actions,isLastActionCancel,enablings,keysArray);
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption, string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] bool[] enablings )
{
   return PerformDialog(false,caption,actions,enablings,keysArray,modifiersArray);
}

//==================================================================================================

public static int PerformDialog( string caption,
                                 string[] actions,
                                 ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] bool[] enablings,
                                 [Optional] string cancelAction )
{
   return PerformDialog( false, caption,
      actions, enablings, keysArray, modifiersArray,
      cancelAction );
}

public static int PerformDialog( string caption,
                                 string[] actions,
                                 ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] bool[] enablings,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey )
{
   return PerformDialog( false, caption,
      actions, enablings, keysArray, modifiersArray,
      cancelAction, cancelKey );
}

public static int PerformDialog( string caption, string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] bool[] enablings,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey,
                                 [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformDialog( false, caption,
      actions, enablings, keysArray, modifiersArray,
      cancelAction, cancelKey, cancelModifiers );
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption,
                                 string[] actions,
                                 bool isLastActionCancel,
                                 [Optional] bool[] enablings,
                                 ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray )
{
   return PerformDialog( false, caption,
      actions, isLastActionCancel, enablings,
      keysArray, modifiersArray );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
