﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray )
{
   return PerformDialog(insertBlankLine,caption,actions,null,keysArray);
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] string cancelAction )
{
   return PerformDialog( insertBlankLine, caption,
      actions, null, keysArray,
      cancelAction );
}

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey )
{
   return PerformDialog( insertBlankLine, caption,
      actions, null, keysArray,
      cancelAction, cancelKey );
}

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey,
                                 [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformDialog( insertBlankLine, caption,
      actions, null, keysArray,
      cancelAction, cancelKey, cancelModifiers );
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, bool isLastActionCancel,
                                 ConsoleKey[] keysArray )
{
   return PerformDialog( insertBlankLine, caption,
      actions, isLastActionCancel, null,
      keysArray );
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray )
{
   return PerformDialog(insertBlankLine,caption,actions,null,keysArray,modifiersArray);
}

//==================================================================================================

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] string cancelAction )
{
   return PerformDialog( insertBlankLine, caption,
      actions, null, keysArray, modifiersArray,
      cancelAction );
}

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey )
{
   return PerformDialog( insertBlankLine, caption,
      actions, null, keysArray, modifiersArray,
      cancelAction, cancelKey );
}

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey,
                                 [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformDialog( insertBlankLine, caption,
      actions, null, keysArray, modifiersArray,
      cancelAction, cancelKey, cancelModifiers );
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( bool insertBlankLine,
                                 string caption,
                                 string[] actions,
                                 bool isLastActionCancel,
                                 ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray )
{
   return PerformDialog( insertBlankLine, caption,
      actions, isLastActionCancel, null,
      keysArray, modifiersArray );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
