﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int PerformDialog(string caption,string[] actions, ConsoleKey[] keysArray)
{
   return PerformDialog(false,caption,actions,keysArray);
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption, string[] actions,
                                 ConsoleKey[] keysArray, [Optional] string cancelAction )
{
   return PerformDialog(false,caption,actions,keysArray,cancelAction);
}

public static int PerformDialog( string caption, string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleKey cancelKey, [Optional] string cancelAction )
{
   return PerformDialog(false,caption,actions,keysArray,cancelAction,cancelKey);
}

public static int PerformDialog( bool insertBlankLine, string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleKey cancelKey,
                                 [Optional] ConsoleModifiers cancelModifiers,
                                 [Optional] string cancelAction )
{
   return PerformDialog(false,caption,actions,keysArray,cancelAction,cancelKey,cancelModifiers);
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption, string[] actions,
                                 bool isLastActionCancel, ConsoleKey[] keysArray )
{
   return PerformDialog(false,caption,actions,isLastActionCancel,keysArray);
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption, string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray )
{
   return PerformDialog(false,caption,actions,keysArray,modifiersArray);
}

//==================================================================================================

public static int PerformDialog( string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 string cancelAction )
{
   return PerformDialog(false,caption,actions,keysArray,modifiersArray,cancelAction);
}

public static int PerformDialog( string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey )
{
   return PerformDialog(false,caption,actions,keysArray,modifiersArray,cancelAction,cancelKey);
}

public static int PerformDialog( string caption,
                                 string[] actions, ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray,
                                 [Optional] string cancelAction,
                                 [Optional] ConsoleKey cancelKey,
                                 [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformDialog( false,
      caption, actions, keysArray, modifiersArray,
      cancelAction, cancelKey, cancelModifiers );
}

//--------------------------------------------------------------------------------------------------

public static int PerformDialog( string caption,
                                 string[] actions,
                                 bool isLastActionCancel,
                                 ConsoleKey[] keysArray,
                                 [Optional] ConsoleModifiers[] modifiersArray )
{
   return PerformDialog(false,caption,actions,isLastActionCancel,keysArray,modifiersArray);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
