﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int PerformNumberedDialog(string caption,string[] actions,[Optional] bool[] enablings)
{
   return PerformNumberedDialog(false,caption,actions,enablings);
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( string caption,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(false,caption,actions,enablings,cancelAction);
}

public static int PerformNumberedDialog( string caption,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(false,caption,actions,enablings,cancelAction,cancelKey);
}

public static int PerformNumberedDialog( string caption,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog(
      false, caption,
      actions, enablings,
      cancelAction, cancelKey, cancelModifiers );
}

//==================================================================================================

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] bool[] enablings )
{
   return PerformNumberedDialog(false,caption,zeroAction,actions,enablings);
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(
      false, caption,
      zeroAction, actions, enablings,
      cancelAction );
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(
      false, caption,
      zeroAction, actions, enablings,
      cancelAction, cancelKey );
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog(
      false, caption,
      zeroAction, actions, enablings,
      cancelAction, cancelKey, cancelModifiers );
}

//==================================================================================================

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] bool[] enablings )
{
   return PerformNumberedDialog( false, caption,
      zeroAction, placeZeroActionDown, actions, enablings );
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog( false, caption,
      zeroAction, placeZeroActionDown, actions, enablings,
      cancelAction );
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog( false, caption,
      zeroAction, placeZeroActionDown, actions, enablings,
      cancelAction, cancelKey );
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] bool[] enablings,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog( false, caption,
      zeroAction, placeZeroActionDown, actions, enablings,
      cancelAction, cancelKey, cancelModifiers );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
