﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int PerformNumberedDialog(bool insertBlankLine,string caption,string[] actions)
{
   return PerformNumberedDialog(insertBlankLine,caption,actions,(bool[])null);
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         string[] actions,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(
      insertBlankLine, caption, actions, null,
      cancelAction );
}

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(
      insertBlankLine, caption, actions, null,
      cancelAction, cancelKey );
}

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog(
      insertBlankLine, caption, actions, null,
      cancelAction, cancelKey, cancelModifiers );
}

//==================================================================================================

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         string[] actions )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, actions,
      (bool[])null );
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, actions, null,
      cancelAction );
}

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, actions, null,
      cancelAction, cancelKey );
}

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, actions, null,
      cancelAction, cancelKey, cancelModifiers );
}

//==================================================================================================

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, placeZeroActionDown,
      actions, (bool[])null );
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, placeZeroActionDown, actions, null,
      cancelAction );
}

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, placeZeroActionDown, actions, null,
      cancelAction, cancelKey );
}

public static int PerformNumberedDialog( bool insertBlankLine,
                                         string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog(
      insertBlankLine, caption,
      zeroAction, placeZeroActionDown, actions, null,
      cancelAction, cancelKey, cancelModifiers );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
