//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int PerformNumberedDialog(string caption,string[] actions)
{
   return PerformNumberedDialog(false,caption,actions);
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( string caption,
                                         string[] actions,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(false,caption,actions,cancelAction,0);
}

public static int PerformNumberedDialog( string caption,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(false,caption,actions,cancelAction,cancelKey);
}

public static int PerformNumberedDialog( string caption,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog(false,caption,actions,cancelAction,cancelKey,cancelModifiers);
}

//==================================================================================================

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions )
{
   return PerformNumberedDialog(false,caption,zeroAction,actions);
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog(false,caption,zeroAction,actions,cancelAction);
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog(false,caption,zeroAction,actions,cancelAction,cancelKey);
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog( false, caption, zeroAction,
      actions, cancelAction, cancelKey, cancelModifiers );
}

//==================================================================================================

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions )
{
   return PerformNumberedDialog(false,caption,zeroAction,placeZeroActionDown,actions);
}

//--------------------------------------------------------------------------------------------------

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] string cancelAction )
{
   return PerformNumberedDialog( false,
      caption, zeroAction, placeZeroActionDown,
      actions, cancelAction );
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey )
{
   return PerformNumberedDialog( false,
      caption, zeroAction, placeZeroActionDown,
      actions, cancelAction, cancelKey );
}

public static int PerformNumberedDialog( string caption,
                                         [Optional] string zeroAction,
                                         bool placeZeroActionDown,
                                         string[] actions,
                                         [Optional] string cancelAction,
                                         [Optional] ConsoleKey cancelKey,
                                         [Optional] ConsoleModifiers cancelModifiers )
{
   return PerformNumberedDialog( false,
      caption, zeroAction, placeZeroActionDown,
      actions, cancelAction, cancelKey, cancelModifiers );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
