﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="InvalidOperationException" />
public static void PerformExitionDialog(bool insertBlankLine)
{
   if (insertBlankLine)
      Print();
   OutputDialogPrompt( ExitionDialogPromptMessage );
   AcceptInputKey( ConsoleKey.Enter, ConsoleKey.Escape );
   Print();
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="InvalidOperationException" />
public static void PerformContinuationDialog(bool insertBlankLine)
{
   if (insertBlankLine)
      Print();
   OutputDialogPrompt( ContinuationDialogPromptMessage );
   AcceptInputKey( ConsoleKey.Enter, ConsoleKey.Escape );
   Print();
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="InvalidOperationException" />
public static bool PerformConfirmationDialog(bool insertBlankLine,string caption)
{
   return PerformDialog( insertBlankLine, caption,
      new string[]{ ConfirmationDialogActionText_Confirm },
      new ConsoleKey[]{ ConsoleKey.Enter },
      ConfirmationDialogActionText_Cancel ) == 0;
}

/// <exception cref="InvalidOperationException" />
public static bool PerformConfirmationDialog( bool insertBlankLine,
                                              string captionFmt,
                                              params string[] parameters )
{
   return PerformConfirmationDialog(false,string.Format(captionFmt,parameters));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
