﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintDialogKeysLegend( bool insertBlankLine,
                                          string[] actions,
                                          ConsoleKey[] keysArray )
{
   PrintDialogKeysLegend( insertBlankLine, null, actions, keysArray );
}

public static void PrintDialogKeysLegend( bool insertBlankLine,
                                          string[] actions, ConsoleKey[] keysArray,
                                          [Optional] ConsoleModifiers[] modifiersArray )
{
   PrintDialogKeysLegend( insertBlankLine, null, actions, keysArray, modifiersArray );
}

//--------------------------------------------------------------------------------------------------

public static void PrintDialogKeysLegend( bool insertBlankLine, [Optional] string caption,
                                          string[] actions, ConsoleKey[] keysArray )
{
   PrintDialogKeysLegend( insertBlankLine, caption, actions, keysArray, null );
}

public static void PrintDialogKeysLegend( bool insertBlankLine, [Optional] string caption,
                                          string[] actions, ConsoleKey[] keysArray,
                                          [Optional] ConsoleModifiers[] modifiersArray )
{
   if ( keysArray.Length==0 ||
        modifiersArray!=null && modifiersArray.Length!=keysArray.Length ||
        actions.Length!=keysArray.Length )
      throw XArgCheck.ArgumentException_IncorrectArguments;

   if (insertBlankLine)
      Print();
   if (caption!=null)
      PrintInformationCaption( caption );

   int itemsCount = keysArray.Length;

   var keyStrings = new string[ itemsCount ];
   for (int i=0; i<keyStrings.Length; i++)
      keyStrings[i] = KeyToString( XArray.GetAtZeroBasedIndex(keysArray,i),
         modifiersArray!=null ? XArray.GetAtZeroBasedIndex(modifiersArray,i) : 0 );

   PrintDashAlignedList(
      keyStrings, DialogKeyColor,
      actions, DialogActionColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
