﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static char BulletChar
{
   get { lock (typeof(XConsole)) return _BulletChar_; }
   set { lock (typeof(XConsole)) _BulletChar_ = value; }
}

public static char DashChar
{
   get { lock (typeof(XConsole)) return _DashChar_; }
   set { lock (typeof(XConsole)) _DashChar_ = value; }
}

public static char NonDisplayableSubstChar
{
   get { lock (typeof(XConsole)) return _NonDisplayableSubstChar_; }
   set { lock (typeof(XConsole)) _NonDisplayableSubstChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char InformationCaptionChar
{
   get { lock (typeof(XConsole)) return _InformationCaptionChar_; }
   set { lock (typeof(XConsole)) _InformationCaptionChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char ArrowedCaptionDashChar
{
   get { lock (typeof(XConsole)) return _ArrowedCaptionDashChar_; }
   set { lock (typeof(XConsole)) _ArrowedCaptionDashChar_ = value; }
}

public static char ArrowedCaptionPointerChar
{
   get { lock (typeof(XConsole)) return _ArrowedCaptionPointerChar_; }
   set { lock (typeof(XConsole)) _ArrowedCaptionPointerChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char DialogCaptionChar
{
   get { lock (typeof(XConsole)) return _DialogCaptionChar_; }
   set { lock (typeof(XConsole)) _DialogCaptionChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char ListItemBulletChar
{
   get { lock (typeof(XConsole)) return _ListItemBulletChar_; }
   set { lock (typeof(XConsole)) _ListItemBulletChar_ = value; }
}

public static char ListItemDashChar
{
   get { lock (typeof(XConsole)) return _ListItemDashChar_; }
   set { lock (typeof(XConsole)) _ListItemDashChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char HeaderFooterChar
{
   get { lock (typeof(XConsole)) return _HeaderFooterChar_; }
   set { lock (typeof(XConsole)) _HeaderFooterChar_ = value; }
}

public static char ShallowHeaderFooterChar
{
   get { lock (typeof(XConsole)) return _ShallowHeaderFooterChar_; }
   set { lock (typeof(XConsole)) _ShallowHeaderFooterChar_ = value; }
}

public static char TitleHeaderFooterChar
{
   get { lock (typeof(XConsole)) return _TitleHeaderFooterChar_; }
   set { lock (typeof(XConsole)) _TitleHeaderFooterChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char SplitterChar
{
   get { lock (typeof(XConsole)) return _SplitterChar_; }
   set { lock (typeof(XConsole)) _SplitterChar_ = value; }
}

public static char DoubleSplitterChar
{
   get { lock (typeof(XConsole)) return _DoubleSplitterChar_; }
   set { lock (typeof(XConsole)) _DoubleSplitterChar_ = value; }
}

public static char ShallowSplitterChar
{
   get { lock (typeof(XConsole)) return _ShallowSplitterChar_; }
   set { lock (typeof(XConsole)) _ShallowSplitterChar_ = value; }
}

public static char ShallowDoubleSplitterChar
{
   get { lock (typeof(XConsole)) return _ShallowDoubleSplitterChar_; }
   set { lock (typeof(XConsole)) _ShallowDoubleSplitterChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static char InputArrowDashChar
{
   get { lock (typeof(XConsole)) return _InputArrowDashChar_; }
   set { lock (typeof(XConsole)) _InputArrowDashChar_ = value; }
}

public static char InputArrowPointerChar
{
   get { lock (typeof(XConsole)) return _InputArrowPointerChar_; }
   set { lock (typeof(XConsole)) _InputArrowPointerChar_ = value; }
}

public static char InputPasswordChar
{
   get { lock (typeof(XConsole)) return _InputPasswordChar_; }
   set { lock (typeof(XConsole)) _InputPasswordChar_ = value; }
}

//--------------------------------------------------------------------------------------------------

/*
public static char 
{
   get { lock (typeof(XConsole)) return __; }
   set { lock (typeof(XConsole)) __ = value; }
}
*/

//==================================================================================================

static char

   _BulletChar_                     = '*',
   _DashChar_                       = XUnicode.LightHorizontal,
   _NonDisplayableSubstChar_        = '?',

   _InformationCaptionChar_         = XUnicode.BlackRectangle,

   _ArrowedCaptionDashChar_         = XUnicode.LightHorizontal,
   _ArrowedCaptionPointerChar_      = XUnicode.BlackRightPointingPointer,

   _DialogCaptionChar_              = XUnicode.UpperHalfBlock,

   _ListItemBulletChar_             = XUnicode.BlackDiamondSuit,
   _ListItemDashChar_               = XUnicode.LightHorizontal,

   _HeaderFooterChar_               = XUnicode.MediumShade,
   _ShallowHeaderFooterChar_        = XUnicode.DoubleHorizontal,
   _TitleHeaderFooterChar_          = XUnicode.MediumShade,

   _SplitterChar_                   = XUnicode.LightHorizontal,
   _DoubleSplitterChar_             = XUnicode.DoubleHorizontal,
   _ShallowSplitterChar_            = '-',
   _ShallowDoubleSplitterChar_      = '=',

   _InputArrowDashChar_             = XUnicode.DoubleHorizontal,
   _InputArrowPointerChar_          = XUnicode.BlackRightPointingPointer,
   _InputPasswordChar_              = XUnicode.BlackSquare;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
