﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static ConsoleColor? NormalColor
{
   get { lock (typeof(XConsole)) return _NormalColor_; }
   set { lock (typeof(XConsole)) _NormalColor_ = value; }
}

public static ConsoleColor? FaintColor
{
   get { lock (typeof(XConsole)) return _FaintColor_; }
   set { lock (typeof(XConsole)) _FaintColor_ = value; }
}

public static ConsoleColor? IntensiveColor
{
   get { lock (typeof(XConsole)) return _IntensiveColor_; }
   set { lock (typeof(XConsole)) _IntensiveColor_ = value; }
}

public static ConsoleColor? ImportantColor
{
   get { lock (typeof(XConsole)) return _ImportantColor_; }
   set { lock (typeof(XConsole)) _ImportantColor_ = value; }
}

public static ConsoleColor? ExpressiveColor
{
   get { lock (typeof(XConsole)) return _ExpressiveColor_; }
   set { lock (typeof(XConsole)) _ExpressiveColor_ = value; }
}

public static ConsoleColor? ExclamationColor
{
   get { lock (typeof(XConsole)) return _ExclamationColor_; }
   set { lock (typeof(XConsole)) _ExclamationColor_ = value; }
}

public static ConsoleColor? InformationColor
{
   get { lock (typeof(XConsole)) return _InformationColor_; }
   set { lock (typeof(XConsole)) _InformationColor_ = value; }
}

public static ConsoleColor? WarningColor
{
   get { lock (typeof(XConsole)) return _WarningColor_; }
   set { lock (typeof(XConsole)) _WarningColor_ = value; }
}

public static ConsoleColor? ErrorColor
{
   get { lock (typeof(XConsole)) return _ErrorColor_; }
   set { lock (typeof(XConsole)) _ErrorColor_ = value; }
}

public static ConsoleColor? SuccessColor
{
   get { lock (typeof(XConsole)) return _SuccessColor_; }
   set { lock (typeof(XConsole)) _SuccessColor_ = value; }
}

public static ConsoleColor? OperationColor
{
   get { lock (typeof(XConsole)) return _OperationColor_; }
   set { lock (typeof(XConsole)) _OperationColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? InformationCaptionColor
{
   get { lock (typeof(XConsole)) return _InformationCaptionColor_; }
   set { lock (typeof(XConsole)) _InformationCaptionColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? ArrowedCaptionColor
{
   get { lock (typeof(XConsole)) return _ArrowedCaptionColor_; }
   set { lock (typeof(XConsole)) _ArrowedCaptionColor_ = value; }
}

public static ConsoleColor? ArrowedCaptionArrowColor
{
   get { lock (typeof(XConsole)) return _ArrowedCaptionArrowColor_; }
   set { lock (typeof(XConsole)) _ArrowedCaptionArrowColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? FeaturedInscriptionColor
{
   get { lock (typeof(XConsole)) return _FeaturedInscriptionColor_; }
   set { lock (typeof(XConsole)) _FeaturedInscriptionColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? HeaderFooterColor
{
   get { lock (typeof(XConsole)) return _HeaderFooterColor_; }
   set { lock (typeof(XConsole)) _HeaderFooterColor_ = value; }
}

public static ConsoleColor? ShallowHeaderFooterColor
{
   get { lock (typeof(XConsole)) return _ShallowHeaderFooterColor_; }
   set { lock (typeof(XConsole)) _ShallowHeaderFooterColor_ = value; }
}

public static ConsoleColor? TitleHeaderFooterColor
{
   get { lock (typeof(XConsole)) return _TitleHeaderFooterColor_; }
   set { lock (typeof(XConsole)) _TitleHeaderFooterColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? SplitterColor
{
   get { lock (typeof(XConsole)) return _SplitterColor_; }
   set { lock (typeof(XConsole)) _SplitterColor_ = value; }
}
public static ConsoleColor? ShallowSplitterColor
{
   get { lock (typeof(XConsole)) return _ShallowSplitterColor_; }
   set { lock (typeof(XConsole)) _ShallowSplitterColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? ListItemCaptionColor
{
   get { lock (typeof(XConsole)) return _ListItemCaptionColor_; }
   set { lock (typeof(XConsole)) _ListItemCaptionColor_ = value; }
}

public static ConsoleColor? ListItemValueColor
{
   get { lock (typeof(XConsole)) return _ListItemValueColor_; }
   set { lock (typeof(XConsole)) _ListItemValueColor_ = value; }
}

public static ConsoleColor? ListItemBulletColor
{
   get { lock (typeof(XConsole)) return _ListItemBulletColor_; }
   set { lock (typeof(XConsole)) _ListItemBulletColor_ = value; }
}

public static ConsoleColor? ListItemPairLigamentColor
{
   get { lock (typeof(XConsole)) return _ListItemPairLigamentColor_; }
   set { lock (typeof(XConsole)) _ListItemPairLigamentColor_ = value; }
}

public static ConsoleColor? ListItemDashColor
{
   get { lock (typeof(XConsole)) return _ListItemDashColor_; }
   set { lock (typeof(XConsole)) _ListItemDashColor_ = value; }
}

public static ConsoleColor? ListItemEquationLigamentColor
{
   get { lock (typeof(XConsole)) return _ListItemEquationLigamentColor_; }
   set { lock (typeof(XConsole)) _ListItemEquationLigamentColor_ = value; }
}

public static ConsoleColor? ListItemNumberColor
{
   get { lock (typeof(XConsole)) return _ListItemNumberColor_; }
   set { lock (typeof(XConsole)) _ListItemNumberColor_ = value; }
}

public static ConsoleColor? ListItemNumberedValueColor
{
   get { lock (typeof(XConsole)) return _ListItemNumberedValueColor_; }
   set { lock (typeof(XConsole)) _ListItemNumberedValueColor_ = value; }
}

public static ConsoleColor? ListItemNumberValueSeparatorColor
{
   get { lock (typeof(XConsole)) return _ListItemNumberValueSeparatorColor_; }
   set { lock (typeof(XConsole)) _ListItemNumberValueSeparatorColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? DialogCaptionColor
{
   get { lock (typeof(XConsole)) return _DialogCaptionColor_; }
   set { lock (typeof(XConsole)) _DialogCaptionColor_ = value; }
}

public static ConsoleColor? DialogKeyColor
{
   get { lock (typeof(XConsole)) return _DialogKeyColor_; }
   set { lock (typeof(XConsole)) _DialogKeyColor_ = value; }
}

public static ConsoleColor? DialogKeyDisablingColor
{
   get { lock (typeof(XConsole)) return _DialogKeyDisablingColor_; }
   set { lock (typeof(XConsole)) _DialogKeyDisablingColor_ = value; }
}

public static ConsoleColor? DialogDashColor
{
   get { lock (typeof(XConsole)) return _DialogDashColor_; }
   set { lock (typeof(XConsole)) _DialogDashColor_ = value; }
}

public static ConsoleColor? DialogActionColor
{
   get { lock (typeof(XConsole)) return _DialogActionColor_; }
   set { lock (typeof(XConsole)) _DialogActionColor_ = value; }
}

public static ConsoleColor? DialogCancelActionColor
{
   get { lock (typeof(XConsole)) return _DialogCancelActionColor_; }
   set { lock (typeof(XConsole)) _DialogCancelActionColor_ = value; }
}

public static ConsoleColor? DialogPromptColor
{
   get { lock (typeof(XConsole)) return _DialogPromptColor_; }
   set { lock (typeof(XConsole)) _DialogPromptColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

public static ConsoleColor? InputCaptionColor
{
   get { lock (typeof(XConsole)) return _InputCaptionColor_; }
   set { lock (typeof(XConsole)) _InputCaptionColor_ = value; }
}

public static ConsoleColor? InputForegroundColor
{
   get { lock (typeof(XConsole)) return _InputForegroundColor_; }
   set { lock (typeof(XConsole)) _InputForegroundColor_ = value; }
}

public static ConsoleColor? InputBackgroundColor
{
   get { lock (typeof(XConsole)) return _InputBackgroundColor_; }
   set { lock (typeof(XConsole)) _InputBackgroundColor_ = value; }
}

public static ConsoleColor? InputArrowColor
{
   get { lock (typeof(XConsole)) return _InputArrowColor_; }
   set { lock (typeof(XConsole)) _InputArrowColor_ = value; }
}

//--------------------------------------------------------------------------------------------------

/*
public static ConsoleColor? 
{
   get { lock (typeof(XConsole)) return __; }
   set { lock (typeof(XConsole)) __ = value; }
}
*/

//==================================================================================================

static ConsoleColor?

   _NormalColor_                       = ConsoleColor.Gray,
   _FaintColor_                        = ConsoleColor.DarkGray,
   _IntensiveColor_                    = ConsoleColor.White,
   _ImportantColor_                    = ConsoleColor.Yellow,
   _ExpressiveColor_                   = ConsoleColor.Yellow,
   _ExclamationColor_                  = ConsoleColor.Magenta,
   _InformationColor_                  = ConsoleColor.Cyan,
   _WarningColor_                      = ConsoleColor.Yellow,
   _ErrorColor_                        = ConsoleColor.Red,
   _SuccessColor_                      = ConsoleColor.Green,
   _OperationColor_                    = ConsoleColor.White,

   _InformationCaptionColor_           = ConsoleColor.Cyan,

   _ArrowedCaptionColor_               = ConsoleColor.White,
   _ArrowedCaptionArrowColor_          = ConsoleColor.Gray,

   _FeaturedInscriptionColor_          = ConsoleColor.Cyan,

   _HeaderFooterColor_                 = ConsoleColor.Gray,
   _ShallowHeaderFooterColor_          = ConsoleColor.Gray,
   _TitleHeaderFooterColor_            = ConsoleColor.White,

   _SplitterColor_                     = ConsoleColor.Gray,
   _ShallowSplitterColor_              = ConsoleColor.DarkGray,

   _ListItemCaptionColor_              = ConsoleColor.White,
   _ListItemValueColor_                = ConsoleColor.Yellow,
   _ListItemBulletColor_               = ConsoleColor.DarkGray,
   _ListItemPairLigamentColor_         = ConsoleColor.Gray,
   _ListItemDashColor_                 = ConsoleColor.DarkGray,
   _ListItemEquationLigamentColor_     = ConsoleColor.DarkGray,
   _ListItemNumberColor_               = ConsoleColor.Yellow,
   _ListItemNumberedValueColor_        = ConsoleColor.White,
   _ListItemNumberValueSeparatorColor_ = null,

   _DialogCaptionColor_                = ConsoleColor.White,
   _DialogKeyColor_                    = ConsoleColor.Yellow,
   _DialogKeyDisablingColor_           = ConsoleColor.DarkGray,
   _DialogDashColor_                   = ConsoleColor.Gray,
   _DialogActionColor_                 = ConsoleColor.White,
   _DialogCancelActionColor_           = ConsoleColor.DarkGray,
   _DialogPromptColor_                 = ConsoleColor.White,

   _InputCaptionColor_                 = ConsoleColor.White,
   _InputForegroundColor_              = ConsoleColor.White,
   _InputBackgroundColor_              = ConsoleColor.DarkCyan,
   _InputArrowColor_                   = ConsoleColor.Gray;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
