﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int NormalWidth
{
   get
   {
      lock (typeof(XConsole))
         return _NormalWidth_;
   }
   set
   {
      if (value<1)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _NormalWidth_ = value;
   }
}

public static int NormalHeight
{
   get
   {
      lock (typeof(XConsole))
         return _NormalHeight_;
   }
   set
   {
      if (value<1)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _NormalHeight_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static int LongDashLength
{
   get
   {
      lock (typeof(XConsole))
         return _LongDashLength_;
   }
   set
   {
      if (value<1)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _LongDashLength_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static int ArrowedCaptionDashMinLength
{
   get
   {
      lock (typeof(XConsole))
         return _ArrowedCaptionDashMinLength_;
   }
   set
   {
      if (value<0)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _ArrowedCaptionDashMinLength_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="ArgumentOutOfRangeException" />
public static int HeaderFooterPaddingWidth
{
   get
   {
      lock (typeof(XConsole))
         return _HeaderFooterPaddingWidth_;
   }
   set
   {
      if (value<1)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _HeaderFooterPaddingWidth_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static int InputArrowDashMinLength
{
   get
   {
      lock (typeof(XConsole))
         return _InputArrowDashMinLength_;
   }
   set
   {
      if (value<0)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _InputArrowDashMinLength_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static int WaitInputPollingPause
{
   get
   {
      lock (typeof(XConsole))
         return _WaitInputPollingPause_;
   }
   set
   {
      if (value<=0)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _WaitInputPollingPause_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static int InputIdlePollingDefaultInterval
{
   get
   {
      lock (typeof(XConsole))
         return _InputIdlePollingDefaultInterval_;
   }
   set
   {
      if (value<=0)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         _InputIdlePollingDefaultInterval_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

/*
public static int 
{
   get
   {
      lock (typeof(XConsole))
         return __;
   }
   set
   {
      if (value)
         throw new ArgumentOutOfRangeException();
      lock (typeof(XConsole))
         __ = value;
   }
}
*/

//==================================================================================================

static int
   _NormalWidth_                       = 100,
   _NormalHeight_                      = 50,
   _LongDashLength_                    = 2,
   _ArrowedCaptionDashMinLength_       = 2,
   _HeaderFooterPaddingWidth_          = 2,
   _InputArrowDashMinLength_           = 2,
   _WaitInputPollingPause_             = 10,
   _InputIdlePollingDefaultInterval_   = 100;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
