﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="ArgumentNullException" />
public static string OperationFormatString
{
   get
   {
      lock (typeof(XConsole))
         return _OperationFormatString_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _OperationFormatString_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static string DialogPromptString
{
   get
   {
      lock (typeof(XConsole))
         return _DialogPromptString_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _DialogPromptString_ = value;
   }
}

public static string DialogPromptFormatString
{
   get
   {
      lock (typeof(XConsole))
         return _DialogPromptFormatString_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _DialogPromptFormatString_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static string FeaturedInscriptionFormatString
{
   get
   {
      lock (typeof(XConsole))
         return _FeaturedInscriptionFormatString_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _FeaturedInscriptionFormatString_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

public static string ListItemPairLigament
{
   get
   {
      lock (typeof(XConsole))
         return _ListItemPairLigament_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _ListItemPairLigament_ = value;
   }
}

public static string ListItemEquationLigament
{
   get
   {
      lock (typeof(XConsole))
         return _ListItemEquationLigament_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _ListItemEquationLigament_ = value;
   }
}

public static string ListItemNumberValueSeparator
{
   get
   {
      lock (typeof(XConsole))
         return _ListItemNumberValueSeparator_;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         _ListItemNumberValueSeparator_ = value;
   }
}

//--------------------------------------------------------------------------------------------------

/*
public static string 
{
   get
   {
      lock (typeof(XConsole))
         return __;
   }
   set
   {
      XArgCheck.VerifyNotNull( value );
      lock (typeof(XConsole))
         __ = value;
   }
}
*/

//==================================================================================================

public static string LongDash
{
   get { return new string(DashChar,LongDashLength); }
}

//==================================================================================================

static string
   _OperationFormatString_             = "* {0} ...",
   _DialogPromptString_                = XUnicode.BlackRightPointingPointer+" . . . ",
   _DialogPromptFormatString_          = XUnicode.BlackRightPointingPointer+" {0} . . . ",
   _FeaturedInscriptionFormatString_   = string.Format( "{1}{1}{1} {0} {1}{1}{1}",
                                                        "{0}", XUnicode.BlackSquare ),
   _ListItemPairLigament_              = " : ",
   _ListItemEquationLigament_          = " = ",
   _ListItemNumberValueSeparator_      = ") ";

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
