﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintUnderbarCaption(char underbarChar,ConsoleColor? color,string caption)
{
   PrintUnderbarCaption(false,underbarChar,color,caption);
}

public static void PrintUnderbarCaption( char underbarChar, ConsoleColor? color,
                                         string captionFmt, params object[] parameters )
{
   PrintUnderbarCaption(false,underbarChar,color,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintUnderbarCaption( bool insertBlankLine,
                                         char underbarChar,
                                         ConsoleColor? color,
                                         string caption )
{
   XArgCheck.VerifyNotNull(caption);
   lock (typeof(XConsole))
   {
      Print(insertBlankLine,color,caption);
      Print( color,
         new string( underbarChar,
            IsInVisualMode ? Math.Min(caption.Length,Width) : caption.Length  ) );
   }
}

public static void PrintUnderbarCaption( bool insertBlankLine,
                                         char underbarChar, ConsoleColor? color,
                                         string captionFmt, params object[] parameters )
{
   PrintUnderbarCaption(insertBlankLine,underbarChar,color,string.Format(captionFmt,parameters));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
