﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintFeaturedInscription(string inscription)
{
   PrintFeaturedInscription(false,inscription);
}

public static void PrintFeaturedInscription(string inscriptionFmt,params object[] parameters)
{
   PrintFeaturedInscription(false,inscriptionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintFeaturedInscription(ConsoleColor? color,string inscription)
{
   PrintFeaturedInscription(false,color,inscription);
}

public static void PrintFeaturedInscription( ConsoleColor? color,
                                             string inscriptionFmt,
                                             params object[] parameters )
{
   PrintFeaturedInscription(false,color,inscriptionFmt,parameters);
}

//==================================================================================================

public static void PrintFeaturedInscription(bool insertBlankLine,string inscription)
{
   PrintFeaturedInscription(insertBlankLine,null,inscription);
}

public static void PrintFeaturedInscription( bool insertBlankLine,
                                             string inscriptionFmt,
                                             params object[] parameters )
{
   PrintFeaturedInscription(insertBlankLine,null,inscriptionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintFeaturedInscription( bool insertBlankLine,
                                             ConsoleColor? color,
                                             string inscription )
{
   XArgCheck.VerifyNotNull( inscription );
   Print( insertBlankLine,
      color ?? FeaturedInscriptionColor,
      FeaturedInscriptionFormatString, inscription );
}

public static void PrintFeaturedInscription( bool insertBlankLine, ConsoleColor? color,
                                             string inscriptionFmt, params object[] parameters )
{
   PrintFeaturedInscription(insertBlankLine,color,string.Format(inscriptionFmt,parameters));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
