﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintFooter(string caption)
{
   PrintHeaderFooter(HeaderFooterType.Normal,true,false,false,caption);
}

public static void PrintFooter(string captionFmt,params object[] parameters)
{
   PrintHeaderFooter(HeaderFooterType.Normal,true,false,false,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintFooter(bool insertPrecedingBlankLine,string caption)
{
   PrintHeaderFooter( HeaderFooterType.Normal, true,
      insertPrecedingBlankLine, false,
      caption );
}

public static void PrintFooter( bool insertPrecedingBlankLine,
                                string captionFmt,
                                params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Normal, true,
      insertPrecedingBlankLine, false,
      captionFmt, parameters );
}

public static void PrintFooter( bool insertPrecedingBlankLine,
                                bool insertPosteriorBlankLinestring,
                                string caption )
{
   PrintHeaderFooter( HeaderFooterType.Normal, true,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      caption );
}

public static void PrintFooter( bool insertPrecedingBlankLine,
                                bool insertPosteriorBlankLinestring,
                                string captionFmt,
                                params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Normal, true,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      captionFmt, parameters );
}

//==================================================================================================

public static void PrintShallowFooter(string caption)
{
   PrintHeaderFooter(HeaderFooterType.Shallow,true,false,false,caption);
}

public static void PrintShallowFooter(string captionFmt,params object[] parameters)
{
   PrintHeaderFooter(HeaderFooterType.Shallow,true,false,false,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintShallowFooter(bool insertPrecedingBlankLine,string caption)
{
   PrintHeaderFooter( HeaderFooterType.Shallow, true,
      insertPrecedingBlankLine, false,
      caption );
}

public static void PrintShallowFooter( bool insertPrecedingBlankLine,
                                       string captionFmt,
                                       params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Shallow, true,
      insertPrecedingBlankLine, false,
      captionFmt, parameters );
}

public static void PrintShallowFooter( bool insertPrecedingBlankLine,
                                       bool insertPosteriorBlankLinestring,
                                       string caption )
{
   PrintHeaderFooter( HeaderFooterType.Shallow, true,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      caption );
}

public static void PrintShallowFooter( bool insertPrecedingBlankLine,
                                       bool insertPosteriorBlankLinestring,
                                       string captionFmt,
                                       params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Shallow, true,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      captionFmt, parameters );
}

//==================================================================================================

public static void PrintTitleFooter(string caption)
{
   PrintHeaderFooter(HeaderFooterType.Title,true,false,false,caption);
}

public static void PrintTitleFooter(string captionFmt,params object[] parameters)
{
   PrintHeaderFooter(HeaderFooterType.Title,true,false,false,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintTitleFooter(bool insertPrecedingBlankLine,string caption)
{
   PrintHeaderFooter( HeaderFooterType.Title, true,
      insertPrecedingBlankLine, false,
      caption );
}

public static void PrintTitleFooter( bool insertPrecedingBlankLine,
                                     string captionFmt,
                                     params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Title, true,
      insertPrecedingBlankLine, false,
      captionFmt, parameters );
}

public static void PrintTitleFooter( bool insertPrecedingBlankLine,
                                     bool insertPosteriorBlankLinestring,
                                     string caption )
{
   PrintHeaderFooter( HeaderFooterType.Title, true,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      caption );
}

public static void PrintTitleFooter( bool insertPrecedingBlankLine,
                                     bool insertPosteriorBlankLinestring,
                                     string captionFmt,
                                     params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Title, true,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      captionFmt, parameters );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
