﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintHeader(string caption)
{
   PrintHeaderFooter(HeaderFooterType.Normal,false,false,false,caption);
}

public static void PrintHeader(string captionFmt,params object[] parameters)
{
   PrintHeaderFooter(HeaderFooterType.Normal,false,false,false,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintHeader(bool insertPrecedingBlankLine,string caption)
{
   PrintHeaderFooter( HeaderFooterType.Normal, false,
      insertPrecedingBlankLine, false,
      caption );
}

public static void PrintHeader( bool insertPrecedingBlankLine,
                                string captionFmt,
                                params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Normal, false,
      insertPrecedingBlankLine, false,
      captionFmt, parameters );
}

public static void PrintHeader( bool insertPrecedingBlankLine,
                                bool insertPosteriorBlankLinestring,
                                string caption )
{
   PrintHeaderFooter( HeaderFooterType.Normal, false,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      caption );
}

public static void PrintHeader( bool insertPrecedingBlankLine,
                                bool insertPosteriorBlankLinestring,
                                string captionFmt,
                                params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Normal, false,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      captionFmt, parameters );
}

//==================================================================================================

public static void PrintShallowHeader(string caption)
{
   PrintHeaderFooter(HeaderFooterType.Shallow,false,false,false,caption);
}

public static void PrintShallowHeader(string captionFmt,params object[] parameters)
{
   PrintHeaderFooter(HeaderFooterType.Shallow,false,false,false,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintShallowHeader(bool insertPrecedingBlankLine,string caption)
{
   PrintHeaderFooter( HeaderFooterType.Shallow, false,
      insertPrecedingBlankLine, false,
      caption );
}

public static void PrintShallowHeader( bool insertPrecedingBlankLine,
                                       string captionFmt,
                                       params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Shallow, false,
      insertPrecedingBlankLine, false,
      captionFmt, parameters );
}

public static void PrintShallowHeader( bool insertPrecedingBlankLine,
                                       bool insertPosteriorBlankLinestring,
                                       string caption )
{
   PrintHeaderFooter( HeaderFooterType.Shallow, false,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      caption );
}

public static void PrintShallowHeader( bool insertPrecedingBlankLine,
                                       bool insertPosteriorBlankLinestring,
                                       string captionFmt,
                                       params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Shallow, false,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      captionFmt, parameters );
}

//==================================================================================================

public static void PrintTitleHeader(string caption)
{
   PrintHeaderFooter(HeaderFooterType.Title,false,false,false,caption);
}

public static void PrintTitleHeader(string captionFmt,params object[] parameters)
{
   PrintHeaderFooter(HeaderFooterType.Title,false,false,false,captionFmt,parameters);
}

//--------------------------------------------------------------------------------------------------

public static void PrintTitleHeader(bool insertPrecedingBlankLine,string caption)
{
   PrintHeaderFooter( HeaderFooterType.Title, false,
      insertPrecedingBlankLine, false,
      caption );
}

public static void PrintTitleHeader( bool insertPrecedingBlankLine,
                                     string captionFmt,
                                     params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Title, false,
      insertPrecedingBlankLine, false,
      captionFmt, parameters );
}

public static void PrintTitleHeader( bool insertPrecedingBlankLine,
                                     bool insertPosteriorBlankLinestring,
                                     string caption )
{
   PrintHeaderFooter( HeaderFooterType.Title, false,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      caption );
}

public static void PrintTitleHeader( bool insertPrecedingBlankLine,
                                     bool insertPosteriorBlankLinestring,
                                     string captionFmt,
                                     params object[] parameters )
{
   PrintHeaderFooter( HeaderFooterType.Title, false,
      insertPrecedingBlankLine, insertPosteriorBlankLinestring,
      captionFmt, parameters );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
