﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintSplitter()
{
   PrintSplitter(false,false,false,false);
}

public static void PrintSplitter(bool insertPrecedingBlankLine)
{
   PrintSplitter(false,false,insertPrecedingBlankLine,false);
}

public static void PrintSplitter( bool insertPrecedingBlankLine,
                                  bool insertPosteriorBlankLine )
{
   PrintSplitter(false,false,insertPrecedingBlankLine,insertPosteriorBlankLine);
}

//--------------------------------------------------------------------------------------------------

public static void PrintDoubleSplitter()
{
   PrintSplitter(false,true,false,false);
}

public static void PrintDoubleSplitter(bool insertPrecedingBlankLine)
{
   PrintSplitter(false,true,insertPrecedingBlankLine,false);
}

public static void PrintDoubleSplitter( bool insertPrecedingBlankLine,
                                        bool insertPosteriorBlankLine )
{
   PrintSplitter(false,true,insertPrecedingBlankLine,insertPosteriorBlankLine);
}

//--------------------------------------------------------------------------------------------------

public static void PrintShallowSplitter()
{
   PrintSplitter(true,false,false,false);
}

public static void PrintShallowSplitter(bool insertPrecedingBlankLine)
{
   PrintSplitter(true,false,insertPrecedingBlankLine,false);
}

public static void PrintShallowSplitter( bool insertPrecedingBlankLine,
                                         bool insertPosteriorBlankLine )
{
   PrintSplitter(true,false,insertPrecedingBlankLine,insertPosteriorBlankLine);
}

//--------------------------------------------------------------------------------------------------

public static void PrintShallowDoubleSplitter()
{
   PrintSplitter(true,true,false,false);
}

public static void PrintShallowDoubleSplitter(bool insertPrecedingBlankLine)
{
   PrintSplitter(true,true,insertPrecedingBlankLine,false);
}

public static void PrintShallowDoubleSplitter( bool insertPrecedingBlankLine,
                                               bool insertPosteriorBlankLine )
{
   PrintSplitter(true,true,insertPrecedingBlankLine,insertPosteriorBlankLine);
}

//==================================================================================================

static void PrintSplitter( bool isShallow, bool isDouble,
                           bool insertPrecedingBlankLine,
                           bool insertPosteriorBlankLine )
{
   char ch;

   if (isShallow)
      if (isDouble) ch=ShallowDoubleSplitterChar;
      else ch=ShallowSplitterChar;
   else
      if (isDouble) ch=DoubleSplitterChar;
      else ch=SplitterChar;

   lock (typeof(XConsole))
   {
      if (insertPrecedingBlankLine)
         Print();
      Print( isShallow ? ShallowSplitterColor : SplitterColor,
             new string(ch,Width) );
      if (insertPosteriorBlankLine)
         Print();
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
