﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintAlignedBulletedList( bool insertBlankLine, [Optional] string caption,
                                             string[] captions, string[] values )
{
   PrintListCaption( insertBlankLine, caption );
   PrintAlignedBulletedList( false, captions, values );
}

//==================================================================================================

public static void PrintAlignedBulletedList(bool insertBlankLine,string[] captions,string[] values)
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, null,
      values, null,
      null, null );
}

public static void PrintAlignedBulletedList( bool insertBlankLine, string[] captions,
                                             string[] values, [Optional] string pairLigament )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, null,
      values, null,
      pairLigament, null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedBulletedList( bool insertBlankLine,
                                             string[] captions,
                                             ConsoleColor? captionColor,
                                             string[] values )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, null,
      null, null );
}

public static void PrintAlignedBulletedList( bool insertBlankLine,
                                             string[] captions, ConsoleColor? captionColor,
                                             string[] values, [Optional] string pairLigament )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, null,
      pairLigament, null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedBulletedList( bool insertBlankLine, string[] captions,
                                             string[] values, ConsoleColor? valueColor )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, null,
      values, valueColor,
      null, null );
}

public static void PrintAlignedBulletedList( bool insertBlankLine, string[] captions,
                                             string[] values, ConsoleColor? valueColor,
                                             [Optional] string pairLigament )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, null,
      values, valueColor,
      pairLigament, null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedBulletedList( bool insertBlankLine, string[] captions,
                                             ConsoleColor? captionColor, string[] values,
                                             ConsoleColor? valueColor )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      null, null );
}

public static void PrintAlignedBulletedList( bool insertBlankLine, string[] captions,
                                             ConsoleColor? captionColor,
                                             string[] values, ConsoleColor? valueColor,
                                             [Optional] string pairLigament )
{
   PrintAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      pairLigament, null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedBulletedList( bool insertBlankLine,
                                             string[] captions, ConsoleColor? captionColor,
                                             string[] values, ConsoleColor? valueColor,
                                             [Optional] string pairLigament,
                                             ConsoleColor? pairLigamentColor )
{
   PrintAlignedList( insertBlankLine,
      captions, captionColor, values, valueColor,
      ListItemBulletChar, null,
      pairLigament, pairLigamentColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
