﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintAlignedList([Optional] string caption,string[] captions,string[] values)
{
   PrintAlignedList(false,caption,captions,values);
}

//==================================================================================================

public static void PrintAlignedList(string[] captions,string[] values)
{
   PrintAlignedList(false,captions,values);
}

public static void PrintAlignedList( string[] captions,
                                     string[] values,
                                     [Optional] string pairLigament )
{
   PrintAlignedList(false,captions,values,pairLigament);
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedList( string[] captions,
                                     ConsoleColor? captionColor,
                                     string[] values )
{
   PrintAlignedList(false,captions,captionColor,values);
}

public static void PrintAlignedList( string[] captions, ConsoleColor? captionColor,
                                     string[] values, [Optional] string pairLigament )
{
   PrintAlignedList(false,captions,captionColor,values,pairLigament);
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedList( string[] captions,
                                     string[] values,
                                     ConsoleColor? valueColor )
{
   PrintAlignedList(false,captions,values,valueColor);
}

public static void PrintAlignedList( string[] captions, string[] values,
                                     ConsoleColor? valueColor, [Optional] string pairLigament )
{
   PrintAlignedList(false,captions,values,valueColor,pairLigament);
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedList( string[] captions, ConsoleColor? captionColor,
                                     string[] values, ConsoleColor? valueColor )
{
   PrintAlignedList(false,captions,captionColor,values,valueColor);
}

public static void PrintAlignedList( string[] captions, ConsoleColor? captionColor,
                                     string[] values, ConsoleColor? valueColor,
                                     [Optional] string pairLigament )
{
   PrintAlignedList(false,captions,captionColor,values,valueColor,pairLigament);
}

//--------------------------------------------------------------------------------------------------

public static void PrintAlignedList( string[] captions, ConsoleColor? captionColor,
                                     string[] values, ConsoleColor? valueColor,
                                     char? bulletChar, ConsoleColor? bulletColor,
                                     [Optional] string pairLigament,
                                     ConsoleColor? pairLigamentColor )
{
   PrintAlignedList( false,
      captions, captionColor,
      values, valueColor,
      bulletChar, bulletColor,
      pairLigament, pairLigamentColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
