﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintDashAlignedBulletedList( bool insertBlankLine, [Optional] string caption,
                                                 string[] captions, string[] values )
{
   PrintListCaption( insertBlankLine, caption );
   PrintDashAlignedBulletedList( false, captions, values );
}

//==================================================================================================

public static void PrintDashAlignedBulletedList( bool insertBlankLine,
                                                 string[] captions,
                                                 string[] values )
{
   PrintDashAlignedBulletedList(
      insertBlankLine,
      captions, null,
      values, null,
      null, null );
}

public static void PrintDashAlignedBulletedList( bool insertBlankLine,
                                                 string[] captions,
                                                 ConsoleColor? captionColor,
                                                 string[] values )
{
   PrintDashAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, null,
      null, null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintDashAlignedBulletedList( bool insertBlankLine,
                                                 string[] captions,
                                                 string[] values,
                                                 ConsoleColor? valueColor )
{
   PrintDashAlignedBulletedList(
      insertBlankLine,
      captions, null,
      values, valueColor,
      null, null );
}

public static void PrintDashAlignedBulletedList( bool insertBlankLine,
                                                 string[] captions, ConsoleColor? captionColor,
                                                 string[] values, ConsoleColor? valueColor )
{
   PrintDashAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      null, null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintDashAlignedBulletedList( bool insertBlankLine,
                                                 string[] captions, ConsoleColor? captionColor,
                                                 string[] values, ConsoleColor? valueColor,
                                                 ConsoleColor? dashColor )
{
   PrintDashAlignedBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintDashAlignedBulletedList( bool insertBlankLine,
                                                 string[] captions, ConsoleColor? captionColor,
                                                 string[] values, ConsoleColor? valueColor,
                                                 char? dashChar, ConsoleColor? dashColor )
{
   PrintDashAlignedList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      ListItemBulletChar, null,
      dashChar, dashColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
