﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintEquationBulletedList( bool insertBlankLine, [Optional] string caption,
                                              string[] captions, string[] values )
{
   PrintListCaption( insertBlankLine, caption );
   PrintEquationBulletedList( false, captions, values );
}

//==================================================================================================

public static void PrintEquationBulletedList( bool insertBlankLine,
                                              string[] captions,
                                              string[] values )
{
   PrintEquationBulletedList(
      insertBlankLine,
      captions, null,
      values, null,
      null );
}

public static void PrintEquationBulletedList( bool insertBlankLine,
                                              string[] captions,
                                              ConsoleColor? captionColor,
                                              string[] values )
{
   PrintEquationBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, null,
      null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintEquationBulletedList( bool insertBlankLine,
                                              string[] captions,
                                              string[] values,
                                              ConsoleColor? valueColor )
{
   PrintEquationBulletedList(
      insertBlankLine,
      captions, null,
      values, valueColor,
      null );
}

public static void PrintEquationBulletedList( bool insertBlankLine,
                                              string[] captions, ConsoleColor? captionColor,
                                              string[] values, ConsoleColor? valueColor )
{
   PrintEquationBulletedList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintEquationBulletedList( bool insertBlankLine,
                                              string[] captions, ConsoleColor? captionColor,
                                              string[] values, ConsoleColor? valueColor,
                                              ConsoleColor? equationLigamentColor )
{
   PrintEquationList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      ListItemBulletChar, null,
      equationLigamentColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
