﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintEquationList( bool insertBlankLine, [Optional] string caption,
                                      string[] captions, string[] values )
{
   PrintListCaption( insertBlankLine, caption );
   PrintEquationList( false, captions, values );
}

//==================================================================================================

public static void PrintEquationList(bool insertBlankLine,string[] captions,string[] values)
{
   PrintEquationList(
      insertBlankLine,
      captions, null,
      values, null,
      null );
}

public static void PrintEquationList( bool insertBlankLine,
                                      string[] captions,
                                      ConsoleColor? captionColor,
                                      string[] values )
{
   PrintEquationList(
      insertBlankLine,
      captions, captionColor,
      values, null,
      null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintEquationList( bool insertBlankLine,
                                      string[] captions,
                                      string[] values,
                                      ConsoleColor? valueColor )
{
   PrintEquationList(
      insertBlankLine,
      captions, null,
      values, valueColor,
      null );
}

public static void PrintEquationList( bool insertBlankLine,
                                      string[] captions, ConsoleColor? captionColor,
                                      string[] values, ConsoleColor? valueColor )
{
   PrintEquationList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      null );
}

//--------------------------------------------------------------------------------------------------

public static void PrintEquationList( bool insertBlankLine,
                                      string[] captions, ConsoleColor? captionColor,
                                      string[] values, ConsoleColor? valueColor,
                                      ConsoleColor? equationLigamentColor )
{
   PrintEquationList(
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      null, null,
      equationLigamentColor );
}

//--------------------------------------------------------------------------------------------------

public static void PrintEquationList( bool insertBlankLine,
                                      string[] captions, ConsoleColor? captionColor,
                                      string[] values, ConsoleColor? valueColor,
                                      char? bulletChar, ConsoleColor? bulletColor,
                                      ConsoleColor? equationLigamentColor )
{
   PrintAlignedList
   (
      insertBlankLine,
      captions, captionColor,
      values, valueColor,
      bulletChar, bulletColor,
      ListItemEquationLigament,
      equationLigamentColor ?? ListItemEquationLigamentColor
   );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
