﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void PrintNumberedList([Optional] string caption,string[] values)
{
   PrintNumberedList(false,caption,values);
}

//==================================================================================================

public static void PrintNumberedList(string[] values)
{
   PrintNumberedList(false,values);
}

public static void PrintNumberedList(string[] values,[Optional] ConsoleColor? valueColor)
{
   PrintNumberedList(false,values,valueColor);
}

//--------------------------------------------------------------------------------------------------

public static void PrintNumberedList( string[] values,
                                      [Optional] ConsoleColor? valueColor,
                                      [Optional] ConsoleColor? numberColor )
{
   PrintNumberedList(false,values,valueColor,numberColor);
}

public static void PrintNumberedList( string[] values,
                                      [Optional] ConsoleColor? valueColor,
                                      [Optional] ConsoleColor? numberColor,
                                      [Optional] string numberValueSeparator )
{
   PrintNumberedList(false,values,valueColor,numberColor,numberValueSeparator);
}

//--------------------------------------------------------------------------------------------------

public static void PrintNumberedList( string[] values,
                                      [Optional] ConsoleColor? valueColor,
                                      [Optional] ConsoleColor? numberColor,
                                      [Optional] string numberValueSeparator,
                                      [Optional] ConsoleColor? numberValueSeparatorColor )
{
   PrintNumberedList( false,
      values, valueColor, numberColor,
      numberValueSeparator, numberValueSeparatorColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
