﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void OutputAlignedListItemCaption
(
   char? bulletChar, ConsoleColor? bulletColor,
   string caption, ConsoleColor? captionColor, int maxCaptionLength,
   [Optional] string pairLigament, ConsoleColor? pairLigamentColor
)
{
   lock (typeof(XConsole))
   {
      if ( bulletChar!=null )
         Output( bulletColor ?? ListItemBulletColor,
                 "{0} ", bulletChar );
      Output(captionColor ?? ListItemCaptionColor,caption);
      Output(new string(' ',XArith.ConfinePositive(maxCaptionLength-caption.Length)));
      Output( pairLigamentColor ?? ListItemPairLigamentColor,
              pairLigament ?? ListItemPairLigament );
   }
}

//==================================================================================================

public static void OutputDashAlignedListItemCaption
(
   char? bulletChar, ConsoleColor? bulletColor,
   string caption, ConsoleColor? captionColor, int maxCaptionLength,
   char? dashChar, ConsoleColor? dashColor
)
{
   lock (typeof(XConsole))
   {
      if ( bulletChar!=null )
         Output( bulletColor ?? ListItemBulletColor,
                 "{0} ", bulletChar );
      Output( captionColor ?? ListItemCaptionColor,
              caption );
      Output
      (
         dashColor ?? ListItemDashColor,
         " {0} ",
         new string( dashChar ?? ListItemDashChar,
            LongDashLength+XArith.ConfinePositive( maxCaptionLength-caption.Length ) )
      );
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
