﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void Print()
   { Print(""); }

//==================================================================================================

public static void Print(object obj)
   { Print(false,obj); }

public static void Print(string str)
   { Print(false,str); }

public static void Print(string format,params object[] parameters)
   { Print(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void Print(ConsoleColor? color,object obj)
   { Print(false,color,obj); }

public static void Print(ConsoleColor? color,string str)
   { Print(false,color,str); }

public static void Print(ConsoleColor? color,string format,params object[] parameters)
   { Print(false,color,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintDefault(object obj)
   { PrintDefault(false,obj); }

public static void PrintDefault(string str)
   { PrintDefault(false,str); }

public static void PrintDefault(string format,params object[] parameters)
   { PrintDefault(false,format,parameters); }

//==================================================================================================

public static void PrintIntensive(object obj)
   { PrintIntensive(false,obj); }

public static void PrintIntensive(string str)
   { PrintIntensive(false,str); }

public static void PrintIntensive(string format,params object[] parameters)
   { PrintIntensive(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintFaint(object obj)
   { PrintFaint(false,obj); }

public static void PrintFaint(string str)
   { PrintFaint(false,str); }

public static void PrintFaint(string format,params object[] parameters)
   { PrintFaint(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintExpressive(object obj)
   { PrintExpressive(false,obj); }

public static void PrintExpressive(string str)
   { PrintExpressive(false,str); }

public static void PrintExpressive(string format,params object[] parameters)
   { PrintExpressive(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintImportant(object obj)
   { PrintImportant(false,obj); }

public static void PrintImportant(string str)
   { PrintImportant(false,str); }

public static void PrintImportant(string format,params object[] parameters)
   { PrintImportant(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintExclamation(object obj)
   { PrintExclamation(false,obj); }

public static void PrintExclamation(string str)
   { PrintExclamation(false,str); }

public static void PrintExclamation(string format,params object[] parameters)
   { PrintExclamation(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintInformation(object obj)
   { PrintInformation(false,obj); }

public static void PrintInformation(string str)
   { PrintInformation(false,str); }

public static void PrintInformation(string format,params object[] parameters)
   { PrintInformation(false,format,parameters); }

//--------------------------------------------------------------------------------------------------

public static void PrintWarning(object obj)
   { PrintWarning(false,obj); }

public static void PrintWarning(string str)
   { PrintWarning(false,str); }

public static void PrintWarning(string format,params object[] parameters)
   { PrintWarning(false,format,parameters); }

//==================================================================================================

public static void PrintError(string str)
   { PrintError(false,str); }

public static void PrintError(string format,params object[] parameters)
   { PrintError(false,format,parameters); }

public static void PrintError(Exception e)
   { PrintError(false,e); }

//--------------------------------------------------------------------------------------------------

public static void PrintSuccess(string str)
   { PrintSuccess(false,str); }

public static void PrintSuccess(string format,params object[] parameters)
   { PrintSuccess(false,format,parameters); }

//==================================================================================================

public static void PrintOperation(string operation)
   { PrintOperation(false,operation); }

public static void PrintOperation(string operationFmt,params object[] parameters)
   { PrintOperation(false,operationFmt,parameters); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
