﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ReportError(bool insertBlankLine,string message)
{
   PrintError(insertBlankLine,message);
   XSound.PlayError();
}

public static void ReportError(bool insertBlankLine,string messageFmt,params object[] parameters)
{
   ReportError(insertBlankLine,string.Format(messageFmt,parameters));
}

public static void ReportError(bool insertBlankLine,Exception e)
{
   ReportError(insertBlankLine,XException.GetErrorMessage(e));
}

//==================================================================================================

public static void ReportSuccess(bool insertBlankLine,string message)
{
   PrintSuccess(insertBlankLine,message);
   XSound.PlaySuccess();
}

public static void ReportSuccess(bool insertBlankLine,string messageFmt,params object[] parameters)
{
   ReportSuccess(insertBlankLine,string.Format(messageFmt,parameters));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
