﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void OutputArrowAlignedInputPrompt( [Optional] string caption,
                                                  [Optional] int maxCaptionLength )
{
   OutputArrowAlignedInputPrompt(caption,null,maxCaptionLength);
}

public static void OutputArrowAlignedInputPrompt( [Optional] string caption,
                                                  ConsoleColor? captionColor,
                                                  int maxCaptionLength )
{
   OutputArrowAlignedInputPrompt(caption,captionColor,maxCaptionLength,null,null,null);
}

//--------------------------------------------------------------------------------------------------

public static void OutputArrowAlignedInputPrompt( [Optional] string caption,
                                                  [Optional] int maxCaptionLength,
                                                  char? dashChar )
{
   OutputArrowAlignedInputPrompt(caption,maxCaptionLength,dashChar,null);
}

public static void OutputArrowAlignedInputPrompt( [Optional] string caption,
                                                  [Optional] int maxCaptionLength,
                                                  char? dashChar, char? pointerChar )
{
   OutputArrowAlignedInputPrompt(caption,null,maxCaptionLength,dashChar,pointerChar,null);
}

//--------------------------------------------------------------------------------------------------

public static void OutputArrowAlignedInputPrompt( [Optional] string caption,
                                                  ConsoleColor? captionColor,
                                                  int maxCaptionLength,
                                                  char? dashChar )
{
   OutputArrowAlignedInputPrompt(caption,captionColor,maxCaptionLength,dashChar,null);
}

public static void OutputArrowAlignedInputPrompt( [Optional] string caption,
                                                  ConsoleColor? captionColor,
                                                  int maxCaptionLength,
                                                  char? dashChar, char? pointerChar )
{
   OutputArrowAlignedInputPrompt(caption,captionColor,maxCaptionLength,dashChar,pointerChar,null);
}

//==================================================================================================

public static void OutputArrowAlignedInputPrompt
(
   [Optional] string caption, ConsoleColor? captionColor, [Optional] int maxCaptionLength,
   char? dashChar, char? pointerChar, ConsoleColor? arrowColor
)
{
   OutputArrowAlignedCaption( caption,
      captionColor ?? InputCaptionColor, maxCaptionLength,
      dashChar ?? InputArrowDashChar, pointerChar ?? InputArrowPointerChar,
      arrowColor ?? InputArrowColor );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
