﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void OutputArrowedInputPrompt([Optional] string caption)
{
   OutputArrowedInputPrompt(caption,null,null,null,null);
}

//--------------------------------------------------------------------------------------------------

public static void OutputArrowedInputPrompt(string caption,ConsoleColor? captionColor)
{
   OutputArrowedInputPrompt(caption,captionColor,null,null,null);
}

//--------------------------------------------------------------------------------------------------

public static void OutputArrowedInputPrompt(string caption,char? dashChar)
{
   OutputArrowedInputPrompt(caption,dashChar,null);
}

public static void OutputArrowedInputPrompt(string caption,char? dashChar,char? pointerChar)
{
   OutputArrowedInputPrompt(caption,null,dashChar,pointerChar,null);
}

//--------------------------------------------------------------------------------------------------

public static void OutputArrowedInputPrompt( string caption,
                                             ConsoleColor? captionColor,
                                             char? dashChar )
{
   OutputArrowedInputPrompt(caption,captionColor,dashChar);
}

public static void OutputArrowedInputPrompt( string caption, ConsoleColor? captionColor,
                                             char? dashChar, char? pointerChar )
{
   OutputArrowedInputPrompt(caption,captionColor,dashChar,pointerChar,null);
}

//==================================================================================================

public static void OutputArrowedInputPrompt( [Optional] string caption, ConsoleColor? captionColor,
                                             char? dashChar, char? pointerChar,
                                             ConsoleColor? arrowColor )
{
   OutputArrowAlignedCaption(caption,captionColor,0,dashChar,pointerChar,arrowColor);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
