﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XConsole {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string InputString()
{
   return InputString((string)null);
}

public static string InputString(XConsoleInputOptions options)
{
   return InputString(null,options);
}

public static string InputString(XValidateConsoleInputCallback validationCallback)
{
   return InputString(null,validationCallback);
}

public static string InputString( XConsoleInputOptions options,
                                  XValidateConsoleInputCallback validationCallback )
{
   return InputString(null,options,validationCallback);
}

//==================================================================================================

public static string InputString([Optional] string caption)
{
   return InputString(caption,0);
}

public static string InputString([Optional] string caption,XConsoleInputOptions options)
{
   return InputString(caption,0,options);
}

public static string InputString
(
   [Optional] string caption,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(caption,0,validationCallback);
}

public static string InputString
(
   [Optional] string caption,
   XConsoleInputOptions options,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(caption,0,options,validationCallback);
}

//--------------------------------------------------------------------------------------------------

public static string InputString([Optional] string caption,ConsoleColor? captionColor)
{
   return InputString(caption,captionColor,0);
}

public static string InputString( [Optional] string caption,
                                  ConsoleColor? captionColor,
                                  XConsoleInputOptions options )
{
   return InputString(caption,captionColor,0,options);
}

public static string InputString
(
   [Optional] string caption,
   ConsoleColor? captionColor,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(caption,captionColor,0,validationCallback);
}

public static string InputString
(
   [Optional] string caption,
   ConsoleColor? captionColor,
   XConsoleInputOptions options,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(caption,captionColor,0,options,validationCallback);
}

//==================================================================================================

public static string InputString(string caption,[Optional] int maxCaptionLength)
{
   return InputString(
      caption, null, maxCaptionLength,
      null, null, 0, null );
}

public static string InputString( string caption,
                                  [Optional] int maxCaptionLength,
                                  XConsoleInputOptions options )
{
   return InputString(
      caption, null, maxCaptionLength,
      null, null, options, null );
}

public static string InputString
(
   string caption,
   [Optional] int maxCaptionLength,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(
      caption, null, maxCaptionLength,
      null, null, 0, validationCallback );
}

public static string InputString
(
   string caption,
   [Optional] int maxCaptionLength,
   XConsoleInputOptions options,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(
      caption, null, maxCaptionLength,
      null, null, options, validationCallback );
}

//--------------------------------------------------------------------------------------------------

public static string InputString( string caption,
                                  ConsoleColor? captionColor,
                                  [Optional] int maxCaptionLength )
{
   return InputString(
      caption, captionColor, maxCaptionLength,
      null, null, 0, null );
}

public static string InputString( string caption,
                                  ConsoleColor? captionColor,
                                  [Optional] int maxCaptionLength,
                                  XConsoleInputOptions options )
{
   return InputString(
      caption, captionColor, maxCaptionLength,
      null, null, options, null );
}

public static string InputString
(
   string caption,
   ConsoleColor? captionColor,
   [Optional] int maxCaptionLength,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(
      caption, captionColor, maxCaptionLength,
      null, null, 0, validationCallback );
}

public static string InputString
(
   string caption,
   ConsoleColor? captionColor,
   [Optional] int maxCaptionLength,
   XConsoleInputOptions options,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   return InputString(
      caption, captionColor, maxCaptionLength,
      null, null, options, validationCallback );
}

//==================================================================================================

public static string InputString
(
   [Optional] string caption,
   ConsoleColor? captionColor,
   [Optional] int maxCaptionLength,
   ConsoleColor? foregroundColor,
   ConsoleColor? backgroundColor,
   XConsoleInputOptions options,
   [Optional] XValidateConsoleInputCallback validationCallback
)
{
   string inputString = null;

   InputStringModify( caption, captionColor, maxCaptionLength,
      ref inputString, foregroundColor, backgroundColor,
      options, validationCallback );

   return inputString;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XConsole
//**************************************************************************************************

} // XHelpers
