﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public partial class XCapture<T>
{
   public T Value;

   public XCapture()
      { Value = default(T); }

   public XCapture(T value)
      { Value = value; }

   public static implicit operator T(XCapture<T> container)
      { return container.Value; }

   static XCapture()
      { Library.Access(); }
}
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
public partial class XSyncCapture<T>
{
   public T Value
   {
      get { lock (this) return _Value_;  }
      set { lock (this) _Value_ = value; }
   }

   public XSyncCapture()
      { _Value_ = default(T); }

   public XSyncCapture(T value)
      { _Value_ = value; }

   public static implicit operator T(XSyncCapture<T> container)
   {
      return container.Value;
   }

   static XSyncCapture()
      { Library.Access(); }

   T _Value_;
}
//**************************************************************************************************

} // XHelpers
