﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Text;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XTextBuilder {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void AppendLine(StringBuilder sb)
{
   if (sb.Length!=0)
      sb.AppendLine();
}

//--------------------------------------------------------------------------------------------------

public static void AppendLine(StringBuilder sb,string str)
{
   AppendLine(sb,false,str);
}

public static void AppendLine(StringBuilder sb,bool separate,string str)
{
   if (sb.Length!=0)
   {
      AppendLine(sb);
      if (separate)
         AppendLine(sb);
   }
   sb.Append(str);
}

//--------------------------------------------------------------------------------------------------

public static void AppendLine(StringBuilder sb,string format,params object[] parameters)
{
   AppendLine(sb,false,format,parameters);
}

public static void AppendLine( StringBuilder sb, bool separate,
                               string format, params object[] parameters )
{
   AppendLine(sb,separate,string.Format(format,parameters));
}

//==================================================================================================

public static string CombineLines(params string[] strings)
{
   return CombineLines(false,strings);
}

public static string CombineLines(bool separate,params string[] strings)
{
   var sb = new StringBuilder();
   foreach (var str in strings)
      AppendLine(sb,str,separate);
   return sb.ToString();
}

//==================================================================================================

static XTextBuilder()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XTextBuilder
//**************************************************************************************************

} // XHelpers
