﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XArgCheck {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static ArgumentException ArgumentException_IncorrectArguments
{
   get
   {
      return new ArgumentException( "Incorrect argument(s)." );
   }
}

//--------------------------------------------------------------------------------------------------

public static ArgumentException ArgumentException_DefaultValue
{
   get
   {
      return new ArgumentException(
         "Value must not be equal to default value of its type." );
   }
}

//--------------------------------------------------------------------------------------------------

public static ArgumentException ArgumentException_ZeroPointer
{
   get { return new ArgumentException( "Pointer is zero." ); }
}

public static ArgumentException ArgumentException_InvalidPointer
{
   get { return new ArgumentException( "Invalid pointer." ); }
}

//--------------------------------------------------------------------------------------------------

public static ArgumentException ArgumentException_EmptyString
{
   get { return new ArgumentException( "String is empty." ); }
}

//--------------------------------------------------------------------------------------------------

public static ArgumentException ArgumentException_EmptyArray
{
   get { return new ArgumentException( "Array is empty." ); }
}

public static ArgumentException ArgumentOutOfRangeException_IncorrectArrayIndex
{
   get { return new ArgumentOutOfRangeException( null, "Array index is incorrect." ); }
}

public static ArgumentException ArgumentOutOfRangeException_IncorrectArrayDimension
{
   get { return new ArgumentOutOfRangeException( null, "Array dimension is incorrect." ); }
}

//==================================================================================================

static XArgCheck()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XArgCheck
//**************************************************************************************************

} // XHelpers
