﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.Serialization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
#if !SILVERLIGHT
[Serializable]
#endif // !SILVERLIGHT
public partial class XArgumentTypeException: XException {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public XArgumentTypeException()
   :base("Incorrect argument type.") {}

public XArgumentTypeException(string message)
   :base(message) {}

public XArgumentTypeException(string message,Exception innerException)
   :base(message,innerException) {}

//--------------------------------------------------------------------------------------------------

public XArgumentTypeException(Type type)
   :base(DefaultMessage(type)) {}

public XArgumentTypeException(Type type,Exception innerException)
   :base(DefaultMessage(type),innerException) {}

//==================================================================================================

#if !SILVERLIGHT
protected XArgumentTypeException(SerializationInfo info,StreamingContext context)
   :base(info,context) {}
#endif // !SILVERLIGHT

//==================================================================================================

static XArgumentTypeException()
{
   Library.Access();
}

//--------------------------------------------------------------------------------------------------

static string DefaultMessage(Type type)
{
   return string.Format(
      "Incorrect argument type: \"{0}\".",
      type );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XArgumentTypeException
//**************************************************************************************************

} // XHelpers
