﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.Serialization;

namespace XHelpers {

//**************************************************************************************************
#if !SILVERLIGHT
[Serializable]
#endif // !SILVERLIGHT
public partial class XGenericTypeException: XException {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public XGenericTypeException()
   :base("Incorrect generic type.") {}

public XGenericTypeException(string message)
   :base(message) {}

public XGenericTypeException(string message,Exception innerException)
   :base(message,innerException) {}

//--------------------------------------------------------------------------------------------------

public XGenericTypeException(Type type)
   :base(DefaultMessage(type)) {}

public XGenericTypeException(Type type,Exception innerException)
   :base(DefaultMessage(type),innerException) {}

//==================================================================================================

#if !SILVERLIGHT
protected XGenericTypeException(SerializationInfo info,StreamingContext context)
   :base(info,context) {}
#endif // !SILVERLIGHT

//==================================================================================================

static string DefaultMessage(Type type)
{
   return string.Format(
      "Incorrect argument type: \"{0}\".",
      type );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XGenericTypeException
//**************************************************************************************************

} // XHelpers
