﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XArray {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool Exists<T>(T[] array,Predicate<T> match)
{
   return Exists(array,match,null,null,false);
}

public static bool Exists<T>(T[] array,Predicate<T> match,int? startIdx)
{
   return Exists(array,match,startIdx,null,false);
}

public static bool Exists<T>(T[] array,Predicate<T> match,int? startIdx,int? count)
{
   return Exists(array,match,startIdx,count,false);
}

//==================================================================================================

public static bool BackwardExists<T>(T[] array,Predicate<T> match,int? startIdx)
{
   return Exists(array,match,startIdx,null,true);
}

public static bool BackwardExists<T>(T[] array,Predicate<T> match,int? startIdx,int? count)
{
   return Exists(array,match,startIdx,count,true);
}

//==================================================================================================

static bool Exists<T>( T[] array, Predicate<T> match,
                       int? startIdx, int? count, bool backwardScan )
{
   return FindIndex(array,match,startIdx,count) != null;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XArray
//**************************************************************************************************

} // XHelpers
