﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XArray {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ForEach<T>(T[] array,Action<T> action)
{
   ForEach(array,action,null,null,false);
}

public static void ForEach<T>(T[] array,Action<T> action,int? startIdx)
{
   ForEach(array,action,startIdx,null,false);
}

public static void ForEach<T>(T[] array,Action<T> action,int? startIdx,int? count)
{
   ForEach(array,action,startIdx,count,false);
}

//--------------------------------------------------------------------------------------------------

public static void BackwardForEach<T>(T[] array,Action<T> action)
{
   ForEach(array,action,null,null,true);
}

public static void BackwardForEach<T>(T[] array,Action<T> action,int? startIdx)
{
   ForEach(array,action,startIdx,null,true);
}

public static void BackwardForEach<T>(T[] array,Action<T> action,int? startIdx,int? count)
{
   ForEach(array,action,startIdx,count,true);
}

//==================================================================================================

static void ForEach<T>( T[] array, Action<T> action,
                        int? startIdx, int? count, bool backwardScan )
{
   Scan
   (
      array,
      (XContinueEnumerationWithIndexCallback<T>)delegate (T element,int index)
      {
         action( array[index] );
         return true;
      },
      startIdx, count, backwardScan
   );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XArray
//**************************************************************************************************

} // XHelpers
