﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XArray {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static T StrictMin<T>(T[] array)
   where T: IComparable
{
   return StrictMinOrMax(array,XMinOrMax.Min,null,null);
}

public static T StrictMin<T>(T[] array,int? startIdx)
   where T: IComparable
{
   return StrictMinOrMax(array,XMinOrMax.Min,startIdx,null);
}

public static T StrictMin<T>(T[] array,int? startIdx,int? count)
   where T: IComparable
{
   return StrictMinOrMax(array,XMinOrMax.Min,startIdx,count);
}

//--------------------------------------------------------------------------------------------------

public static T StrictMax<T>(T[] array)
   where T: IComparable
{
   return StrictMinOrMax(array,XMinOrMax.Max,null,null);
}

public static T StrictMax<T>(T[] array,int? startIdx)
   where T: IComparable
{
   return StrictMinOrMax(array,XMinOrMax.Max,startIdx,null);
}

public static T StrictMax<T>(T[] array,int? startIdx,int? count)
   where T: IComparable
{
   return StrictMinOrMax(array,XMinOrMax.Max,startIdx,count);
}

//==================================================================================================

public static int? StrictIndexOfMin<T>(T[] array)
   where T: IComparable
{
   return StrictIndexOfMinOrMax(array,XMinOrMax.Min,null,null);
}

public static int? StrictIndexOfMin<T>(T[] array,int? startIdx)
   where T: IComparable
{
   return StrictIndexOfMinOrMax(array,XMinOrMax.Min,startIdx,null);
}

public static int? StrictIndexOfMin<T>(T[] array,int? startIdx,int? count)
   where T: IComparable
{
   return StrictIndexOfMinOrMax(array,XMinOrMax.Min,startIdx,count);
}

//--------------------------------------------------------------------------------------------------

public static int? StrictIndexOfMax<T>(T[] array)
   where T: IComparable
{
   return StrictIndexOfMinOrMax(array,XMinOrMax.Max,null,null);
}

public static int? StrictIndexOfMax<T>(T[] array,int? startIdx)
   where T: IComparable
{
   return StrictIndexOfMinOrMax(array,XMinOrMax.Max,startIdx,null);
}

public static int? StrictIndexOfMax<T>(T[] array,int? startIdx,int? count)
   where T: IComparable
{
   return StrictIndexOfMinOrMax(array,XMinOrMax.Max,startIdx,count);
}

//==================================================================================================

static T StrictMinOrMax<T>(T[] array,XMinOrMax minmax,int? startIdx,int? count)
   where T: IComparable
{
   int? index;
   T value = GetMinOrMax(array,minmax,startIdx,count,out index);
   if (index==null)
      throw new XEmptySetException();
   return value;
}

//--------------------------------------------------------------------------------------------------

static int? StrictIndexOfMinOrMax<T>(T[] array,XMinOrMax minmax,int? startIdx,int? count)
   where T: IComparable
{
   int? index;
   GetMinOrMax(array,minmax,startIdx,count,out index);
   if (index==null)
      throw new XEmptySetException();
   return index;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XArray
//**************************************************************************************************

} // XHelpers
