﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Collections;
using System.Collections.Generic;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public partial class XDictionary<TKey,TValue>: DictionaryBase {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public TValue this[TKey key]
{
   get { return (TValue)Dictionary[key]; }
   set { Dictionary[key] = (TValue)value; }
}

//--------------------------------------------------------------------------------------------------

public ICollection<TKey> Keys
{
   get
   {
      var keys=new List<TKey>();
      foreach (TKey key in Dictionary.Keys)
         keys.Add(key);
      return keys;
   }
}

public ICollection Values
{
   get
   {
      var values=new List<TValue>();
      foreach (TValue value in Dictionary.Values)
         values.Add(value);
      return values;
   }
}

//--------------------------------------------------------------------------------------------------

public void Add(TKey key,TValue value)
{
   Dictionary.Add(key,value);
}

public bool Contains(TKey key)
{
   return Dictionary.Contains(key);
}

public void Remove(TKey key)
{
   Dictionary.Remove(key);
}

//==================================================================================================
/*
protected override void OnInsert(object key,object value)
{
   if ( key.GetType() != typeof(TKey) )
      throw XInvOpExceptionCreation.IncorrectArguments;
   if ( value.GetType() != typeof(TValue) )
      throw XInvOpExceptionCreation.IncorrectArguments;
}

protected override void OnRemove(object key,object value)
{
   if ( key.GetType() != typeof(TKey) )
      throw XInvOpExceptionCreation.IncorrectArguments;
}

protected override void OnSet(object key,object oldValue,object newValue)
{
   if ( key.GetType() != typeof(TKey) )
      throw XInvOpExceptionCreation.IncorrectArguments;
   if ( newValue.GetType() != typeof(TValue) )
      throw XInvOpExceptionCreation.IncorrectArguments;
}

protected override void OnValidate(object key,object value)
{
   if ( key.GetType() != typeof(TKey) )
      throw XInvOpExceptionCreation.IncorrectArguments;
   if ( value.GetType() != typeof(TValue) )
      throw XInvOpExceptionCreation.IncorrectArguments;
}
*/

//==================================================================================================

static XDictionary()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XDictionary<TKey,TValue>
//**************************************************************************************************

} // XHelpers
