﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
[Flags]
public enum XFatalErrorFlags
{
   None = 0,
   ShowReport = 1 << 1,
#if SILVERLIGHT
   Default = ShowReport
#else
   Default = None,
   TerminateEntireProcess    = 1 << 2,
   RaiseOnUnhandledException = 1 << 3,
   UseFatalErrorException    = 1 << 4,
   ProcessOwnerDefaults =
      TerminateEntireProcess | RaiseOnUnhandledException | ShowReport
#endif
}
//**************************************************************************************************


//**************************************************************************************************
public partial class XFatalErrorException: Exception
{
   internal XFatalErrorException(string message): base(message)
   {}
}
//**************************************************************************************************


//**************************************************************************************************
public delegate void XFatalErrorEmergencyHandler(string reportText);
//**************************************************************************************************

} // XHelpers
