﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Reflection;

namespace XHelpers {

//**************************************************************************************************
class BlockTracer {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public BlockTracer(bool debug,string blockName)
{
#if SILVERLIGHT
   _Tracer_ = XDebug.Tracer;
#else
   _Tracer_ = debug ? XDebug.Tracer : XTrace.Tracer;
#endif
   _Tracer_.Print(
      XTraceMessageCategory.Neutral,
      "=== In \"{0}\": ===",
      blockName );
   _BlockName_ = blockName;
}

public BlockTracer(bool debug,string blockNameFmt,params object[] parameters)
   :this(debug,string.Format(blockNameFmt,parameters))
{}

public BlockTracer(bool debug,MethodBase method)
   :this(debug,string.Format("[{0}] {1}",method.DeclaringType,method))
{}

//==================================================================================================

public static void Dispose(BlockTracer instance)
{
   if (instance!=null)
      instance.DoDispose();
}

//==================================================================================================

void DoDispose()
{
   _Tracer_.Print(
      XTraceMessageCategory.Neutral,
      "=== Out of \"{0}\". ===",
      _BlockName_ );
}

//==================================================================================================

Tracer
   _Tracer_;
string
   _BlockName_;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // BlockTracer
//**************************************************************************************************

} // XHelpers
