﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
class AppExitData
{
   public AppExitData()
   {}

   public AppExitData(int exitCode)
   {
      ExitCode=exitCode;
   }

   public AppExitData(object associatedData)
   {
      AssociatedData=associatedData;
   }

   public AppExitData(int exitCode,object associatedData)
   {
      ExitCode = exitCode;
      AssociatedData = associatedData;
   }

   public int ExitCode;
   public object AssociatedData;

   static AppExitData()
   {
      Library.Access();
   }
}
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
public partial class XAppExitException: XEscapeException {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public XAppExitException()
   :base((string)null,new AppExitData()) {}

//--------------------------------------------------------------------------------------------------

public XAppExitException(string message)
   :base(message,new AppExitData()) {}

public XAppExitException(string message,Exception innerException)
   :base(message,innerException,new AppExitData()) {}

public XAppExitException(string message,int exitCode)
   :base(message,new AppExitData(exitCode)) {}

public XAppExitException(string message,Exception innerException,int exitCode)
   :base(message,innerException,new AppExitData(exitCode)) {}

//--------------------------------------------------------------------------------------------------

public XAppExitException(int exitCode)
   :base(new AppExitData(exitCode)) {}

public XAppExitException(Exception innerException)
   :base(innerException,new AppExitData()) {}

public XAppExitException(Exception innerException,int exitCode)
   :base(innerException,new AppExitData(exitCode)) {}

//==================================================================================================

public XAppExitException(object associatedData)
   :base((string)null,new AppExitData(associatedData)) {}

//--------------------------------------------------------------------------------------------------

public XAppExitException(string message,object associatedData)
   :base(message,new AppExitData(associatedData)) {}

public XAppExitException(string message,Exception innerException,object associatedData)
   :base(message,innerException,new AppExitData(associatedData)) {}

public XAppExitException(string message,int exitCode,object associatedData)
   :base(message,new AppExitData(exitCode,associatedData)) {}

public XAppExitException( string message, Exception innerException,
                          int exitCode, object associatedData )
   :base(message,innerException,new AppExitData(exitCode,associatedData)) {}

//--------------------------------------------------------------------------------------------------

public XAppExitException(int exitCode,object associatedData)
   :base(new AppExitData(exitCode,associatedData)) {}

public XAppExitException(Exception innerException,object associatedData)
   :base(innerException,new AppExitData(associatedData)) {}

public XAppExitException(Exception innerException,int exitCode,object associatedData)
   :base(innerException,new AppExitData(exitCode,associatedData)) {}

//==================================================================================================

public int ExitCode
{
   get { return ((AppExitData)base.AssociatedData).ExitCode; }
}

public new object AssociatedData
{
   get { return ((AppExitData)base.AssociatedData).AssociatedData; }
}

//==================================================================================================

static XAppExitException()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XAppExitException
//**************************************************************************************************

} // XHelpers
