﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XInvOpExceptionCreation {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static InvalidOperationException EmptyCollection
{
   get
   {
      return new InvalidOperationException( "Collection is empty." );
   }
}

public static InvalidOperationException InvalidStaticOperation
{
   get
   {
      return new InvalidOperationException( "Invalid static operation." );
   }
}

//==================================================================================================

public static InvalidOperationException PropertyWasNotSpecified(string name)
{
   XArgCheck.VerifyNotNull( name );
   return Create(
      "Property was not specified: \"{0}\".",
      name );
}


public static InvalidOperationException ObjectMustBeDisposedSynchronously(object obj)
{
   XArgCheck.VerifyNotNull( obj );
   return Create(
      "Object of type \"{0}\" must be disposed synchronously.",
      obj.GetType() );
}

//==================================================================================================

public static InvalidOperationException Create(string messageFmt,params object[] parameters)
{
   XArgCheck.VerifyNotNulls( messageFmt, parameters );
   return new InvalidOperationException(string.Format( messageFmt, parameters ));
}

//==================================================================================================

static XInvOpExceptionCreation()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XInvOpExceptionCreation
//**************************************************************************************************

} // XHelpers
