﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.ComponentModel;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XOpFailedExceptionCreation {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static XOperationFailedException Win32FunctionFailed(string functionName)
{
   return Create(
      "Win32 function \"{0}\" has failed.",
      functionName );
}

//--------------------------------------------------------------------------------------------------

//==================================================================================================

public static XOperationFailedException Create(string messageFmt,params object[] parameters)
{
   XArgCheck.VerifyNotNulls( messageFmt, parameters );
   return new XOperationFailedException(string.Format(messageFmt,parameters));
}

//==================================================================================================

static XOpFailedExceptionCreation()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XOpFailedExceptionCreation
//**************************************************************************************************

} // XHelpers
