﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.Serialization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
#if !SILVERLIGHT
[Serializable]
#endif // !SILVERLIGHT
public abstract partial class XException<T>: XException {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public XException()
   {}

//--------------------------------------------------------------------------------------------------

public XException(string message)
   :base(message) {}

public XException(string message,Exception innerException)
   :base(message,innerException) {}

//--------------------------------------------------------------------------------------------------

public XException(T associatedData)
   :base (associatedData) {}

public XException(string message,T associatedData)
   :base(message,associatedData) {}

public XException(Exception innerException,T associatedData)
   :base(innerException,associatedData) {}

public XException(string message,Exception innerException,T associatedData)
   :base(message,innerException,associatedData) {}

//--------------------------------------------------------------------------------------------------

public new T AssociatedData
{
   get { return (T)base.AssociatedData; }
   set { AssociatedData = value; }
}

//==================================================================================================

#if !SILVERLIGHT
protected XException(SerializationInfo info,StreamingContext context)
   :base(info,context) {}
#endif // !SILVERLIGHT

//==================================================================================================

static XException()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XException<T>
//**************************************************************************************************

} // XHelpers
