﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Text;
using System.Runtime.Serialization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
#if !SILVERLIGHT
[Serializable]
#endif // !SILVERLIGHT
public abstract partial class XException: Exception {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public XException()
   {}

//--------------------------------------------------------------------------------------------------

public XException(string message)
   :base(message) {}

public XException(string message,Exception innerException)
   :base(message,innerException) {}

//--------------------------------------------------------------------------------------------------

public XException(object associatedData)
   { _AssociatedData_=associatedData; }

public XException(string message,object associatedData)
   :base(message) { _AssociatedData_=associatedData; }

public XException(Exception innerException,object associatedData)
   :base(null,innerException) { _AssociatedData_=associatedData; }

public XException(string message,Exception innerException,object associatedData)
   :base(message,innerException) { _AssociatedData_=associatedData; }

//--------------------------------------------------------------------------------------------------

public object AssociatedData
{
   get { return _AssociatedData_; }
   set { _AssociatedData_ = value; }
}

//==================================================================================================

#if !SILVERLIGHT
protected XException(SerializationInfo info,StreamingContext context)
   :base(info,context) {}
#endif // !SILVERLIGHT

//==================================================================================================

object _AssociatedData_;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XException
//**************************************************************************************************

} // XHelpers
