﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XCultureInfo {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static CultureInfo CurrentUINeutralCulture
{
   get { return ToNeutral( CultureInfo.CurrentUICulture ); }
}

//==================================================================================================

public static NotSupportedException CreateNotSupportedOperationException()
{
   return CreateNotSupportedOperationException( CultureInfo.CurrentCulture );
}

public static NotSupportedException CreateNotSupportedOperationException
(
   [Optional] CultureInfo culture
)
{
   return new NotSupportedException(string.Format(
      "Operation is not supported for this culture: \"{0}\".",
      culture ?? CultureInfo.InvariantCulture
   ));
}

//--------------------------------------------------------------------------------------------------

public static CultureInfo ToNeutral([Optional] CultureInfo culture)
{
   for (var ci=culture;;ci=ci.Parent)
      if (ci==null || ci==CultureInfo.InvariantCulture)
         return CultureInfo.InvariantCulture;
      else
         if (ci.IsNeutralCulture)
            return ci==culture ? (CultureInfo)ci.Clone() : ci;
}

//==================================================================================================

static XCultureInfo()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XCultureInfo
//**************************************************************************************************

} // XHelpers
