﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XSpecificCultureNames {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public const string
   af_ZA       = "af-ZA",        // Afrikaans (South Africa)
   ar_AE       = "ar-AE",        // Arabic (U.A.E.)
   ar_BH       = "ar-BH",        // Arabic (Bahrain)
   ar_DZ       = "ar-DZ",        // Arabic (Algeria)
   ar_EG       = "ar-EG",        // Arabic (Egypt)
   ar_IQ       = "ar-IQ",        // Arabic (Iraq)
   ar_JO       = "ar-JO",        // Arabic (Jordan)
   ar_KW       = "ar-KW",        // Arabic (Kuwait)
   ar_LB       = "ar-LB",        // Arabic (Lebanon)
   ar_LY       = "ar-LY",        // Arabic (Libya)
   ar_MA       = "ar-MA",        // Arabic (Morocco)
   arn_CL      = "arn-CL",       // Mapudungun (Chile)
   ar_OM       = "ar-OM",        // Arabic (Oman)
   ar_QA       = "ar-QA",        // Arabic (Qatar)
   ar_SA       = "ar-SA",        // Arabic (Saudi Arabia)
   ar_SY       = "ar-SY",        // Arabic (Syria)
   ar_TN       = "ar-TN",        // Arabic (Tunisia)
   ar_YE       = "ar-YE",        // Arabic (Yemen)
   az_Cyrl_AZ  = "az-Cyrl-AZ",   // Azeri (Cyrillic, Azerbaijan)
   az_Latn_AZ  = "az-Latn-AZ",   // Azeri (Latin, Azerbaijan)
   be_BY       = "be-BY",        // Belarusian (Belarus)
   bg_BG       = "bg-BG",        // Bulgarian (Bulgaria)
   bs_Cyrl_BA  = "bs-Cyrl-BA",   // Bosnian (Cyrillic) (Bosnia and Herzegovina)
   bs_Latn_BA  = "bs-Latn-BA",   // Bosnian (Bosnia and Herzegovina)
   ca_ES       = "ca-ES",        // Catalan (Catalan)
   cs_CZ       = "cs-CZ",        // Czech (Czech Republic)
   cy_GB       = "cy-GB",        // Welsh (United Kingdom)
   da_DK       = "da-DK",        // Danish (Denmark)
   de_AT       = "de-AT",        // German (Austria)
   de_CH       = "de-CH",        // German (Switzerland)
   de_DE       = "de-DE",        // German (Germany)
   de_LI       = "de-LI",        // German (Liechtenstein)
   de_LU       = "de-LU",        // German (Luxembourg)
   dv_MV       = "dv-MV",        // Divehi (Maldives)
   el_GR       = "el-GR",        // Greek (Greece)
   en_029      = "en-029",       // English (Caribbean)
   en_AU       = "en-AU",        // English (Australia)
   en_BZ       = "en-BZ",        // English (Belize)
   en_CA       = "en-CA",        // English (Canada)
   en_GB       = "en-GB",        // English (United Kingdom)
   en_IE       = "en-IE",        // English (Ireland)
   en_JM       = "en-JM",        // English (Jamaica)
   en_NZ       = "en-NZ",        // English (New Zealand)
   en_PH       = "en-PH",        // English (Republic of the Philippines)
   en_TT       = "en-TT",        // English (Trinidad and Tobago)
   en_US       = "en-US",        // English (United States)
   en_ZA       = "en-ZA",        // English (South Africa)
   en_ZW       = "en-ZW",        // English (Zimbabwe)
   es_AR       = "es-AR",        // Spanish (Argentina)
   es_BO       = "es-BO",        // Spanish (Bolivia)
   es_CL       = "es-CL",        // Spanish (Chile)
   es_CO       = "es-CO",        // Spanish (Colombia)
   es_CR       = "es-CR",        // Spanish (Costa Rica)
   es_DO       = "es-DO",        // Spanish (Dominican Republic)
   es_EC       = "es-EC",        // Spanish (Ecuador)
   es_ES       = "es-ES",        // Spanish (Spain)
   es_GT       = "es-GT",        // Spanish (Guatemala)
   es_HN       = "es-HN",        // Spanish (Honduras)
   es_MX       = "es-MX",        // Spanish (Mexico)
   es_NI       = "es-NI",        // Spanish (Nicaragua)
   es_PA       = "es-PA",        // Spanish (Panama)
   es_PE       = "es-PE",        // Spanish (Peru)
   es_PR       = "es-PR",        // Spanish (Puerto Rico)
   es_PY       = "es-PY",        // Spanish (Paraguay)
   es_SV       = "es-SV",        // Spanish (El Salvador)
   es_UY       = "es-UY",        // Spanish (Uruguay)
   es_VE       = "es-VE",        // Spanish (Venezuela)
   et_EE       = "et-EE",        // Estonian (Estonia)
   eu_ES       = "eu-ES",        // Basque (Basque)
   fa_IR       = "fa-IR",        // Persian (Iran)
   fi_FI       = "fi-FI",        // Finnish (Finland)
   fil_PH      = "fil-PH",       // Filipino (Philippines)
   fo_FO       = "fo-FO",        // Faroese (Faroe Islands)
   fr_BE       = "fr-BE",        // French (Belgium)
   fr_CA       = "fr-CA",        // French (Canada)
   fr_CH       = "fr-CH",        // French (Switzerland)
   fr_FR       = "fr-FR",        // French (France)
   fr_LU       = "fr-LU",        // French (Luxembourg)
   fr_MC       = "fr-MC",        // French (Principality of Monaco)
   fy_NL       = "fy-NL",        // Frisian (Netherlands)
   ga_IE       = "ga-IE",        // Irish (Ireland)
   gl_ES       = "gl-ES",        // Galician (Galician)
   gu_IN       = "gu-IN",        // Gujarati (India)
   he_IL       = "he-IL",        // Hebrew (Israel)
   hi_IN       = "hi-IN",        // Hindi (India)
   hr_BA       = "hr-BA",        // Croatian (Bosnia and Herzegovina)
   hr_HR       = "hr-HR",        // Croatian (Croatia)
   hu_HU       = "hu-HU",        // Hungarian (Hungary)
   hy_AM       = "hy-AM",        // Armenian (Armenia)
   id_ID       = "id-ID",        // Indonesian (Indonesia)
   is_IS       = "is-IS",        // Icelandic (Iceland)
   it_CH       = "it-CH",        // Italian (Switzerland)
   it_IT       = "it-IT",        // Italian (Italy)
   iu_Latn_CA  = "iu-Latn-CA",   // Inuktitut (Latin) (Canada)
   ja_JP       = "ja-JP",        // Japanese (Japan)
   ka_GE       = "ka-GE",        // Georgian (Georgia)
   kk_KZ       = "kk-KZ",        // Kazakh (Kazakhstan)
   kn_IN       = "kn-IN",        // Kannada (India)
   kok_IN      = "kok-IN",       // Konkani (India)
   ko_KR       = "ko-KR",        // Korean (Korea)
   ky_KG       = "ky-KG",        // Kyrgyz (Kyrgyzstan)
   lb_LU       = "lb-LU",        // Luxembourgish (Luxembourg)
   lt_LT       = "lt-LT",        // Lithuanian (Lithuania)
   lv_LV       = "lv-LV",        // Latvian (Latvia)
   mi_NZ       = "mi-NZ",        // Maori (New Zealand)
   mk_MK       = "mk-MK",        // Macedonian (Former Yugoslav Republic of Macedonia)
   mn_MN       = "mn-MN",        // Mongolian (Cyrillic, Mongolia)
   moh_CA      = "moh-CA",       // Mohawk (Canada)
   mr_IN       = "mr-IN",        // Marathi (India)
   ms_BN       = "ms-BN",        // Malay (Brunei Darussalam)
   ms_MY       = "ms-MY",        // Malay (Malaysia)
   mt_MT       = "mt-MT",        // Maltese (Malta)
   nb_NO       = "nb-NO",        // Norwegian, Bokm├еl (Norway)
   nl_BE       = "nl-BE",        // Dutch (Belgium)
   nl_NL       = "nl-NL",        // Dutch (Netherlands)
   nn_NO       = "nn-NO",        // Norwegian, Nynorsk (Norway)
   ns_ZA       = "ns-ZA",        // Northern Sotho (South Africa)
   pa_IN       = "pa-IN",        // Punjabi (India)
   pl_PL       = "pl-PL",        // Polish (Poland)
   pt_BR       = "pt-BR",        // Portuguese (Brazil)
   pt_PT       = "pt-PT",        // Portuguese (Portugal)
   quz_BO      = "quz-BO",       // Quechua (Bolivia)
   quz_EC      = "quz-EC",       // Quechua (Ecuador)
   quz_PE      = "quz-PE",       // Quechua (Peru)
   rm_CH       = "rm-CH",        // Romansh (Switzerland)
   ro_RO       = "ro-RO",        // Romanian (Romania)
   ru_RU       = "ru-RU",        // Russian (Russia)
   sa_IN       = "sa-IN",        // Sanskrit (India)
   se_FI       = "se-FI",        // Sami (Northern) (Finland)
   se_NO       = "se-NO",        // Sami (Northern) (Norway)
   se_SE       = "se-SE",        // Sami (Northern) (Sweden)
   sk_SK       = "sk-SK",        // Slovak (Slovakia)
   sl_SI       = "sl-SI",        // Slovenian (Slovenia)
   sma_NO      = "sma-NO",       // Sami (Southern) (Norway)
   sma_SE      = "sma-SE",       // Sami (Southern) (Sweden)
   smj_NO      = "smj-NO",       // Sami (Lule) (Norway)
   smj_SE      = "smj-SE",       // Sami (Lule) (Sweden)
   smn_FI      = "smn-FI",       // Sami (Inari) (Finland)
   sms_FI      = "sms-FI",       // Sami (Skolt) (Finland)
   sq_AL       = "sq-AL",        // Albanian (Albania)
   sr_Cyrl_BA  = "sr-Cyrl-BA",   // Serbian (Cyrillic) (Bosnia and Herzegovina)
   sr_Cyrl_CS  = "sr-Cyrl-CS",   // Serbian (Cyrillic, Serbia)
   sr_Latn_BA  = "sr-Latn-BA",   // Serbian (Latin) (Bosnia and Herzegovina)
   sr_Latn_CS  = "sr-Latn-CS",   // Serbian (Latin, Serbia)
   sv_FI       = "sv-FI",        // Swedish (Finland)
   sv_SE       = "sv-SE",        // Swedish (Sweden)
   sw_KE       = "sw-KE",        // Kiswahili (Kenya)
   syr_SY      = "syr-SY",       // Syriac (Syria)
   ta_IN       = "ta-IN",        // Tamil (India)
   te_IN       = "te-IN",        // Telugu (India)
   th_TH       = "th-TH",        // Thai (Thailand)
   tn_ZA       = "tn-ZA",        // Tswana (South Africa)
   tr_TR       = "tr-TR",        // Turkish (Turkey)
   tt_RU       = "tt-RU",        // Tatar (Russia)
   uk_UA       = "uk-UA",        // Ukrainian (Ukraine)
   ur_PK       = "ur-PK",        // Urdu (Islamic Republic of Pakistan)
   uz_Cyrl_UZ  = "uz-Cyrl-UZ",   // Uzbek (Cyrillic, Uzbekistan)
   uz_Latn_UZ  = "uz-Latn-UZ",   // Uzbek (Latin, Uzbekistan)
   vi_VN       = "vi-VN",        // Vietnamese (Vietnam)
   xh_ZA       = "xh-ZA",        // Xhosa (South Africa)
   zh_CN       = "zh-CN",        // Chinese (People's Republic of China)
   zh_HK       = "zh-HK",        // Chinese (Hong Kong S.A.R.)
   zh_MO       = "zh-MO",        // Chinese (Macao S.A.R.)
   zh_SG       = "zh-SG",        // Chinese (Singapore)
   zh_TW       = "zh-TW",        // Chinese (Taiwan)
   zu_ZA       = "zu-ZA";        // Zulu (South Africa)

//==================================================================================================

static XSpecificCultureNames()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XSpecificCultureNames
//**************************************************************************************************

} // XHelpers
