﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Reflection;

namespace XHelpers {

//**************************************************************************************************
public static partial class XHelpersLibrary {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#if !SILVERLIGHT
public static bool IsInFullFunctionalMode
{
   get
   {
      try { UnsafeHelpers.Access(); }
      catch { return false; }
      return true;
   }
}
#endif // !SILVERLIGHT

//==================================================================================================

public static void Initialize()
{
   DoInitialize( false );
}

#if !SILVERLIGHT
public static void Initialize(bool fullFunctionalMode)
{
   DoInitialize( fullFunctionalMode );
}
#endif // !SILVERLIGHT

//==================================================================================================

static void DoInitialize(bool fullFunctionalMode)
{
   try
   {
      Library.Access();
#if !SILVERLIGHT
      if (fullFunctionalMode)
         UnsafeHelpers.Access();
#endif // !SILVERLIGHT
   }
   catch (Exception e)
   {
      for (Exception x=e; x!=null; x=x.InnerException)
         if (!(
            x is TypeInitializationException ||
            x is TargetInvocationException
         ))
            throw x;
      throw;
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XHelpersLibrary
//**************************************************************************************************

} // XHelpers
