﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XBinExponential {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <summary>1K: 2^10 (0x400).</summary>
public const int Kilo = 2 << 10;
/// <summary>1M: 2^20 (0x100000).</summary>
public const int Mega = 2 << 20;
/// <summary>1G: 2^30 (0x40000000).</summary>
public const int Giga = 2 << 30;
/// <summary>1T: 2^40 (0x10000000000).</summary>
public const long Tera= 2 << 40;

//==================================================================================================

public static bool IsRegular(int value)
{
   if (value<0)
      return false;
   for (int q=value; q>1; q/=2)
   {
      if (q%2!=0)
         return false;
   }
   return true;
}

public static bool IsRegular(long value)
{
   if (value<0L)
      return false;
   for (long q=value; q>1L; q/=2L)
      if (q%2L!=0L)
         return false;
   return true;
}

//--------------------------------------------------------------------------------------------------

[CLSCompliant(false)]
public static bool IsRegular(uint value)
{
   for (uint q=value; q>1u; q/=2u)
      if (q%2u!=0u)
         return false;
   return true;
}

[CLSCompliant(false)]
public static bool IsRegular(ulong value)
{
   for (ulong q=value; q>1ul; q/=2ul)
      if (q%2ul!=0ul)
         return false;
   return true;
}

//==================================================================================================

static XBinExponential()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XBinExponential
//**************************************************************************************************

} // XHelpers
