﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XEnum {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool TryParse<EnumType>(string src,out EnumType dst)
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,XEnumParsingOptions.None,null,out dst);
}

public static bool TryParse<EnumType>(string src,XEnumParsingOptions options,out EnumType dst)
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,options,null,out dst);
}

public static bool TryParse<EnumType>(string src,EnumType def,out EnumType dst)
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,XEnumParsingOptions.None,def,out dst);
}

public static bool TryParse<EnumType>( string src, XEnumParsingOptions options,
                                       EnumType def, out EnumType dst )
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,options,def,out dst);
}

//--------------------------------------------------------------------------------------------------

public static bool TryParse<EnumType>(string src,char? separator,out EnumType dst)
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,XEnumParsingOptions.None,null,out dst);
}

public static bool TryParse<EnumType>( string src, char? separator,
                                       XEnumParsingOptions options,
                                       out EnumType dst )
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,options,null,out dst);
}

public static bool TryParse<EnumType>( string src, char? separator,
                                       EnumType def, out EnumType dst )
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,XEnumParsingOptions.None,def,out dst);
}

public static bool TryParse<EnumType>( string src,  char? separator,
                                       XEnumParsingOptions options, EnumType def,
                                       out EnumType dst )
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,options,def,out dst);
}

//==================================================================================================

public static bool TryParse<EnumType>(string src,out EnumType dst,out string err)
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,XEnumParsingOptions.None,null,out dst,out err);
}

public static bool TryParse<EnumType>( string src, XEnumParsingOptions options,
                                       out EnumType dst, out string err )
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,options,null,out dst,out err);
}

public static bool TryParse<EnumType>( string src, EnumType def,
                                       out EnumType dst, out string err )
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,XEnumParsingOptions.None,def,out dst,out err);
}

public static bool TryParse<EnumType>( string src, XEnumParsingOptions options, EnumType def,
                                       out EnumType dst, out string err )
   where EnumType: struct
{
   return TryParse<EnumType>(src,null,options,def,out dst,out err);
}

//--------------------------------------------------------------------------------------------------

public static bool TryParse<EnumType>(string src,char? separator,out EnumType dst,out string err)
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,XEnumParsingOptions.None,null,out dst,out err);
}

public static bool TryParse<EnumType>( string src, char? separator, XEnumParsingOptions options,
                                       out EnumType dst, out string err )
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,options,null,out dst,out err);
}

public static bool TryParse<EnumType>( string src, char? separator, EnumType def,
                                       out EnumType dst, out string err )
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,XEnumParsingOptions.None,def,out dst,out err);
}

public static bool TryParse<EnumType>( string src, char? separator,
                                       XEnumParsingOptions options, EnumType def,
                                       out EnumType dst, out string err )
   where EnumType: struct
{
   return TryParse<EnumType>(src,separator,options,def,out dst,out err);
}

//==================================================================================================

static bool TryParse<EnumType>( string src, char? separator,
                                XEnumParsingOptions options,
                                EnumType? def, out EnumType dst )
   where EnumType: struct
{
   string err; return TryParse(src,separator,options,def,out dst,out err);
}

static bool TryParse<EnumType>( string src, char? separator,
                                XEnumParsingOptions options, EnumType? def,
                                out EnumType dst, out string err )
   where EnumType: struct
{
   try
   {
      dst=Parse(src,null,options,def);
   }
   catch (XParseValueException e)
   {
      dst=default(EnumType); err=e.Message; return false;
   }
   err=null; return true;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XEnum
//**************************************************************************************************

} // XHelpers
