﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Reflection;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XEnum {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool IsFlagsEnumeration(Type type)
{
   XArgCheck.VerifyNotNull(type);

   return type.IsEnum &&
      type.GetCustomAttributes(typeof(FlagsAttribute),false).Length!=0;
}

//--------------------------------------------------------------------------------------------------

public static string FullValueName(Enum value)
{
   return string.Format("{0}.{1}",value.GetType(),value);
}

//==================================================================================================

#if !SILVERLIGHT

//--------------------------------------------------------------------------------------------------

public static int ValueCountOf<T>()
{
   return GetValuesOf<T>().Length;
}

//--------------------------------------------------------------------------------------------------

public static EnumType[] GetValuesOf<EnumType>()
{
   Type type = typeof( EnumType );
   XGenericTypeCheck.VerifyIsEnum( type );
   return (EnumType[])Enum.GetValues( type );
}

//--------------------------------------------------------------------------------------------------

#endif // !SILVERLIGHT

//==================================================================================================

static XEnum()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XEnum
//**************************************************************************************************

} // XHelpers
