﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Security;
using System.Security.Permissions;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XSecurityPermission {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool CheckUnrestricted()
{
   try
      { DemandUnrestricted(); }
   catch (SecurityException)
      { return false; }
   return true;
}

public static void DemandUnrestricted()
{
   new SecurityPermission( PermissionState.Unrestricted ).Demand();
}

public static PermissionSet CreateExecutionPermissionSet()
{
   var result = new PermissionSet(PermissionState.None);
   result.AddPermission( new SecurityPermission( SecurityPermissionFlag.Execution ) );
   return result;
}

//==================================================================================================

static XSecurityPermission()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XSecurityPermission
//**************************************************************************************************

} // XHelpers
