﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
public static partial class XByte {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="XParseValueException" />
public static byte HexParse(string src)
   { return XHexParser.Parse<byte>(src); }
/// <exception cref="XParseValueException" />
public static byte HexParse(string src,byte def)
   { return XHexParser.Parse(src,def); }

/// <exception cref="XParseValueException" />
public static byte HexParse(string src,XHexParseOptions options)
   { return XHexParser.Parse<byte>(src,options); }
/// <exception cref="XParseValueException" />
public static byte HexParse(string src,XHexParseOptions options,byte def)
   { return XHexParser.Parse(src,options,def); }

//==================================================================================================

public static bool TryHexParse(string src,out byte dst)
   { return XHexParser.TryParse(src,out dst); }
public static bool TryHexParse(string src,byte def,out byte dst)
   { return XHexParser.TryParse(src,def,out dst); }

public static bool TryHexParse(string src,out byte dst,out XParseValueException e)
   { return XHexParser.TryParse(src,out dst,out e); }
public static bool TryHexParse(string src,byte def,out byte dst,out XParseValueException e)
   { return XHexParser.TryParse(src,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryHexParse(string src,XHexParseOptions options,out byte dst)
   { return XHexParser.TryParse(src,options,out dst); }
public static bool TryHexParse(string src,XHexParseOptions options,byte def,out byte dst)
   { return XHexParser.TryParse(src,options,def,out dst); }

public static bool TryHexParse( string src, XHexParseOptions options,
                                out byte dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,out dst,out e); }
public static bool TryHexParse( string src, XHexParseOptions options, byte def,
                                out byte dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XByte
//**************************************************************************************************

} // XHelpers
