﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XByte {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static byte Parse(string src)
   { return XValueParser.Parse<byte>(src); }
public static byte Parse(string src,byte def)
   { return XValueParser.Parse<byte>(src,def); }

public static byte Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<byte>(src,styles); }
public static byte Parse(string src,NumberStyles styles,byte def)
   { return XNumParser.Parse<byte>(src,styles,def); }

public static byte Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<byte>(src,provider); }
public static byte Parse(string src,IFormatProvider provider,byte def)
   { return XValueParser.Parse<byte>(src,provider,def); }

public static byte Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<byte>(src,styles,provider); }
public static byte Parse(string src,NumberStyles styles,IFormatProvider provider,byte def)
   { return XNumParser.Parse<byte>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static byte ParseInvariant(string src)
   { return XNumParser.ParseInvariant<byte>(src); }
public static byte ParseInvariant(string src,byte def)
   { return XNumParser.ParseInvariant<byte>(src,def); }

public static byte ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<byte>(src,styles); }
public static byte ParseInvariant(string src,NumberStyles styles,byte def)
   { return XNumParser.ParseInvariant<byte>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XByte
//**************************************************************************************************

} // XHelpers
