﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XByte {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string ToNormalString(byte value)
{
   return value.ToString("G",NumberFormatInfo.InvariantInfo);
}

//==================================================================================================

public static string ToHexString(byte value)
{
   return ToHexString(value,false);
}

public static string ToHexString(byte value,bool withPrefix)
{
   return Numeric.ToHexString(value,2,withPrefix);
}

//==================================================================================================

public static byte HighPart(byte value)
{
   return (byte)(value >> 4);
}

public static byte LowPart(byte value)
{
   return (byte)(value & 0x0Fu);
}

//==================================================================================================

static XByte()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XByte
//**************************************************************************************************

} // XHelpers
