﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XDecimal {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static decimal Parse(string src)
   { return XValueParser.Parse<decimal>(src); }
public static decimal Parse(string src,decimal def)
   { return XValueParser.Parse<decimal>(src,def); }

public static decimal Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<decimal>(src,styles); }
public static decimal Parse(string src,NumberStyles styles,decimal def)
   { return XNumParser.Parse<decimal>(src,styles,def); }

public static decimal Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<decimal>(src,provider); }
public static decimal Parse(string src,IFormatProvider provider,decimal def)
   { return XValueParser.Parse<decimal>(src,provider,def); }

public static decimal Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<decimal>(src,styles,provider); }
public static decimal Parse( string src, NumberStyles styles,
                                    IFormatProvider provider, decimal def )
   { return XNumParser.Parse<decimal>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static decimal ParseInvariant(string src)
   { return XNumParser.ParseInvariant<decimal>(src); }
public static decimal ParseInvariant(string src,decimal def)
   { return XNumParser.ParseInvariant<decimal>(src,def); }

public static decimal ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<decimal>(src,styles); }
public static decimal ParseInvariant(string src,NumberStyles styles,decimal def)
   { return XNumParser.ParseInvariant<decimal>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XDecimal
//**************************************************************************************************

} // XHelpers
