﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XDouble {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static double Parse(string src)
   { return XValueParser.Parse<double>(src); }
public static double Parse(string src,double def)
   { return XValueParser.Parse<double>(src,def); }

public static double Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<double>(src,styles); }
public static double Parse(string src,NumberStyles styles,double def)
   { return XNumParser.Parse<double>(src,styles,def); }

public static double Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<double>(src,provider); }
public static double Parse(string src,IFormatProvider provider,double def)
   { return XValueParser.Parse<double>(src,provider,def); }

public static double Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<double>(src,styles,provider); }
public static double Parse( string src, NumberStyles styles,
                                  IFormatProvider provider, double def )
   { return XNumParser.Parse<double>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static double ParseInvariant(string src)
   { return XNumParser.ParseInvariant<double>(src); }
public static double ParseInvariant(string src,double def)
   { return XNumParser.ParseInvariant<double>(src,def); }

public static double ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<double>(src,styles); }
public static double ParseInvariant(string src,NumberStyles styles,double def)
   { return XNumParser.ParseInvariant<double>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XDouble
//**************************************************************************************************

} // XHelpers
