﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XDouble {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool TryParse(string src,out double dst,out XParseValueException e)
   { return XValueParser.TryParse(src,out dst,out e); }
public static bool TryParse(string src,double def,out double dst,out XParseValueException e)
   { return XValueParser.TryParse(src,def,out dst,out e); }

public static bool TryParse( string src, NumberStyles styles, out double dst,
                             out XParseValueException e )
   { return XNumParser.TryParse(src,styles,out dst,out e); }
public static bool TryParse( string src, NumberStyles styles, double def,
                             out double dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,def,out dst,out e); }

public static bool TryParse( string src, IFormatProvider provider,
                             out double dst, out XParseValueException e )
   { return XValueParser.TryParse(src,provider,out dst,out e); }
public static bool TryParse( string src, IFormatProvider provider, double def,
                             out double dst, out XParseValueException e )
   { return XValueParser.TryParse(src,provider,def,out dst,out e); }

public static bool TryParse( string src, NumberStyles styles, IFormatProvider provider,
                             out double dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,provider,out dst,out e); }
public static bool TryParse( string src, NumberStyles styles,
                             IFormatProvider provider, double def,
                             out double dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,provider,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryParseInvariant(string src,out double dst,out XParseValueException e)
   { return XNumParser.TryParseInvariant(src,out dst,out e); }
public static bool TryParseInvariant( string src, double def,
                                      out double dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,def,out dst,out e); }

public static bool TryParseInvariant( string src, NumberStyles styles,
                                      out double dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,styles,out dst,out e); }
public static bool TryParseInvariant( string src, NumberStyles styles, double def,
                                      out double dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,styles,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XDouble
//**************************************************************************************************

} // XHelpers
