﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XInt32 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static Int32 Parse(string src)
   { return XValueParser.Parse<Int32>(src); }
public static Int32 Parse(string src,Int32 def)
   { return XValueParser.Parse<Int32>(src,def); }

public static Int32 Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<Int32>(src,styles); }
public static Int32 Parse(string src,NumberStyles styles,Int32 def)
   { return XNumParser.Parse<Int32>(src,styles,def); }

public static Int32 Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<Int32>(src,provider); }
public static Int32 Parse(string src,IFormatProvider provider,Int32 def)
   { return XValueParser.Parse<Int32>(src,provider,def); }

public static Int32 Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<Int32>(src,styles,provider); }
public static Int32 Parse(string src,NumberStyles styles,IFormatProvider provider,Int32 def)
   { return XNumParser.Parse<Int32>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static Int32 ParseInvariant(string src)
   { return XNumParser.ParseInvariant<Int32>(src); }
public static Int32 ParseInvariant(string src,Int32 def)
   { return XNumParser.ParseInvariant<Int32>(src,def); }

public static Int32 ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<Int32>(src,styles); }
public static Int32 ParseInvariant(string src,NumberStyles styles,Int32 def)
   { return XNumParser.ParseInvariant<Int32>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XInt32
//**************************************************************************************************

} // XHelpers
