﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XInt64 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static Int64 Parse(string src)
   { return XValueParser.Parse<Int64>(src); }
public static Int64 Parse(string src,Int64 def)
   { return XValueParser.Parse<Int64>(src,def); }

public static Int64 Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<Int64>(src,styles); }
public static Int64 Parse(string src,NumberStyles styles,Int64 def)
   { return XNumParser.Parse<Int64>(src,styles,def); }

public static Int64 Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<Int64>(src,provider); }
public static Int64 Parse(string src,IFormatProvider provider,Int64 def)
   { return XValueParser.Parse<Int64>(src,provider,def); }

public static Int64 Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<Int64>(src,styles,provider); }
public static Int64 Parse(string src,NumberStyles styles,IFormatProvider provider,Int64 def)
   { return XNumParser.Parse<Int64>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static Int64 ParseInvariant(string src)
   { return XNumParser.ParseInvariant<Int64>(src); }
public static Int64 ParseInvariant(string src,Int64 def)
   { return XNumParser.ParseInvariant<Int64>(src,def); }

public static Int64 ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<Int64>(src,styles); }
public static Int64 ParseInvariant(string src,NumberStyles styles,Int64 def)
   { return XNumParser.ParseInvariant<Int64>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XInt64
//**************************************************************************************************

} // XHelpers
