﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XIntPtr {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static readonly IntPtr
   MinusOneValue = (IntPtr)(-1);

//==================================================================================================

public static string ToNormalString(IntPtr value)
{
   return XPlatform.Bitness==32 ?
      XInt32.ToNormalString( (Int32)value ) :
      XInt64.ToNormalString( (Int64)value );
}

//==================================================================================================

public static IntPtr ZeroExchange(ref IntPtr value)
{
   return XOps.Exchange(ref value,IntPtr.Zero);
}

//==================================================================================================

public static IntPtr ZeroSubstitution(IntPtr value,IntPtr subst)
{
   return value!=IntPtr.Zero ? value : subst;
}

//--------------------------------------------------------------------------------------------------

[CLSCompliant(false)]
public static void ZeroSubstitution(ref IntPtr operand,IntPtr subst)
{
   if (operand==IntPtr.Zero)
      operand = subst;
}

//==================================================================================================

public static IntPtr MinusOneExchange(ref IntPtr value)
{
   return XOps.Exchange(ref value,MinusOneValue);
}

//--------------------------------------------------------------------------------------------------

public static IntPtr MinusOneSubstitution(IntPtr value,IntPtr subst)
{
   return value!=MinusOneValue ? value : subst;
}

[CLSCompliant(false)]
public static void MinusOneSubstitution(ref IntPtr operand,IntPtr subst)
{
   if (operand==MinusOneValue)
      operand = subst;
}

//==================================================================================================

static XIntPtr()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XIntPtr
//**************************************************************************************************

} // XHelpers
