﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XSingle {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static float Parse(string src)
   { return XValueParser.Parse<float>(src); }
public static float Parse(string src,float def)
   { return XValueParser.Parse<float>(src,def); }

public static float Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<float>(src,styles); }
public static float Parse(string src,NumberStyles styles,float def)
   { return XNumParser.Parse<float>(src,styles,def); }

public static float Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<float>(src,provider); }
public static float Parse(string src,IFormatProvider provider,float def)
   { return XValueParser.Parse<float>(src,provider,def); }

public static float Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<float>(src,styles,provider); }
public static float Parse( string src, NumberStyles styles,
                                  IFormatProvider provider, float def )
   { return XNumParser.Parse<float>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static float ParseInvariant(string src)
   { return XNumParser.ParseInvariant<float>(src); }
public static float ParseInvariant(string src,float def)
   { return XNumParser.ParseInvariant<float>(src,def); }

public static float ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<float>(src,styles); }
public static float ParseInvariant(string src,NumberStyles styles,float def)
   { return XNumParser.ParseInvariant<float>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XSingle
//**************************************************************************************************

} // XHelpers
