﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XSingle {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool TryParse(string src,out float dst,out XParseValueException e)
   { return XValueParser.TryParse(src,out dst,out e); }
public static bool TryParse(string src,float def,out float dst,out XParseValueException e)
   { return XValueParser.TryParse(src,def,out dst,out e); }

public static bool TryParse( string src, NumberStyles styles, out float dst,
                             out XParseValueException e )
   { return XNumParser.TryParse(src,styles,out dst,out e); }
public static bool TryParse( string src, NumberStyles styles, float def,
                             out float dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,def,out dst,out e); }

public static bool TryParse( string src, IFormatProvider provider,
                             out float dst, out XParseValueException e )
   { return XValueParser.TryParse(src,provider,out dst,out e); }
public static bool TryParse( string src, IFormatProvider provider, float def,
                             out float dst, out XParseValueException e )
   { return XValueParser.TryParse(src,provider,def,out dst,out e); }

public static bool TryParse( string src, NumberStyles styles, IFormatProvider provider,
                             out float dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,provider,out dst,out e); }
public static bool TryParse( string src, NumberStyles styles,
                             IFormatProvider provider, float def,
                             out float dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,provider,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryParseInvariant(string src,out float dst,out XParseValueException e)
   { return XNumParser.TryParseInvariant(src,out dst,out e); }
public static bool TryParseInvariant( string src, float def,
                                      out float dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,def,out dst,out e); }

public static bool TryParseInvariant( string src, NumberStyles styles,
                                      out float dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,styles,out dst,out e); }
public static bool TryParseInvariant( string src, NumberStyles styles, float def,
                                      out float dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,styles,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XSingle
//**************************************************************************************************

} // XHelpers
