﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUInt16 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="XParseValueException" />
public static UInt16 HexParse(string src)
   { return XHexParser.Parse<UInt16>(src); }
/// <exception cref="XParseValueException" />
public static UInt16 HexParse(string src,UInt16 def)
   { return XHexParser.Parse(src,def); }

/// <exception cref="XParseValueException" />
public static UInt16 HexParse(string src,XHexParseOptions options)
   { return XHexParser.Parse<UInt16>(src,options); }
/// <exception cref="XParseValueException" />
public static UInt16 HexParse(string src,XHexParseOptions options,UInt16 def)
   { return XHexParser.Parse(src,options,def); }

//==================================================================================================

public static bool TryHexParse(string src,out UInt16 dst)
   { return XHexParser.TryParse(src,out dst); }
public static bool TryHexParse(string src,UInt16 def,out UInt16 dst)
   { return XHexParser.TryParse(src,def,out dst); }

public static bool TryHexParse(string src,out UInt16 dst,out XParseValueException e)
   { return XHexParser.TryParse(src,out dst,out e); }
public static bool TryHexParse(string src,UInt16 def,out UInt16 dst,out XParseValueException e)
   { return XHexParser.TryParse(src,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryHexParse(string src,XHexParseOptions options,out UInt16 dst)
   { return XHexParser.TryParse(src,options,out dst); }
public static bool TryHexParse(string src,XHexParseOptions options,UInt16 def,out UInt16 dst)
   { return XHexParser.TryParse(src,options,def,out dst); }

public static bool TryHexParse( string src, XHexParseOptions options,
                                out UInt16 dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,out dst,out e); }
public static bool TryHexParse( string src, XHexParseOptions options, UInt16 def,
                                out UInt16 dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt16
//**************************************************************************************************

} // XHelpers
