﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUInt16 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static UInt16 Parse(string src)
   { return XValueParser.Parse<UInt16>(src); }
public static UInt16 Parse(string src,UInt16 def)
   { return XValueParser.Parse<UInt16>(src,def); }

public static UInt16 Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<UInt16>(src,styles); }
public static UInt16 Parse(string src,NumberStyles styles,UInt16 def)
   { return XNumParser.Parse<UInt16>(src,styles,def); }

public static UInt16 Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<UInt16>(src,provider); }
public static UInt16 Parse(string src,IFormatProvider provider,UInt16 def)
   { return XValueParser.Parse<UInt16>(src,provider,def); }

public static UInt16 Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<UInt16>(src,styles,provider); }
public static UInt16 Parse( string src, NumberStyles styles,
                            IFormatProvider provider, UInt16 def )
   { return XNumParser.Parse<UInt16>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static UInt16 ParseInvariant(string src)
   { return XNumParser.ParseInvariant<UInt16>(src); }
public static UInt16 ParseInvariant(string src,UInt16 def)
   { return XNumParser.ParseInvariant<UInt16>(src,def); }

public static UInt16 ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<UInt16>(src,styles); }
public static UInt16 ParseInvariant(string src,NumberStyles styles,UInt16 def)
   { return XNumParser.ParseInvariant<UInt16>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt16
//**************************************************************************************************

} // XHelpers
