﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Threading;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
[CLSCompliant(false)]
public static partial class XUInt16 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string ToNormalString(UInt16 value)
{
   return value.ToString("G",NumberFormatInfo.InvariantInfo);
}

//--------------------------------------------------------------------------------------------------

public static string ToHexString(UInt16 value)
{
   return ToHexString(value,false);
}

public static string ToHexString(UInt16 value,bool withPrefix)
{
   return Numeric.ToHexString(value,4,withPrefix);
}

//==================================================================================================

public static byte HighByte(UInt16 value)
{
   return (byte)(value >> 8);
}

public static byte LowByte(UInt16 value)
{
   return (byte)(value & 0x00FFu);
}

//==================================================================================================

static XUInt16()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt16
//**************************************************************************************************

} // XHelpers
