﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUInt32 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static UInt32 Parse(string src)
   { return XValueParser.Parse<UInt32>(src); }
public static UInt32 Parse(string src,UInt32 def)
   { return XValueParser.Parse<UInt32>(src,def); }

public static UInt32 Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<UInt32>(src,styles); }
public static UInt32 Parse(string src,NumberStyles styles,UInt32 def)
   { return XNumParser.Parse<UInt32>(src,styles,def); }

public static UInt32 Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<UInt32>(src,provider); }
public static UInt32 Parse(string src,IFormatProvider provider,UInt32 def)
   { return XValueParser.Parse<UInt32>(src,provider,def); }

public static UInt32 Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<UInt32>(src,styles,provider); }
public static UInt32 Parse( string src, NumberStyles styles,
                            IFormatProvider provider, UInt32 def )
   { return XNumParser.Parse<UInt32>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static UInt32 ParseInvariant(string src)
   { return XNumParser.ParseInvariant<UInt32>(src); }
public static UInt32 ParseInvariant(string src,UInt32 def)
   { return XNumParser.ParseInvariant<UInt32>(src,def); }

public static UInt32 ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<UInt32>(src,styles); }
public static UInt32 ParseInvariant(string src,NumberStyles styles,UInt32 def)
   { return XNumParser.ParseInvariant<UInt32>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt32
//**************************************************************************************************

} // XHelpers
