﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUInt32 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool TryParse(string src,out UInt32 dst,out XParseValueException e)
   { return XValueParser.TryParse(src,out dst,out e); }
public static bool TryParse(string src,UInt32 def,out UInt32 dst,out XParseValueException e)
   { return XValueParser.TryParse(src,def,out dst,out e); }

public static bool TryParse( string src, NumberStyles styles,
                             out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,out dst,out e); }
public static bool TryParse( string src, NumberStyles styles, UInt32 def,
                             out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,def,out dst,out e); }

public static bool TryParse( string src, IFormatProvider provider,
                             out UInt32 dst, out XParseValueException e )
   { return XValueParser.TryParse(src,provider,out dst,out e); }
public static bool TryParse( string src, IFormatProvider provider, UInt32 def,
                             out UInt32 dst, out XParseValueException e )
   { return XValueParser.TryParse(src,provider,def,out dst,out e); }

public static bool TryParse( string src, NumberStyles styles, IFormatProvider provider,
                             out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,provider,out dst,out e); }
public static bool TryParse( string src, NumberStyles styles,
                             IFormatProvider provider, UInt32 def,
                             out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParse(src,styles,provider,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryParseInvariant(string src,out UInt32 dst,out XParseValueException e)
   { return XNumParser.TryParseInvariant(src,out dst,out e); }
public static bool TryParseInvariant( string src, UInt32 def,
                                      out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,def,out dst,out e); }

public static bool TryParseInvariant( string src, NumberStyles styles,
                                      out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,styles,out dst,out e); }
public static bool TryParseInvariant( string src, NumberStyles styles, UInt32 def,
                                      out UInt32 dst, out XParseValueException e )
   { return XNumParser.TryParseInvariant(src,styles,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt32
//**************************************************************************************************

} // XHelpers
