﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Threading;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
[CLSCompliant(false)]
public static partial class XUInt32 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string ToNormalString(UInt32 value)
{
   return value.ToString("G",NumberFormatInfo.InvariantInfo);
}

//--------------------------------------------------------------------------------------------------

public static string ToHexString(UInt32 value)
{
   return ToHexString(value,false);
}

public static string ToHexString(UInt32 value,bool withPrefix)
{
   return Numeric.ToHexString(value,8,withPrefix);
}


//==================================================================================================

public static UInt16 HighWord(UInt32 value)
{
   return (UInt16)(value >> 16);
}

public static UInt16 LowWord(UInt32 value)
{
   return (UInt16)(value & 0x0000FFFFu);
}

//==================================================================================================

static XUInt32()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt32
//**************************************************************************************************

} // XHelpers
