﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUInt64 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="XParseValueException" />
public static UInt64 HexParse(string src)
   { return XHexParser.Parse<UInt64>(src); }
/// <exception cref="XParseValueException" />
public static UInt64 HexParse(string src,UInt64 def)
   { return XHexParser.Parse(src,def); }

/// <exception cref="XParseValueException" />
public static UInt64 HexParse(string src,XHexParseOptions options)
   { return XHexParser.Parse<UInt64>(src,options); }
/// <exception cref="XParseValueException" />
public static UInt64 HexParse(string src,XHexParseOptions options,UInt64 def)
   { return XHexParser.Parse(src,options,def); }

//==================================================================================================

public static bool TryHexParse(string src,out UInt64 dst)
   { return XHexParser.TryParse(src,out dst); }
public static bool TryHexParse(string src,UInt64 def,out UInt64 dst)
   { return XHexParser.TryParse(src,def,out dst); }

public static bool TryHexParse(string src,out UInt64 dst,out XParseValueException e)
   { return XHexParser.TryParse(src,out dst,out e); }
public static bool TryHexParse(string src,UInt64 def,out UInt64 dst,out XParseValueException e)
   { return XHexParser.TryParse(src,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryHexParse(string src,XHexParseOptions options,out UInt64 dst)
   { return XHexParser.TryParse(src,options,out dst); }
public static bool TryHexParse(string src,XHexParseOptions options,UInt64 def,out UInt64 dst)
   { return XHexParser.TryParse(src,options,def,out dst); }

public static bool TryHexParse( string src, XHexParseOptions options,
                                out UInt64 dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,out dst,out e); }
public static bool TryHexParse( string src, XHexParseOptions options, UInt64 def,
                                out UInt64 dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt64
//**************************************************************************************************

} // XHelpers
