﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUInt64 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static UInt64 Parse(string src)
   { return XValueParser.Parse<UInt64>(src); }
public static UInt64 Parse(string src,UInt64 def)
   { return XValueParser.Parse<UInt64>(src,def); }

public static UInt64 Parse(string src,NumberStyles styles)
   { return XNumParser.Parse<UInt64>(src,styles); }
public static UInt64 Parse(string src,NumberStyles styles,UInt64 def)
   { return XNumParser.Parse<UInt64>(src,styles,def); }

public static UInt64 Parse(string src,IFormatProvider provider)
   { return XValueParser.Parse<UInt64>(src,provider); }
public static UInt64 Parse(string src,IFormatProvider provider,UInt64 def)
   { return XValueParser.Parse<UInt64>(src,provider,def); }

public static UInt64 Parse(string src,NumberStyles styles,IFormatProvider provider)
   { return XNumParser.Parse<UInt64>(src,styles,provider); }
public static UInt64 Parse( string src, NumberStyles styles,
                            IFormatProvider provider, UInt64 def )
   { return XNumParser.Parse<UInt64>(src,styles,provider,def); }

//--------------------------------------------------------------------------------------------------

public static UInt64 ParseInvariant(string src)
   { return XNumParser.ParseInvariant<UInt64>(src); }
public static UInt64 ParseInvariant(string src,UInt64 def)
   { return XNumParser.ParseInvariant<UInt64>(src,def); }

public static UInt64 ParseInvariant(string src,NumberStyles styles)
   { return XNumParser.ParseInvariant<UInt64>(src,styles); }
public static UInt64 ParseInvariant(string src,NumberStyles styles,UInt64 def)
   { return XNumParser.ParseInvariant<UInt64>(src,styles,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt64
//**************************************************************************************************

} // XHelpers
