﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Threading;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
[CLSCompliant(false)]
public static partial class XUInt64 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string ToNormalString(UInt64 value)
{
   return value.ToString("G",NumberFormatInfo.InvariantInfo);
}

//--------------------------------------------------------------------------------------------------

public static string ToHexString(UInt64 value)
{
   return ToHexString(value,false);
}

public static string ToHexString(UInt64 value,bool withPrefix)
{
   return Numeric.ToHexString(value,16,withPrefix);
}

//==================================================================================================

public static UInt32 HighPart(UInt64 value)
{
   return (UInt32)(value >> 32);
}

public static UInt32 LowPart(UInt64 value)
{
   return (UInt32)(value & 0x00000000FFFFFFFFul);
}

//==================================================================================================

static XUInt64()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUInt64
//**************************************************************************************************

} // XHelpers
