﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
public static partial class XUIntPtr {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/// <exception cref="XParseValueException" />
public static UIntPtr HexParse(string src)
   { return XHexParser.Parse<UIntPtr>(src); }
/// <exception cref="XParseValueException" />
public static UIntPtr HexParse(string src,UIntPtr def)
   { return XHexParser.Parse(src,def); }

/// <exception cref="XParseValueException" />
public static UIntPtr HexParse(string src,XHexParseOptions options)
   { return XHexParser.Parse<UIntPtr>(src,options); }
/// <exception cref="XParseValueException" />
public static UIntPtr HexParse(string src,XHexParseOptions options,UIntPtr def)
   { return XHexParser.Parse(src,options,def); }

//==================================================================================================

public static bool TryHexParse(string src,out UIntPtr dst)
   { return XHexParser.TryParse(src,out dst); }
public static bool TryHexParse(string src,UIntPtr def,out UIntPtr dst)
   { return XHexParser.TryParse(src,def,out dst); }

public static bool TryHexParse(string src,out UIntPtr dst,out XParseValueException e)
   { return XHexParser.TryParse(src,out dst,out e); }
public static bool TryHexParse(string src,UIntPtr def,out UIntPtr dst,out XParseValueException e)
   { return XHexParser.TryParse(src,def,out dst,out e); }

//--------------------------------------------------------------------------------------------------

public static bool TryHexParse(string src,XHexParseOptions options,out UIntPtr dst)
   { return XHexParser.TryParse(src,options,out dst); }
public static bool TryHexParse( string src, XHexParseOptions options, UIntPtr def,
                                out UIntPtr dst )
   { return XHexParser.TryParse(src,options,def,out dst); }

public static bool TryHexParse( string src, XHexParseOptions options,
                                out UIntPtr dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,out dst,out e); }
public static bool TryHexParse( string src, XHexParseOptions options, UIntPtr def,
                                out UIntPtr dst, out XParseValueException e )
   { return XHexParser.TryParse(src,options,def,out dst,out e); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUIntPtr
//**************************************************************************************************

} // XHelpers
