﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
[CLSCompliant(false)]
public static partial class XUIntPtr {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static string ToNormalString(UIntPtr value)
{
   return XPlatform.Bitness==32 ?
      XUInt32.ToNormalString( (UInt32)value ) :
      XUInt64.ToNormalString( (UInt64)value );
}

//--------------------------------------------------------------------------------------------------

public static string ToHexString(UIntPtr value)
{
   return ToHexString(value,false);
}

public static string ToHexString(UIntPtr value,bool withPrefix)
{
   return XPlatform.Bitness==32 ?
      XUInt32.ToHexString( (UInt32)value, withPrefix ) :
      XUInt64.ToHexString( (UInt64)value, withPrefix );
}

//==================================================================================================

static XUIntPtr()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUIntPtr
//**************************************************************************************************

} // XHelpers
