﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
partial class XOperatingSystem {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void Verify(OperatingSystem requiredMinimalOS)
{
   XArgCheck.VerifyNotNull( requiredMinimalOS );

   if (!CheckOperatingSystem( requiredMinimalOS ))
      throw new XInvalidEnvironmentException(string.Format(
         "Operation is not supported in current environment.\r\n"+
         "Required minimal operating system is \"{0}\".",
         GetNameOrVersionString( requiredMinimalOS ) ));
}

//==================================================================================================

public static void VerifyIsWindows2KOrLater()
{
   VerifyIsWindows2KOrLater( Environment.OSVersion );
}

public static void VerifyIsWindowsXPOrLater()
{
   VerifyIsWindowsXPOrLater( Environment.OSVersion );
}

public static void VerifyIsWindowsVistaOrLater()
{
   VerifyIsWindowsVistaOrLater( Environment.OSVersion );
}

public static void VerifyIsWindows7OrLater()
{
   VerifyIsWindows7OrLater( Environment.OSVersion );
}

//--------------------------------------------------------------------------------------------------

public static void VerifyIsWindows2KOrLater(OperatingSystem system)
{
   Verify( Windows2K );
}

public static void VerifyIsWindowsXPOrLater(OperatingSystem system)
{
   Verify( WindowsXP );
}

public static void VerifyIsWindowsVistaOrLater(OperatingSystem system)
{
   Verify( WindowsVista );
}

public static void VerifyIsWindows7OrLater(OperatingSystem system)
{
   Verify( Windows7 );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XOperatingSystem
//**************************************************************************************************

} // XHelpers
