﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Threading;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XThread {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#if SILVERLIGHT

//--------------------------------------------------------------------------------------------------

public static void Start(Action operation)
{
   Start(false,operation);
}

public static void Start(bool inheritCurrentCulture,Action operation)
{
   Start(inheritCurrentCulture,false,operation);
}

public static void Start( bool inheritCurrentCulture,
                          bool inheritCurrentUICulture,
                          Action operation )
{
   StartEx(inheritCurrentCulture,inheritCurrentUICulture,operation);
}

//--------------------------------------------------------------------------------------------------

public static void StartWithInheritedCultures(Action operation)
{
   Start(true,true,operation);
}

//--------------------------------------------------------------------------------------------------

#endif // !SILVERLIGHT

//==================================================================================================

#if !SILVERLIGHT

//--------------------------------------------------------------------------------------------------

public static void Start(Action operation)
{
   Start(null,operation);
}

public static void Start([Optional] ThreadPriority? priority,Action operation)
{
   Start(priority,false,operation);
}

public static void Start(bool inheritCurrentCulture,Action operation)
{
   Start(inheritCurrentCulture,false,operation);
}

public static void Start( bool inheritCurrentCulture,
                          bool inheritCurrentUICulture,
                          Action operation )
{
   Start(null,inheritCurrentCulture,inheritCurrentUICulture,operation);
}

public static void Start( [Optional] ThreadPriority? priority,
                          bool inheritCurrentCulture,
                          Action operation )
{
   Start(priority,inheritCurrentCulture,false,operation);
}

public static void Start( [Optional] ThreadPriority? priority,
                          bool inheritCurrentCulture,
                          bool inheritCurrentUICulture,
                          Action operation )
{
   StartEx(priority,inheritCurrentCulture,inheritCurrentUICulture,operation);
}

//--------------------------------------------------------------------------------------------------

public static void StartWithInheritedCultures(Action operation)
{
   StartWithInheritedCultures(null,operation);
}

public static void StartWithInheritedCultures([Optional] ThreadPriority? priority,Action operation)
{
   Start(priority,true,true,operation);
}

//--------------------------------------------------------------------------------------------------

#endif // !SILVERLIGHT

//==================================================================================================

public static void HangExecution()
{
   Thread.Sleep( Timeout.Infinite );
}

//==================================================================================================

static XThread()
{
   Library.Access();
}

//--------------------------------------------------------------------------------------------------

static void StartEx
(
#if !SILVERLIGHT
   ThreadPriority? priority,
#endif // !SILVERLIGHT
   bool inheritCurrentCulture,
   bool inheritCurrentUICulture,
   Action operation
)
{
   var thread = new Thread(new ThreadStart(operation));
#if !SILVERLIGHT
   thread.Priority = priority ?? ThreadPriority.Normal;
#endif // !SILVERLIGHT
   if (inheritCurrentCulture)
      thread.CurrentCulture = Thread.CurrentThread.CurrentCulture;
   if (inheritCurrentUICulture)
      thread.CurrentUICulture = Thread.CurrentThread.CurrentUICulture;
   Thread.MemoryBarrier();
   thread.Start();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XThread
//**************************************************************************************************

} // XHelpers
