﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Reflection;
using System.Globalization;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XNumParser {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static T Parse<T>(string src,NumberStyles styles) where T: struct
   { return Parse<T>(src,styles,NumberFormatInfo.CurrentInfo); }
public static T Parse<T>(string src,NumberStyles styles,T def) where T: struct
   { return Parse<T>(src,styles,NumberFormatInfo.CurrentInfo,def); }

public static T Parse<T>(string src,NumberStyles styles,IFormatProvider provider)
   where T: struct
{
   return XValueParser.Parse<T>(src,new object[]{styles,provider});
}
public static T Parse<T>(string src,NumberStyles styles,IFormatProvider provider,T def)
   where T: struct
{
   return XValueParser.Parse<T>(src,new object[]{styles,provider},def);
}

//--------------------------------------------------------------------------------------------------

public static T ParseInvariant<T>(string src) where T: struct
   { return XValueParser.Parse<T>(src,NumberFormatInfo.InvariantInfo); }
public static T ParseInvariant<T>(string src, T def) where T: struct
   { return XValueParser.Parse<T>(src,NumberFormatInfo.InvariantInfo,def); }

public static T ParseInvariant<T>(string src,NumberStyles styles) where T: struct
   { return Parse<T>(src,styles,NumberFormatInfo.InvariantInfo); }
public static T ParseInvariant<T>(string src,NumberStyles styles,T def) where T: struct
   { return Parse<T>(src,styles,NumberFormatInfo.InvariantInfo,def); }

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XNumParser
//**************************************************************************************************

} // XHelpers
