﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XVersion {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool CheckMinMajor(Version version,int minMajor)
{
   XArgCheck.VerifyNotNull( version);
   return version.Major >= minMajor;
}

public static bool CheckMinMajorMinor(Version version,int minMajor,int minMinor)
{
   XArgCheck.VerifyNotNull( version );
   return
      version.Major > minMajor ||
      version.Major == minMajor && version.Minor >= minMinor;
}

public static bool CheckReqMajorMinorMinBuildRevision( Version version,
                                                       int reqMajor, int reqMinor,
                                                       int minBuild, int minRevision )
{
   XArgCheck.VerifyNotNull( version );
   return
      version.Major == reqMajor && version.Minor == reqMinor &&
      ( version.Build > minBuild ||
        version.Build == minBuild && version.Revision >= minRevision );
}

//==================================================================================================

static XVersion()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XVersion
//**************************************************************************************************

} // XHelpers
