﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.IO;
using System.Linq;
using System.Media;
using System.Runtime.CompilerServices;

namespace XHelpers {

//**************************************************************************************************
class BeepsLayout
{
   public readonly XSound
      Sound;
   public readonly double[]
      Beeps;
   public BeepsLayout(XSound sound,double[] beeps)
   {
      Sound = sound; Beeps = beeps;
   }
}
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
public partial class XSounds {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static readonly XSound
   None        = new XSound(),
   Default     = new XSound(),
   Success     = new XSound(),
   NotSuccess  = new XSound(),
   Information = new XSound(),
   Error       = new XSound(),
   Warning     = new XSound(),
   Exclamation = new XSound(),
   Question    = new XSound(),
   Disabled    = new XSound();

//==================================================================================================

internal static readonly BeepsLayout[]
   DefaultBeepsLayouts;

//==================================================================================================

static XSounds()
{
   Library.Access();

   DefaultBeepsLayouts = new BeepsLayout[]
   {
      new BeepsLayout( Success    , new double[]{ 1,1, 2,1 } ),
      new BeepsLayout( NotSuccess , new double[]{ 0.5,3    } ),
      new BeepsLayout( Information, new double[]{ 1,1      } ),
      new BeepsLayout( Error      , new double[]{ 2,2      } ),
      new BeepsLayout( Warning    , new double[]{ 1,1      } ),
      new BeepsLayout( Exclamation, new double[]{ 1,1      } ),
      new BeepsLayout( Question   , new double[]{ 1,1      } ),
      new BeepsLayout( Disabled   , new double[]{ 2,1      } )
   };
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XSounds
//**************************************************************************************************

} // XHelpers
