﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Diagnostics;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XProcess {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static IntPtr Handle
{
   get
   {
      return Process.GetCurrentProcess().Handle;
   }
}

public static IntPtr MainModuleHandle
{
   get
   {
      var hProcess = Win32.GetModuleHandle( IntPtr.Zero );
      if (hProcess!=IntPtr.Zero)
         return hProcess;
      throw XWin32Error.CreateExceptionFromLastError();
   }
}

public static IntPtr HeapHandle
{
   get
   {
      var hProcessHeap = Win32.GetProcessHeap();
      if (hProcessHeap!=IntPtr.Zero)
         return hProcessHeap;
      throw XWin32Error.CreateExceptionFromLastError();
   }
}

//==================================================================================================

static XProcess()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XProcess
//**************************************************************************************************

} // XHelpers
