﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XUnsafeBytesBuffer {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static unsafe byte* Clear([Out] byte* destination,int count)
{
   return (byte*)XMemory.Clear<byte>((IntPtr)destination,count);
}

public static unsafe byte* Copy([In] byte* source,[Out] byte* destination,int count)
{
   return (byte*)XMemory.Copy<byte>((IntPtr)source,(IntPtr)destination,count);
}

//==================================================================================================

/// <exception cref="XOperationFailedException" />
public static unsafe byte* Allocate(int capacity)
{
   return (byte*)XMemory.Allocate<byte>( capacity );
}

/// <exception cref="XOperationFailedException" />
public static unsafe byte* ReAllocate(byte* allocatedBuffer,int newCapacity)
{
   return (byte*)XMemory.ReAllocate<byte>((IntPtr)allocatedBuffer,newCapacity);
}

/// <exception cref="XOperationFailedException" />
public static unsafe byte* ReAllocate(ref byte* allocatedBuffer,int newCapacity)
{
   return allocatedBuffer = ReAllocate(allocatedBuffer,newCapacity);
}

/// <exception cref="XOperationFailedException" />
public static unsafe byte* Duplicate([In] byte* allocatedBuffer)
{
   return (byte*)XMemory.Duplicate<byte>( (IntPtr)allocatedBuffer );
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="XOperationFailedException" />
public static unsafe int GetAllocatedCapacity([In] byte* allocatedBuffer)
{
   return XMemory.GetAllocatedCapacity<byte>( (IntPtr)allocatedBuffer );
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="Win32Exception" />
public static unsafe void Free([Optional] byte* allocatedBuffer)
{
   XMemory.Free<byte>( (IntPtr)allocatedBuffer );
}

/// <exception cref="Win32Exception" />
public static unsafe void Free([Optional] ref byte* allocatedBuffer)
{
   byte* buffer = allocatedBuffer;
   allocatedBuffer = null;
   Free( buffer );
}

//==================================================================================================

static XUnsafeBytesBuffer()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUnsafeBytesBuffer
//**************************************************************************************************

} // XHelpers
