﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XUnsafeCharBuffer {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static int ElementSize()
{
   return XMemory.ElementSize<char>();
}

public static int CountToSize(int count)
{
   return XMemory.CountToSize<char>( count );
}

//==================================================================================================

public static unsafe char* Clear([Out] char* destination,int count)
{
   return (char*)XMemory.Clear<char>((IntPtr)destination,count);
}

public static unsafe char* Copy([In] char* source,[Out] char* destination,int count)
{
   return (char*)XMemory.Copy<char>((IntPtr)source,(IntPtr)destination,count);
}

//==================================================================================================

/// <exception cref="XOperationFailedException" />
public static unsafe char* Allocate(int capacity)
{
   return (char*)XMemory.Allocate<char>( capacity );
}

/// <exception cref="XOperationFailedException" />
public static unsafe char* ReAllocate(char* allocatedBuffer,int newCapacity)
{
   return (char*)XMemory.ReAllocate<char>((IntPtr)allocatedBuffer,newCapacity);
}

/// <exception cref="XOperationFailedException" />
public static unsafe char* ReAllocate(ref char* allocatedBuffer,int newCapacity)
{
   return allocatedBuffer = ReAllocate(allocatedBuffer,newCapacity);
}

/// <exception cref="XOperationFailedException" />
public static unsafe char* Duplicate([In] char* allocatedBuffer)
{
   return (char*)XMemory.Duplicate<char>((IntPtr)allocatedBuffer);
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="XOperationFailedException" />
public static unsafe int GetAllocatedCapacity([In] char* allocatedBuffer)
{
   return XMemory.GetAllocatedCapacity<char>( (IntPtr)allocatedBuffer );
}

//--------------------------------------------------------------------------------------------------

/// <exception cref="Win32Exception" />
public static unsafe void Free([Optional] char* allocatedBuffer)
{
   XMemory.Free<char>( (IntPtr)allocatedBuffer );
}

/// <exception cref="Win32Exception" />
public static unsafe void Free([Optional] ref char* allocatedBuffer)
{
   char* buffer = allocatedBuffer;
   allocatedBuffer = null;
   Free( buffer );
}

//==================================================================================================

static XUnsafeCharBuffer()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XUnsafeCharBuffer
//**************************************************************************************************

} // XHelpers
