﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;
using System.Windows.Threading;
using System.Windows.Controls;

namespace XHelpers {

//**************************************************************************************************
partial class XApplication {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static Panel LayoutRoot;

//==================================================================================================

public static Control RootControl
{
   get
   {
      UIElement rootVisual =
         Application.Current.RootVisual;
      if (rootVisual==null)
         return null;
      if (rootVisual is Control)
         return (Control)rootVisual;
      throw new XOperationFailedException(string.Format(
         "Root element of visual tree of the application "+
         "has a type another than \"{0}\".",
         typeof(Control) ));
   }
   set
   {
      Application.Current.RootVisual = value;
   }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XApplication
//**************************************************************************************************

} // XHelpers
