﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Globalization;
using System.ComponentModel;

using System.Windows;
using System.Windows.Data;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XBusyOverlayHelpers {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static HorizontalAlignment HorizontalAlignment
{
   get
   {
      return XDesignHelpers.UseActualStyles ?
         HorizontalAlignment.Stretch : HorizontalAlignment.Left;
   }
}

//==================================================================================================

static XBusyOverlayHelpers()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XBusyOverlayHelpers
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
[ValueConversion(typeof(bool),typeof(bool))]
public partial class XBusyToIsEnabledConverter: IValueConverter {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public object Convert(object value,Type targerType,object parameter,CultureInfo culture)
{
   return !(bool)value;
}

public object ConvertBack(object value,Type targetType,object parameter,CultureInfo culture)
{
   throw new NotSupportedException();
}

//==================================================================================================

static XBusyToIsEnabledConverter()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XBusyToIsEnabledConverter
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
[ValueConversion(typeof(bool),typeof(Visibility))]
public partial class XBusyToOverlayVisibilityConverter: IValueConverter {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public object Convert(object value,Type targerType,object parameter,CultureInfo culture)
{
   return (bool)value ? Visibility.Visible : Visibility.Collapsed;
}

public object ConvertBack(object value,Type targetType,object parameter,CultureInfo culture)
{
   throw new NotSupportedException();
}

//==================================================================================================

static XBusyToOverlayVisibilityConverter()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XBusyToOverlayVisibilityConverter
//**************************************************************************************************

} // XHelpers
