﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
static partial class Win32 {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public const int
   SM_CXFULLSCREEN= 16,
   SM_CYFULLSCREEN= 17,
   SW_RESTORE     = 9;

public const uint
   SC_CLOSE                = 0x0000F060,
   MF_BYCOMMAND            = 0x00000000,
   MF_ENABLED              = 0x00000000,
   MF_GRAYED               = 0x00000001,
   WM_SYSCOMMAND           = 0x00000112,
   SWP_NOZORDER            = 0x00000004,
   WM_DWMCOMPOSITIONCHANGED= 0x031E;

//==================================================================================================

[StructLayout(LayoutKind.Sequential)]
public struct RECT
{
   public int
      Left,Top,Right,Bottom;
}

[StructLayout(LayoutKind.Sequential)]
public struct MARGINS
{
   public int
      cxLeftWidth,
      cxRightWidth,
      cyTopHeight,
      cyBottomHeight;
}

//==================================================================================================

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern int GetSystemMetrics(int nIndex);

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern IntPtr GetSystemMenu(IntPtr hWnd,bool bRevert);

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern uint EnableMenuItem(IntPtr hMenu,uint uIDEnableItem,uint uEnable);

//[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
//public static extern IntPtr DefWindowProc(IntPtr hWnd,uint msg,IntPtr wParam,IntPtr lParam);

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern bool ShowWindow(IntPtr hWnd,int nCmdShow);

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern bool SetWindowPos( IntPtr hWnd, IntPtr hWndInsertAfter,
                                        int x, int y, int cx, int cy,
                                        uint uFlags );

[DllImport("User32.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern bool GetWindowRect(IntPtr hWnd,out RECT rect);

[DllImport("DwmApi.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern int DwmExtendFrameIntoClientArea(IntPtr hWnd,[In] ref MARGINS marInset);

[DllImport("DwmApi.dll",CharSet=CharSet.Unicode,SetLastError=true)]
public static extern int DwmIsCompositionEnabled(out int nEnabled);

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // Win32
//**************************************************************************************************

} // XHelpers
