﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public delegate void XDisplayAppWaitingStatusHandler( bool isActive,
                                                      [Optional] string caption,
                                                      [Optional] object data );
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
public delegate void XReportAppWaitingErrorCallback( string errorMessage,
                                                     string actionTitle,
                                                     [Optional] object data );
//**************************************************************************************************


//**************************************************************************************************
/// <summary>
/// </summary>
public partial class XAppWaitingStatus {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public string Caption
   { get { return _Caption_; }  }

public object Data
   { get { return _Data_; } }

//--------------------------------------------------------------------------------------------------

public XAppWaitingStatus(): this (null)
{}

public XAppWaitingStatus(string caption): this (caption,null)
{}

public XAppWaitingStatus(string caption,object data)
{
   _Caption_ = caption; _Data_ = data;
}

//--------------------------------------------------------------------------------------------------

public static readonly XAppWaitingStatus
   Neutral = new XAppWaitingStatus();

//==================================================================================================

internal XAppWaitingStatus Duplicate()
{
   return (XAppWaitingStatus)MemberwiseClone();
}

//==================================================================================================

static XAppWaitingStatus()
{
   Library.Access();
}

//==================================================================================================

internal string
   _Caption_;
internal object
   _Data_;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XAppWaitingStatus
//**************************************************************************************************

} // PaycorMaster
