﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;
using System.Windows.Input;

namespace XHelpers {

//**************************************************************************************************
partial class XApplication {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static Window
   AnchorWindow;

public static event Action<XWindow>
   WindowActivated;

//==================================================================================================

public static Window ActiveWindow
{
   get
   {
      foreach (Window window in Application.Current.Windows)
         if (window.IsActive)
            return window;
      return null;
   }
}

//==================================================================================================

public static void Shutdown()
{
   Shutdown(0);
}

public static void Shutdown(int exitCode)
{
   IsBusy = true;
   Application.Current.Shutdown( exitCode );
}

//--------------------------------------------------------------------------------------------------

public static void UpdateWindowsBusy()
{
   foreach (Window window in Application.Current.Windows)
      if (XWindow.GetSynchronizeIsBusyWithApplication(window))
         XWindow.SetIsBusy(window,_IsBusy_);
   CommandManager.InvalidateRequerySuggested();
}

//==================================================================================================

internal static void RaiseWindowActivated(XWindow window)
{
   if (WindowActivated!=null)
      WindowActivated( window );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XApplication
//**************************************************************************************************

} // XHelpers
