﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Threading;
using System.Runtime.InteropServices;

namespace XHelpers {

//**************************************************************************************************
partial class XBackgroundOperation {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void Start(Action operation)
{
   StartEx(false,null,null,null,operation);
}

//--------------------------------------------------------------------------------------------------

public static void Start([Optional] string appWaitingTitle,Action operation)
{
   Start(appWaitingTitle,appWaitingTitle,operation);
}

public static void Start( [Optional] string appWaitingTitle,
                          [Optional] string appWaitingCaption,
                          Action operation )
{
   Start(appWaitingTitle,new XAppWaitingStatus(appWaitingCaption),operation);
}

public static void Start( [Optional] string appWaitingTitle,
                          [Optional] XAppWaitingStatus appWaitingStatus,
                          Action operation )
{
   StartEx(true,appWaitingTitle,appWaitingStatus,null,operation);
}

//==================================================================================================

#if !SILVERLIGHT

//--------------------------------------------------------------------------------------------------

public static void Start([Optional] ThreadPriority priority,Action operation)
{
   StartEx(false,null,null,priority,operation);
}

//--------------------------------------------------------------------------------------------------

public static void Start( [Optional] string appWaitingTitle,
                          [Optional] ThreadPriority priority, Action operation )
{
   Start(appWaitingTitle,appWaitingTitle,priority,operation);
}

public static void Start( [Optional] string appWaitingTitle,
                          [Optional] string appWaitingCaption,
                          [Optional] ThreadPriority priority, Action operation )
{
   Start(appWaitingTitle,new XAppWaitingStatus(appWaitingCaption),priority,operation);
}

public static void Start( [Optional] string appWaitingTitle,
                          [Optional] XAppWaitingStatus appWaitingStatus,
                          [Optional] ThreadPriority priority, Action operation )
{
   StartEx(true,appWaitingTitle,appWaitingStatus,priority,operation);
}

//--------------------------------------------------------------------------------------------------

#endif // !SILVERLIGHT

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XBackgroundOperation
//**************************************************************************************************

} // XHelpers
