﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections;

using System.Windows;
using System.Windows.Input;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XCursor {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static Cursor Current
{
   get
   {
      return XDispatcher.Synchronize
      (
         (XResultDelegate<Cursor>)delegate{
            return Mouse.OverrideCursor; }
      );
   }
}

//--------------------------------------------------------------------------------------------------

public static Cursor SetWait()
{
   return Override( Cursors.Wait );
}

public static Cursor Reset()
{
   return Override( null );
}

public static Cursor Override(Cursor cursor)
{
   return XDispatcher.Synchronize
   (
      (XResultDelegate<Cursor>)delegate
      {
         var prevCursor = Mouse.OverrideCursor;
         Mouse.OverrideCursor = cursor;
         return prevCursor;
      }
   );
}

//--------------------------------------------------------------------------------------------------

public static Cursor Create(byte[] buffer)
{
   using (var stream=new MemoryStream(buffer))
      return new Cursor(stream);
}

//==================================================================================================

static XCursor()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XCursor
//**************************************************************************************************

} // XHelpers
