﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;
using System.Windows.Threading;

namespace XHelpers {

//**************************************************************************************************
partial class XDispatcher {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void BeginInvoke(Action operation)
{
   BeginInvoke(null,operation);
}

public static void BeginInvoke(DispatcherPriority? priority,Action operation)
{
   BeginInvokeEx(priority,operation);
}

//--------------------------------------------------------------------------------------------------

public static void Synchronize(Action operation)
{
   Synchronize(null,operation);
}

public static void Synchronize(DispatcherPriority? priority,Action operation)
{
   SynchronizeEx(priority,operation);
}

//--------------------------------------------------------------------------------------------------

public static T Synchronize<T>(XResultDelegate<T> operation)
{
   return Synchronize(null,operation);
}

public static T Synchronize<T>(DispatcherPriority? priority,XResultDelegate<T> operation)
{
   return SynchronizeEx(priority,operation);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XDispatcher
//**************************************************************************************************

} // XHelpers
