﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Collections.Generic;
using System.Collections;

using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
public static partial class XFocus {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#if SILVERLIGHT

public static void StrictFocus(Control control)
{
   StrictFocusEx( control );
}

#endif // SILVERLIGHT

//==================================================================================================

#if !SILVERLIGHT

public static void StrictFocus(UIElement element)
{
   StrictFocusEx( element );
}

public static bool MoveToFirstElementOf(UIElement element)
{
   return element.MoveFocus( new TraversalRequest(FocusNavigationDirection.First) );
}

public static void StrictMoveToFirstElementOf(UIElement element)
{
   if (!MoveToFirstElementOf(element))
      throw new XOperationFailedException(
         "Can not move keyboard focus." );
}

#endif // !SILVERLIGHT

//==================================================================================================

public static void StrictFocusEx(object element)
{
   XArgCheck.VerifyNotNull( element );
#if SILVERLIGHT
   if (!((Control)element).Focus())
#else
   if (!((UIElement)element).Focus())
#endif
      throw new XOperationFailedException(string.Format(
         "Can not set keyboard focus to element: \"{0}\".",
         element ));
}

//==================================================================================================

static XFocus()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XFocus
//**************************************************************************************************

} // XHelpers
