﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Text;
using System.Collections.Generic;

using System.Windows;
using System.Windows.Input;
using System.Windows.Controls;
using System.Windows.Documents;

namespace XHelpers {

//**************************************************************************************************
partial class XInput {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static bool ProvideToolTipWithGesture(FrameworkElement element)
{
   string
      toolTipString   = element.ToolTip as string,
      keyGestureString= ExtractGestureDisplayString(element);

   if (toolTipString==null)
      return false;

   var span = new Span(new Run(toolTipString));
   if (keyGestureString!=null)
   {
      span.Inlines.Add(" (");
      span.Inlines.Add(new Bold(new Run(keyGestureString)));
      span.Inlines.Add(")");
   }
   element.ToolTip = new TextBlock(span);

   return true;
}

//--------------------------------------------------------------------------------------------------

public static void ProvideToolTipsWithGestures(FrameworkElement root)
{
   ProvideToolTipsWithGestures(root,true);
}

public static void ProvideToolTipsWithGestures(FrameworkElement root,bool processRoot)
{
   XLogicalTreeHelper.ProcessNodes
   (
      root,
      processRoot,
      delegate (FrameworkElement element)
      {
         ProvideToolTipWithGesture(element);
      }
   );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XInput
//**************************************************************************************************

} // XHelpers
