﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowError(XSound sound,string text)
{
   ShowError(sound,(Window)null,text);
}

public static MessageBoxResult ShowError(XSound sound,string text,MessageBoxButton button)
{
   return ShowError(sound,(Window)null,text,button);
}

public static MessageBoxResult ShowError( XSound sound,
                                          string text, MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowError(sound,(Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(XSound sound,string text,string caption)
{
   ShowError(sound,(Window)null,text,caption);
}

public static MessageBoxResult ShowError( XSound sound,
                                          string text, string caption,
                                          MessageBoxButton button )
{
   return ShowError(sound,(Window)null,text,caption,button);
}

public static MessageBoxResult ShowError( XSound sound,
                                          string text, string caption,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(sound,(Window)null,text,caption,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(XSound sound,Exception e)
{
   ShowError(sound,(Window)null,e);
}

public static MessageBoxResult ShowError(XSound sound,Exception e,MessageBoxButton button)
{
   return ShowError(sound,(Window)null,e,button);
}

public static MessageBoxResult ShowError( XSound sound, Exception e,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(sound,(Window)null,e,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(XSound sound,Exception e,string caption)
{
   ShowError(sound,(Window)null,e,caption);
}

public static MessageBoxResult ShowError( XSound sound,
                                          Exception e, string caption,
                                          MessageBoxButton button )
{
   return ShowError(sound,(Window)null,e,caption,button);
}

public static MessageBoxResult ShowError( XSound sound, Exception e, string caption,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(sound,(Window)null,e,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowError(XSound sound,Window owner,string text)
{
   ShowError(sound,owner,text,null);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          string text, MessageBoxButton button )
{
   return ShowError(sound,owner,text,null,button);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          string text, MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowError(sound,owner,text,null,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(XSound sound,Window owner,string text,string caption)
{
   ShowError(sound,owner,text,caption,MessageBoxButton.OK);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          string text, string caption,
                                          MessageBoxButton button )
{
   return ShowError(
      sound, owner, text, caption, button,
      DefaultResultFromButton(button) );
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          string text, string caption,
                                          MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowMessage( sound, owner,
      text, caption ?? ErrorCaption,
      button, MessageBoxImage.Error,
      defaultResult );
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(XSound sound,Window owner,Exception e)
{
   ShowError(sound,owner,e,null);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          Exception e, MessageBoxButton button )
{
   return ShowError(sound,owner,e,null,button);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          Exception e, MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowError(sound,owner,e,null,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(XSound sound,Window owner,Exception e,string caption)
{
   ShowError(sound,owner,XException.GetErrorMessage(e),caption);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          Exception e, string caption,
                                          MessageBoxButton button )
{
   return ShowError(sound,owner,XException.GetErrorMessage(e),caption,button);
}

public static MessageBoxResult ShowError( XSound sound, Window owner,
                                          Exception e, string caption,
                                          MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowError(sound,owner,XException.GetErrorMessage(e),caption,button,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
