﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowExclamation(XSound sound,string text)
{
   ShowExclamation(sound,(Window)null,text);
}

public static MessageBoxResult ShowExclamation(XSound sound,string text,MessageBoxButton button)
{
   return ShowExclamation(sound,(Window)null,text,button);
}

public static MessageBoxResult ShowExclamation( XSound sound,
                                                string text,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation(sound,(Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowExclamation(XSound sound,string text,string caption)
{
   ShowExclamation(sound,(Window)null,text,caption);
}

public static MessageBoxResult ShowExclamation( XSound sound,
                                                string text, string caption,
                                                MessageBoxButton button )
{
   return ShowExclamation(sound,(Window)null,text,caption,button);
}

public static MessageBoxResult ShowExclamation( XSound sound,
                                                string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation(sound,(Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowExclamation(XSound sound,Window owner,string text)
{
   ShowExclamation(sound,owner,text,null);
}

public static MessageBoxResult ShowExclamation( XSound sound, Window owner,
                                                string text, MessageBoxButton button )
{
   return ShowExclamation(sound,owner,text,null,button);
}

public static MessageBoxResult ShowExclamation( XSound sound, Window owner,
                                                string text, MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation(sound,owner,text,null,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowExclamation(XSound sound,Window owner,string text,string caption)
{
   ShowExclamation(sound,owner,text,caption,MessageBoxButton.OK);
}

public static MessageBoxResult ShowExclamation( XSound sound, Window owner,
                                                string text, string caption,
                                                MessageBoxButton button )
{
   return ShowExclamation(
      sound, owner, text, caption, button,
      DefaultResultFromButton(button) );
}

public static MessageBoxResult ShowExclamation( XSound sound, Window owner,
                                                string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowMessage( sound, owner,
      text, caption ?? ExclamationCaption,
      button, MessageBoxImage.Exclamation,
      defaultResult );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
