﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowInformation(XSound sound,string text)
{
   ShowInformation(sound,(Window)null,text);
}

public static MessageBoxResult ShowInformation(XSound sound,string text,MessageBoxButton button)
{
   return ShowInformation(sound,(Window)null,text,button);
}

public static MessageBoxResult ShowInformation( XSound sound,
                                                string text,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation(sound,(Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowInformation(XSound sound,string text,string caption)
{
   ShowInformation(sound,(Window)null,text,caption);
}

public static MessageBoxResult ShowInformation( XSound sound,
                                                string text, string caption,
                                                MessageBoxButton button )
{
   return ShowInformation(sound,(Window)null,text,caption,button);
}

public static MessageBoxResult ShowInformation( XSound sound,
                                                string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation(sound,(Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowInformation(XSound sound,Window owner,string text)
{
   ShowInformation(sound,owner,text,null);
}

public static MessageBoxResult ShowInformation( XSound sound, Window owner,
                                                string text, MessageBoxButton button )
{
   return ShowInformation(sound,owner,text,null,button);
}

public static MessageBoxResult ShowInformation( XSound sound, Window owner,
                                                string text, MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation(sound,owner,text,null,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowInformation(XSound sound,Window owner,string text,string caption)
{
   ShowInformation(sound,owner,text,caption,MessageBoxButton.OK);
}

public static MessageBoxResult ShowInformation( XSound sound, Window owner,
                                                string text, string caption,
                                                MessageBoxButton button )
{
   return ShowInformation(
      sound, owner, text, caption, button,
      DefaultResultFromButton(button) );
}

public static MessageBoxResult ShowInformation( XSound sound, Window owner,
                                                string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowMessage( sound, owner,
      text, caption ?? InformationCaption,
      button, MessageBoxImage.Information,
      defaultResult );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
