﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowMessage(XSound sound,string text,string caption,MessageBoxImage icon)
{
   ShowMessage(sound,null,text,caption,icon);
}

public static MessageBoxResult ShowMessage( XSound sound, string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon )
{
   return ShowMessage(sound,null,text,caption,button,icon);
}

public static MessageBoxResult ShowMessage( XSound sound, string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon,
                                            MessageBoxResult defaultResult )
{
   return ShowMessage(sound,null,text,caption,button,icon,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowMessage( XSound sound, Window owner,
                                string text, string caption,
                                MessageBoxImage icon )
{
   ShowMessage(sound,owner,text,caption,MessageBoxButton.OK,icon);
}

public static MessageBoxResult ShowMessage( XSound sound, Window owner,
                                            string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon )
{
   return ShowMessage( sound, owner,
      text, caption, button, icon,
      DefaultResultFromButton(button) );
}

public static MessageBoxResult ShowMessage( XSound sound, Window owner,
                                            string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon,
                                            MessageBoxResult defaultResult )
{
   return XDispatcher.Synchronize
   (
      (XResultDelegate<MessageBoxResult>)delegate
      {
         return DoShowMessage( sound, owner,
            text, caption, button, icon, defaultResult );
      }
   );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
