﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowQuestion(XSound sound,string text)
{
   ShowQuestion(sound,(Window)null,text);
}

public static MessageBoxResult ShowQuestion(XSound sound,string text,MessageBoxButton button)
{
   return ShowQuestion(sound,(Window)null,text,button);
}

public static MessageBoxResult ShowQuestion( XSound sound,
                                             string text,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion(sound,(Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowQuestion(XSound sound,string text,string caption)
{
   ShowQuestion(sound,(Window)null,text,caption);
}

public static MessageBoxResult ShowQuestion( XSound sound,
                                             string text, string caption,
                                             MessageBoxButton button )
{
   return ShowQuestion(sound,(Window)null,text,caption,button);
}

public static MessageBoxResult ShowQuestion( XSound sound,
                                             string text, string caption,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion(sound,(Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowQuestion(XSound sound,Window owner,string text)
{
   ShowQuestion(sound,owner,text,null);
}

public static MessageBoxResult ShowQuestion( XSound sound, Window owner,
                                             string text, MessageBoxButton button )
{
   return ShowQuestion(sound,owner,text,null,button);
}

public static MessageBoxResult ShowQuestion( XSound sound, Window owner,
                                             string text, MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion(sound,owner,text,null,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowQuestion(XSound sound,Window owner,string text,string caption)
{
   ShowQuestion(sound,owner,text,caption,MessageBoxButton.OK);
}

public static MessageBoxResult ShowQuestion( XSound sound, Window owner,
                                             string text, string caption,
                                             MessageBoxButton button )
{
   return ShowQuestion(
      sound, owner, text, caption, button,
      DefaultResultFromButton(button) );
}

public static MessageBoxResult ShowQuestion( XSound sound, Window owner,
                                             string text, string caption,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowMessage( sound, owner,
      text, caption ?? QuestionCaption,
      button, MessageBoxImage.Question,
      defaultResult );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
