﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowWarning(XSound sound,string text)
{
   ShowWarning(sound,(Window)null,text);
}

public static MessageBoxResult ShowWarning(XSound sound,string text,MessageBoxButton button)
{
   return ShowWarning(sound,(Window)null,text,button);
}

public static MessageBoxResult ShowWarning( XSound sound,
                                            string text,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning(sound,(Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowWarning(XSound sound,string text,string caption)
{
   ShowWarning(sound,(Window)null,text,caption);
}

public static MessageBoxResult ShowWarning( XSound sound,
                                            string text, string caption,
                                            MessageBoxButton button )
{
   return ShowWarning(sound,(Window)null,text,caption,button);
}

public static MessageBoxResult ShowWarning( XSound sound,
                                            string text, string caption,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning(sound,(Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowWarning(XSound sound,Window owner,string text)
{
   ShowWarning(sound,owner,text,null);
}

public static MessageBoxResult ShowWarning( XSound sound, Window owner,
                                            string text, MessageBoxButton button )
{
   return ShowWarning(sound,owner,text,null,button);
}

public static MessageBoxResult ShowWarning( XSound sound, Window owner,
                                            string text, MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning(sound,owner,text,null,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowWarning(XSound sound,Window owner,string text,string caption)
{
   ShowWarning(sound,owner,text,caption,MessageBoxButton.OK);
}

public static MessageBoxResult ShowWarning( XSound sound, Window owner,
                                            string text, string caption,
                                            MessageBoxButton button )
{
   return ShowWarning(
      sound, owner, text, caption, button,
      DefaultResultFromButton(button) );
}

public static MessageBoxResult ShowWarning( XSound sound, Window owner,
                                            string text, string caption,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowMessage( sound, owner,
      text, caption ?? WarningCaption,
      button, MessageBoxImage.Warning,
      defaultResult );
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
