﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowError(string text)
{
   ShowError((Window)null,text);
}

public static MessageBoxResult ShowError(string text,MessageBoxButton button)
{
   return ShowError((Window)null,text,button);
}

public static MessageBoxResult ShowError( string text,
                                          MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowError((Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(string text,string caption)
{
   ShowError((Window)null,text,caption);
}

public static MessageBoxResult ShowError(string text,string caption,MessageBoxButton button)
{
   return ShowError((Window)null,text,caption,button);
}

public static MessageBoxResult ShowError( string text, string caption,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError((Window)null,text,caption,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(Exception e)
{
   ShowError((Window)null,e);
}

public static MessageBoxResult ShowError(Exception e,MessageBoxButton button)
{
   return ShowError((Window)null,e,button);
}

public static MessageBoxResult ShowError( Exception e,
                                          MessageBoxButton button,
                                          MessageBoxResult defaultResult )
{
   return ShowError((Window)null,e,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(Exception e,string caption)
{
   ShowError((Window)null,e,caption);
}

public static MessageBoxResult ShowError(Exception e,string caption,MessageBoxButton button)
{
   return ShowError((Window)null,e,caption,button);
}

public static MessageBoxResult ShowError( Exception e, string caption,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError((Window)null,e,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowError(Window owner,string text)
{
   ShowError(XSounds.Default,owner,text);
}

public static MessageBoxResult ShowError(Window owner,string text,MessageBoxButton button)
{
   return ShowError(XSounds.Default,owner,text,button);
}

public static MessageBoxResult ShowError( Window owner, string text,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(XSounds.Default,owner,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(Window owner,string text,string caption)
{
   ShowError(XSounds.Default,owner,text,caption);
}

public static MessageBoxResult ShowError( Window owner,
                                          string text, string caption,
                                          MessageBoxButton button )
{
   return ShowError(XSounds.Default,owner,text,caption,button);
}

public static MessageBoxResult ShowError( Window owner, string text, string caption,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(XSounds.Default,owner,text,caption,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(Window owner,Exception e)
{
   ShowError(XSounds.Default,owner,e);
}

public static MessageBoxResult ShowError(Window owner,Exception e, MessageBoxButton button)
{
   return ShowError(XSounds.Default,owner,e,button);
}

public static MessageBoxResult ShowError( Window owner, Exception e,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(XSounds.Default,owner,e,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowError(Window owner,Exception e,string caption)
{
   ShowError(XSounds.Default,owner,e,caption);
}

public static MessageBoxResult ShowError( Window owner,
                                          Exception e, string caption,
                                          MessageBoxButton button )
{
   return ShowError(XSounds.Default,owner,e,caption,button);
}

public static MessageBoxResult ShowError( Window owner, Exception e, string caption,
                                          MessageBoxButton button, MessageBoxResult defaultResult )
{
   return ShowError(XSounds.Default,owner,e,caption,button,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
