﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowExclamation(string text)
{
   ShowExclamation((Window)null,text);
}

public static MessageBoxResult ShowExclamation(string text,MessageBoxButton button)
{
   return ShowExclamation((Window)null,text,button);
}

public static MessageBoxResult ShowExclamation( string text,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation((Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowExclamation(string text,string caption)
{
   ShowExclamation((Window)null,text,caption);
}

public static MessageBoxResult ShowExclamation(string text,string caption,MessageBoxButton button)
{
   return ShowExclamation((Window)null,text,caption,button);
}

public static MessageBoxResult ShowExclamation( string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation((Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowExclamation(Window owner,string text)
{
   ShowExclamation(XSounds.Default,owner,text);
}

public static MessageBoxResult ShowExclamation(Window owner,string text,MessageBoxButton button)
{
   return ShowExclamation(XSounds.Default,owner,text,button);
}

public static MessageBoxResult ShowExclamation( Window owner, string text,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation(XSounds.Default,owner,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowExclamation(Window owner,string text,string caption)
{
   ShowExclamation(XSounds.Default,owner,text,caption);
}

public static MessageBoxResult ShowExclamation( Window owner,
                                                string text, string caption,
                                                MessageBoxButton button )
{
   return ShowExclamation(XSounds.Default,owner,text,caption,button);
}

public static MessageBoxResult ShowExclamation( Window owner,
                                                string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowExclamation(XSounds.Default,owner,text,caption,button,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
