﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowInformation(string text)
{
   ShowInformation((Window)null,text);
}

public static MessageBoxResult ShowInformation(string text,MessageBoxButton button)
{
   return ShowInformation((Window)null,text,button);
}

public static MessageBoxResult ShowInformation( string text,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation((Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowInformation(string text,string caption)
{
   ShowInformation((Window)null,text,caption);
}

public static MessageBoxResult ShowInformation(string text,string caption,MessageBoxButton button)
{
   return ShowInformation((Window)null,text,caption,button);
}

public static MessageBoxResult ShowInformation( string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation((Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowInformation(Window owner,string text)
{
   ShowInformation(XSounds.Default,owner,text);
}

public static MessageBoxResult ShowInformation(Window owner,string text,MessageBoxButton button)
{
   return ShowInformation(XSounds.Default,owner,text,button);
}

public static MessageBoxResult ShowInformation( Window owner, string text,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation(XSounds.Default,owner,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowInformation(Window owner,string text,string caption)
{
   ShowInformation(XSounds.Default,owner,text,caption);
}

public static MessageBoxResult ShowInformation( Window owner,
                                                string text, string caption,
                                                MessageBoxButton button )
{
   return ShowInformation(XSounds.Default,owner,text,caption,button);
}

public static MessageBoxResult ShowInformation( Window owner,
                                                string text, string caption,
                                                MessageBoxButton button,
                                                MessageBoxResult defaultResult )
{
   return ShowInformation(XSounds.Default,owner,text,caption,button,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
