﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowMessage(string text,string caption,MessageBoxImage icon)
{
   ShowMessage((Window)null,text,caption,icon);
}

public static MessageBoxResult ShowMessage( string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon )
{
   return ShowMessage((Window)null,text,caption,button,icon);
}

public static MessageBoxResult ShowMessage( string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon,
                                            MessageBoxResult defaultResult )
{
   return ShowMessage((Window)null,text,caption,button,icon,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowMessage(Window owner,string text,string caption,MessageBoxImage icon)
{
   ShowMessage(XSounds.Default,owner,text,caption,icon);
}

public static MessageBoxResult ShowMessage( Window owner, string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon )
{
   return ShowMessage(XSounds.Default,owner,text,caption,button,icon);
}

public static MessageBoxResult ShowMessage( Window owner, string text, string caption,
                                            MessageBoxButton button, MessageBoxImage icon,
                                            MessageBoxResult defaultResult )
{
   return ShowMessage(XSounds.Default,owner,text,caption,button,icon,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
