﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowQuestion(string text)
{
   ShowQuestion((Window)null,text);
}

public static MessageBoxResult ShowQuestion(string text,MessageBoxButton button)
{
   return ShowQuestion((Window)null,text,button);
}

public static MessageBoxResult ShowQuestion( string text,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion((Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowQuestion(string text,string caption)
{
   ShowQuestion((Window)null,text,caption);
}

public static MessageBoxResult ShowQuestion(string text,string caption,MessageBoxButton button)
{
   return ShowQuestion((Window)null,text,caption,button);
}

public static MessageBoxResult ShowQuestion( string text, string caption,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion((Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowQuestion(Window owner,string text)
{
   ShowQuestion(XSounds.Default,owner,text);
}

public static MessageBoxResult ShowQuestion(Window owner,string text,MessageBoxButton button)
{
   return ShowQuestion(XSounds.Default,owner,text,button);
}

public static MessageBoxResult ShowQuestion( Window owner, string text,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion(XSounds.Default,owner,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowQuestion(Window owner,string text,string caption)
{
   ShowQuestion(XSounds.Default,owner,text,caption);
}

public static MessageBoxResult ShowQuestion( Window owner,
                                             string text, string caption,
                                             MessageBoxButton button )
{
   return ShowQuestion(XSounds.Default,owner,text,caption,button);
}

public static MessageBoxResult ShowQuestion( Window owner,
                                             string text, string caption,
                                             MessageBoxButton button,
                                             MessageBoxResult defaultResult )
{
   return ShowQuestion(XSounds.Default,owner,text,caption,button,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
