﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;

using System.Windows;

namespace XHelpers {

//**************************************************************************************************
partial class XMessageBox {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static void ShowWarning(string text)
{
   ShowWarning((Window)null,text);
}

public static MessageBoxResult ShowWarning(string text,MessageBoxButton button)
{
   return ShowWarning((Window)null,text,button);
}

public static MessageBoxResult ShowWarning( string text,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning((Window)null,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowWarning(string text,string caption)
{
   ShowWarning((Window)null,text,caption);
}

public static MessageBoxResult ShowWarning(string text,string caption,MessageBoxButton button)
{
   return ShowWarning((Window)null,text,caption,button);
}

public static MessageBoxResult ShowWarning( string text, string caption,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning((Window)null,text,caption,button,defaultResult);
}

//==================================================================================================

public static void ShowWarning(Window owner,string text)
{
   ShowWarning(XSounds.Default,owner,text);
}

public static MessageBoxResult ShowWarning(Window owner,string text,MessageBoxButton button)
{
   return ShowWarning(XSounds.Default,owner,text,button);
}

public static MessageBoxResult ShowWarning( Window owner, string text,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning(XSounds.Default,owner,text,button,defaultResult);
}

//--------------------------------------------------------------------------------------------------

public static void ShowWarning(Window owner,string text,string caption)
{
   ShowWarning(XSounds.Default,owner,text,caption);
}

public static MessageBoxResult ShowWarning( Window owner,
                                            string text, string caption,
                                            MessageBoxButton button )
{
   return ShowWarning(XSounds.Default,owner,text,caption,button);
}

public static MessageBoxResult ShowWarning( Window owner,
                                            string text, string caption,
                                            MessageBoxButton button,
                                            MessageBoxResult defaultResult )
{
   return ShowWarning(XSounds.Default,owner,text,caption,button,defaultResult);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XMessageBox
//**************************************************************************************************

} // XHelpers
