﻿//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//
// XHelpers Solution Library (Freeware);  Author: Sergei Kitaev
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

using System;
using System.Collections.Generic;
using System.Collections;
using System.Security.Permissions;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;

namespace XHelpers {

//**************************************************************************************************
/// <summary>
/// </summary>
[SecurityPermission(SecurityAction.LinkDemand,Unrestricted=true)]
public static partial class XVideo {
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public static double DpiX
{
   get
   {
      int fullScreenPixelsX = Win32.GetSystemMetrics(Win32.SM_CXFULLSCREEN);
      if (fullScreenPixelsX==0)
         throw new XOperationFailedException(
            "Can not obtain horizontal screen resolution." );
      return fullScreenPixelsX/SystemParameters.FullPrimaryScreenWidth*96;
   }
}

public static double DpiY
{
   get
   {
      int fullScreenPixelsY = Win32.GetSystemMetrics(Win32.SM_CYFULLSCREEN);
      if (fullScreenPixelsY==0)
         throw new XOperationFailedException(
            "Can not obtain vertical screen resolution." );
      return fullScreenPixelsY/SystemParameters.FullPrimaryScreenHeight*96;
   }
}

//==================================================================================================

public static int UnitsToPixelsX(double unitsX)
{
   return (int)Math.Round(unitsX*DpiX/96);
}

public static int UnitsToPixelsY(double unitsY)
{
   return (int)Math.Round(unitsY*DpiY/96);
}

//--------------------------------------------------------------------------------------------------

public static double PixelsToUnitsX(int pixelsX)
{
   return pixelsX/DpiX*96;
}

public static double PixelsToUnitsY(int pixelsY)
{
   return pixelsY/DpiY*96;
}

//==================================================================================================

static XVideo()
{
   Library.Access();
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
} // XVideo
//**************************************************************************************************

} // XHelpers
