@echo off
setlocal
set initial_cd=%CD%

if "%~0"=="CLEAN_ALL.cmd" goto BEGIN
cls
echo 
echo  REMOVING ALL OUTPUT AND INTERMEDIATE FILES/FOLDERS: 

:BEGIN
call :RESET_ERROR

call :CLEAN "XHelpers.Core"
if %errorlevel% neq 0 goto ERROR

call :CLEAN "XHelpers.PAccess"
if %errorlevel% neq 0 goto ERROR

call :CLEAN "XHelpers.Console"
if %errorlevel% neq 0 goto ERROR

call :CLEAN "XHelpers.Windows"
if %errorlevel% neq 0 goto ERROR

call :CLEAN "XHelpers.Silverlight"
if %errorlevel% neq 0 goto ERROR

call :RESTORE_DIR

:DONE
if "%~0"=="CLEAN_ALL.cmd" goto FINISH
echo.
echo 
goto FINISH

rem ================================================================================

:CLEAN
call :CHANGE_DIR "%initial_cd%\%~1"
if %errorlevel% neq 0 goto :EOF

call CLEAN_ALL.cmd
if %errorlevel% neq 0 goto :EOF

echo.
echo 
goto :EOF

rem ================================================================================

:RESET_ERROR
set errorlevel=0
set errorlevel=
goto :EOF

:CHANGE_DIR
echo.
echo * Changing directory to: "%~1" ...
cd /d "%~1"
goto :EOF

:RESTORE_DIR
if /i "%CD%"=="%initial_cd%" goto :EOF
echo.
echo * Restoring directory to: "%initial_cd%" ...
cd /d "%initial_cd%"
if /i "%CD%"=="%initial_cd%" goto :EOF
echo.
echo ## === FATAL ERROR: ===
echo ## Can not restore directory to: "%initial_cd%".
echo ## Batch processing terminated!
echo 
pause
exit

rem ================================================================================

:ERROR
if "%~0"=="CLEAN_ALL.cmd" goto SKIP_ERROR_PAUSE
echo 
pause

:SKIP_ERROR_PAUSE
call :RESTORE_DIR

:ERROR_EXIT
endlocal
set errorlevel=1
goto :EOF

:FINISH
if "%~0"=="CLEAN_ALL.cmd" goto SKIP_FINISH_PAUSE
echo.
pause

:SKIP_FINISH_PAUSE
call :RESTORE_DIR

:NORMAL_EXIT
endlocal
call :RESET_ERROR
goto :EOF

rem ================================================================================
